unit uArbreDeProbabilites;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, StdCtrls, ColorGrd, Buttons, shellAPI;

type
  TfmArbreDeProbabilites = class(TForm)
    grArbre: TStringGrid;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    btExemple1: TButton;
    btExemple2: TButton;
    grCoordonnees: TStringGrid;
    fdEvenements: TFontDialog;
    gbFormat: TGroupBox;
    cgCouleurs: TColorGrid;
    sbPoliceEvenements: TSpeedButton;
    sbPoliceProbabilites: TSpeedButton;
    fdProbabilites: TFontDialog;
    Label3: TLabel;
    rgEpaisseur: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    cbOmega: TCheckBox;
    Label4: TLabel;
    btEffacerTout: TButton;
    btExemple3: TButton;
    btAnnuler: TButton;
    btOK: TButton;
    cbEffacerRepere: TCheckBox;
    rbTailleAutomatique: TRadioButton;
    rbTailleApercu: TRadioButton;
    Memo1: TMemo;
    btnAide: TButton;
    procedure FormShow(Sender: TObject);
    procedure btExemple1Click(Sender: TObject);
    procedure btExemple2Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure sbPoliceEvenementsClick(Sender: TObject);
    procedure sbPoliceProbabilitesClick(Sender: TObject);
    procedure cgCouleursClick(Sender: TObject);
    procedure rgEpaisseurClick(Sender: TObject);
    procedure grArbreKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure grArbreDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure grArbreClick(Sender: TObject);
    procedure cbOmegaClick(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure btEffacerToutClick(Sender: TObject);
    procedure btExemple3Click(Sender: TObject);
    procedure grArbreKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure TrierArbre;
  public
     procedure CalculerArbre;
    { Dclarations publiques }
  end;

var
  fmArbreDeProbabilites: TfmArbreDeProbabilites;

implementation
uses uDessin,uFonctions;

{$R *.dfm}

procedure TfmArbreDeProbabilites.FormShow(Sender: TObject);
begin
   with grArbre do
   begin
      RowHeights[0]:=30;
      Cells[0,0]:='Code de la branche';
      cells[1,0]:='vnement';
      Cells[2,0]:='Probabilit';
   end;
   with Image1.Canvas do
   begin
      brush.color:=clFond;
      brush.Style:=bsSolid;
      rectangle(0,0,Image1.Width,Image1.Height);
      brush.style:=bsClear;
   end;
   if grArbre.cells[0,1]='' then btExemple1Click(sender)
                            else CalculerArbre;
end;

Procedure TFmArbreDeProbabilites.TrierArbre;
//il est ncssaire, pour les calculs, que les branches soient enregistres dans un ordre bien prcis...
//on suppose que l'utilisateur n'a pas laiss de lignes vides en dbut de grille !
var n,i,j,k,LigneDeSaisie: integer;
    ch,CodeDeSaisie : string;
begin
   n:=1;
   CodeDeSaisie:=grArbre.Cells[0,grArbre.row];
   while grArbre.Cells[0,n]<>'' do inc(n);
   n:=n-1; //n reprsente le nombre de branches
   for i:=n-1 downto 1 do for j:=1 to i do //mthode du tri  bulles, lente mais suffisante pour un petit tableau
      if grArbre.Cells[0,j]>grArbre.Cells[0,j+1] then //il faut permuter les lignes j et j+1
         for k:=0 to 2 do begin
                             ch:=grArbre.Cells[k,j];
                             grArbre.Cells[k,j]:=grArbre.Cells[k,j+1];
                             grArbre.Cells[k,j+1]:=ch;
                          end;
   LigneDeSaisie:=grArbre.Cols[0].IndexOf(CodeDeSaisie);
   grArbre.Row:=LigneDeSaisie;
end;

Procedure TfmArbreDeProbabilites.CalculerArbre;
var i,j,k,nbEtages,nbBouts,nbBranches : integer;
    y : real;

    Function Ordonnee(prefixe:string;z:integer):real;
    var n,p,q,code : integer;
        s,s1 : real;
        ch : string;
    begin
       q:=length(prefixe);
       s:=0;p:=0;
       for n:=z+1 to nbBranches do
       begin
          if length(grCoordonnees.Cells[0,n])=q+1 then
          begin
             if copy(grCoordonnees.cells[0,n],1,q)=prefixe then
             begin
                inc(p);
                ch:=grCoordonnees.Cells[2,n];
                if ch<>'' then begin val(ch,s1,code);s:=s+s1;end
                          else s:=s+Ordonnee(grCoordonnees.cells[0,n],n);  //appel rcursif
             end;
          end;
       end;
       s:=s/p;
       str(s:6:4,ch);
       ordonnee:=s;
       grCoordonnees.Cells[2,z]:=ch;
    end;

    Procedure DessinerArbre;
    var Hauteur,Largeur,n,i,j,code,a,b,c,d : integer;
        dx,dy,x1,y1,x2,y2,z : real;
        ch1,ch2,ch3 : string;
        blBarre  : boolean;
    begin
       Hauteur:=round(0.9*Image1.Height);Largeur:=round(0.9*Image1.Width)-50;
       //on se garde une marge de 50 pixels  droite de l'arbre pour permettre, le cas chant, d'afficher des
       //noms d'vnements longs
       dx:=Largeur/nbEtages;if nbBouts>1 then dy:=Hauteur/(nbBouts-1) else dy:=Hauteur;
       with Image1.Canvas do
       begin
          brush.color:=clFond;
          brush.Style:=bsSolid;
          rectangle(0,0,Image1.Width,Image1.Height);
          brush.style:=bsClear;
       end;
       For n:=1 to nbBranches do   //dessin des traits
       begin
          ch1:=grCoordonnees.Cells[0,n];
          if length(ch1)=1 then begin x1:=0;val(grCoordonnees.cells[2,0],y1,code);end
                           else begin
                                   ch2:=Copy(ch1,1,length(ch1)-1);
                                   i:=grCoordonnees.Cols[0].IndexOf(ch2);
                                   val(grCoordonnees.cells[1,i],x1,code);
                                   val(grCoordonnees.cells[2,i],y1,code);
                                end;
          val(grCoordonnees.cells[1,n],x2,code);
          val(grCoordonnees.cells[2,n],y2,code);
          with Image1.Canvas do
          begin
             a:=round(0.05*Image1.Width+x1*dx);b:=round(0.05*Image1.Height+y1*dy);
             c:=round(0.05*Image1.Width+x2*dx);d:=round(0.05*Image1.Height+y2*dy);
             pen.Width:=rgEpaisseur.ItemIndex+1;
             pen.Color:=cgCouleurs.ForegroundColor;
             MoveTo(a,b);LineTo(c,d);
             pen.Width:=1;
          end;
       end;
       For n:=1 to nbBranches do    //dessin des textes avec effacement partiel des traits
       begin
          ch1:=grCoordonnees.Cells[0,n];
          if length(ch1)=1 then begin x1:=0;val(grCoordonnees.cells[2,0],y1,code);end
                           else begin
                                   ch2:=Copy(ch1,1,length(ch1)-1);
                                   i:=grCoordonnees.Cols[0].IndexOf(ch2);
                                   val(grCoordonnees.cells[1,i],x1,code);
                                   val(grCoordonnees.cells[2,i],y1,code);
                                end;
          val(grCoordonnees.cells[1,n],x2,code);
          val(grCoordonnees.cells[2,n],y2,code);
          with Image1.Canvas do
          begin
             a:=round(0.05*Image1.Width+x1*dx);b:=round(0.05*Image1.Height+y1*dy);
             c:=round(0.05*Image1.Width+x2*dx);d:=round(0.05*Image1.Height+y2*dy);
             ch1:=grArbre.Cells[1,n];if ch1<>'' then blBarre:=ch1[1]='&' else blBarre:=false;
             if blBarre then delete(ch1,1,1);
             ch2:=grArbre.Cells[2,n]; //ch2 = texte contenant la valeur de la probabilit
             Font:=fdEvenements.Font;
             if ch1<>'' then          //ch1 = nom de l'vnement (sans le prfixe ventuel &)
             begin
                brush.Style:=bsSolid;pen.Color:=clFond; //la couleur de brush est dj clFond
                Rectangle(round(c-0.5*textwidth(ch1+'AA')),round(d-0.8*textheight(ch1)),
                          round(c+0.5*textwidth(ch1+'AA')),round(d+0.8*textheight(ch1)));
                brush.Style:=bsClear;pen.Color:=clBlack;
                ch3:=ch1[length(ch1)];  //ch3 est le dernier caractre du nom de l'vnement
                if (ch3>='0')and(ch3<='9') //si le dernier caractre est un chiffre de 0  9
                then                                           //alors on le considre comme devant tre affich en indice
                begin
                   ch1:=copy(ch1,1,length(ch1)-1);TextOut(round(c-textwidth(ch1)/2),round(d-TextHeight(ch1)/2),ch1);
                   Font.Size:=Font.Size-2;TextOut(TextWidth(ch1)+round(c-textwidth(ch1)/2),round(d-TextHeight(ch1)/4),ch3);
                   Font.Size:=Font.Size+2;
                end
                else TextOut(round(c-textwidth(ch1)/2),round(d-TextHeight(ch1)/2),ch1);
                if blBarre then
                begin
                   pen.Color:=fdEvenements.Font.Color;
                   if fsBold in fdEvenements.Font.Style then pen.Width:=2 else pen.Width:=1;
                   MoveTo(round(c-0.6*textwidth(ch1)),round(d-0.6*textheight(ch1)));
                   LineTo(round(c+0.6*textwidth(ch1)),round(d-0.6*textheight(ch1)));
                   pen.Color:=clBlack;pen.Width:=1;  //on remet les valeurs standard
                end;
             end;
             Font:=fdProbabilites.Font;
             if ch2<>'' then
             begin
                brush.Style:=bsSolid;pen.Color:=clFond; //la couleur de brush est dj clFond
                Rectangle(round((a+c)/2-0.7*TextWidth(ch2)),round((b+d)/2-0.5*TextHeight(ch2)),
                          round((a+c)/2+0.7*TextWidth(ch2)),round((b+d)/2+0.5*TextHeight(ch2)));
                z:=f(ch2,0);  //z est la valeur numrique de la probabilit. Si c'est une constante calculable alors ok=true
                if (pos('/',ch2)>0)and ok then //si c'est une fraction ...
                begin
                   ch3:=copy(ch2,1,pos('/',ch2)-1); //ch3 est ici le numrateur de la fraction
                   TextOut(round((a+c-textwidth(ch3))/2),round((b+d)/2-textHeight(ch3)),ch3);
                   ch3:=copy(ch2,pos('/',ch2)+1,length(ch2));  //ch3 est maintenant le dnominateur de la fraction
                   TextOut(round((a+c-textwidth(ch3))/2),round((b+d)/2),ch3);
                   pen.Color:=fdProbabilites.Font.Color;
                   if fsBold in fdProbabilites.Font.Style then pen.Width:=2 else pen.Width:=1;
                   MoveTo(round((a+c-textwidth(ch3))/2),round((b+d)/2));LineTo(round((a+c+textwidth(ch3))/2),round((b+d)/2));
                   pen.Color:=clBlack;pen.Width:=1;  //on remet les valeurs standard
                end
                else TextOut(round((a+c-textwidth(ch2))/2),round((b+d-TextHeight(ch2))/2),ch2);
                brush.Style:=bsClear;pen.Color:=clBlack;
             end;
          end;
       end;
       if cbOmega.Checked then with Image1.Canvas do
       begin
          val(grCoordonnees.cells[2,0],y2,code);
          brush.Style:=bsSolid;pen.Color:=clFond;
          Font:=fdEvenements.Font;  //on rcupre les attribut de la police des noms d'vnements
          Font.Name:='Symbol';      //sauf le nom de la police pour obtenir la lettre omega majuscule
          a:=round(0.05*Image1.Width);b:=round(0.05*Image1.Height+y2*dy);
          Rectangle(round(a-0.5*TextWidth('WW')),round(b-0.5*TextHeight('W')),
                    round(a+0.5*TextWidth('WW')),round(b+0.5*TextHeight('W')));
          brush.Style:=bsClear;pen.Color:=clBlack;
          TextOut(round(a-textwidth('W')/2),round(b-TextHeight('W')/2),'W');
          Font:=fdEvenements.Font;
       end;
    end;

begin
   with grArbre do //if Dessinable then
   begin
      nbEtages:=0;
      for i:=1 to RowCount-1 do if length(cells[0,i])>nbEtages then nbEtages:=length(Cells[0,i]);
      i:=1;
      while cells[0,i]<>'' do inc(i);
      nbBranches:=i-1;
      nbBouts:=nbBranches;
      for i:=1 to nbBranches-1 do
      begin
         if length(cells[0,i])<length(cells[0,i+1]) then dec(nbBouts);
      end;
      grCoordonnees.Cols[0]:=grArbre.cols[0];grCoordonnees.Cells[0,0]:='';
      grCoordonnees.Cols[1].Clear;
      grCoordonnees.Cols[2].Clear;
      grCoordonnees.Cells[1,0]:='0';
      j:=0;
      for i:=1 to nbBranches-1 do
      begin
         grCoordonnees.cells[1,i]:=inttostr(length(grArbre.cells[0,i]));
         if length(grArbre.cells[0,i])>=length(grArbre.cells[0,i+1]) then
         begin
            grCoordonnees.cells[2,i]:=inttostr(j);
            inc(j);
         end;
      end;
      grCoordonnees.cells[1,nbBranches]:=inttostr(length(grArbre.cells[0,nbBranches]));
      grCoordonnees.cells[2,nbBranches]:=inttostr(nbBouts-1);
      if nbBranches>0 then y:=Ordonnee('',0);
      //--- On stocke les 3 variables nbBranches, nbEtages et nbBouts dans la grille grCoordonnees
      //--- pour viter de dclarer 3 nouvelles variables globables supplmentaires.
      //--- Ces 3 variables seront rcupres dans uDessin pour dessiner l'arbre
      grCoordonnees.cells[3,1]:=inttostr(nbBranches);
      grCoordonnees.cells[3,2]:=inttostr(nbEtages);
      grCoordonnees.cells[3,3]:=inttostr(nbBouts);
      if nbBranches>0 then DessinerArbre;
   end;
end;

procedure TfmArbreDeProbabilites.btExemple1Click(Sender: TObject);
var i : integer;
begin
   with grArbre do
   begin
      for i:=1 to RowCount-1 do Rows[i].Clear;
      cells[0,1]:='1';cells[1,1]:='A';cells[2,1]:='3/5';
      cells[0,2]:='11';cells[1,2]:='B';cells[2,2]:='7/10';
      cells[0,3]:='12';cells[1,3]:='&B';cells[2,3]:='3/10';
      cells[0,4]:='2';cells[1,4]:='&A';cells[2,4]:='2/5';
      cells[0,5]:='21';cells[1,5]:='B';cells[2,5]:='1/2';
      cells[0,6]:='22';cells[1,6]:='&B';cells[2,6]:='1/2';
      fdEvenements.Font.Name:='Times New Roman';
      fdEvenements.Font.color:=clMaroon;
      fdEvenements.Font.size:=11;
      fdEvenements.Font.Style:=[fsBold,fsItalic];
      fdProbabilites.Font.Name:='Calibri';
      fdProbabilites.Font.color:=clBlack;
      fdProbabilites.Font.size:=11;
      fdProbabilites.Font.Style:=[fsBold];
      cgCouleurs.ForeGroundIndex:=cgCouleurs.ColorToIndex(clGreen);
      cbOmega.Checked:=True;
      rgEpaisseur.ItemIndex:=1;panel1.Color:=clGreen;panel2.Color:=clGreen;panel3.Color:=clGreen;
      sbPoliceEvenements.Font:=fdEvenements.Font;
      sbPoliceEvenements.Caption:='Noms des vnements :'+chr(13)+fdEvenements.Font.Name+' : '+inttostr(fdEvenements.Font.Size);
      sbPoliceProbabilites.Font:=fdProbabilites.Font;
      sbPoliceProbabilites.Caption:='Valeurs des probabilites :'+chr(13)+fdProbabilites.Font.Name+' : '+inttostr(fdProbabilites.font.Size);
    end;
    CalculerArbre;
end;

procedure TfmArbreDeProbabilites.btExemple2Click(Sender: TObject);
var i : integer;
begin
   with grArbre do
   begin
      for i:=1 to RowCount-1 do Rows[i].Clear;
      cells[0,1]:='1';cells[1,1]:='A';cells[2,1]:='0,8';
      cells[0,2]:='11';cells[1,2]:='B';cells[2,2]:='0,4';
      cells[0,3]:='12';cells[1,3]:='&B';cells[2,3]:='0,6';
      cells[0,4]:='2';cells[1,4]:='&A';cells[2,4]:='0,2';
      cells[0,5]:='21';cells[1,5]:='C';cells[2,5]:='0,7';
      cells[0,6]:='211';cells[1,6]:='D';cells[2,6]:='0,3';
      cells[0,7]:='212';cells[1,7]:='E';cells[2,7]:='0,3';
      cells[0,8]:='213';cells[1,8]:='F';cells[2,8]:='0,4';
      cells[0,9]:='22';cells[1,9]:='&C';cells[2,9]:='0,3';
      fdEvenements.Font.Name:='Cambria';
      fdEvenements.Font.color:=clBlack;
      fdEvenements.Font.size:=10;
      fdEvenements.Font.Style:=[fsItalic];
      fdProbabilites.Font.Name:='Arial';
      fdProbabilites.Font.color:=clGreen;
      fdProbabilites.Font.size:=11;
      fdProbabilites.Font.Style:=[fsBold];
      cgCouleurs.ForeGroundIndex:=cgCouleurs.ColorToIndex(clNavy);
      cbOmega.Checked:=True;
      rgEpaisseur.ItemIndex:=1;panel1.Color:=clNavy;panel2.Color:=clNavy;panel3.Color:=clNavy;
      sbPoliceEvenements.Font:=fdEvenements.Font;
      sbPoliceEvenements.Caption:='Noms des vnements :'+chr(13)+fdEvenements.Font.Name+' : '+inttostr(fdEvenements.Font.Size);
      sbPoliceProbabilites.Font:=fdProbabilites.Font;
      sbPoliceProbabilites.Caption:='Valeurs des probabilites :'+chr(13)+fdProbabilites.Font.Name+' : '+inttostr(fdProbabilites.font.Size);
    end;
    CalculerArbre;
end;

procedure TfmArbreDeProbabilites.btExemple3Click(Sender: TObject);
var i,j,k,l : integer;
begin
   with grArbre do
   begin
      for i:=1 to RowCount-1 do Rows[i].Clear;
      for i:=1 to 2 do for j:=1 to 2 do for k:=1 to 2 do for l:=1 to 2 do
      begin
         cells[0,8*(i-1)+4*(j-1)+2*(k-1)+l]:=inttostr(i)+inttostr(j)+inttostr(k)+inttostr(l);
         if odd(l) then cells[1,8*(i-1)+4*(j-1)+2*(k-1)+l]:='P' else cells[1,8*(i-1)+4*(j-1)+2*(k-1)+l]:='F';
         cells[2,8*(i-1)+4*(j-1)+2*(k-1)+l]:='0,5';
      end;
      for i:=1 to 2 do for j:=1 to 2 do for k:=1 to 2 do
      begin
         cells[0,17+4*(i-1)+2*(j-1)+(k-1)]:=inttostr(i)+inttostr(j)+inttostr(k);
         if odd(k) then cells[1,17+4*(i-1)+2*(j-1)+(k-1)]:='P' else cells[1,17+4*(i-1)+2*(j-1)+(k-1)]:='F';
         cells[2,17+4*(i-1)+2*(j-1)+(k-1)]:='0,5';
      end;
      for i:=1 to 2 do for j:=1 to 2 do
      begin
         cells[0,25+2*(i-1)+(j-1)]:=inttostr(i)+inttostr(j);
         if odd(j) then cells[1,25+2*(i-1)+(j-1)]:='P' else cells[1,25+2*(i-1)+(j-1)]:='F';
         cells[2,25+2*(i-1)+(j-1)]:='1/2';
      end;
      For i:=1 to 2 do
      begin
         cells[0,28+i]:=inttostr(i);
         if i=1 then cells[1,28+i]:='P' else cells[1,28+i]:='F';
         cells[2,28+i]:='1/2';
      end;
      TrierArbre;
      fdEvenements.Font.Name:='Cambria';
      fdEvenements.Font.color:=clBlack;
      fdEvenements.Font.size:=10;
      fdEvenements.Font.Style:=[fsItalic];
      fdProbabilites.Font.Name:='Arial';
      fdProbabilites.Font.color:=clGreen;
      fdProbabilites.Font.size:=10;
      fdProbabilites.Font.Style:=[fsBold];
      cgCouleurs.ForeGroundIndex:=cgCouleurs.ColorToIndex(clNavy);
      cbOmega.Checked:=True;
      rgEpaisseur.ItemIndex:=0;panel1.Color:=clNavy;panel2.Color:=clNavy;panel3.Color:=clNavy;
      sbPoliceEvenements.Font:=fdEvenements.Font;
      sbPoliceEvenements.Caption:='Noms des vnements :'+chr(13)+fdEvenements.Font.Name+' : '+inttostr(fdEvenements.Font.Size);
      sbPoliceProbabilites.Font:=fdProbabilites.Font;
      sbPoliceProbabilites.Caption:='Valeurs des probabilites :'+chr(13)+fdProbabilites.Font.Name+' : '+inttostr(fdProbabilites.font.Size);
    end;
    CalculerArbre;
end;

procedure TfmArbreDeProbabilites.Label2Click(Sender: TObject);
begin
   TrierArbre;
   CalculerArbre;
end;

procedure TfmArbreDeProbabilites.sbPoliceEvenementsClick(Sender: TObject);
begin
   if fdEvenements.Execute then
   begin
      sbPoliceEvenements.Font:=fdEvenements.Font;
      sbPoliceEvenements.Caption:='Noms des vnements :'+chr(13)+fdEvenements.Font.Name+' : '+inttostr(fdEvenements.Font.Size);
      CalculerArbre;
   end;
end;

procedure TfmArbreDeProbabilites.sbPoliceProbabilitesClick(
  Sender: TObject);
begin
   if fdProbabilites.Execute then
   begin
      sbPoliceProbabilites.Font:=fdProbabilites.Font;
      sbPoliceProbabilites.Caption:='Valeurs des probabilites :'+chr(13)+fdProbabilites.Font.Name+' : '+inttostr(fdProbabilites.font.Size);
      CalculerArbre;
   end;
end;

procedure TfmArbreDeProbabilites.cgCouleursClick(Sender: TObject);
begin
   panel1.Color:=cgCouleurs.ForegroundColor;
   panel2.Color:=cgCouleurs.ForegroundColor;
   panel3.Color:=cgCouleurs.ForegroundColor;
   CalculerArbre;
end;

procedure TfmArbreDeProbabilites.rgEpaisseurClick(Sender: TObject);
begin
   CalculerArbre;
end;

procedure TfmArbreDeProbabilites.grArbreKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
   if (key=vk_Return)or((key=vk_right)and grArbre.EditorMode)then
      if grArbre.Col=2 then
      begin
         grArbre.Col:=0;
         while grArbre.cells[0,grArbre.Row]<>'' do grArbre.Row:=grArbre.Row+1;
      end
      else grArbre.Col:=grArbre.Col+1;
   if (key=vk_left)and grArbre.EditorMode then if grArbre.Col>0 then grArbre.Col:=grArbre.Col-1;
end;

// Colorisation de la String-Grid

procedure TfmArbreDeProbabilites.grArbreDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var txt : string;
begin
   txt := grArbre.Cells[acol, arow];
   if ARow=0  //s'il s'agit de la premire ligne
      then GrilleCouleur(grArbre, rect, txt, taCenter, clBtnFace, clBlack, [fsBold])
      else if gdSelected in State then GrilleCouleur(grArbre, rect, txt, taCenter, clNavy, clWhite, [])
                                  else GrilleCouleur(grArbre, rect, txt, taCenter, clWindow, clBlack, [])
end;

procedure TfmArbreDeProbabilites.grArbreClick(Sender: TObject);
begin
   TrierArbre;
   CalculerArbre;
end;

procedure TfmArbreDeProbabilites.cbOmegaClick(Sender: TObject);
begin
   grArbreClick(sender);
end;

procedure TfmArbreDeProbabilites.Label4Click(Sender: TObject);
begin
   cbOmega.Checked:=not cbOmega.Checked;
end;

procedure TfmArbreDeProbabilites.btEffacerToutClick(Sender: TObject);
var i : integer;
begin
   For i:=1 to grArbre.RowCount-1 do grArbre.Rows[i].Clear;
   for i:=0 to grCoordonnees.RowCount-1 do grCoordonnees.Rows[i].Clear;
   with Image1.Canvas do
   begin
      brush.color:=clFond;
      brush.Style:=bsSolid;
      rectangle(0,0,Image1.Width,Image1.Height);
      brush.style:=bsClear;
   end;
end;


procedure TfmArbreDeProbabilites.grArbreKeyPress(Sender: TObject;
  var Key: Char);
begin
   if grArbre.Col=2 then if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmArbreDeProbabilites.FormCreate(Sender: TObject);
begin
//rglages par dfaut
   fdEvenements.Font.Name:='Times New Roman';
   fdEvenements.Font.color:=clMaroon;
   fdEvenements.Font.size:=11;
   fdEvenements.Font.Style:=[fsBold,fsItalic];
   fdProbabilites.Font.Name:='Calibri';
   fdProbabilites.Font.color:=clBlack;
   fdProbabilites.Font.size:=11;
   fdProbabilites.Font.Style:=[fsBold];
   cgCouleurs.ForeGroundIndex:=cgCouleurs.ColorToIndex(clGreen);
   sbPoliceEvenements.Font:=fdEvenements.Font;
   sbPoliceEvenements.Caption:='Noms des vnements :'+chr(13)+fdEvenements.Font.Name+' : '+inttostr(fdEvenements.Font.Size);
   sbPoliceProbabilites.Font:=fdProbabilites.Font;
   sbPoliceProbabilites.Caption:='Valeurs des probabilites :'+chr(13)+fdProbabilites.Font.Name+' : '+inttostr(fdProbabilites.font.Size);
   sbPoliceEvenements.Font:=fdEvenements.Font;
end;

procedure TfmArbreDeProbabilites.btnAideClick(Sender: TObject);
begin
   Aide(61);
end;

end.
