unit uAutresOptions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ColorGrd, StdCtrls, ExtCtrls, uDessin, ComCtrls, shellAPI;

type
  TfmAutresOptions = class(TForm)
    GroupBox1: TGroupBox;
    cbEnveloppe: TCheckBox;
    cbDeveloppee: TCheckBox;
    rgPoints: TRadioGroup;
    gbCaracteristiques: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edNom: TEdit;
    edAbscisse: TEdit;
    cbLigneCote: TCheckBox;
    cbTangente: TCheckBox;
    cbFlecheTangente: TCheckBox;
    cgCouleurPoint: TColorGrid;
    cbVoirProgressionDessin: TCheckBox;
    btnOK: TButton;
    Panel1: TPanel;
    btnPolice: TButton;
    FontDialog1: TFontDialog;
    btnAnnuler: TButton;
    Memo1: TMemo;
    cbNormale: TCheckBox;
    Label5: TLabel;
    edVitesse: TEdit;
    udVitesse: TUpDown;
    gbPositionNom: TGroupBox;
    rbAucunePosition: TRadioButton;
    rbDroite: TRadioButton;
    rbHautDroite: TRadioButton;
    rbHaut: TRadioButton;
    rbHautGauche: TRadioButton;
    rbGauche: TRadioButton;
    rbBasGauche: TRadioButton;
    rbBas: TRadioButton;
    rbBasDroite: TRadioButton;
    lblPosition: TPanel;
    lblEquation: TLabel;
    Label6: TLabel;
    cbAfficherEquation: TCheckBox;
    btnAide: TButton;
    procedure rgPointsClick(Sender: TObject);
    procedure edAbscisseChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edAbscisseExit(Sender: TObject);
    procedure btnPoliceClick(Sender: TObject);
    procedure cgCouleurPointClick(Sender: TObject);
    procedure cbLigneCoteClick(Sender: TObject);
    procedure cbTangenteClick(Sender: TObject);
    procedure cbFlecheTangenteClick(Sender: TObject);
    procedure edNomChange(Sender: TObject);
    procedure cbNormaleClick(Sender: TObject);
    procedure edAbscisseKeyPress(Sender: TObject; var Key: Char);
    procedure cbVoirProgressionDessinClick(Sender: TObject);
    procedure rbDroiteClick(Sender: TObject);
    procedure rbHautDroiteClick(Sender: TObject);
    procedure rbHautClick(Sender: TObject);
    procedure rbHautGaucheClick(Sender: TObject);
    procedure rbGaucheClick(Sender: TObject);
    procedure rbBasGaucheClick(Sender: TObject);
    procedure rbBasClick(Sender: TObject);
    procedure rbBasDroiteClick(Sender: TObject);
    procedure rbAucunePositionClick(Sender: TObject);
    procedure cbAfficherEquationClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure AfficherEquation;
  public
    { Dclarations publiques }
  end;

var
  fmAutresOptions: TfmAutresOptions;
  PointsParticuliers : array[1..10]of TPointsParticuliers; //variable locale  l'unit

implementation

uses uListeFonctions,uListeCourbesParametrees,uFonctions;
{$R *.DFM}

Procedure TfmAutresOptions.AfficherEquation;
var Delta,a,nDerive : real;
    i   : integer;
    err : byte;
    chFonction,chnDerive,cha,chfa: string;
begin
   i:=rgPoints.ItemIndex;     //point particulier (i+1)
   if Pos('paramtre',caption)>0 then
   begin  //cas d'une courbe paramtre
      Label6.Enabled:=false;
      lblEquation.Caption:='';
   end
   else
   begin  //cas d'une fonction
      Delta:=(XMax-XMin)/10000000;
      with POintsParticuliers[i+1] do
      if (abscisse<>9999)and(blTangente or blFlecheTangente) then
      begin
         chFonction:=panel1.caption;
         chFonction:=Traduction(chFonction,err);
         if chFonction='' then exit;
         nDerive:=(f(chFonction,abscisse+Delta)-f(chFonction,abscisse))/Delta;
         chnDerive:=FloatToStr(round(1000*nDerive)/1000);
         a:=f(chFonction,abscisse);chfa:=floattostr(round(1000*a)/1000);if a>0 then chfa:='+'+chfa;
         cha:=edAbscisse.text;if abscisse>0 then cha:='-'+cha else begin delete(cha,1,1);cha:='+'+cha;end;
         lblEquation.caption:='y='+chnDerive+'(x'+cha+')'+chfa ;
         Label6.Enabled:=true;
      end
      else begin Label6.enabled:=false;lblEquation.Caption:='';end;
      cbAfficherEquation.Enabled:=(POintsParticuliers[i+1].abscisse<>9999)and POintsParticuliers[i+1].blTangente;
   end;
end;

procedure TfmAutresOptions.rgPointsClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   gbCaracteristiques.Caption:='Caractristiques du '+rgPoints.Items[rgPoints.ItemIndex];
   with PointsParticuliers[i+1] do
   begin
      if Abscisse=9999 then edAbscisse.text:=''
                       else edAbscisse.Text:=FloatToStrF(Abscisse,ffGeneral,4,4);
      edNom.Text:=Nom;
      edNom.Font:=Police;
      case PositionNom of
         0 : rbDroite.Checked:=true;
         1 : rbHautDroite.Checked:=true;
         2 : rbHaut.Checked:=true;
         3 : rbHautGauche.Checked:=true;
         4 : rbGauche.Checked:=true;
         5 : rbBasGauche.Checked:=true;
         6 : rbBas.Checked:=true;
         7 : rbBasDroite.Checked:=true;
         8 : rbAucunePosition.Checked:=true;
      end;
      cgCouleurPoint.ForegroundIndex:=cgCouleurPoint.ColorToIndex(Couleur);
      cbLigneCote.Checked:=blLigneCote;
      cbTangente.Checked:=blTangente;
      cbFlecheTangente.Checked:=blFlecheTangente;
      cbAfficherEquation.Checked:=blEquationTangente;
      AfficherEquation;
   end;
end;

procedure TfmAutresOptions.edAbscisseChange(Sender: TObject);
begin
   edNom.Enabled:=edAbscisse.text<>'';
   btnPolice.Enabled:=edAbscisse.text<>'';
   gbPositionNom.Enabled:=edAbscisse.text<>'';
   cgCouleurPoint.Enabled:=edAbscisse.text<>'';
   cbLigneCote.Enabled:=edAbscisse.text<>'';
   cbTangente.Enabled:=edAbscisse.text<>'';
   cbNormale.Enabled:=edAbscisse.text<>'';
   cbFlecheTangente.Enabled:=edAbscisse.text<>'';
   Label1.Enabled:=edAbscisse.text<>'';
   Label3.Enabled:=edAbscisse.text<>'';
   Label4.Enabled:=edAbscisse.text<>'';
   Label6.Enabled:=(edAbscisse.text<>'')and(cbTangente.checked or cbFlecheTangente.checked);
   cbAfficherEquation.Enabled:=(edAbscisse.text<>'')and(cbTangente.checked)
end;

procedure TfmAutresOptions.FormShow(Sender: TObject);
begin
   rgPoints.ItemIndex:=0;    //on se place sur le premier point
   rgPointsClick(sender);    //permet de mettre  jour le titre contenant le n du point
   edAbscisseChange(sender); //rend accessibles ou non les caractristiques du point
   if Pos('paramtre',caption)>0 then label2.caption:='Paramtre du point :'
                                  else label2.caption:='Abscisse (obligatoire) :';
   udVitesse.Enabled:=cbVoirProgressionDessin.Checked;
   edVitesse.Enabled:=cbVoirProgressionDessin.Checked;
   AfficherEquation;
end;

procedure TfmAutresOptions.edAbscisseExit(Sender: TObject);
var i,err : byte;
    ch    : string;
begin
   i:=rgPoints.ItemIndex+1;
   ch:=edAbscisse.text;
   if ch='' then begin PointsParticuliers[i].abscisse:=9999;exit;end;
   ch:=Traduction(edAbscisse.text,err);
   if (err>0)or(pos('X',ch)>0)or(Pos('T',ch)>0) then
   begin
      ShowMessage('La constante '+edAbscisse.Text+' n''est pas correcte');
      //on remet la valeur initiale de Abscisse
      edAbscisse.Text:='';
      PointsParticuliers[i].abscisse:=9999;
   end
   else PointsParticuliers[i].Abscisse:=F(ch,1);
   edAbscisse.Text:=FloatToStr(PointsParticuliers[i].abscisse);
   AfficherEquation;
end;

procedure TfmAutresOptions.btnPoliceClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   fontDialog1.Font:=edNom.Font;
   if FontDialog1.execute then
   begin
      edNom.Font:=FontDialog1.Font;
      PointsParticuliers[i+1].Police.name:=edNom.Font.name;
      PointsParticuliers[i+1].Police.size:=edNom.Font.size;
      PointsParticuliers[i+1].Police.style:=edNom.Font.style;
   end;
end;

procedure TfmAutresOptions.cgCouleurPointClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].Couleur:=cgCouleurPoint.ForegroundColor;
end;

procedure TfmAutresOptions.cbLigneCoteClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].blLigneCote:=cbLigneCote.Checked;
end;

procedure TfmAutresOptions.cbTangenteClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].blTangente:=cbTangente.Checked;
   AfficherEquation;
end;

procedure TfmAutresOptions.cbFlecheTangenteClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].blFlecheTangente:=cbFlecheTangente.Checked;
   AfficherEquation;
end;

procedure TfmAutresOptions.edNomChange(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].Nom:=edNom.Text;
end;

procedure TfmAutresOptions.cbNormaleClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].blNormale:=cbNormale.Checked;
end;

procedure TfmAutresOptions.edAbscisseKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmAutresOptions.cbVoirProgressionDessinClick(Sender: TObject);
begin
   udVitesse.Enabled:=cbVoirProgressionDessin.Checked;
   edVitesse.Enabled:=cbVoirProgressionDessin.Checked;
end;

procedure TfmAutresOptions.rbDroiteClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:=' droite';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=0;
end;

procedure TfmAutresOptions.rbHautDroiteClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:='en haut  droite';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=1;
end;

procedure TfmAutresOptions.rbHautClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:='en haut';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=2;
end;

procedure TfmAutresOptions.rbHautGaucheClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:='en haut  gauche';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=3;
end;

procedure TfmAutresOptions.rbGaucheClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:=' gauche';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=4;
end;

procedure TfmAutresOptions.rbBasGaucheClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:='en bas  gauche';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=5;
end;

procedure TfmAutresOptions.rbBasClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:='en bas';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=6;
end;

procedure TfmAutresOptions.rbBasDroiteClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:='en bas  droite';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=7;
end;

procedure TfmAutresOptions.rbAucunePositionClick(Sender: TObject);
var i : byte;
begin
   lblPosition.Caption:='pas d''affichage du nom';
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].PositionNom:=8;
end;

procedure TfmAutresOptions.cbAfficherEquationClick(Sender: TObject);
var i : byte;
begin
   i:=rgPoints.ItemIndex;
   PointsParticuliers[i+1].blEquationTangente:=cbAfficherEquation.Checked;
end;

procedure TfmAutresOptions.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmAutresOptions.btnAideClick(Sender: TObject);
begin
  Aide(81);
end;

end.
