unit uConique;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ColorGrd, Buttons, Math, StrUtils, shellAPI;

type
  TfmConique = class(TForm)
    rgDefinition: TRadioGroup;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edFoyer: TEdit;
    edDirectrice: TEdit;
    edExcentricite: TEdit;
    Panel3: TPanel;
    edA: TEdit;
    edB: TEdit;
    edC: TEdit;
    edD: TEdit;
    edE: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    edF: TEdit;
    gbCouleur: TGroupBox;
    btAnnuler: TButton;
    btOK: TButton;
    btAide: TButton;
    gbEpaisseur: TGroupBox;
    Apercu: TImage;
    edEpaisseur: TEdit;
    udEpaisseur: TUpDown;
    Label4: TLabel;
    Label5: TLabel;
    Panel2: TPanel;
    lbTracer: TLabel;
    cbFoyer: TCheckBox;
    cbDirectrice: TCheckBox;
    cbAxe: TCheckBox;
    cbSommet: TCheckBox;
    btPlus: TButton;
    ApercuConique: TImage;
    lbGenre: TLabel;
    cbCentre: TCheckBox;
    cbAsymptote: TCheckBox;
    lbApercu: TLabel;
    btExemple: TBitBtn;
    Panel4: TPanel;
    cbMetriques: TCheckBox;
    cbEquations: TCheckBox;
    cbCoordonnees: TCheckBox;
    cbExcentricite: TCheckBox;
    btAleatoire: TBitBtn;
    lbExcentricite: TLabel;
    Label6: TLabel;
    Label13: TLabel;
    cgCouleur: TColorGrid;
    Label14: TLabel;
    cgCouleurDroites: TColorGrid;
    Label15: TLabel;
    Label16: TLabel;
    GroupBox2: TGroupBox;
    Image1: TImage;
    Image2: TImage;
    rbPoint: TRadioButton;
    rbPlus: TRadioButton;
    rbCroix: TRadioButton;
    rbEtoile: TRadioButton;
    rbCarre: TRadioButton;
    rbLosange: TRadioButton;
    rbRond: TRadioButton;
    rbCarre2: TRadioButton;
    rbLosange2: TRadioButton;
    Label17: TLabel;
    rbStyleDroites1: TRadioButton;
    Label19: TLabel;
    rbStyleDroites2: TRadioButton;
    rbStyleDroites3: TRadioButton;
    lbAfficher: TLabel;
    rbValeursExactes: TRadioButton;
    rbValeursApprochees: TRadioButton;
    procedure edEpaisseurChange(Sender: TObject);
    procedure btAideClick(Sender: TObject);
    procedure rgDefinitionClick(Sender: TObject);
    procedure edFoyerChange(Sender: TObject);
    procedure edDirectriceChange(Sender: TObject);
    procedure edExcentriciteChange(Sender: TObject);
    procedure edAChange(Sender: TObject);
    procedure edBChange(Sender: TObject);
    procedure edCChange(Sender: TObject);
    procedure edDChange(Sender: TObject);
    procedure edEChange(Sender: TObject);
    procedure edFChange(Sender: TObject);
    procedure VerifieDefinition(i:integer);
    procedure DessinerApercu;
    procedure EffacerApercu;
    procedure btExempleClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btAleatoireClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btPlusClick(Sender: TObject);
  private
    { Dclarations prives }
    definitionOK : boolean;
  public
    { Dclarations publiques }
  end;

type
  TTab2Dim = array[1..24, 1..6] of integer;
const
  ListeExemples: TTab2Dim =(
                            (   1,  -4,   4,   6, -12,   5),
                            (   1,  -4,   4,  10, -20,  25),
                            (   1,   0,   0,  -8,   0,  16),
                            (   0,   0,   1,   0,   6,   9),
                            (   1,   4,   4,  -2,  -4,   2),
                            (   3,  -5,  -2,  14,   7,  -5),
                            (   1,  -2,   0,   0,  10, -25),
                            (   0,   1,  -2,   3,  -1,  15),
                            (   0,   1,   0,   3,  -5, -15),
                            (   1,   0,   1,   2,  -4,   5),
                            (   2,   0,   2,   3,  -1,   1),
                            (   4,   2,   3,   5,   1,  -1),
                            (   1,  -3,   5,   4,   0,   2),
                            (   4,   0,   1,  -3,   1,  -3),
                            (   2,   0,   9,   1,  -4,  -1),
                            (   2,   0,   9,   1,  -4,   1),
                            (  -2,   0,   5,  -6,   2,  -1),
                            (  -6,   0,   5,   2,   7,  -9),
                            (  -2,   2,   1,   3,  -1,   4),
                            (  -2,   8,  -7,   3,  -1,   5),
                            (   1,  -2,   1,   2,   3,  10),
                            (   9,   6,   1,   1,  -7,   4),
                            (   2,   0,   0,  -4,  -4,   0),
                            (   0,   0,   1,   2,   9,  -2)
                            );
  nbExemples = 24;

var
  fmConique : TfmConique;
  Exemple   : integer;
  blExemple : boolean;


implementation

uses uDessin, uSchema, uFonctions;

{$R *.DFM}

procedure TfmConique.edEpaisseurChange(Sender: TObject);
begin
  edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
  Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,cgCouleur.ForeGroundColor));
end;

procedure TfmConique.btAideClick(Sender: TObject);
begin
	Aide(35);
end;

procedure TfmConique.rgDefinitionClick(Sender: TObject);
begin
   case rgDefinition.ItemIndex of
      0 : begin
      		edA.Enabled:=False;
            edA.Color:=clBtnFace;
            edB.Enabled:=False;
            edB.Color:=clBtnFace;
            edC.Enabled:=False;
            edC.Color:=clBtnFace;
            edD.Enabled:=False;
            edD.Color:=clBtnFace;
            edE.Enabled:=False;
            edE.Color:=clBtnFace;
            edF.Enabled:=False;
            edF.Color:=clBtnFace;
            Label7.Enabled:=False;
            Label8.Enabled:=False;
            Label9.Enabled:=False;
            Label10.Enabled:=False;
            Label11.Enabled:=False;
            Label12.Enabled:=False;

            edFoyer.Enabled:=true;
            edFoyer.Color:=clWindow;
            edDirectrice.Enabled:=true;
            edDirectrice.Color:=clWindow;
            edExcentricite.Enabled:=true;
            edExcentricite.Color:=clWindow;
            Label1.Enabled:=true;
            Label2.Enabled:=true;
            Label3.Enabled:=true;
            Label4.Enabled:=true;
            Label5.Enabled:=true;
            Label6.Enabled:=true;
            if Self.visible then edFoyer.SetFocus;
         end;
     1 : begin
   			edFoyer.Enabled:=False;
            edFoyer.Color:=clBtnFace;
            edDirectrice.Enabled:=False;
            edDirectrice.Color:=clBtnFace;
            edExcentricite.Enabled:=False;
            edExcentricite.Color:=clBtnFace;
            Label1.Enabled:=False;
            Label2.Enabled:=False;
            Label3.Enabled:=False;
            Label4.Enabled:=False;
            Label5.Enabled:=False;
            Label6.Enabled:=False;

            edA.Enabled:=true;
            edA.Color:=clWindow;
            edB.Enabled:=true;
            edB.Color:=clWindow;
            edC.Enabled:=true;
            edC.Color:=clWindow;
            edD.Enabled:=true;
            edD.Color:=clWindow;
            edE.Enabled:=true;
            edE.Color:=clWindow;
            edF.Enabled:=true;
            edF.Color:=clWindow;
            Label7.Enabled:=true;
            Label8.Enabled:=true;
            Label9.Enabled:=true;
            Label10.Enabled:=true;
            Label11.Enabled:=true;
            Label12.Enabled:=true;
            if Self.visible then edA.SetFocus;
          end;
   end;
end;

procedure TfmConique.VerifieDefinition(i:integer);

	function ConstanteOK(s:string):boolean;
   var
   	err : byte;
   begin
   if s[1]='+' then delete(s,1,1);
   NomVar:='X';
   if pos(NomVar,s)>0
   	then ConstanteOK:=False
      else begin
      s:=Traduction(s,err);
      if (err=0) and ok
      	then ConstanteOK:=True
       	else ConstanteOK:=False;
      end;
   end;

	function FoyerOK:boolean;
	var
   	ChaineFoyer,Chx,Chy : String;
      p,l               : integer;
      x,y                 : Real;
	begin
   ChaineFoyer:=edFoyer.Text;
   While Pos(' ',ChaineFoyer)>0 do Delete(ChaineFoyer,Pos(' ',ChaineFoyer),1); // suppression des espaces
   if ChaineFoyer[1]='(' // si foyer donn par ses coordonnes
   	then begin
   		p:=pos(';',ChaineFoyer);
      	if p=0 then begin FoyerOK:=False;Exit; end;
      	if posEx(';',ChaineFoyer,p+1)>0 then begin FoyerOK:=False;Exit; end;// un seul ;
   		l:=length(ChaineFoyer);
         if ChaineFoyer[l]<>')' then begin FoyerOK:=False;Exit; end;
      	Chx:=copy(ChaineFoyer,2,p-2);
      	Chy:=copy(ChaineFoyer,p+1,l-p-1);
      	if ConstanteOK(Chx) and ConstanteOK(Chy)
      		then FoyerOK:=True else FoyerOK:=False;
     	end else begin         //si nom du foyer
     		if fmSchema.ExistePoint(ChaineFoyer,x,y)
     			then FoyerOK:=True else FoyerOK:=False;
     	end;
   end;

   function DirectriceOK : boolean;
   var
   	ChaineDirectrice              : string;
      l                             : integer;
      a,b,x,x1,x2,y1,y2,y3,z1,z2,z3 : real;
      err                           : byte;
   begin
   DirectriceOK:=False;
   ChaineDirectrice:=edDirectrice.Text;
   While Pos(' ',ChaineDirectrice)>0 do Delete(ChaineDirectrice,Pos(' ',ChaineDirectrice),1); // suppression des espaces
   if (copy (ChaineDirectrice,1,2)='x=')   //quation rduite d'une droite verticale
   	or (copy (ChaineDirectrice,1,2)='X=')
   	then begin
      	Delete(ChaineDirectrice,1,2); // suppression x=
      	if ConstanteOK(ChaineDirectrice) then DirectriceOK:=True;
      end;
   if (copy (ChaineDirectrice,1,2)='y=')    //quation rduite d'une droite oblique ou horizontale
   	or (copy (ChaineDirectrice,1,2)='Y=')
   	then begin
      	Delete(ChaineDirectrice,1,2);  // suppression y=
      	NomVar:='X';
         ChaineDirectrice:=Traduction(ChaineDirectrice , err);
         if err>0 then begin DirectriceOK:=False; Exit; end;
         Randomize;
         x:=random;
         y1:=F(ChaineDirectrice,x);
         y2:=F(ChaineDirectrice,x+1);
         y3:=F(ChaineDirectrice,x+2);
         if abs(y1-2*y2+y3)< 1E-10 // vrifie que la fonction est bien du premier degr en x, c--d  f(x+1)-f(x) est constante
         	then DirectriceOK:=True;
      end;
    l:=length(ChaineDirectrice);
    if copy (ChaineDirectrice,l-1,2)='=0' // quation cartsienne
    	then begin
      	Delete(ChaineDirectrice,l-1,2);  // suppression =0
      	NomVar:='X';
         NomPar:='Y';     // f(x,y) = ax+by+c
         ChaineDirectrice:=Traduction(ChaineDirectrice , err);
         if err>0 then begin DirectriceOK:=False; Exit; end;
         Randomize;
         a:=random;
         b:=random;       // on va calculer f(0,0), f(a,b) et f(2a,2b)
         uFonctions.p:=0;
         z1:=F(ChaineDirectrice,0);
         uFonctions.p:=b;
         z2:=F(ChaineDirectrice,a);
         uFonctions.p:=2*b;
         z3:=F(ChaineDirectrice,2*a);
         if abs(z1-2*z2+z3)< 1E-10 // vrifie que f(x,y) est du premier degr
         	then directriceOK:=True;
      end;
   if (pos ('(',ChaineDirectrice)>0) and (pos (')',ChaineDirectrice)>0)
   	then begin //si dfinie par deux points existants, comme(AB)
      if fmSchema.ExistePoint(ChaineDirectrice[2],x1,y1)
      	and fmSchema.ExistePoint(ChaineDirectrice[3],x2,y2)
         then DirectriceOK:=True ;
      end;
   if (pos ('=',ChaineDirectrice)=0) and (pos ('(',ChaineDirectrice)=0)
      then begin                // si nom d'une droite existante comme d, d1
      if fmSchema.ExisteDroite(ChaineDirectrice,x1,y1,x2,y2) then DirectriceOK:=True ;
      end;
   end;

   function ExcentriciteOK:boolean;
   var
   	exc :real;
   begin
   if ConstanteOK(edExcentricite.text)
   	then begin
      exc:=ValConstante(edExcentricite.text);
      if exc>0 then ExcentriciteOK:=True else ExcentriciteOK:=False;
      end else ExcentriciteOK:=False;
   end;

begin
lbApercu.Caption:='';
if i=0
	then begin
   if (edFoyer.text<>'') and (edDirectrice.text<>'') and (edExcentricite.text<>'')
   	then begin
      if FoyerOK and ExcentriciteOK and DirectriceOK
      	then definitionOK:=True else definitionOK:=False
      end else definitionOK:=False;
   end;
if i=1
	then begin
   if (edA.text<>'') and (edB.text<>'') and (edC.text<>'') and (edD.text<>'') and (edE.text<>'') and (edF.text<>'')
   	then begin
      if ConstanteOK(edA.text) and
      	ConstanteOK(edB.text) and
         ConstanteOK(edC.text) and
         ConstanteOK(edD.text) and
         ConstanteOK(edE.text) and
         ConstanteOK(edF.text)
       	then begin
         if (ValConstante(edA.Text)<>0) or
         	(ValConstante(edB.Text)<>0) or
            (ValConstante(edC.Text)<>0) // au moins l'un des trois doit tre non nul
         	then definitionOK:=True
            else definitionOK:=False; // A, B et C sont nuls tous les trois
         end else definitionOK:= False; // tous les contenus ne sont pas numriques
      end else definitionOK:=False; // tous les champs ne sont pas remplis
   end;
if definitionOK
	then begin
   btOK.Enabled:=True;
   lbApercu.Enabled:=True;
   lbApercu.Visible:=True;
   DessinerApercu;
   end else begin
   btOK.Enabled:=False;
   lbApercu.Enabled:=False;
   lbApercu.Visible:=False;
   lbExcentricite.Visible:=False;
   EffacerApercu;
   end;
end;


procedure TfmConique.edFoyerChange(Sender: TObject);
begin
VerifieDefinition(0);
end;

procedure TfmConique.edDirectriceChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(0);
end;

procedure TfmConique.edExcentriciteChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(0);
end;

procedure TfmConique.edAChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(1);
end;

procedure TfmConique.edBChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(1);
end;

procedure TfmConique.edCChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(1);
end;

procedure TfmConique.edDChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(1);
end;

procedure TfmConique.edEChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(1);
end;

procedure TfmConique.edFChange(Sender: TObject);
begin
if not blExemple then VerifieDefinition(1);
end;

procedure TfmConique.EffacerApercu;
var PetitDessin : TBitmap;
begin
PetitDessin:=TBitmap.Create;
PetitDessin.PixelFormat:=pf24bit;
Petitdessin.Width:=120;
Petitdessin.Height:=120;
ApercuConique.picture.bitmap.assign(PetitDessin);
PetitDessin.Free;
end;

procedure TfmConique.DessinerApercu;
var
	chaineConique                    : string;
   conique                          : TObjConique;
   a,b,c,d,e,f,delta,lambda,m       : real;
   Canevas                          : TCanvas;
   w,w2,w8                          : Integer;
   GrosDessin,PetitDessin           : TBitmap;


   Procedure TracerFonctionConique(i:integer);
   var
   	penwidth                                                      : integer;
   	x0,y0,x1,y1,x2,y2,x_,y_,DeltaX,Pas,nDerive,p,q,R,excentricite : real;
     	ok,ok1,ok2,ok3,ok4                                            : boolean;
      function pix(x:real):integer; //transforme abscisse en abscisse dessin
      begin
      	Result:=Round(w2+(x-x0)*R/p);
      end;
      function piy(y:real):integer; //transforme ordonne en ordonne dessin
      begin
      	Result:=Round(w2-(y-y0)*R/p);
      end;
     	function FC(x:real ; i:integer):real;  //fonction conique
     	begin
     	if i=1
     		then begin
         if (delta*x*x+2*(b*e-2*c*d)*x+e*e-4*c*f) >= 0
        		then begin
           	Result:=(-b*x-e+sqrt(delta*x*x+2*(b*e-2*c*d)*x+e*e-4*c*f))/(2*c);
           	ok:=True; // ok = la fonction est dfinie en x
           	end else ok:=False;
        	end;
     	if i=2
     		then begin
        	if delta*x*x+2*(b*e-2*c*d)*x+e*e-4*c*f>=0
        		then begin
           	Result:=(-b*x-e-sqrt(delta*x*x+2*(b*e-2*c*d)*x+e*e-4*c*f))/(2*c);
           	ok:=True;
           	end else ok:=False;
        	end;
     	if i=3
     		then begin
        		if b*x+e<>0
        		then begin
           	Result:=(-a*x*x-d*x-f)/(b*x+e);;
           	ok:=True;
           	end else ok:=False;
        	end;
     	if i=4
     		then begin
        	Result:=(-a*x*x-d*x-f)/e;
        	ok:=True;
        	end;
     	end;// fin fonction FC
   begin
   with canevas
   	do begin
      pen.Color:=clRed;
      penwidth:=pen.Width;
      pen.Width:=penwidth div 2;
   	Ellipse(w2-pen.width,w2-pen.width,w2+pen.width,w2+pen.width);// centre de la figure
   	if delta>1E-10   // si hyperbole
      	then begin
         p:=2*sqrt(abs(lambda))*sqrt(sqrt((a-c)*(a-c)+b*b))/delta; //distance centre-foyer
         R:=w div 6; // distance centre-foyer = 1/6 de la largeur du dessin
         x0:=(2*c*d-b*e)/delta; // dessin centr au centre de l'hyperbole
         y0:=(2*a*e-b*d)/delta;
         lbApercu.Caption:='Hyperbole';
         lbTracer.Visible:=True;
         cbFoyer.Visible:=True;
         cbDirectrice.Visible:=True;
         cbAxe.Visible:=True;
         cbSommet.Visible:=True;
         cbCentre.Visible:=True;
         cbAsymptote.Visible:=True;
         lbAfficher.Visible:=True;
         cbExcentricite.Visible:=True;
         cbMetriques.Visible:=True;
         cbEquations.Visible:=True;
         cbCoordonnees.Visible:=True;
         if b<>0
         	then begin  //axe focal
            excentricite:=sqrt(2*((c-a)*(c-a)+b*b-sign(lambda)*(c+a)*sqrt((c-a)*(c-a)+b*b))/delta);
         	m:=(c-a-sign(lambda)*sqrt((c-a)*(c-a)+b*b))/b;
         	moveto(0,Round(w2+m*w2));
         	lineto(w,Round(w2-m*w2));
            end else begin
            if lambda*c>0 //horizontal
            	then begin
               excentricite:=sqrt(1-a/c);
               moveto(0,w2);
               lineto(w,w2);
               end;
            if lambda*c<0 //vertical
            	then begin
               excentricite:=sqrt(1-c/a);
               moveto(w2,0);
               lineto(w2,w);
               end;
            end;
         lbExcentricite.Caption:='e='+FloatTostrF(excentricite,ffGeneral,6,1);
         if lbExcentricite.Caption='e=1,41421' then lbApercu.Caption:='Hyperbole quilatre';
         lbExcentricite.Visible:=True;
         end;
   	if delta<-1E-10   // si ellipse
        	then begin
         if lambda*a>0 //ellipse vraie
         	then begin
         	if ((b=0) and (c=a)) // si cercle
         		then begin
               excentricite:=0;
            	p:=sqrt(lambda/(4*a*a*a));
            	q:=sqrt(lambda/(4*a*a*a));
            	end else begin
            	if b<>0  //oblique
            		then begin
                  excentricite:=sqrt(2*((c-a)*(c-a)+b*b-sign(lambda)*(c+a)*sqrt((c-a)*(c-a)+b*b))/delta);
            		p:=sqrt(2*lambda*(a+c+sign(a)*sqrt((a-c)*(a-c)+b*b)))/abs(delta); //demi-grand axe
         			q:=sqrt(2*lambda*(a+c-sign(a)*sqrt((a-c)*(a-c)+b*b)))/abs(delta); //demi-petit axe
               	end else begin  //si b=0
               	if abs(c)>abs(a) //horizontale
               		then begin
                     excentricite:=sqrt(1-a/c);        
                  	p:=sqrt(lambda*c)/(2*a*c);
                  	q:=sqrt(lambda*a)/(2*a*c);
                  	end;
               	if abs(c)<abs(a)  //verticale
               		then begin
                     excentricite:=sqrt(1-c/a);
                 		p:=sqrt(lambda*a)/(2*a*c);
                  	q:=sqrt(lambda*c)/(2*a*c);
                  	end;
               	end;
            	end;
         	R:=Round((0.4-0.15*q/p)*w); // demi-grand axe plus grand pour les ellipses les plus aplaties
         	x0:=(2*c*d-b*e)/delta; // dessin centr au centre de l'ellipse
         	y0:=(2*a*e-b*d)/delta;
         	if ((b=0) and (c=a))
            	then begin
               lbApercu.Caption:='Cercle';
               lbTracer.Visible:=True;
               cbFoyer.Visible:=False;
         		cbDirectrice.Visible:=False;
         		cbAxe.Visible:=False;
         		cbSommet.Visible:=False;
         		cbCentre.Visible:=True;
         		cbAsymptote.Visible:=False;
               lbAfficher.Visible:=True;
               cbExcentricite.Visible:=False;
         		cbMetriques.Visible:=True;
         		cbEquations.Visible:=False;
         		cbCoordonnees.Visible:=True;
            	end else begin
            	lbApercu.Caption:='Ellipse';
               lbTracer.Visible:=True;
               cbFoyer.Visible:=True;
         		cbDirectrice.Visible:=True;
         		cbAxe.Visible:=True;
         		cbSommet.Visible:=True;
         		cbCentre.Visible:=True;
         		cbAsymptote.Visible:=False;
               lbAfficher.Visible:=True;
               cbExcentricite.Visible:=True;
         		cbMetriques.Visible:=True;
         		cbEquations.Visible:=True;
         		cbCoordonnees.Visible:=True;
         		if b<>0
         			then begin  //axe focal
         			m:=(c-a-sign(lambda)*sqrt((c-a)*(c-a)+b*b))/b;
         			moveto(0,Round(w2+m*w2));
         			lineto(w,Round(w2-m*w2));
            		end else begin
            		if abs(c)>abs(a) //horizontal
            			then begin
               		moveto(0,w2);
               		lineto(w,w2);
               		end;
            		if abs(c)<abs(a) //vertical
            			then begin
               		moveto(w2,0);
               		lineto(w2,w);
               		end;
            		end;
            	end;
         	lbExcentricite.Caption:='e='+FloatTostrF(excentricite,ffGeneral,6,1);
         	lbExcentricite.Visible:=True;
	         end else begin // ellipse dgnre
        		lbApercu.Caption:='Ensemble vide';
            lbTracer.Visible:=False;
            cbFoyer.Visible:=False;
            cbDirectrice.Visible:=False;
            cbAxe.Visible:=False;
            cbSommet.Visible:=False;
            cbCentre.Visible:=False;
            cbAsymptote.Visible:=False;
            lbAfficher.Visible:=False;
            cbExcentricite.Visible:=False;
            cbMetriques.Visible:=False;
            cbEquations.Visible:=False;
            cbCoordonnees.Visible:=False;
         	pen.Color:=clWhite;
         	Brush.Color:=clWhite;
   			Ellipse(0,0,w,w);// efface le point central
            lbExcentricite.Visible:=False;
         	end;
         end;
      if abs(delta) < 1E-10  //si parabole
      	then begin
         lbApercu.Caption:='Parabole';
         lbExcentricite.Caption:='e=1';
         lbExcentricite.Visible:=True;
         lbTracer.Visible:=True;
         cbFoyer.Visible:=True;
         cbDirectrice.Visible:=True;
         cbAxe.Visible:=True;
         cbSommet.Visible:=True;
         cbCentre.Visible:=False;
         cbAsymptote.Visible:=False;
         lbAfficher.Visible:=True;
         cbExcentricite.Visible:=True;
         cbMetriques.Visible:=True;
         cbEquations.Visible:=True;
         cbCoordonnees.Visible:=True;
         p:=0.5*sqrt(lambda/((c+a)*(c+a)*(c+a)));  // distance foyer-directrice
         R:= w div 6;  // distance foyer-directrice = 1/3 de la largeur du dessin
         if (a<>0) or(b<>0)
         	then begin
         	x0:=(b*e*e+4*a*e*d-b*d*d-4*a*f*b-4*f*b*c)/(4*(a+c)*(b*d-2*a*e)); // dessin centr au foyer de la parabole
         	y0:=(a*e*e+4*a*a*f+4*a*c*f-e*b*d-a*d*d)/(2*(a+c)*(b*d-2*a*e));
            end else begin  // si a=0 et b=0
            x0:=(e*e-d*d-4*c*f)/(4*c*d);
            y0:=-e/(2*c);
            end;
         if b<>0
         	then begin       // axe focal
         	m:=-2*a/b;
         	moveto(0,Round(w2+m*w2)); 
         	lineto(w,Round(w2-m*w2));
            end else begin
            if a<>0
            	then begin     // vertical
               moveto(w2,0);
               lineto(w2,w);
               end else begin // horizontal
               moveto(0,w2);
               lineto(w,w2);
               end;
            end;
         end;
      pen.Color:=clBlue;
      pen.Width:=penwidth;
      Xmin:=x0-w2*p/R;
      Xmax:=x0+w2*p/R;
      Ymin:=y0-w2*p/R;
      Ymax:=y0+w2*p/R;
     	DeltaX:=(XMax-XMin)/10000000;    //utilis pour calculer la drive
     	Pas:=p/R;          // distance entre 2 points successifs = 1 pixel
     	x1:=XMin;
     	y1:=FC(x1,i);
     	ok1:= ok and(y1>=YMin)and(y1<=YMax); //si fonction dfinie et rentre dans la fentre
     	Repeat
     		x_:=x1+DeltaX; // pour calculer la drive
        	y_:=FC(x_,i);
        	nDerive:=(y_-y1)/DeltaX; //nombre driv en x1 corrig en fonction du repre ...
        	ok4 := ok; //la fonction est aussi dfinie en x+DeltaX
        	if ok4 and ok1
        		then x2:=x1+pas*cos(arctan(nDerive))
           	else x2:=x1+pas;
        	if x2>XMax then x2:=XMax+DeltaX; //pour ne pas dborder  droite
        	y2:=FC(x2,i);
        	ok2:=ok and(y2>=YMin)and(y2<=YMax);
        	ok3:=abs(y2-y1)*R/p<20; // discontinuit si >=20 pixels d'cart entre deux points successifs
        	if ok1 and ok2 and ok3
        		then begin
           	Moveto(pix(x1),piy(y1));
           	Lineto(pix(x2),piy(y2));
           	end;
        	x1:=x2;y1:=y2;ok1:=ok2;
     		until x1>XMax;

     	x1:=XMax;  // la fonction est trace une deuxime fois dans l'autre sens, pour viter les coupures en cas de tangente verticale
     	y1:=FC(x1,i);
     	ok1:= ok and(y1>=YMin)and(y1<=YMax); //si fonction dfinie et rentre dans la fentre
     	Repeat
     		x_:=x1-DeltaX; // pour calculer la drive
        	y_:=FC(x_,i);
        	nDerive:=(y_-y1)/DeltaX; //nombre driv en x1 corrig en fonction du repre ...
       	 ok4 := ok; //la fonction est aussi dfinie en x+DeltaX
        	if ok4 and ok1
        		then x2:=x1-pas*cos(arctan(nDerive))
           	else x2:=x1-pas;
        	if x2<XMin then x2:=XMin-DeltaX; //pour ne pas dborder  droite
        	y2:=FC(x2,i);
        	ok2:=ok and(y2>=YMin)and(y2<=YMax);
        	ok3:=abs(y2-y1)*R/p<20; // discontinuit si >=20 pixels d'cart entre deux points successifs
        	if ok1 and ok2 and ok3
        		then begin
           	Moveto(pix(x1),piy(y1));
           	Lineto(pix(x2),piy(y2));
           	end;
        	x1:=x2;y1:=y2;ok1:=ok2;
     		until x1<XMin;
   	end; // fin with canevas
   end;    // fin TracerFonctionConique
begin
chaineConique:=fmSchema.ConstruitChaineConique;
conique:=fmSchema.DecomposeChaineConique(chaineConique);
a:=Conique.A;
b:=Conique.B;
c:=Conique.C;
d:=Conique.D;
e:=Conique.E;
f:=Conique.F;
delta:=b*b-4*a*c;
lambda:=a*e*e+c*d*d+f*b*b-b*d*e-4*a*c*f;
GrosDessin:=TBitmap.Create;
GrosDessin.PixelFormat:=pf24bit;
Grosdessin.Width:=480;
Grosdessin.Height:=480;
PetitDessin:=TBitmap.Create;
PetitDessin.PixelFormat:=pf24bit;
Petitdessin.Width:=120;
Petitdessin.Height:=120;
if blAnticrenelage
	then begin
   Canevas:=GrosDessin.Canvas;
   w:=480
   end else begin
   Canevas:=PetitDessin.Canvas;
   w:=120;
   end;
with Canevas do
	begin
   w2:=w div 2;
   w8:=w div 8;
   pen.width:=w div 60;
   pen.Color:=clBlue;
	if lambda=0//////////////////conique dgnre////////////////////////////
		then begin
      lbExcentricite.visible:=False;
      lbTracer.Visible:=False;
      cbFoyer.Visible:=False;
      cbDirectrice.Visible:=False;
      cbAxe.Visible:=False;
      cbSommet.Visible:=False;
      cbCentre.Visible:=False;
      cbAsymptote.Visible:=False;
      lbAfficher.Visible:=False;
      cbExcentricite.Visible:=False;
      cbMetriques.Visible:=False;
      cbEquations.Visible:=False;
      cbCoordonnees.Visible:=False;
   	if delta=0
   		then begin
      	if ((a<>0) and (d*d-4*a*f>=0))or((a=0) and(e*e-4*c*f>=0))
      		then begin  // deux droites parallles
         	if b<>0
         		then begin  // obliques
            	m:=-2*a/b;
            	if ((a<>0) and (d*d-4*a*f=0)) or((a=0) and (e*e-4*c*f=0))
            		then begin  // confondues
               	moveto(0,Round(w2+m*w2));
               	lineto(w,Round(w2-m*w2));
                  lbApercu.Caption:='Deux droites confondues'
               	end else begin  // disjointes
               	moveto(0,w2+Round(m*w2-w8*sqrt(1+m*m)));
               	lineto(w,w2+Round(-m*w2-w8*sqrt(1+m*m)));
               	moveto(0,w2+Round(m*w2+w8*sqrt(1+m*m)));
               	lineto(w,w2+Round(-m*w2+w8*sqrt(1+m*m)));
                  lbApercu.Caption:='Deux droites parallles';
               	end;
            	end;
         	if (b=0) and (a<>0)
         		then begin  //verticales
            	if ((a<>0) and (d*d-4*a*f=0)) or((a=0) and (e*e-4*c*f=0))
            		then begin  // confondues
               	moveto(w2,0);
               	lineto(w2,w);
                  lbApercu.Caption:='Deux droites confondues'
               	end else begin  // disjointes
               	moveto(w2-w8,0);
               	lineto(w2-w8,w);
               	moveto(w2+w8,0);
               	lineto(w2+w8,w);
                  lbApercu.Caption:='Deux droites parallles';
               	end;
            	end;
         	if (b=0) and (a=0)
         		then begin   // horizontales
            	if ((a<>0) and (d*d-4*a*f=0)) or((a=0) and (e*e-4*c*f=0))
            		then begin  // confondues
               	moveto(0,w2);
               	lineto(w,w2);
                  lbApercu.Caption:='Deux droites confondues'
               	end else begin  // disjointes
               	moveto(0,w2-w8);
               	lineto(w,w2-w8);
               	moveto(0,w2+w8);
               	lineto(w,w2+w8);
                  lbApercu.Caption:='Deux droites parallles';
               	end;
            	end;
         	end else lbApercu.Caption:='Ensemble vide';
      	end;
   	if delta>0   //deux droites scantes
   		then begin
      	if (a<>0) and (c<>0)
      		then begin  //obliques
         	m:=(-b-sqrt(delta))/(2*c);
         	moveto(0,w2+Round(m*w2));
         	lineto(w,w2-Round(m*w2));
         	m:=(-b+sqrt(delta))/(2*c);
         	moveto(0,w2+Round(m*w2));
         	lineto(w,w2-Round(m*w2));
         	end;
      	if (a<>0) and (c=0)
      		then begin  // l'une oblique, l'autre verticale
         	m:=-a/b;
         	moveto(0,w2+Round(m*w2));
         	lineto(w,w2-Round(m*w2));
         	moveto(w2,0);
         	lineto(w2,w);
         	end;
      	if (a=0) and (c<>0)
      		then begin  // l'une oblique, l'autre horizontale.
         	m:=-b/c;
         	moveto(0,w2+Round(m*w2));
         	lineto(w,w2-Round(m*w2));
         	moveto(0,w2);
         	lineto(w,w2)
         	end;
      	if (a=0) and (c=0)
      		then begin  // l'une verticale, l'autre horizontale
         	moveto(w2,0);
         	lineto(w2,w);
         	moveto(0,w2);
         	lineto(w,w2)
         	end;
         lbApercu.Caption:='Deux droites scantes'
      	end;
   	if delta<0   // un point
   		then begin
      	Ellipse(w2-pen.width div 2,w2-pen.width div 2,w2+pen.width div 2,w2+pen.width div 2);
         lbApercu.Caption:='Un point'
      	end;
   	end; //endif lambda = 0


   end; //fin Canevas

   if lambda<>0//////////////////////conique propre//////////////////////////
 	  	then begin
      if c<>0
    	   then begin
         TracerFonctionConique(1);   //arc suprieur
         TracerFonctionConique(2);   //arc infrieur
         end;
      if (c=0) and (b<>0) then TracerFonctionConique(3);  //hyperbole
      if (c=0) and (b=0) then TracerFonctionConique(4);  //parabole
     	end;

if blAntiCrenelage
	then begin
   fmdessin.FastAntiAliasPicture(GrosDessin,PetitDessin);
   end;
ApercuConique.picture.bitmap.assign(PetitDessin);
GrosDessin.Free;
PetitDessin.Free;
end;

procedure TfmConique.btExempleClick(Sender: TObject);
begin
blExemple:=True;
RgDefinition.ItemIndex:=1;
btExemple.Caption:='Exemple suivant';
//btExemple.Glyph.LoadFromResourceName(HInstance,'SUIVANT');
edA.text:=IntToStr(ListeExemples[Exemple,1]);
edB.text:=IntToStr(ListeExemples[Exemple,2]);
edC.text:=IntToStr(ListeExemples[Exemple,3]);
edD.text:=IntToStr(ListeExemples[Exemple,4]);
edE.text:=IntToStr(ListeExemples[Exemple,5]);
edF.text:=IntToStr(ListeExemples[Exemple,6]);
VerifieDefinition(1);
Exemple := Exemple - 1;
if Exemple=0 then Exemple := NbExemples;
blExemple:=False;
end;

procedure TfmConique.FormCreate(Sender: TObject);
begin
Exemple:=NbExemples;
end;

procedure TfmConique.btAleatoireClick(Sender: TObject);
var
	a,b,c,d,e,f,i   : integer;
   parabole        : boolean;
begin
blExemple:=True;
RgDefinition.ItemIndex:=1;
if int(random(10))<=1 // 10% de paraboles
	then parabole:=True else Parabole:=False;
if Parabole
	then begin
   b:=2*Round(random(5))-10; //b doit tre pair
   Repeat
   	a:=Round(random(20))-10;
   	c:=Round(random(20))-10;
      until b*b-4*a*c=0;
   end else begin
	a:=Round(random(20))-10;
	i:=0;
	Repeat
		inc(i);   //pour augmenter la proportion de B=0
		b:=Round(random(20))-10
   	until (b=0) or (i=5);
	c:=Round(random(20))-10;
   end;
if (a=0) and (b=0) and (c=0) // second degr obligatoirement
	then begin
   Repeat
		a:=Round(random(20))-10;
		b:=Round(random(20))-10;
		c:=Round(random(20))-10
		until (a<>0) or (b<>0) or (c<>0);
   end;
d:=Round(random(20))-10;
e:=Round(random(20))-10;
f:=Round(random(20))-10;
edA.Text:=intToStr(a);
edB.Text:=intToStr(b);
edC.Text:=intToStr(c);
edD.Text:=intToStr(d);
edE.Text:=intToStr(e);
edF.Text:=intToStr(f);
VerifieDefinition(1);
blExemple:=False;
end;

procedure TfmConique.FormShow(Sender: TObject);
begin
	Randomize;
   rgDefinitionClick(sender);
   btOK.Enabled:=False;
   btExemple.Caption:='Galerie d''exemples';
   btExemple.Glyph:=nil;
   blExemple:=False;
   VerifieDefinition(rgDefinition.ItemIndex);
end;


procedure TfmConique.btPlusClick(Sender: TObject);
begin
   if FileExists(CheminDepart+'\Discussion coniques.pdf') then
   begin
   ShellExecute( 0, Nil, PChar(CheminDepart+'\Discussion coniques.pdf'),Nil, Nil, SW_SHOWNORMAL );
   end
   else ShowMessage('Le fichier ''Discussion coniques.pdf'' est absent dans le rpertoire '+CheminDepart);
end;

end.
