unit uCourbesPolaires;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ColorGrd, ExtCtrls, ComCtrls, shellAPI;

type
  TfmListeCourbesPolaires = class(TForm)
    LabelExpressions: TLabel;
    LabelNoms: TLabel;
    Label2: TLabel;
    gbFormat: TGroupBox;
    rgStyle: TRadioGroup;
    Panel4: TPanel;
    Label1: TLabel;
    cgCouleur: TColorGrid;
    btnAutresOptions: TButton;
    btnAnnuler: TButton;
    btnOK: TButton;
    gbParametreT: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edTMin: TEdit;
    edTMax: TEdit;
    edNbT: TEdit;
    udNbT: TUpDown;
    Memo1: TMemo;
    Label6: TLabel;
    edEpaisseur: TEdit;
    Edit1: TEdit;
    udEpaisseur: TUpDown;
    btnAide: TButton;
    Apercu: TImage;
    procedure edCourbePolaireExit(Sender: TObject);
    procedure edCourbePolaireEnter(Sender: TObject);
    procedure edCourbePolaireKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnAnnulerClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure cgCouleurChange(Sender: TObject);
//  procedure rgEpaisseurClick(Sender: TObject);
    procedure rgStyleClick(Sender: TObject);
    procedure btnAutresOptionsClick(Sender: TObject);
    procedure edTMinExit(Sender: TObject);
    procedure edTMinKeyPress(Sender: TObject; var Key: Char);
    procedure edTMaxKeyPress(Sender: TObject; var Key: Char);
    procedure edTMaxExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
    procedure edNbTChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmListeCourbesPolaires: TfmListeCourbesPolaires;
  edCourbesPolaires : array[1..10] of TEdit;
  lbNomsFonctions : array[1..10] of TLabel;
  cbDessiner : array[1..10] of TCheckBox;

implementation
uses uDessin, ufonctions, uAutresOptions;
var CourbesPolairesBis : array[1..10] of TCourbesPolaires;
{$R *.DFM}

procedure TfmListeCourbesPolaires.edCourbePolaireExit(Sender: TObject);
var ch,chErreur : string;
    err : byte;
begin
   with Sender as TEdit do
   begin
      if Text<>'' then
      begin
         cbDessiner[tag].checked:=true;
         CourbesPolairesBis[tag].Expression:=Text;
      end;
      CourbesPolairesBis[tag].Expression:=Text;
   end;
end;

procedure TfmListeCourbesPolaires.edCourbePolaireEnter(Sender: TObject);
var i,num,den : integer;
    ch        : string;
begin
   if sender is TEdit then with (Sender as TEdit) do
   begin
      for i:=1 to 10 do
      begin
         edCourbesPolaires[i].color:=clWhite;
         lbNomsFonctions[i].font.style:=[];
      end;
      gbFormat.caption:='Format de la courbe de f'+inttostr(tag);
      if CourbesPolairesBis[tag].expression='' then
      begin  //format par dfaut pour les nouvelles courbes polaires
         cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(clFonctions);
         udEpaisseur.Position:=EpaisseurFonctions;
         rgStyle.ItemIndex:=ord(StyleFonctions);
         if DecomposeFraction(abs(TMin)/pi,num,den)or(den=1) then
         begin
            ch:=inttostr(num)+'pi/'+inttostr(den);
            if num=0 then ch:='0';
            if num=1 then delete(ch,1,1);
            if den=1 then delete(ch,length(ch)-1,2);
            if TMin<0 then ch:='-'+ch;
            edTMin.Text:=ch;
         end
         else edTMin.Text:=CourbesPolairesBis[tag].chTMin;
         if DecomposeFraction(abs(TMax)/pi,num,den)or(den=1) then
         begin
            ch:=inttostr(num)+'pi/'+inttostr(den);
            if num=0 then ch:='0';
            if num=1 then delete(ch,1,1);
            if den=1 then delete(ch,length(ch)-1,2);
            if TMax<0 then ch:='-'+ch;
            edTMax.Text:=ch;
         end
         else edTMax.Text:=CourbesPolairesBis[tag].chTMax;
         udNbt.Position:=nbt;
      end
      else
      begin
         cgCouleur.ForeGroundIndex:=cgCouleur.ColorToIndex(CourbesPolairesBis[Tag].Couleur);
         udEpaisseur.Position:=CourbesPolairesBis[Tag].Epaisseur;
         rgStyle.ItemIndex:=ord(CourbesPolairesBis[Tag].style);
         edTMin.Text:=CourbesPolairesBis[tag].chTMin;
         edTMax.Text:=CourbesPolairesBis[tag].chTMax;
         udNbt.Position:=CourbesPolairesBis[tag].nbt;
      end;
      gbParametreT.Caption:='Intervalle de variation de la variable t (Courbe polaire n '
                                        +inttostr(tag)+')';
      LbNomsFonctions[tag].font.style:=[fsBold];
      color:=$00AAFFFF;//clYellow;
   end;
end;

procedure TfmListeCourbesPolaires.edCourbePolaireKeyPress(Sender: TObject;
  var Key: Char);
begin
   if sender is TEdit then with (Sender as TEdit) do
      if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmListeCourbesPolaires.FormCreate(Sender: TObject);
var k   : byte;
    h   : integer;
begin
   h:=ClientHeight div 16;
   for k:=1 to 10 do
   begin
      edCourbesPolaires[k]:=TEdit.Create(self);
      edCourbesPolaires[k].parent:=fmListeCourbesPolaires;
      edCourbesPolaires[k].left:=60;
      edCourbesPolaires[k].top:=25+h*(k-1);
      edCourbesPolaires[k].width:=260;
      edCourbesPolaires[k].text:='';
      edCourbesPolaires[k].font.name:='Courier New';
      edCourbesPolaires[k].font.size:=10;
      edCourbesPolaires[k].font.color:=clBlack;
      edCourbesPolaires[k].tag:=k;
      edCourbesPolaires[k].TabOrder:=k-1;
      edCourbesPolaires[k].OnExit:=edCourbePolaireExit;
      edCourbesPolaires[k].OnEnter:=edCourbePolaireEnter;
      edCourbesPolaires[k].OnKeyPress:=edCourbePolaireKeyPress;
      cbDessiner[k]:=TCheckBox.Create(self);
      cbDessiner[k].parent:=fmListeCourbesPolaires;
      cbDessiner[k].caption:='';
      cbDessiner[k].left:=325;
      cbDessiner[k].top:=25+h*(k-1);
      cbDessiner[k].width:=20;
      cbDessiner[k].checked:=false;
      cbDessiner[k].tag:=k;
      cbDessiner[k].OnClick:=CheckBox1Click;
      LabelExpressions.left:=60;
      lbNomsFonctions[k]:=TLabel.Create(self);
      lbNomsFonctions[k].parent:=fmListeCourbesPolaires;
      lbNomsFonctions[k].left:=5;
      lbNomsFonctions[k].top:=28+h*(k-1);
      lbNomsFonctions[k].font.name:='Courier New';
      lbNomsFonctions[k].font.size:=10;
      lbNomsFonctions[k].font.color:=clBlack;
      lbNomsFonctions[k].caption:='f'+inttostr(k)+'(t)=';
      LabelNoms.left:=5;
   end;
end;

procedure TfmListeCourbesPolaires.CheckBox1Click(Sender: TObject);
begin
   if sender is TCheckBox then with (Sender as TCheckBox) do
   begin
      CourbesPolairesBis[tag].blDessiner:=checked;
   end;
end;

procedure TfmListeCourbesPolaires.FormShow(Sender: TObject);
var k : byte;
begin
   For k:=1 to 10 do
   begin // on effectue une copie des donnes avant de les modifier ventuellement
      CourbesPolairesBis[k]:=CourbesPolaires[k];
      edCourbesPolaires[k].text:=CourbesPolaires[k].expression;
      edCourbesPolaires[k].font.color:=CourbesPolaires[k].couleur;
      cbDessiner[k].checked:=CourbesPolaires[k].blDessiner;
   end;
   edCourbesPolaires[1].SetFocus;
end;

procedure TfmListeCourbesPolaires.btnAnnulerClick(Sender: TObject);
var k : byte;
begin
   for k:=1 to 10 do
   begin
      edCourbesPolaires[k].text:=CourbesPolaires[k].expression;
   end;
end;

procedure TfmListeCourbesPolaires.btnOKClick(Sender: TObject);
var k : byte;
begin
   for k:=1 to 10 do CourbesPolaires[k]:=CourbesPolairesBis[k];
end;

procedure TfmListeCourbesPolaires.cgCouleurChange(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   CourbesPolairesBis[k].Couleur:=cgCouleur.ForegroundColor;
   edCourbesPolaires[k].Font.Color:=CourbesPolairesBis[k].Couleur;
   edCourbesPolaires[k].Color:=$00AAFFFF;
end;

procedure TfmListeCourbesPolaires.rgStyleClick(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   CourbesPolairesBis[k].Style:=TStyleCourbe(rgStyle.ItemIndex);
   edCourbesPolaires[k].Color:=$00AAFFFF;
end;

procedure TfmListeCourbesPolaires.btnAutresOptionsClick(Sender: TObject);
var ch : string;
    k,i  : byte;
begin
   with fmAutresOptions do
   begin
      ch:=Copy(gbFormat.caption,25,2);
      k:=StrToInt(ch);
      Tag:=k;
      Caption:='Autres options de la courbe d''quation y=f'+ch+'(t)='+CourbesPolairesBis[k].Expression;

      {on transfre les variables de la courbe k  la fiche des autres options
       puis, si on appuie sur le bouton OK, on rcupre les nouvelles valeurs}

      cbVoirProgressionDessin.Checked:=CourbesPolairesBis[k].blVoirProgressionDessin;
      cbEnveloppe.checked:=CourbesPolairesBis[k].blEnveloppeTangentielle;
      cbDeveloppee.Checked:=CourbesPolairesBis[k].blDeveloppeeNormale;
      udVitesse.Position:=CourbesPolairesBis[k].Vitesse;
      for i:=1 to 10 do PointsParticuliers[i]:=CourbesPolairesBis[k].PointsParticuliers[i];
      if ShowModal=mrOK then
      begin
         CourbesPolairesBis[k].blVoirProgressionDessin:=cbVoirProgressionDessin.Checked;
         CourbesPolairesBis[k].blEnveloppeTangentielle:=cbEnveloppe.checked;
         CourbesPolairesBis[k].blDeveloppeeNormale:=cbDeveloppee.Checked;
         CourbesPolairesBis[k].vitesse:=udVitesse.Position;
         for i:=1 to 10 do CourbesPolairesBis[k].PointsParticuliers[i]:=PointsParticuliers[i];
      end;
      edCourbesPolaires[k].Color:=$00AAFFFF;
   end;
end;

procedure TfmListeCourbesPolaires.edTMinExit(Sender: TObject);
var ch  : string;
    err : byte;
    k   : integer;
begin
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=strtoint(ch);
   NomVar:='X';
   ch:=Traduction(edTMin.text,err);
   if (err>0)or(pos('X',ch)>0) then
   begin
      ShowMessage('La constante '+edTMin.Text+' n''est pas correcte');
      //on remet la valeur initiale de TMin
      edTMin.Text:=CourbesPolairesBis[k].chTMin;
   end;
   CourbesPolairesBis[k].chTMin:=edTMin.Text;
end;

procedure TfmListeCourbesPolaires.edTMinKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmListeCourbesPolaires.edTMaxKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmListeCourbesPolaires.edTMaxExit(Sender: TObject);
var ch  : string;
    err : byte;
    k   : integer;
begin
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=strtoint(ch);
   NomVar:='X';
   ch:=Traduction(edTMax.text,err);
   if (err>0)or(pos('X',ch)>0) then
   begin
      ShowMessage('La constante '+edTMax.Text+' n''est pas correcte');
      //on remet la valeur initiale de TMax
      edTMin.Text:=CourbesPolairesBis[k].chTMax;
   end;
   CourbesPolairesBis[k].chTMax:=edTMax.Text;
end;

procedure TfmListeCourbesPolaires.FormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmListeCourbesPolaires.Edit1Change(Sender: TObject);
var ch : string;
    k  : byte;
begin
   edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
	Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,cgCouleur.ForegroundColor));
   ch:=Copy(gbFormat.caption,25,2);
   if ch<>''
   then begin
   	k:=StrToInt(ch);
   	CourbesPolairesBis[k].Epaisseur:=udEpaisseur.Position;
   	edCourbesPolaires[k].Color:=$00AAFFFF;
   end;
end;

procedure TfmListeCourbesPolaires.edNbTChange(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,25,2);
   if ch<>''
   then begin
   	k:=StrToInt(ch);
   	CourbesPolairesBis[k].NbT:=udNbT.Position;
   end;
end;


procedure TfmListeCourbesPolaires.btnAideClick(Sender: TObject);
begin
   Aide(21);
end;

end.
