unit uDroites;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ColorGrd, ExtCtrls, ComCtrls, shellAPI;

type
  TfmDroites = class(TForm)
    labelNoms: TLabel;
    LabelExpressions: TLabel;
    gbFormat: TGroupBox;
    rgStyle: TRadioGroup;
    Panel4: TPanel;
    Label1: TLabel;
    cgCouleur: TColorGrid;
    btOK: TButton;
    btAnnuler: TButton;
    Memo1: TMemo;
    Label6: TLabel;
    edEpaisseur: TEdit;
    Edit1: TEdit;
    udEpaisseur: TUpDown;
    btnAide: TButton;
    Apercu: TImage;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel5: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure edDroiteExit(Sender : TObject);
    procedure edDroiteEnter(Sender : TObject);
    procedure btOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cgCouleurChange(Sender: TObject);
//    procedure rgEpaisseurClick(Sender: TObject);
    procedure rgStyleClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure edDroiteKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmDroites: TfmDroites;
  edDroites : array[1..10] of TEdit;
  lbNomsDroites : array[1..10] of TLabel;
  cbDessiner : array[1..10] of TCheckBox;
  cbEquation : array[1..10] of TCheckBox;

implementation

uses uDessin,uFonctions;
var DroitesBis : array[1..10] of TDroites;
{$R *.DFM}

procedure TfmDroites.FormCreate(Sender: TObject);
var k : byte;
    h : integer;
begin
   h:=(ClientHeight-memo1.Height) div 12;
   for k:=1 to 10 do
   begin
      edDroites[k]:=TEdit.Create(self);
      edDroites[k].parent:=fmDroites;
      edDroites[k].left:=60;
      edDroites[k].top:=45+h*(k-1);
      edDroites[k].width:=260;
      edDroites[k].text:='';
      edDroites[k].font.name:='Courier New';
      edDroites[k].font.size:=10;
      edDroites[k].font.color:=clBlack;
      edDroites[k].tag:=k;
      edDroites[k].TabOrder:=k-1;
      edDroites[k].OnExit:=edDroiteExit;
      edDroites[k].OnEnter:=edDroiteEnter;
      edDroites[k].OnKeyPress:=edDroiteKeyPress;
      cbDessiner[k]:=TCheckBox.Create(self);
      cbDessiner[k].parent:=fmDroites;
      cbDessiner[k].caption:='';
      cbDessiner[k].left:=325;
      cbDessiner[k].top:=45+h*(k-1);
      cbDessiner[k].width:=20;
      cbDessiner[k].checked:=false;
      cbDessiner[k].tag:=k;
      cbDessiner[k].OnClick:=CheckBox1Click;
      cbEquation[k]:=TCheckBox.Create(self);
      cbEquation[k].parent:=fmDroites;
      cbEquation[k].caption:='';
      cbEquation[k].left:=355;
      cbEquation[k].top:=45+h*(k-1);
      cbEquation[k].width:=20;
      cbEquation[k].checked:=false;
      cbEquation[k].tag:=k;
      cbEquation[k].OnClick:=CheckBox2Click;
      LabelExpressions.left:=60;
      lbNomsDroites[k]:=TLabel.Create(self);
      lbNomsDroites[k].parent:=fmDroites;
      lbNomsDroites[k].left:=5;
      lbNomsDroites[k].top:=48+h*(k-1);
      lbNomsDroites[k].font.name:='Courier New';
      lbNomsDroites[k].font.size:=10;
      lbNomsDroites[k].font.color:=clBlack;
      lbNomsDroites[k].caption:='D'+inttostr(k)+' : ';
      LabelNoms.left:=5;
   end;
end;

procedure TfmDroites.edDroiteEnter(Sender : TObject);
var k : integer;
begin
   if sender is TEdit then with (Sender as TEdit) do
   begin
      for k:=1 to 10 do
      begin
         edDroites[k].color:=clWhite;
         lbNomsDroites[k].font.style:=[];
      end;
      gbFormat.caption:='Format de la droite D'+inttostr(tag);
      if Droites[tag].expression='' then
      begin                          //valeurs prfrentielles pour les nouvelles droites
         cgCouleur.ForeGroundIndex:=cgCouleur.ColorToIndex(clDroites);
         udEpaisseur.Position:=EpaisseurDroites;
         rgStyle.ItemIndex:=ord(StyleDroites);
      end
      else
      begin
         cgCouleur.ForeGroundIndex:=cgCouleur.ColorToIndex(Droites[Tag].Couleur);
         udEpaisseur.Position:=DroitesBis[Tag].Epaisseur;
         rgStyle.ItemIndex:=ord(DroitesBis[Tag].style);
      end;
      color:=$00aaffff;
      lbNomsDroites[tag].font.style:=[fsBold];
   end;
end;

function TraduirechDroite(ch:string;var chMessageErreur:string):TDroites;
var Droite : TDroites;
    chCoef_a,chCoef_b,chD : string;
    err               : byte;
begin
   chMessageErreur:='';
   with Droite do
   begin
      if ch='' then exit;
      Expression:=ch;
      style:=scContinu;
      epaisseur:=1;
      couleur:=clBlack;
      while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1); //suppression de tous les espaces
      if ch='' then exit;
      while pos('.',ch)>0
      	do ch:=Copy(ch,1,pos('.',ch)-1)+','+copy(ch,pos('.',ch)+1,length(ch)-pos('.',ch));
      if pos('x=',ch)>0 then with droite do
      begin
         TypeDroite:=tdVerticale;
         chCoef_a:=Copy(ch,3,length(ch)-2);
         if chCoef_a[1]='+' then delete(chCoef_a,1,1);
         NomVar:='X';
         if pos(NomVar,chCoef_a)>0 then chMessageErreur:='Erreur dans l''quation de la droite';
         chCoef_a:=Traduction(chCoef_a,err);
         if err=0 then Coef_a:=F(chCoef_a,1);
         if (err>0)or not ok then chMessageErreur:='Erreur dans la constante a';
      end;
      if pos('y=',ch)>0 then with droite do
      begin
         if pos('x',ch)>0 then
         begin
            TypeDroite:=tdOblique;
            NomVar:='X';
            chD:=Copy(ch,3,length(ch)-2);
            chD:=Traduction(chD,err);
            Coef_a:=(F(chD,1)-F(chD,0));
            Coef_b:=F(chD,0);
            chCoef_a:=FloatToStr(Coef_a);
            chCoef_b:=FloatToStr(Coef_b);

            NomVar:='X';
            chCoef_a:=Traduction(chCoef_a,err);
            if err=0 then Coef_a:=F(chCoef_a,1);
            if (err>0)or not ok then chMessageErreur:='Erreur dans la constante a';
            if chCoef_b[1]='+' then delete(chCoef_b,1,1);
            chCoef_b:=Traduction(chCoef_b,err);
            if err=0 then Coef_b:=F(chCoef_b,1);
            if (err>0)or not ok then chMessageErreur:='Erreur dans la constante b';
         end
         else
         begin
            TypeDroite:=tdHorizontale;
            chCoef_a:=Copy(ch,3,length(ch)-2);
            if chCoef_a[1]='+' then delete(chCoef_a,1,1);
            NomVar:='X';
            chCoef_a:=Traduction(chCoef_a,err);
            if err=0 then Coef_a:=F(chCoef_a,1);
            if (err>0)or not ok then chMessageErreur:='Erreur dans la constante a';
         end;
      end;
   end;
   TraduirechDroite:=Droite;
end;
procedure TfmDroites.edDroiteExit(Sender : TObject);
var Droite : TDroites;
    chMessageErreur : string;
begin
   with (Sender as TEdit) do
   begin
      Droite:=TraduirechDroite(text,chMessageErreur);
      if chMessageErreur<>'' then ShowMessage(chMessageErreur)
      else if text<>'' then cbDessiner[tag].checked:=true;
      DroitesBis[tag].blDessiner:=cbDessiner[tag].checked;
      DroitesBis[tag].blEquation:=cbEquation[tag].checked;
   end;
end;

procedure TfmDroites.btOKClick(Sender: TObject);
var k : byte;
    chMessageErreur : string;
begin
   chMessageErreur:='';
   for k:=1 to 10 do
      if edDroites[k].text<>'' then
      begin
         Droites[k]:=TraduirechDroite(edDroites[k].text,chMessageErreur);
         Droites[k].Couleur:=DroitesBis[k].couleur;
         Droites[k].epaisseur:=DroitesBis[k].epaisseur;
         Droites[k].style:=DroitesBis[k].style;
         Droites[k].blDessiner:=DroitesBis[k].blDessiner;
         Droites[k].blEquation:=DroitesBis[k].blEquation;
      end
      else
      begin
         Droites[k].Expression:='';
      end;
end;

procedure TfmDroites.FormShow(Sender: TObject);
var k : byte;
begin
   for k:=1 to 10 do
   begin
      DroitesBis[k]:=Droites[k];
      edDroites[k].Text:=DroitesBis[k].Expression;
      edDroites[k].Font.Color:=DroitesBis[k].Couleur;
      cbDessiner[k].checked:=DroitesBis[k].blDessiner;
      cbEquation[k].checked:=DroitesBis[k].blEquation;
   end;
   edDroites[1].SetFocus;
end;

procedure TfmDroites.cgCouleurChange(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,22,2);
   k:=StrToInt(ch);
   DroitesBis[k].Couleur:=cgCouleur.ForegroundColor;
   edDroites[k].Font.Color:=DroitesBis[k].Couleur;
end;
{
procedure TfmDroites.rgEpaisseurClick(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,22,2);
   k:=StrToInt(ch);
   DroitesBis[k].epaisseur:=rgEpaisseur.ItemIndex+1;
end;
}
procedure TfmDroites.rgStyleClick(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,22,2);
   k:=StrToInt(ch);
   DroitesBis[k].Style:=TStyleCourbe(rgStyle.ItemIndex);
end;

procedure TfmDroites.CheckBox1Click(Sender: TObject);
begin
   if sender is TCheckBox then with (Sender as TCheckBox) do
   begin
      DroitesBis[tag].blDessiner:=checked;
   end;
end;

procedure TfmDroites.edDroiteKeyPress(Sender: TObject; var Key: Char);
begin
   if sender is TEdit then with (Sender as TEdit) do
      if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmDroites.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmDroites.Edit1Change(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,22,2);
   if ch<>''
   	then begin
   	k:=StrToInt(ch);
   	DroitesBis[k].epaisseur:=udEpaisseur.Position;
      end;
	edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
	Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,cgCouleur.ForegroundColor));
end;

procedure TfmDroites.btnAideClick(Sender: TObject);
begin
	Aide(25);
end;

procedure TfmDroites.CheckBox2Click(Sender: TObject);
begin
 if sender is TCheckBox then with (Sender as TCheckBox) do
   begin
      DroitesBis[tag].blEquation:=checked;
   end;
end;

end.
