unit uEllipse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, shellAPI, ComCtrls;

type
  TfmEllipse = class(TForm)
    rgDefinition: TRadioGroup;
    Panel1: TPanel;
    Label1: TLabel;
    edCentre: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    edAxeHorizontal: TEdit;
    edAxeVertical: TEdit;
    Panel2: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    edSommet1: TEdit;
    edSommet2: TEdit;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    ColorGrid1: TColorGrid;
    ColorGrid2: TColorGrid;
    btAnnuler: TButton;
    btOK: TButton;
    btnAide: TButton;
    Panel6: TPanel;
    Panel7: TPanel;
    GroupBox1: TGroupBox;
    Apercu: TImage;
    edEpaisseur: TEdit;
    udEpaisseur: TUpDown;
    procedure rgDefinitionClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edCentreExit(Sender: TObject);
    procedure edSommet1Exit(Sender: TObject);
    procedure edSommet2Exit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
    procedure edEpaisseurChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmEllipse: TfmEllipse;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmEllipse.rgDefinitionClick(Sender: TObject);
var k : integer;
begin
   for k:=0 to ComponentCount-1 do
   begin
      if Components[k] is TLabel then (Components[k] as TLabel).Enabled:=false;
      if Components[k] is TEdit and not(Components[k].Name='edEpaisseur') then
      begin
         (Components[k] as TEdit).color:=clBtnFace;
         (Components[k] as TEdit).Enabled:=false;
      end;
   end;
   Label6.Enabled:=true;Label7.Enabled:=true;
   case rgDefinition.ItemIndex of
      0 : begin
             edCentre.Enabled:=true;
             edCentre.Color:=clWindow;
             edAxeHorizontal.Enabled:=true;
             edAxeHorizontal.Color:=clWindow;
             edAxeVertical.Enabled:=true;
             edAxeVertical.Color:=clWindow;
             Label1.Enabled:=true;
             Label2.Enabled:=true;
             Label3.Enabled:=true;
             if Self.visible then edCentre.SetFocus;
          end;
      1 : begin
             edSommet1.Enabled:=true;
             edSommet1.Color:=clWindow;
             edSommet2.Enabled:=true;
             edSommet2.Color:=clWindow;
             Label4.Enabled:=true;
             Label5.Enabled:=true;
             if Self.visible then edSommet1.SetFocus;
          end;
   end;
end;

procedure TfmEllipse.FormActivate(Sender: TObject);
begin
   rgDefinitionClick(sender);
end;
function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmEllipse.edCentreExit(Sender: TObject);
begin
   edCentre.Text:=SansEspace(edCentre.Text);
end;

procedure TfmEllipse.edSommet1Exit(Sender: TObject);
begin
   edSommet1.Text:=SansEspace(edSommet1.Text);
end;

procedure TfmEllipse.edSommet2Exit(Sender: TObject);
begin
   edSommet2.Text:=SansEspace(edSommet2.Text);
end;

procedure TfmEllipse.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmEllipse.btnAideClick(Sender: TObject);
begin
   Aide(33);
end;


procedure TfmEllipse.edEpaisseurChange(Sender: TObject);
begin
  edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
  Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,ColorGrid1.ForeGroundColor));
end;

end.
