unit uEquation;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ColorGrd, shellAPI;

type
  TfmEquation = class(TForm)
    edMembreGauche: TEdit;
    Label1: TLabel;
    edMembreDroite: TEdit;
    MemoExemples: TMemo;
    Label2: TLabel;
    lbSolutions: TListBox;
    btOK: TButton;
    btAnnuler: TButton;
    btCalcul: TButton;
    edPrecision: TEdit;
    udPrecision: TUpDown;
    Label3: TLabel;
    gbIntervalle: TGroupBox;
    edInf: TEdit;
    edSup: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    cbLignesCote: TCheckBox;
    cgCouleur: TColorGrid;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    rbPoint: TRadioButton;
    rbPlus: TRadioButton;
    rbCroix: TRadioButton;
    rbEtoile: TRadioButton;
    rbCarre: TRadioButton;
    rbLosange: TRadioButton;
    rbAucuneMarque: TRadioButton;
    rgTaille: TRadioGroup;
    btEffacer: TButton;
    btnAide: TButton;
    Image1: TImage;
    rbRond: TRadioButton;
    rbCarre2: TRadioButton;
    rbLosange2: TRadioButton;
    procedure btCalculClick(Sender: TObject);
    procedure udPrecisionClick(Sender: TObject; Button: TUDBtnType);
    procedure btOKClick(Sender: TObject);
    procedure btEffacerClick(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmEquation: TfmEquation;

implementation
uses uDessin,ufonctions;
{$R *.DFM}

procedure TfmEquation.btCalculClick(Sender: TObject);
var DeltaX,x,a,b,y1,y2,precision,borneSup,BorneInf : real;
    chEquation   : string;
    erreur,n     : byte;
    ok1,ok2      : boolean;
begin
   if edInf.text='' then BorneInf:=XMin else BorneInf:=f(edInf.text,1);
   if edSup.text='' then BorneSup:=XMax else BorneSup:=f(edSup.text,1);
   DeltaX:=(BorneSup-BorneInf)/1000;
   chEquation:=Traduction(edMembreGauche.text+'-('+edMembreDroite.text+')',erreur);
   lbSolutions.Items.Clear;
   x:=BorneInf;n:=udPrecision.Position;
   precision:=f('10^(-'+edPrecision.text+')',1);
   try
   if erreur=0 then
   repeat
      repeat
         y1:=f(chEquation,x);ok1:=ok;
         y2:=f(chEquation,x+DeltaX);ok2:=ok;
         x:=x+DeltaX;
      until (ok1 and ok2 and (y1*y2<=0))or (x>BorneSup);
      x:=x-DeltaX;
      if (ok1 and ok2 and (y1*y2<=0)) then
      begin
         if y1=0 then
         begin
            lbSolutions.Items.Add(FloatToStrf(x,ffFixed,n,udPrecision.position));
         end
         else
         begin
            a:=x;b:=x+DeltaX;
            while (b-a)>precision do
            begin
               y1:=f(chEquation,a);
               y2:=f(chEquation,(a+b)/2);
               if y1*y2>=0 then a:=(a+b)/2
                           else b:=(a+b)/2;
            end;
            if abs(y1-y2)<Uy/10
            //si la distance entre y1 et y2 est suprieure  Uy/10, il s'agit certainement d'une discontinuit
            then lbSolutions.Items.Add(FloatToStrf(a,ffFixed,n,udPrecision.position));
         end;
      end;
      x:=x+DeltaX;
   until x>BorneSup;
   except
      ShowMessage('Erreur dans les calculs.'+chr(13)+'L''quation est peut-tre mal dfinie...');
   end;
end;

procedure TfmEquation.udPrecisionClick(Sender: TObject;
  Button: TUDBtnType);
begin
   btCalculClick(sender);
end;

procedure TfmEquation.btOKClick(Sender: TObject);
begin
   btCalculClick(sender);
end;

procedure TfmEquation.btEffacerClick(Sender: TObject);
begin
   lbSolutions.Clear;
   edMembreGauche.Text:='';
   edMembreDroite.Text:='';
end;

procedure TfmEquation.btnAideClick(Sender: TObject);
begin
   Aide(93);
end;

end.
