unit uFamille;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ColorGrd, ExtCtrls, ComCtrls, shellAPI;

type
  TfmFamille = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    edFp: TEdit;
    gbIntervalleP: TGroupBox;
    edPMin: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edPMax: TEdit;
    edDeltaP: TEdit;
    gbOptions: TGroupBox;
    cbVoirProgression: TCheckBox;
    cbVoirProgressionDetaillee: TCheckBox;
    cbAfficherValeursP: TCheckBox;
    gbFormat: TGroupBox;
    rgStyle: TRadioGroup;
    Panel4: TPanel;
    Label6: TLabel;
    cgCouleur: TColorGrid;
    btOK: TButton;
    btAnnuler: TButton;
    Label7: TLabel;
    Label8: TLabel;
    edAbscisseAffichageP: TEdit;
    cbPositionAffichageP: TComboBox;
    cbCouleursMultiples: TCheckBox;
    Label9: TLabel;
    edVitesse: TEdit;
    udVitesse: TUpDown;
    Label10: TLabel;
    edEpaisseur: TEdit;
    Edit1: TEdit;
    udEpaisseur: TUpDown;
    btnAide: TButton;
    Apercu: TImage;
    procedure cbAfficherValeursPClick(Sender: TObject);
    procedure edPMinExit(Sender: TObject);
    procedure edPMaxExit(Sender: TObject);
    procedure edDeltaPExit(Sender: TObject);
    procedure edDeltaPKeyPress(Sender: TObject; var Key: Char);
    procedure edPMinKeyPress(Sender: TObject; var Key: Char);
    procedure edPMaxKeyPress(Sender: TObject; var Key: Char);
    procedure cbVoirProgressionClick(Sender: TObject);
    procedure cbVoirProgressionDetailleeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmFamille: TfmFamille;

implementation
uses uDessin,uFonctions;

{$R *.DFM}

procedure TfmFamille.cbAfficherValeursPClick(Sender: TObject);
begin
   label7.Enabled:=cbAfficherValeursP.Checked;
   label8.Enabled:=cbAfficherValeursP.Checked;
   edAbscisseAffichageP.Enabled:=cbAfficherValeursP.Checked;
   cbPositionAffichageP.Enabled:=cbAfficherValeursP.Checked;
end;

procedure TfmFamille.edPMinExit(Sender: TObject);
var ch,ch1 : string;
    err  : byte;
    x   : real;
begin
   ch:=edPMin.text;
   ch1:=ch;
   edPMin.Text:=ch;
   NomVar:='X';
   ch:=traduction(ch,err);
   x:=f(ch,1);
   if (err>0)or(Pos('X',ch)>0)or not ok then
   begin
      ShowMessage('La constante '+ch1+' est incorrecte.');
      edPMin.text:=ch1;
   end
   else
   begin
      Famille.PMin:=x;
      Famille.chPMin:=ch1;
   end;
end;

procedure TfmFamille.edPMaxExit(Sender: TObject);
var ch,ch1 : string;
    err  : byte;
    x   : real;
begin
   ch:=edPMax.text;
   ch1:=ch;
   edPMax.Text:=ch;
   NomVar:='X';
   ch:=traduction(ch,err);
   x:=f(ch,1);
   if (err>0)or(Pos('X',ch)>0)or not ok then
   begin
      ShowMessage('La constante '+ch1+' est incorrecte.');
      edPMax.text:=ch1;
   end
   else
   begin
      Famille.PMax:=x;
      Famille.chPMax:=ch1;
   end;
end;

procedure TfmFamille.edDeltaPExit(Sender: TObject);
var ch,ch1 : string;
    err : byte;
    x   : real;
begin
   ch:=edDeltaP.text;
   NomVar:='X';ok:=true;
   ch:=traduction(ch,err);
   x:=f(ch,1);
   if (err>0)or(Pos('X',ch)>0)or not ok then
   begin
      ShowMessage('La constante '+ch1+' est incorrecte.');
      edDeltaP.text:=ch1;
   end
   else
   begin
      Famille.DeltaP:=x;
      Famille.chDeltaP:=ch1;
   end;
end;

procedure TfmFamille.edDeltaPKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.') or (key=',') then key:=DecimalSeparator;
end;

procedure TfmFamille.edPMinKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmFamille.edPMaxKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmFamille.cbVoirProgressionClick(Sender: TObject);
begin
   udVitesse.Enabled:=cbVoirProgression.Checked;
   edVitesse.Enabled:=cbVoirProgression.Checked;
end;

procedure TfmFamille.cbVoirProgressionDetailleeClick(Sender: TObject);
begin
   udVitesse.Enabled:=cbVoirProgressionDetaillee.Checked;
   edVitesse.Enabled:=cbVoirProgressionDetaillee.Checked;
end;

procedure TfmFamille.FormShow(Sender: TObject);
begin
   udVitesse.Enabled:=cbVoirProgression.Checked;
   edVitesse.Enabled:=cbVoirProgression.Checked;
end;

procedure TfmFamille.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmFamille.Edit1Change(Sender: TObject);
begin
   edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
	Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,cgCouleur.ForegroundColor));

end;

procedure TfmFamille.btnAideClick(Sender: TObject);
begin
	Aide(26);
end;

end.
