unit uFonctions;
{ Unit utilise par le traceur de courbes "Sine qua none".
  Projet ralis pendant l't 2001.
  Cette unit met  disposition essentiellement 2 fonctions :
  - la fonction "Traduction" qui transforme une chane de caractres reprsentant
       une expression fonctionnelle avec une syntaxe habituelle en une chane plus
       compacte o les espaces ont t supprims, les noms des fonctions remplacs
       par des noms  un seul caractre, les parenthses ajoutes de faon  tenir
       compte des priorits dans les oprations.
  - la fonction "F" qui value, pour une expression et une valeur donnes, le rsultat
       numrique du calcul. L'expression (chane de caractres) doit avoir t
       pralablement fournie par la fonction "Traduction".

  La syntaxe des expressions acceptes reprend la syntaxe des calculatrices
  avec les particularits suivantes :
    - les donnes peuvent tre indifremment en majuscules ou en minuscules
    - le nombre pi est not "pi" (ou "PI" ou "Pi" ...)
    - le nombre e est reconnu, mais il est prfrable d'utiliser exp(x) plutt que e^x,
      car le compilateur traduit e par exp(1).
    - la fonction "carr" peut tre soit note "carr", soit indique avec l'exposant 
       par exemple, pour le carr de x, on notera soit "Carr(x)" soit "x"
    - on peut mettre autant d'espaces que l'on veut pour arer l'criture
    - on peut prciser un intervalle de dfinition, par exemple,
      si la fonction est dfinie sur ]5, +infini[, il suffira de multiplier par "(x>5)",
      si elle est dfinie sur [3, 7[, on mettra "(x>=3)(x<7)"
    - les oprateurs reconnus sont +, -, *, /, ^, <, >, <=, >=
    - les fonctions reconnues sont abs, arccos, arcsin, arctan, argch, argsh, argth,
      carr (ou carre), cos, ch, exp, frac, int, ln, log, racine, sh, sin, tan et th
    - l'oprateur * peut tre sous-entendu comme par exemple dans "3x + 4"
    - le signe moins unaire et le signe moins binaire sont tous deux nots "-"
    - si l'argument d'une fonction est simple, les parenthses peuvent tre omises,
      par exemple on peut crire indiffremment "sin(x)" ou "sin x" ou mme "sinx".
      On entend par "argument simple" soit la variable x ou t, soit une constante.
    - le sparateur dcimal est toujours le point et jamais la virgule.
    - les rgles de priorits sont, dans l'ordre :
       les expressions entre parenthses
       les multiplications implicites (sous entendues), sauf si l'oprateur qui
       suit est une exponentiation.
          par exemple 3x+4 est traduit par (3*x)+4    (priorit  la multiplication implicite)
                      3x^4 est traduit par 3*(x^4)    (priorit  l'exponentiation)
                      sin 2x est traduit par sin(2*x)
                      sin 2x + pi est traduit par sin(2*x)+pi
                      3sin2x est traduit par 3*sin(2*x)
                      3sin2x+4 est traduit par (3*sin(2*x))+4
       les fonctions usuelles ou dfinies par l'utilisateur
       le signe moins unaire
       l'oprateur d'exponentiation "^"
       les oprateurs de multiplication et division *, /
       les oprateurs d'addition et de soustraction +, -
       les oprateurs relationnels <, >, <=, >=
    - il est possible de composer les fonctions. L'utilisateur a  sa disposition
      10 fonctions qu'il peut dfinir : f1, f2, ... f10. Il peut dfinir une fonction
      en faisant appel  une fonction pralablement dfinie, par exemple :
        f5(x) = "f1(x) + 3f2(x)"    (combinaisons de fonctions)
        f5(x) = "f4(f2(x))"     (ou "f4f2(x)" ou "f4f2(x)")   (composition f4f2)
         ce sujet, l'oprateur de composition des fonctions peut indifremment
          tre  (degr) ou o (lettre o minuscule ou majuscule), MAIS PAS le chiffre 0}


INTERFACE
uses dialogs,sysutils,math;

Var NomVar : AnsiChar;     // Nom de la variable, gnralement x ou t
    NomPar : AnsiChar;     // utilis pour la famille paramtre de fonctions
    p      : real;     // valeur du paramtre
    ok     : boolean;  // variable globale qui contrle la validit d'un calcul
    f1,f2,f3,f4,f5,f6,f7,f8,f9,f10 : AnsiString; // fonctions dfinies par l'utilisateur

    { f1  f10 : 10 fonctions dfinies par l'utilisateur. Les oprations sur les
      fonctions f1  f10 sont permises  condition qu'il n'y ait pas de rfrence
      circulaire (fonction dfinie directement ou indirectement  l'aide d'elle mme).
      Toute fonction fn, dont la dfinition contient fp, doit tre dfinie APRS fp,
      sinon on aura une rfrence circulaire impossible  rsoudre. Concrtement,
      les fonctions tant traduites dans l'ordre f1  f10, la fonction f5 pourra faire
      appel  la fonction f1 ou f4, mais pas  la fonction f5 ou f6 ou f10...}

Function TypeElement(chaine:AnsiString;position:integer):integer;
Function Traduction(chaine:AnsiString;var erreur : byte):AnsiString;
Function F(chaine:AnsiString;x:real):real;
Function ValConstante(chaine:AnsiString):real;
Function ExtraitConstante(chaine:AnsiString;position:integer):AnsiString;
Function ExtraitExpression(chaine:AnsiString; position:integer):AnsiString;

IMPLEMENTATION

Const TabFonction : Array[1..21] of AnsiString =
      ('ABS',   'ARCCOS', 'ARCSIN', 'ARCTAN',  'ARGCH',  'ARGSH',   'ARGTH',
       'CARRE', 'CH',     'COS',    'EXP',     'FRAC',   'LN',      'LOG',
       'RACINE','SH',     'SIN',    'TAN',     'TH',     'INT',     '?');

      { les fonctions usuelles sont codes sur un seul caractre de 128  146 :
        Abs    : #128 ()       ArcCos : #129 ()       ArcSin : #130 ()
        ArcTan : #131 ()       ArgCh  : #132 ()       ArgSh  : #133 ()
        ArgTh  : #134 ()       Carr  : #135 ()       Cos    : #136 ()
        Ch     : #137 ()       Exp    : #138 ()       Frac   : #139 ()
        Ln     : #140 ()       Log    : #141 ()       Racine : #142 ()
        Sh     : #143 ()       Sin    : #144 ()       Tan    : #145 ()
        Th     : #146 ()       Int    : #147 ()       ?      : #148 () }


Function TypeElement(chaine:AnsiString;position:integer):integer;
   { analyse les diffrents types d'lments de la chane aprs que :
      les espaces ont t supprims,
      les fonctions usuelles ont t remplaces par un caractre #128  #147,
      les fonctions utilisateur ont t remplaces par un caractre #161  #170,
      les constantes PI ont t remplaces par le caractre  (#227). }

   var k : integer;
   begin
      k:=0;if (Position<1)or(Position>500) then begin result:=0;exit;end;
      case Chaine[Position] of
         '0'..'9','.',',' : k:=1;         { constante }
          '('         : k:=3;         { parenthse ouverte  }
          ')'         : k:=4;         { parenthse ferme   }
          ''..''    : k:=5;         { fonction usuelle Abs, ArcCos, ArcSin, ...}
          ''..''    : k:=5;         { fonction utilisateur f1  f10}
          '+','-','*','/','^','','',
          '>','<'     : k:=6;         { oprateur }
          ''         : k:=8;         { exposant  }
          ''         : k:=9;         { constante  }
          'e'         : k:=11;        {constante e}
          '!','?'     : k:=12;        { factorielle }
          end;
      if Chaine[Position] = NomVar then k:=2;      { variable  }
      if Chaine[Position] = NomPar then k:=10;     { paramtre }
      if Chaine[Position] = '-' then
      begin                           { moins unaire }
         if position=1 then k:=7;
         if (position>1) and
         (chaine[position-1] in ['(','+','-','*','/','^','<','>','','']) then k:=7;
      end;
      TypeElement:=k;
   end;

Function ExtraitConstante(chaine:AnsiString;position:integer):AnsiString;
   { retourne la chaine constante qui commence  partir de la position
     indique incluse.  }

   var k : integer;
       s : AnsiString;
   begin
      s:=Chaine[position];
      k:=1;
      while TypeElement(chaine,position+k)=1 do
      begin
         s:=s+chaine[position+k];
         inc(k);
      end;
      ExtraitConstante:=s;
   end;

Function ExtraitExpression(chaine:AnsiString; position:integer):AnsiString;

   { Retourne l'expression qui commence  la position indique. Cette
     expression peut contenir plusieurs oprandes. La fin de l'expression
     est rencontre soit lorsqu'il n'y a plus de caractre dans chaine,
     soit lorsqu'une parenthse est ferme et que la parenthse ouverte
     correspondante se trouvait avant le dbut de l'expression  extraire }

   var k,niveau : integer;
   begin
      k:=position; niveau:=0;
      repeat
         if chaine[k]='(' then inc(niveau);
         if chaine[k]=')' then dec(niveau);
         inc(k);
      until (k>length(chaine)) or (niveau<0);
      dec(k);
      ExtraitExpression:=Copy(chaine,position,k-position);
      if (k>length(chaine)) and (niveau>0) then ok:=false;
   end;

Function ExtraitOperande2(chaine:AnsiString;position:integer):AnsiString;
   { retourne l'oprande situ  droite de la position indique }
   var k : integer;  // nombre de caractres de l'oprande2  extraire
   begin
   	if TypeElement(chaine,position+1)=0 then begin ok:=False; Exit;end; // si l'oprande est absent
      k:=1;
      case TypeElement(chaine,position+1) of
         1 : k:=length(ExtraitConstante(chaine,position+1));
         2 : k:=1;
         3 : k:=length(ExtraitExpression(chaine,position+2))+2;
         5 : k:=length(ExtraitExpression(chaine,position+3))+3;
         7 : k:=length(ExtraitExpression(chaine,position+3))+3;
         9 : k:=1;
        10 : k:=1;
        11 : k:=1;
         end;
      ExtraitOperande2:=Copy(chaine,position+1,k);
   end;


Function Traduction(chaine:AnsiString; var erreur:byte):AnsiString;

{ traduit une chaine fonctionnelle saisie au clavier en une chaine
  fonctionnelle normalise interprtable par l'valuateur d'expressions.
  Si la traduction s'est bien droule, la variable ok est TRUE, sinon
  elle est FALSE et Erreur contient le n de l'erreur commise. }



   Function ExtraitOperande1(chaine:AnsiString;position:integer):AnsiString;
   { retourne l'oprande situ  gauche de la position indique }
   var k,niveau : integer;
   begin
      k:=1;
      case TypeElement(chaine,position-k) of
         1 : begin
                while TypeElement(chaine,position-k)=1 do inc(k);
                dec(k);
             end;
         4 : begin
                niveau:=0;
                repeat
                   if chaine[position-k]='(' then dec(niveau);
                   if chaine[position-k]=')' then inc(niveau);
                   inc(k);
                until (chaine[position-k+1]='(') and (niveau=0);
                dec(k);
             end;
         end;
      if TypeElement(chaine,position-k-1) in [5] then inc(k);
      ExtraitOperande1:=Copy(chaine,position-k,k);
   end;



   Procedure SupprimerEspaces; // suppression de tous les espaces et des oprateurs 
   var i : byte;
   begin
      While Pos(' ',Chaine)>0 do Delete(Chaine,Pos(' ',Chaine),1);
      while Pos('',chaine)>0 do Delete(Chaine,Pos('',Chaine),1);
      while pos(',',chaine)>0 do
      begin
         i:=Pos(',',chaine);
         chaine:=copy(chaine,1,i-1)+'.'+copy(chaine,i+1,length(chaine)-i);
      end;
   end;

   Procedure VerifierParentheses;

   { vrifie qu'il y a autant de parenthses fermes que d'ouvertes en analysant
     la chane de gauche  droite et en s'assurant qu' tout moment, le nombre
     de parenthses ouvertes est suprieur ou gal au nombre de parenthses fermes}

   var k,niveau : integer;
   begin
      niveau:=0;
      k:=1;
      Repeat
         if chaine[k]='(' then inc(niveau);
         if chaine[k]=')' then dec(niveau);
         inc(k);
      Until (niveau<0) or (k>length(Chaine));
      ok:=  (niveau=0) and (k>Length(chaine));
   end;

   procedure TraduireInfEgalSupEgal;

     {remplace les caracres doubles <= et >= par un seul caractre,
      respectivement   (#0171) et  ('#0187) }

   var i : integer;
   begin
      while Pos('<=',chaine)>0 do
      begin
         i:=Pos('<=',chaine);
         Delete(chaine,i,2);
         Insert('',chaine,i);
      end;
      while Pos('>=',chaine)>0 do
      begin
         i:=Pos('>=',chaine);
         Delete(chaine,i,2);
         Insert('',chaine,i);
      end;
   end;

   Procedure TraduireFonctions;

   { Traduit les 21 fonctions usuelles en un seul caractre (#128  #148)
     Remplace galement la constante PI par le caractre  .
     Traduit galement les fonctions utilisateurs f1  f10 en un seul caractre (#161  #170)}

   var k,i : byte;
       ch  : AnsiString;
   begin
      while pos('',chaine)>0 do //au cas o on aurait "carr" ...
      begin
         i:=pos('',chaine);
         delete(chaine,i,1);
         insert('E',chaine,i);
      end;
      For k:=1 to length(chaine) do Chaine[k]:=UpCase(chaine[k]);
      for k:=1 to 21 do
         while Pos(TabFonction[k],chaine)>0 do
         begin
            i:=Pos(TabFonction[k],chaine);
            Delete(chaine,i,Length(TabFonction[k]));
            Insert(Ansichar(chr(127+k)),chaine,i);
         end;

      //cas o l'oprateur de composition utilis tait "o" transform en "O"
      while Pos('O',chaine)>0 do Delete(Chaine,Pos('O',Chaine),1);

      for k:=1 to 10 do //10 fonctions utilisateur
      begin
         str(k,ch);
         ch:='F'+ch;
         while Pos(ch,chaine)>0 do
         begin
            i:=Pos(ch,chaine);
            delete(chaine,i,length(ch));
            Insert(Ansichar(chr(160+k)),chaine,i);
         end;
      end;
      while pos('E',chaine)>0 do
      begin
         i:=Pos('E',chaine);
         Delete(chaine,i,1);
         Insert('(1)',chaine,i);  // insertion de exp(1), la fonction exp tant code 
      end;
      while Pos('PI',chaine)>0 do
      begin
         i:=Pos('PI',chaine);
         Delete(chaine,i,2);
         Insert('',chaine,i);   // est le caractre de code ascii 227
      end;
      for k:=1 to length(chaine) do if not (chaine[k] in
        [NomVar,NomPar,'0'..'9','.',',','','+','-','n','*','/','^',''..'',
              '(',')','','<','>','','',''..'','!'])
        then ok:=false;
   end;

   Procedure TransformerExposant2;
   { remplace l'exposant  (situ aprs son argument) par la fonction CARRE
     (place avant son argument) }
   var niveau,i,j : integer;
   begin
      i:=2;
      repeat
         if TypeElement(chaine,i)=8 then
         begin
            Delete(chaine,i,1);
            j:=TypeElement(chaine,i-1);
            case j of
               1 : begin                   { carr d'une constante numrique }
                      i:=i-2;
                      while TypeElement(chaine,i)=1 do dec(i);
                      insert('',chaine,i+1);
                   end;
               2 : insert('',chaine,i-1);          { carr de la variable }
               3 : OK:=False;            { impossible d'avoir la squence ( }
               4 : begin                               { on a la squence ) }
                      i:=i-2; niveau:=1;
                      repeat
                         if chaine[i]=')' then inc(niveau);
                         if chaine[i]='(' then dec(niveau);
                         dec(i);
                      until (chaine[i+1]='(') and (niveau=0);
                      insert('',chaine,i+1);
                   end;
               5 : insert('',chaine,i-1);          { carr d'une fonction }
               6 : OK:=False;      { impossible d'avoir + ou - ou * ou / }
               7 : OK:=False;         { impossible d'avoir - (moins unaire) }
               8 : ;    { impossible d'avoir  : le 1er  a dj t trait }
               9 : insert('',chaine,i-1);       { carr de la constante  }
               10 : insert('',chaine,i-1);      { carr du paramtre }
            end;
         end
         else inc(i);
      until i>length(chaine);
   end;

   Procedure TransformerFactorielle;
   {dplace le point d'exclamation situ aprs son argument par la fonction '' situe avant son argument}
   var niveau,i,j : integer;
   begin
      i:=2;
      repeat
         if TypeElement(chaine,i)=12 then
         begin
            Delete(chaine,i,1);
            j:=TypeElement(chaine,i-1);
            case j of
               1 : begin                   { factorielle d'une constante numrique }
                      i:=i-2;
                      while TypeElement(chaine,i)=1 do dec(i);
                      insert('',chaine,i+1);
                   end;
               2 : insert('',chaine,i-1);          { factorielle de la variable }
               3 : OK:=False;            { impossible d'avoir la squence (! }
               4 : begin                               { on a la squence )! }
                      i:=i-2; niveau:=1;
                      repeat
                         if chaine[i]=')' then inc(niveau);
                         if chaine[i]='(' then dec(niveau);
                         dec(i);
                      until (chaine[i+1]='(') and (niveau=0);
                      insert('',chaine,i+1);
                   end;
               5 : insert('',chaine,i-1);          { factorielle d'une fonction }
               6 : OK:=False;      { impossible d'avoir +! ou -! ou *! ou /! }
               7 : OK:=False;         { impossible d'avoir -! (moins unaire) }
               8 : ;    { impossible d'avoir ! : le 1er  a dj t trait }
               9 : insert('',chaine,i-1);       { factorielle de la constante  }
               10 : insert('',chaine,i-1);      { factorielle du paramtre }
            end;
         end
         else inc(i);
      until i>length(chaine);
   end;

   Procedure AjouterMultiplicationsImplicites;
   { ajoute l'oprateur * chaque fois qu'il est sous entendu }
   var i,k1,k2 : integer;
       s       : AnsiString;
   begin
      i:=1;
      while i<=length(chaine) do
      begin
         k1:=TypeElement(chaine,i);
         case k1 of
            1 : begin
                   s:=ExtraitConstante(chaine,i);
                   i:=i+length(s);
                end;
            else inc(i);
            end;
         if i<=length(chaine) then k2:=TypeElement(chaine,i) else k2:=0;
         if (k1 in [1,2,4,9,10]) and (k2 in [1,2,3,5,9,10])then
         begin
            insert('*',chaine,i);
            {ajouter des parenthses autour de l'opration afin de la rendre prioritaire
               sauf si l''oprateur suivant est ^}
            if length(chaine)>i+1 then   //ajout de parenthses autour de "kx" sauf
                                         //s'il s'agit de kx^n
               if (k1=1)and(k2=2)and(chaine[i+2]<>'^') then
               begin
                  insert('(',chaine,i-length(s));
                  insert(')',chaine,i+3);
               end;
            if length(chaine)=i+1 then  //par exemple, chane = "sin 2x"
               if (k1=1)and(k2=2)then
               begin
                  insert('(',chaine,i-length(s));
                  insert(')',chaine,i+3);
               end;
         end;
      end;
   end;

   Procedure AjouterParenthesesArg(var expression : AnsiString);

   { Encadre si ce n'est dj fait, l'argument des fonctions avec des parenthses.
     Le moins unaire est considr comme une fonction et son argument est donc
     toujours encadr par des parenthses. }

   var i,k,niveau : integer;
       s          : AnsiString;
       fin        : boolean;
   begin
      i:=1;
      while i<=length(expression) do
      begin
         if (expression[i] in [''..'',''..'']) or (TypeElement(expression,i)=7)
         then
         begin
         	if i=length(expression) then begin ok:=false; Exit; end; //si la fonction n'a pas d'argument
            if expression[i+1]='(' then
            {l'expression qui suit la fonction commence par une parenthse mais,
              l'intrieur des 2 parenthses, il peut y avoir d'autres fonctions
             dont les arguments ne sont pas parenthss, d'o l'appel rcursif ...}
            begin
               s:=ExtraitExpression(expression,i+2);
               Delete(Expression,i+2,length(s));
               AjouterParenthesesArg(s);             // appel rcursif
               insert(s,expression,i+2);
               i:=i+length(s)+2;
            end
            else
            begin
               k:=1; s:=''; niveau:=0; fin:=false;
               repeat     // on ajoute des parenthses autour de l'argument
                  s:=s+expression[i+k];
                  if s[k]='(' then inc(niveau);
                  if (s[k]=')') then
                     if (niveau>0) then dec(niveau)
                     else fin:=true;
                  if not(fin) then inc(k);
               until ((expression[i+k] in ['+','-','*','/','^','<','>','','']) and (niveau=0))
                     or (i+k>length(expression)) or fin;
               {il s'agit maintenant de vrifier que l'argument lui mme ne contient
                pas des fonctions dont les arguments ne sont pas parenthss ...}
               delete(Expression,i+1,length(s));
               AjouterParenthesesArg(s);              // appel rcursif
               insert('('+s+')', expression,i+1);
               i:=i+length(s)+2;
            end;
         end;
         inc(i);
      end;
   end;

   Procedure AjouterParenthesesPuissances;
   { encadre les puissances avec des parenthses - ordre de priorit = 1}
   var i,j,k : integer;
       s1,s2 : AnsiString;
   begin
      i:=1;
      while i<=length(chaine) do
         if chaine[i]='^' then
         begin
            s1:=ExtraitOperande1(chaine,i);
            s2:=ExtraitOperande2(chaine,i);
            j:=i-length(s1);
            k:=i+length(s2);
            if (j-1=0)or(chaine[j-1] in ['*','/','+','-','<','>','','',''..'',''..''])
               or (chaine[k+1] in ['*','/','+','-','<','>','','',''..'',''..'']) then
            begin
               insert('(',chaine,j);
               inc(k);
               insert(')',chaine,k+1);
            end;
            i:=i+2;
         end
         else inc(i);
   end;

   Procedure AjouterParenthesesProduits;
   { encadre les produits et les divisions avec des parenthses - ordre de priorit = 2 }
   var i,j,k : integer;
       s1,s2 : AnsiString;
   begin
      i:=1;
      while i<=length(chaine) do
         if chaine[i] in ['/','*'] then
         begin
            s1:=ExtraitOperande1(chaine,i);
            s2:=ExtraitOperande2(chaine,i);
            j:=i-length(s1);
            k:=i+length(s2);
            if (j-1=0)or(chaine[j-1] in ['+','-','<','>','',''])
               or (chaine[k+1] in ['+','-','<','>','','']) then
            begin
               insert('(',chaine,j);
               inc(k);
               insert(')',chaine,k+1);
            end;
            i:=i+2;
         end
         else inc(i);
   end;

   Procedure AjouterParenthesesAdditions;  //04/09/01
   { encadre les additions et les soustractions avec des parenthses - ordre de priorit = 3 }
   var i,j,k : integer;
       s1,s2 : AnsiString;
   begin
      i:=1;
      while i<=length(chaine) do
         if chaine[i] in ['+','-'] then
         begin
            s1:=ExtraitOperande1(chaine,i);
            s2:=ExtraitOperande2(chaine,i);
            j:=i-length(s1);
            k:=i+length(s2);
            if (chaine[j-1] in ['<','>','',''])
               or (chaine[k+1] in ['<','>','','']) then
            begin
               insert('(',chaine,j);
               inc(k);
               insert(')',chaine,k+1);
            end;
            i:=i+2;
         end
         else inc(i);
   end;

   procedure TraduireMoinsUnaire;
   {remplace le signe '-' unaire par le couple '-1', sauf si le signe '-' prcde
    une constante. Ce signe '-' unaire devient alors la constante -1 suivie
    d'une multiplication implicite.}
   var k : byte;
   begin
      for k:=1 to length(chaine)-1 do
         if (TypeElement(Chaine,k)=7)and(TypeElement(chaine,k+1)<>1) then
         insert('1',chaine,k+1);
   end;

begin    { Function Traduction }
   ok := true;erreur:=0;
   SupprimerEspaces;
   if Chaine<>'' then
   begin
      VerifierParentheses;
      if ok then
      begin
         TraduireInfEgalSupEgal;
         TraduireFonctions;
         if ok then
         begin
            TransformerExposant2;
            TransformerFactorielle;
            if ok then
            begin
               TraduireMoinsUnaire;
               AjouterMultiplicationsImplicites;
               AjouterParenthesesPuissances;
               AjouterParenthesesArg(chaine);
               AjouterParenthesesProduits;
               AjouterParenthesesAdditions;
               if not ok then Erreur:=6    { argument absent aprs l'oprateur ou la fonction }
            end
            else Erreur:=5;   { erreur sur l'utilisation de l'exposant  }
         end
         else Erreur:=4;     { fonction ou symbole non reconnu }
      end
      else Erreur:=3;   { erreur sur les parenthses }
   end;
   Traduction:=Chaine;
end;    { Function Traduction }

// dbut de l'valuateur d'expressions ==========================

function DecomposeFraction(r:real;var num,den : integer):boolean;  //23/05/2002
//retourne vrai si le rel r peut s'crire sous forme de fraction. Dans ce cas,
//les variables num et den contiennent respectivement le numrateur et le dnominateur
var x,y,z,E,F,G,H :real;
begin
   y:=r;
   x:=abs(y);
   z:=int(x);
   num:=round(z);
   den:=1;
   if (abs(x-z)>1e-10)and(abs(x-z)>x*1.e-10) then
   begin
      G:=1;H:=z;E:=0;F:=1;
      repeat
         x:=1/(x-z);
         z:=int(x);
         num:=round(H*z+G);
         G:=H;
         H:=num;
         den:=round(F*z+E);
         E:=F;
         F:=den;
      until abs(abs(y)-num/den)<1e-10;
   end
   else
   begin
      if y<0 then num:=-num;
   end;
   DecomposeFraction:=((den<=1000)and(den<>1));
end;

Function EvalOperation(Op1,Op2 : real; Op : AnsiChar):Real;
var i,k,num,den : integer;
    r           : real;
Begin
   r:=0;
   case Op of
      '+' : r:=op1+op2;
      '-' : r:=op1-op2;
      '*' : if (op1=0) or (op2=0) then r:=0
            else if (ln(abs(op1))+ln(abs(op2))>307)or(ln(abs(op1))+ln(abs(op2))<-323)          //limites maximales du type real=double
                 then ok:=false
                 else r:=op1*op2;
      '/' : if op2=0 then ok:=false
            else if op1=0 then r:=0
                 else if (ln(abs(op1))-ln(abs(op2))>307)or(ln(abs(op1))-ln(abs(op2))<-323)
                      then ok:=false
                      else r:=op1/op2;
      '^' : if op2-int(op2)=0 then
               if ((op1=0)and(op2<0))or(abs(op2)>32767) then ok:=false
               else
               begin
                  i:=trunc(op2);
                  if i=0 then r:=1
                  else if i>0 then r:=op1
                       else
                       begin
                          i:=-i;
                          op1:=1/op1;
                          r:=op1;
                       end;
                  for k:=2 to i do r:=r*op1;
               end
            else if op1<=0 then
                 begin            //acceptation des exposants fractionnaires si le dnominateur est impair (27/12/2004)
                    num:=1;den:=1;//initialisations bidon
                    if op1=0 then op1:=-1E-80;
      //cas limite qu'il faut prvoir sinon la fonction (1+racine(1+x))^(1/3)+(1-racine(1+x))^(1/3) ne marche pas !
                    if DecomposeFraction(op2,num,den) then
                    begin
                       if odd(den) and (op2*ln(-op1)>-88)and(op2*ln(-op1)<88)then
                       begin
                          if odd(num) then r:=-exp(op2*ln(-op1))
                                      else r:=exp(op2*ln(-op1));
                       end
                       else ok:=false;
                    end
                    else ok:=false;
                 end
                 else if (op2*ln(op1)<-88)or(op2*ln(op1)>88) then ok:=false
                      else r:=exp(op2*ln(op1));
        '<' : if op1>=op2 then ok:=false
              else r:=1;
        '>' : if op1<=op2 then ok:=false
              else r:=1;
        '' : if op1>op2 then ok:=false   //infrieur ou gal
              else r:=1;
        '' : if op1<op2 then ok:=false   //suprieur ou gal
              else r:=1;
      else ok:=false;
   end;  { case }
   if not(ok) then r:=0;
   EvalOperation:=r;
end;


Function Gamma(x:Real):Real;   //fonction gamma pour tendre la factorielle aux rels (sauf entiers ngatifs)
CONST
	c:  ARRAY[1..8] OF Real           //coefficients formule de Stirling pour ln(gamma(x))
	=  (1/12, -1/360, 1/1260, -1/1680, 1/1188, -691/360360, 1/156, -3617/122400);  
   lnrac2pi: Real =0.91893853320467274178;
VAR
	f,fp,ip:Real;
   i:integer;
begin
   ip:=Floor(x);
   fp:=x-ip;
   if (x=ip) and (x<0) //non dfinie si entier ngatif
	 then begin
          Result:=0;  //gamma(x) ne s"annule jamais
          Exit;
        end;
   if x>170 //dpassement capacit
	 then begin
           Result:=0;
           Exit;
        end;
   if ip<10 then x:=10+fp;  // on doit avoir x>=10 pour une prcision suffisante
   f:=c[8];
   For i:=7 downto 1 do f:=f/(x*x)+c[i]; //mthode de Horner pour la srie de puissances
   f:=(x-0.5)*Ln(x)-x+lnrac2pi+f/x;
   f:=Exp(f);
   For i:=9 downto round(ip) do
   begin
      if i+fp<>0 then f:=f/(i+fp); //rcurrence
   end;
   Result:=f;
end;

Function EvalFonction(k:byte; x:real):Real;
var v : real;
    n : integer;
begin
   v:=0;
   case k of
      1 : v:=abs(x);             { valeur absolue }
      2 : if (x<-1) or (x>1)     { arc cosinus }
          then ok:=false
          else if x=1 then v:=0
               else if x=-1 then v:=pi
                  else v:=pi/2-ArcTan(x/sqrt(1-sqr(x)));
      3 : if (x<-1) or (x>1)     { arc sinus }
          then ok:=false
          else if x=-1 then v:=-pi/2
               else if x=1 then v:=pi/2
                    else v:=ArcTan(x/sqrt(1-sqr(x)));
      4 : v:=ArcTan(x);          { Arc tangente }
      5 : if (x<1)or(x>1E18)     { Argument cosinus hyperbolique }
          then ok:=false
          else v:=ln(x+sqrt(sqr(x)-1));
      6 : if (x<-1E18)or(x>1E18) { Argument sinus hyperbolique }
          then ok:=false
          else v:=ln(x+sqrt(sqr(x)+1));
      7 : if (x<-1) or (x>1)     { Argument tangente hyperbolique }
          then ok:=false
          else v:=ln((1+x)/(1-x))/2;
      8 : if abs(x)>1E18         { carr }
          then ok:=false
          else v:=sqr(x);
      9 : if (x<-88) or (x>88)   { Cosinus hyperbolique }
          then ok:=false
          else v:=(exp(x)+exp(-x))/2;
     10 : v:=cos(x);             { cosinus }
     11 : if (x<-88) or (x>88)   { exponentielle }
          then ok:=false
          else v:=exp(x);
     12 : if x>=0 then v:=x-int(x)           { partie fractionnaire }
                  else v:=x-int(x)+1;
     13 : if x<=0                { Logarithme nprien }
          then ok:=false
          else v:=ln(x);
     14 : if x<=0                { Logarithme dcimal }
          then ok:=false
          else v:=ln(x)/ln(10);
     15 : if x<0                 { racine carre }
          then ok:=false
          else v:=sqrt(x);
     16 : if (x<-88) or (x>88)   { Sinus hyperbolique }
          then ok:=false
          else v:=(exp(x)-exp(-x))/2;
     17 : v:=sin(x);             { Sinus }
     18 : v:=EvalOperation(sin(x),cos(x),'/');            { Tangente }
     19 : if (x<-88) or (x>88)   { Tangente hyperbolique }
          then ok:=false
          else v:=(exp(x)-exp(-x))/(exp(x)+exp(-x));
     20 : v:=Floor(x);     {partie entire}
     21 : if (x=floor(x)) and (x<0) then ok:=false
                                   else v:=gamma(x+1);  { factorielle tendue }
     else ok:=false;
   end;  { case }
   if ok then EvalFonction:=v
         else EvalFonction:=0;
end;

Function EvalFonctionUtilisateur(k:byte; x:real):Real;
{l'utilisateur peut dfinir jusqu' 10 fonctions f1  f10. Ces fonctions,
 une fois traduites, sont values  l'aide de la fonction F. Cel suppose
 que toute fonction fn, dont la dfinition contient fp, soit dfinie APRS fp,
 sinon on aura une rfrence circulaire impossible  rsoudre. Concrtement,
 les fonctions tant traduites dans l'ordre f1  f10, la fonction f5 pourra faire
 appel  la fonction f1 ou f4, mais pas  la fonction f5 ou f6 ou f10...}
var v : real;
    okbis : boolean;
begin
   v:=0;
   okbis:=ok;
   case k of
      34 : if f1<>'' then v:=F(f1,x) else ok:=false;
      35 : if f2<>'' then v:=F(f2,x) else ok:=false;
      36 : if f3<>'' then v:=F(f3,x) else ok:=false;
      37 : if f4<>'' then v:=F(f4,x) else ok:=false;
      38 : if f5<>'' then v:=F(f5,x) else ok:=false;
      39 : if f6<>'' then v:=F(f6,x) else ok:=false;
      40 : if f7<>'' then v:=F(f7,x) else ok:=false;
      41 : if f8<>'' then v:=F(f8,x) else ok:=false;
      42 : if f9<>'' then v:=F(f9,x) else ok:=false;
      43 : if f10<>'' then v:=F(f10,x) else ok:=false;
   end;
   ok:=ok and okbis;
   if ok then EvalFonctionUtilisateur:=v
         else EvalFonctionUtilisateur:=0;
end;

Function F(chaine:AnsiString;x:real):real;
var operande : AnsiString;
    op       : AnsiChar;
    i        : integer;
    r,y      : real;
    okbis    : boolean;

    Function EvalOperande(s:AnsiString;x:real):real;
    var SousChaine    : AnsiString;
        r             : real;
        i,code,err    : integer;
    begin
       i:=TypeElement(s,1);
       Case i of
           1 : Begin                     { constante }
                  val(s,r,err   );
                  if err>0 then ok:=False;
                  EvalOperande:=r;
               end;
           2 : EvalOperande:=x;          { variable }
           3 : begin                     { parenthse ouverte }
                 SousChaine:=ExtraitExpression(s,2);
                 okBis:=ok;
                 EvalOperande:=F(SousChaine,x);        //appel rcursif
                 ok:=ok and okbis;
               end;
           5 : begin                     { fonction }
                  code:=ord(s[1])-127;
                  SousChaine:=ExtraitOperande2(s,1);
                  r:=EvalOperande(SousChaine,x);       //appel rcursif
                  if code<22 then EvalOperande:=EvalFonction(code,r)
                  else EvalOperande:=EvalFonctionUtilisateur(code,r);
                  //les fonctions usuelles sont codes de 1  19
                  //les fonctions utilisateurs sont codes  partir de 34
                end;
           7 : begin                     { moins unaire }
                  SousChaine:=ExtraitOperande2(s,1);
                  r:=EvalOperande(SousChaine,x);       //appel rcursif
                  EvalOperande:=-r;
               end;
           9 : EvalOperande:=pi;         { constante  }
           10 : EvalOperande:=p;        { paramtre }
       else EvalOperande:=0;
       end;
    end;

begin
   ok:=true;
   Operande:=ExtraitOperande2(chaine,0);
   y:=EvalOperande(Operande,x);
   i:=Length(Operande)+1;
   While i<Length(chaine) do
   begin
      op:=chaine[i];
      Operande:=ExtraitOperande2(chaine,i);
      r:=EvalOperande(Operande,x);
      y:=EvalOperation(y,r,op);
      i:=i+1+Length(Operande);
   end;
   F:=y;
end;

Function ValConstante(chaine:Ansistring):real;
var
	err : byte;
begin
   NomVar:='X';
   chaine:=Traduction(chaine,err);
   ValConstante:=F(chaine,1);
end;


BEGIN  { initialisation de l'unit }
   NomVar:='X';
   NomPar:='P';
   OK:=True;
   f1:='';
   f2:='';
   f3:='';
   f4:='';
   f5:='';
   f6:='';
   f7:='';
   f8:='';
   f9:='';
   f10:='';
END.


