unit uInequations;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, jpeg, ExtCtrls, ComCtrls, Grids, Buttons, shellAPI;

type
  TfmInequations = class(TForm)
    TabControl1: TTabControl;
    btOK: TButton;
    btAnnuler: TButton;
    ColorDialog1: TColorDialog;
    cbStyle: TComboBox;
    Label1: TLabel;
    Image1: TImage;
    RadioGroup1: TRadioGroup;
    sbInferieur: TSpeedButton;        //ces 4 speed buttons sont invisibles et utiliss uniquement pour leur proprit glyph
    sbInferieurouegal: TSpeedButton;
    sbSuperieur: TSpeedButton;
    sbSuperieurOuEgal: TSpeedButton;
    asgInequations: TStringGrid;
    asgToutesInequations: TStringGrid;
    Label2: TLabel;
    btnAide: TButton;
    procedure FormCreate(Sender: TObject);
    procedure cbStyleDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure cbStyleClick(Sender: TObject);
    procedure asgInequationsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure TabControl1Change(Sender: TObject);
    procedure TabControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure btOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure asgInequationsClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure asgInequationsDblClick(Sender: TObject);
    procedure asgInequationsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmInequations: TfmInequations;

implementation
uses uDessin;
{$R *.DFM}

procedure TfmInequations.FormCreate(Sender: TObject);
var i,j,k : integer;
begin
   with asgInequations do
   begin
      cells[0,0]:='n';
      cells[1,0]:='a';
      cells[2,0]:='b';
      cells[3,0]:='c';
      cells[4,0]:='ingalit';
      cells[5,0]:='couleur';
      cells[6,0]:='style';
      cells[7,0]:='Distance entre les hachures (en mm)';
      for i:=1 to 10 do cells[0,i]:='inquation n '+inttostr(i);
      RowHeights[0]:=39;
      DefaultColWidth:=80;
      ColWidths[0]:=95;
      ColWidths[5]:=0;
      ColWidths[7]:=100;
   end;
end;

procedure TfmInequations.cbStyleDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var x,y     : integer;
    Couleur : TColor;
begin
   x:=asgInequations.col;
   y:=asgInequations.row;
   if y>0 then Couleur:=StringToColor(asgInequations.cells[5,y])
          else couleur:=clBlack;
   with (Control as TComboBox).canvas do
   case index of
      0 : begin
             brush.style:=bsBDiagonal;
             brush.color:=couleur;
             Rectangle(Rect.left,Rect.Top,rect.right,rect.bottom);
             brush.Style:=bsClear;
          end;
      1 : begin
             brush.style:=bsFDiagonal;
             brush.color:=couleur;
             Rectangle(Rect.left,Rect.Top,rect.right,rect.bottom);
             brush.Style:=bsClear;
          end;
      2 : begin
             brush.style:=bsCross;
             brush.color:=couleur;
             Rectangle(Rect.left,Rect.Top,rect.right,rect.bottom);
             brush.Style:=bsClear;
          end;
      3 : begin
             brush.style:=bsDiagCross;
             brush.color:=couleur;
             Rectangle(Rect.left,Rect.Top,rect.right,rect.bottom);
             brush.Style:=bsClear;
          end;
      4 : begin
             brush.style:=bsVertical;
             brush.color:=couleur;
             Rectangle(Rect.left,Rect.Top,rect.right,rect.bottom);
             brush.Style:=bsClear;
          end;
      5 : begin
             brush.style:=bsHorizontal;
             brush.color:=couleur;
             Rectangle(Rect.left,Rect.Top,rect.right,rect.bottom);
             brush.Style:=bsClear;
          end;
   end;
end;

procedure TfmInequations.cbStyleClick(Sender: TObject);
var x,y : integer;
begin
   x:=asgInequations.col;
   y:=asgInequations.row;
   asgInequations.cells[x,y]:=IntToStr(cbStyle.ItemIndex);
end;

function InvertColor(const Color: TColor): TColor;
//Retourne une clWhite si Color est une couleur fonce et clBlack si Color est une couleur claire
begin
   if (GetRValue(Color) + GetGValue(Color) + GetBValue(Color)) > 384
      then     result := clBlack
      else     result := clWhite;
end;

procedure TfmInequations.asgInequationsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var ch : string;
    k : integer;
    Couleur : TColor;
begin
   k:=TabControl1.TabIndex;
   ch:=asgInequations.cells[ACol,ARow];
   if ARow>0 then Couleur:=StringToColor(asgInequations.cells[5,ARow]);
   if ARow*ACol=0 then GrilleCouleur(asgInequations,Rect,ch,taCenter,clBtnFace,clBlack,[]);
   if (ACol=4)and(ARow>0) then with asgInequations.canvas do if not (gdSelected in State) then
   begin
      brush.style:=bsSolid;Brush.Color:=clWhite;FillRect(Rect);
      GrilleCouleur(asgInequations,Rect,ch,taCenter,Couleur,Couleur,[]);
      if ch='<' then Draw((Rect.left+rect.right-sbInferieur.glyph.width)div 2,
                  (Rect.top+rect.bottom-sbInferieur.glyph.height)div 2,sbInferieur.glyph);
      if ch='>' then Draw((Rect.left+rect.right-sbSuperieur.glyph.width)div 2,
                  (Rect.top+rect.bottom-sbSuperieur.glyph.height)div 2,sbSuperieur.glyph);
      if ch='<=' then Draw((Rect.left+rect.right-sbInferieurOuEgal.glyph.width)div 2,
                  (Rect.top+rect.bottom-sbInferieurOuEgal.glyph.height)div 2,sbInferieurOuEgal.glyph);
      if ch='>=' then Draw((Rect.left+rect.right-sbSuperieurOuEgal.glyph.width)div 2,
                  (Rect.top+rect.bottom-sbSuperieurOuEgal.glyph.height)div 2,sbSuperieurOuEgal.glyph);
   end;
   if (ACol=5)and(ARow>0) then GrilleCouleur(asgInequations,Rect,ch,taCenter,Couleur,Couleur,[]);
   if (ACol=6)and(ARow>0) then with asgInequations.canvas do if not (gdSelected in State) then
   begin
      brush.style:=bsSolid;Brush.Color:=clWhite;FillRect(Rect);
      brush.Style:=bsBDiagonal; //valeur par dfaut
      if ch='1' then Brush.Style:=bsFDiagonal;
      if ch='2' then Brush.Style:=bsCross;
      if ch='3' then Brush.Style:=bsDiagCross;
      if ch='4' then Brush.Style:=bsHorizontal;
      if ch='5' then Brush.Style:=bsVertical;
      Brush.color:=Couleur;
      Rectangle(Rect.left,rect.top,rect.right,rect.bottom);
      brush.style:=bsClear;
   end;
   if (ACol=7)and(ARow>0) then GrilleCouleur(asgInequations,Rect,ch,taCenter,Couleur,InvertColor(Couleur),[]);
   if (ARow>0)and((ACol=1)or(ACol=2)or(ACol=3)) then
      GrilleCouleur(asgInequations,Rect,ch,taCenter,Couleur,InvertColor(Couleur),[]);
end;

procedure TfmInequations.TabControl1Change(Sender: TObject);
var x,y,z : integer;
begin
   //cet vnement se produit aprs que le changement d'onglet ait eu lieu. Il permet de restaurer la page en cours
   z:=TabControl1.TabIndex;
   for y:=0 to 9 do
   begin
      for x:=0 to 6 do
      begin
         asgInequations.cells[x+1,y+1]:=asgToutesInequations.cells[7*z+x,y];
      end;
   end;
end;

procedure TfmInequations.TabControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
var x,y,z : integer;
begin
   //cet vnement se produit avant que l'on soit sur le nouvel onglet. Il permet de sauvegarder la page en cours
   z:=TabControl1.TabIndex;
   for y:=0 to 9 do
   begin
      for x:=0 to 6 do asgToutesInequations.cells[7*z+x,y]:=asgInequations.cells[x+1,y+1];
   end;
end;

procedure TfmInequations.btOKClick(Sender: TObject);   //sauvegarde de la page en cours
var x,y,z : integer;
begin
   z:=TabControl1.TabIndex;
   for y:=0 to 9 do
   begin
      for x:=0 to 6 do asgToutesInequations.cells[7*z+x,y]:=asgInequations.cells[x+1,y+1];
   end;
end;

procedure TfmInequations.FormShow(Sender: TObject);
var i,j,k : integer;
begin
   with asgInequations do
   begin
      for i:=0 to 9 do for j:=0 to 9 do for k:=0 to 6 do
      begin
         if (k=4)and(asgToutesInequations.cells[7*i+k,j]='')
         then asgToutesInequations.cells[7*i+k,j]:=ColorToString(TabCouleurs[(7*i+j) mod 15]);
//         else asgToutesInequations.cells[7*i+k,j]:='';
         if (k=5)and(asgToutesInequations.cells[7*i+k,j]='') then asgToutesInequations.cells[7*i+k,j]:='0';
      end;
   end;
   TabControl1Change(sender);
end;

procedure TfmInequations.asgInequationsClick(Sender: TObject);
var x,y,i,k,style : integer;
    R       : TRect;
    ch      : string;
begin
   x:=asgInequations.col;
   y:=asgInequations.row;
   k:=TabControl1.TabIndex;
   if y=0 then exit;
   if (x=5)or(x=6) then asgInequations.Options:=asgInequations.Options-[goEditing]
                   else asgInequations.Options:=asgInequations.Options+[goEditing];
   if x=6 then
   begin
      R:=asgInequations.CellRect(x,y);
      cbStyle.Visible:=true;
      cbStyle.BringToFront;
      cbStyle.Left:=R.Left+1+asgInequations.left;
      cbStyle.Top:=R.Top+1+asgInequations.top;
      cbStyle.Width:=R.Right-R.Left;
      style:=StrToInt(asgInequations.Cells[6,y]);
      cbStyle.ItemIndex:=style;
   end
   else cbStyle.Visible:=false;
   if x=7 then
   begin
      if (asgInequations.cells[x,y]='')and(asgInequations.cells[1,y]<>'')
                                       and(asgInequations.cells[2,y]<>'')
                                       and(asgInequations.cells[3,y]<>'')
      then asgInequations.cells[x,y]:='3';  //valeur par dfaut
   end;
end;

procedure TfmInequations.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmInequations.asgInequationsDblClick(Sender: TObject);
var x,y,k : integer;
    ch : string;
begin
   x:=asgInequations.col;
   y:=asgInequations.row;
   ch:=asgInequations.cells[x,y];
   //k:=TabControl1.TabIndex;
   ColorDialog1.Color:=StringToColor(asgInequations.Cells[5,y]);
   if ColorDialog1.Execute then
   begin
      asgInequations.Cells[5,y]:=ColorToString(ColorDialog1.Color);
      for k:=1 to 7 do asgInequationsDrawCell(sender,k,y,asgInequations.CellRect(k,y),[]);
      //GrilleCouleur(asgInequations,asgInequations.CellRect(k,y),asgInequations.Cells[k,y],
      //              taCenter,ColorDialog1.Color,InvertColor(ColorDialog1.Color),[]);
   end;
end;

procedure TfmInequations.asgInequationsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var i,j : integer;
begin
   i:=asgInequations.Col;
   j:=asgInequations.Row;
   if (key=vk_return)or((key=vk_right)and asgInequations.EditorMode) then
   begin
      if i<7 then inc(i) else begin i:=1;inc(j);end;
      if i=5 then i:=6;
   end;
   if (key=vk_left)and asgInequations.EditorMode and (i>1) then
   begin
      dec(i);
      if i=5 then i:=4;
   end;
   asgInequations.Col:=i;
   asgInequations.Row:=j;
end;

procedure TfmInequations.btnAideClick(Sender: TObject);
begin
   Aide(79);
end;

end.
