unit uIntegrale;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, shellAPI;

type
  TfmIntegrale = class(TForm)
    GroupBox1: TGroupBox;
    rbIntegrale1: TRadioButton;
    Image1: TImage;
    rbIntegrale2: TRadioButton;
    Image2: TImage;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edA: TEdit;
    Label3: TLabel;
    edB: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edF: TEdit;
    edG: TEdit;
    pnCouleurIntegrale: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    lblValeurIntegrale: TLabel;
    cbAfficherIntegrale: TCheckBox;
    btAnnuler: TButton;
    btOK: TButton;
    cdCouleurDomaine: TColorDialog;
    udStyle: TUpDown;
    Label9: TLabel;
    Panel1: TPanel;
    shStyleDomaine: TShape;
    btnAide: TButton;
    procedure rbIntegrale1Click(Sender: TObject);
    procedure rbIntegrale2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edFExit(Sender: TObject);
    procedure edAKeyPress(Sender: TObject; var Key: Char);
    procedure edBKeyPress(Sender: TObject; var Key: Char);
    procedure edFKeyPress(Sender: TObject; var Key: Char);
    procedure edGKeyPress(Sender: TObject; var Key: Char);
    procedure edGExit(Sender: TObject);
    procedure btAnnulerClick(Sender: TObject);
    procedure edAExit(Sender: TObject);
    procedure edBExit(Sender: TObject);
    procedure pnCouleurIntegraleClick(Sender: TObject);
    procedure udStyleClick(Sender: TObject; Button: TUDBtnType);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmIntegrale: TfmIntegrale;

implementation
uses uFonctions, uDessin;

{$R *.DFM}

Function Integrale(ch : string;a,b : double):double;
//calcul approch de l'intgrale par la mthode de Simpson
var I,h,x : double;
    erreur,k  : byte;
    chf,chErreur : string;
begin
   h:=(b-a)/100;
   erreur:=0;
   chf:=Traduction(ch,erreur);
   if erreur>0 then
   begin            //erreurs de syntaxe
      if erreur=3 then chErreur:='problme de parenthses.';
      if erreur=4 then chErreur:='fonction ou symbole non reconnu.';
      if erreur=5 then chErreur:='mauvaise utilisation du symbole ';
      ShowMessage('Erreur de syntaxe dans la fonction f(x) = '+ch+ ' : '+chErreur);
   end;
   x:=a;
   I:=f(chf,x);
   I:=I+f(chf,b);
   for k:=1 to 99 do
   begin
      x:=x+h/2;
      I:=I+4*f(chf,x);
      x:=x+h/2;
      I:=I+2*f(chf,x);
   end;
   x:=x+h/2;
   I:=I+4*f(chf,x);
   Result:=h*I/6;
end;

Procedure Calculs;
var I,J,a,b,x : double;
    erreur : byte;
begin
   x:=0;   //pour tromper le vrificateur de Delphi et initialiser x
   if (fmIntegrale.edA.text='')or(fmIntegrale.edB.text='')or(fmIntegrale.edf.text='') then exit;
   if (fmIntegrale.rbIntegrale2.Checked)and(fmIntegrale.edg.text='') then exit;
   try
      a:=f(traduction(fmIntegrale.edA.text,erreur),x);
      b:=f(traduction(fmIntegrale.edB.text,erreur),x);
      if fmIntegrale.rbIntegrale1.checked then
      begin
         I:=Integrale(fmIntegrale.edF.text,a,b);
         fmIntegrale.lblValeurIntegrale.Caption:=FloatToStrF(I,ffGeneral,6,4);
      end;
      if fmIntegrale.rbIntegrale2.Checked then
      begin
         I:=Integrale(fmIntegrale.edF.text,a,b);
         J:=Integrale(fmIntegrale.edG.text,a,b);
         fmIntegrale.lblValeurIntegrale.Caption:=FloatToStrF(I-J,ffGeneral,6,4);
      end;
   except
   end;
end;

procedure TfmIntegrale.rbIntegrale1Click(Sender: TObject);
begin
   edG.Color:=clbtnFace;
   edG.Enabled:=false;
   Calculs;
end;

procedure TfmIntegrale.rbIntegrale2Click(Sender: TObject);
begin
   edG.Color:=clWindow;
   edG.Enabled:=true;
   Calculs;
end;

procedure TfmIntegrale.FormShow(Sender: TObject);
begin
   shStyleDomaine.Brush.Color:=pnCouleurIntegrale.Color;
   if rbIntegrale1.Checked then
   begin
      edG.Color:=clbtnFace;
      edG.Enabled:=false;
   end
   else
   begin
      edG.Color:=clWindow;
      edG.Enabled:=true;
   end;
end;

procedure TfmIntegrale.edFExit(Sender: TObject);
begin
   Calculs;
end;

procedure TfmIntegrale.edAKeyPress(Sender: TObject; var Key: Char);
begin
   if key in['.',','] then key:=DecimalSeparator;
end;

procedure TfmIntegrale.edBKeyPress(Sender: TObject; var Key: Char);
begin
   if key in['.',','] then key:=DecimalSeparator;
end;

procedure TfmIntegrale.edFKeyPress(Sender: TObject; var Key: Char);
begin
   if key in['.',','] then key:=DecimalSeparator;
end;

procedure TfmIntegrale.edGKeyPress(Sender: TObject; var Key: Char);
begin
   if key in['.',','] then key:=DecimalSeparator;
end;

procedure TfmIntegrale.edGExit(Sender: TObject);
begin
   Calculs;
end;

procedure TfmIntegrale.btAnnulerClick(Sender: TObject);
begin
   rbIntegrale1.checked:=false;
   rbIntegrale2.Checked:=false;
   lblValeurIntegrale.Caption:='';
end;

procedure TfmIntegrale.edAExit(Sender: TObject);
begin
   Calculs;
end;

procedure TfmIntegrale.edBExit(Sender: TObject);
begin
   Calculs;
end;

procedure TfmIntegrale.pnCouleurIntegraleClick(Sender: TObject);
begin
   cdCouleurDomaine.Color:=pnCouleurIntegrale.Color;
   if cdCouleurDomaine.Execute then pnCouleurIntegrale.Color:=cdCouleurDomaine.Color;
end;

procedure TfmIntegrale.udStyleClick(Sender: TObject; Button: TUDBtnType);
begin
    shStyleDomaine.Brush.Color:=pnCouleurIntegrale.Color;
    shStyleDomaine.Brush.Style:=TBrushStyle(udStyle.position);
end;

procedure TfmIntegrale.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmIntegrale.btnAideClick(Sender: TObject);
begin
	Aide(76);
end;

end.
