unit uLatex;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, GifImg, Grids, shellapi;

type
  TfmLatex = class(TForm)
    ImageLatex: TImage;
    btAnnuler: TButton;
    btOK: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    RadioButton_transparent: TRadioButton;
    RadioButton_opaque: TRadioButton;
    asgLatex: TStringGrid;
    asgExemples: TStringGrid;
    btnAide: TButton;
    procedure FormShow(Sender: TObject);
    procedure asgLatexClick(Sender: TObject);
    procedure asgExemplesDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Label6Click(Sender: TObject);
    procedure asgExemplesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure asgLatexDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure asgLatexKeyPress(Sender: TObject; var Key: Char);
    procedure asgLatexKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmLatex: TfmLatex;
  Raz:string;

implementation

uses uDessin;

{$R *.DFM}

Procedure EffacerDessin;
begin
   with fmLatex.ImageLatex.Canvas do
   begin
      brush.style:=bsSolid;
      brush.Color:=clWhite;
      Rectangle(0,0,fmLatex.imageLatex.width,fmLatex.ImageLatex.height);
      brush.style:=bsClear;
   end;
end;

procedure TfmLatex.FormShow(Sender: TObject);
begin
   EffacerDessin;
   Raz:='3$ \black \normalsize 1';
end;

procedure TfmLatex.asgLatexClick(Sender: TObject);
var chaineLaTex,FichierGif   : string;
    MonGif                   : TGifImage;
    MonBMP,BMPreduit         : TBitmap;
    x,y,i,j,w,h,r            : integer;
begin
   i:=asgLatex.row;
   j:=asglatex.Col;
   ChaineLaTex:=asgLatex.Cells[1,i];
   if ChaineLatex<>'' then
   begin
      EffacerDessin;
      if blAntiCrenelage
   		then begin
      	MonBMP:=TBitMap.Create;
         BMPreduit:=TBitMap.Create;
      	FichierGif:='EquationLaTeX.gif';
      	CreateGifFromEq_HR(pAnsiChar(AnsiString(Raz)), pAnsiChar(AnsiString(FichierGif)));
      	CreateGifFromEq_HR(pAnsiChar(AnsiString(ChaineLaTex)), pAnsiChar(AnsiString(FichierGif)));
      	MonGif:=TGifImage.Create;
      	MonGif.LoadFromFile('EquationLaTeX.gif');
      	MonBMP.Assign(MonGif);
      	w:=MonBMP.Width;
      	r:=w mod 4;
      	if r>0
      		then begin
         	w:=w+4-r;
         	MonBMP.Width:=w;
         	end;
      	h:=MonBMP.Height;
      	r:=h mod 4;
      	if r>0
      		then begin
         	h:=h+4-r;
         	MonBMP.Height:=h;
         	end;
			MonBMP.PixelFormat:=pf24bit;
			bmpReduit.PixelFormat:=pf24bit;
      	bmpReduit.Width:=MonBMP.Width div 4;
      	bmpReduit.Height:=MonBMP.Height div 4;
      	fmdessin.FastAntiAliasPicture(MonBMP,bmpReduit);
      	MonBMP.Assign(bmpReduit);
      	x:=(ImageLatex.width-MonBMP.width)div 2;
      	y:=(ImageLatex.height-MonBMP.Height)div 2;
      	ImageLatex.Canvas.Draw(x,y,MonBMP);
      	MonGif.Free;
         BMPreduit.Free;
      	MonBMP.Free;
         end else begin
      	MonBMP:=TBitMap.Create;
      	FichierGif:='EquationLaTeX.gif';
      	CreateGifFromEq(pAnsiChar(AnsiString(Raz)), pAnsiChar(AnsiString(FichierGif)));
      	CreateGifFromEq(pAnsiChar(AnsiString(ChaineLaTex)), pAnsiChar(AnsiString(FichierGif)));
      	MonGif:=TGifImage.Create;
      	MonGif.LoadFromFile('EquationLaTeX.gif');
      	MonBMP.Assign(MonGif);
//      MonBMP.SaveToFile('EquationLatex.bmp');
//      ReducBMP(MonBMP,4);
      	x:=(ImageLatex.width-MonBMP.width)div 2;
      	y:=(ImageLatex.height-MonBMP.Height)div 2;
      	ImageLatex.Canvas.Draw(x,y,MonBMP);
      	MonGif.Free;
      	MonBMP.Free;
         end;
   end;
end;

procedure TfmLatex.asgExemplesDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var chaineLaTex,FichierGif : string;
    MonGif                 : TGifImage;
    BitMap,bmpReduit       : TBitMap;
    MonRect                : Trect;
    w,h,r                  : integer;
begin
   ChaineLatex:=asgExemples.cells[ACol,ARow];
   if ARow=0 then GrilleCouleur(asgExemples,Rect,ChaineLatex,taCenter,clBtnFace,clBlack,[]);
   if (ACol=0) and (Arow>0) then GrilleCouleur(asgExemples,Rect,ChaineLatex,taLeftJustify,clBtnFace,clBlack,[]);
   if (ARow>0)and(ACol=1)and(asgExemples.Cells[0,ARow]<>'') then
   begin
      ChaineLatex:=asgExemples.Cells[0,ARow];
      FichierGif:='EquationLaTeX.gif';
      if blAntiCrenelage
   		then begin
      	CreateGifFromEq_HR(pAnsiChar(AnsiString(Raz)), pAnsiChar(AnsiString(FichierGif)));
      	CreateGifFromEq_HR(pAnsiChar(AnsiString(ChaineLaTex)), pAnsiChar(AnsiString(FichierGif)));
      	MonGif:=TGifImage.Create;
      	BitMap:=TBitMap.Create;
      	bmpReduit:=TBitMap.Create;
      	MonGif.LoadFromFile(FichierGif);
      	BitMap.Assign(MonGif);
      	w:=BitMap.Width;
      	r:=w mod 4;
      	if r>0
      		then begin
         	w:=w+4-r;
         	BitMap.Width:=w;
         	end;
      	h:=BitMap.Height;
      	r:=h mod 4;
      	if r>0
      		then begin
         	h:=h+4-r;
         	BitMap.Height:=h;
         	end;
			BitMap.PixelFormat:=pf24bit;
			bmpReduit.PixelFormat:=pf24bit;
      	bmpReduit.Width:=BitMap.Width div 4;
      	bmpReduit.Height:=BitMap.Height div 4;
      	fmdessin.FastAntiAliasPicture(BitMap,bmpReduit);
      	BitMap.Assign(bmpReduit);
      	end else begin
      	CreateGifFromEq(pAnsiChar(AnsiString(Raz)), pAnsiChar(AnsiString(FichierGif)));
      	CreateGifFromEq(pAnsiChar(AnsiString(ChaineLaTex)), pAnsiChar(AnsiString(FichierGif)));
      	MonGif:=TGifImage.Create;
      	BitMap:=TBitMap.Create;
      	MonGif.LoadFromFile(FichierGif);
      	BitMap.Assign(MonGif);
      	end;
      BitMap.Canvas.Brush.Color:=clwhite;
      w:=BitMap.Width;
      h:=BitMap.Height;
      if asgExemples.RowHeights[Arow]<h+2 then asgExemples.RowHeights[Arow]:=h+2;
      asgExemples.Canvas.Draw((Rect.Left+Rect.Right-w)div 2,(rect.Top+rect.Bottom-h)div 2,BitMap);
      bmpReduit.Free;
      MonGif.Free;
      BitMap.Free;
   end;
end;

procedure TfmLatex.Label6Click(Sender: TObject);
begin
   ShellExecute( 0, Nil, PChar('http://www.ilemaths.net/guide-latex.php'),Nil, Nil, SW_NORMAL );
end;


procedure TfmLatex.asgExemplesClick(Sender: TObject);
var
   chaine:string;
   x,y,j:integer;
   cellule:TGridRect;
   oui:boolean;
begin
   oui:=asgExemples.col=2;
   y:=asgExemples.Row;
   chaine:=asgExemples.Cells[0,y];
   x:=asgLatex.selection.Left;
   y:=asgLatex.selection.Top;
   if (x<>1) and oui then
   begin
      j:=1;
      While (asgLatex.cells[1,j]<>'') and (j<50) do inc(j);
      if j=50 then j:=1;
      cellule.Left:=1;
      cellule.Right:=1;
      cellule.Top:=j;
      cellule.Bottom:=j;
      asgLatex.Selection:=cellule;
      asgLatex.cells[1,j]:=chaine;
      end else begin
      asgLatex.cells[1,y]:=chaine;
   end;
end;

procedure TfmLatex.FormCreate(Sender: TObject);
var j : integer;
begin
   with asgLatex do
   begin
      ColWidths[0]:=30;
      ColWidths[2]:=40;
      ColWidths[3]:=40;
      ColWidths[1]:=340;
      Width:=ColWidths[0]+ColWidths[1]+ColWidths[2]+ColWidths[3]+24;
      cells[0,0]:='n';
      cells[1,0]:='Expressions LaTeX';
      cells[2,0]:='x';
      cells[3,0]:='y';
      for j:=1 to 50 do asgLatex.cells[0,j]:=intToStr(j);
   end;
   with asgExemples do
   begin
      ColWidths[0]:=250;
      ColWidths[1]:=250;
      Width:=ColWidths[0]+ColWidths[1]+22;
      Cells[0,0]:='Exemples d''expressions LaTeX';  Cells[1,0]:='Rsultats';
      RowHeights[1]:=30;
      Cells[0,1]:='4\times 7';
      Cells[0,2]:='\red\frac{4}{7}';
      Cells[0,3]:='5$\blue\infty';
      Cells[0,4]:='4$\green\sqrt{50}..\sqrt[1$3]{5$50}';
      Cells[0,5]:='\cyan \approx \equiv \leqslant \geqslant \neq \perp \varparallel';
      Cells[0,6]:='\magenta \alpha  \beta  \gamma  \delta ... \omega';
      Cells[0,7]:='\mathbb{NZDQRC}';
      Cells[0,8]:='f: \ x \longmapsto 2x-\sqrt{x^2-x-5} ';
      RowHeights[9]:=50;
      Cells[0,9]:='	f(x)=\left\{1-2x  \text{   si }x<0 \\x+1 \text{     si } x \geqslant 0 \right.';
      Cells[0,10]:='3$ ( \text{O},\vec{ \imath },\vec{ \jmath })';
      Cells[0,11]:='\Gamma \Lambda \Xi \Psi \Omega';
      Cells[0,12]:='\mathrm{ \Gamma \Lambda \Xi \Psi \Omega}';
      Cells[0,13]:='\cap \cup \subset \in \notin \varnothing';
      Cells[0,14]:='3$ \forall \exists \Leftrightarrow \Rightarrow';
      Cells[0,15]:='4$ \mathscr{ABCDEF}';
      Cells[0,16]:='4$ \mathcal{ABCDEF}';
      Cells[0,17]:='\widehat{ABC}';
      Cells[0,18]:='\vec{AB}';
      Cells[0,19]:='\left\| \vec{V}\right\|';
      Cells[0,20]:='\bar{z} \overline{z+z''}';
      Cells[0,21]:='3$ u_{n+1}=(u_n+3)^2';
      Cells[0,22]:='\sum_{i=1}^nf(i)';
      RowHeights[23]:=50;
      Cells[0,23]:='\bigsum_{i=1}^{20}f(i)';
      RowHeights[24]:=90;
      Cells[0,24]:='3$ \int_1^{10}f(t)dt';
      Cells[0,25]:='\lim_{x\to+\infty}f(x)';
      Cells[0,26]:='x=\frac{-b\pm\sqrt{b^2-4ac}} {2a}';
      RowHeights[27]:=50;
      Cells[0,27]:='\(\array{1&2&3\\4&5&6}\)';
      RowHeights[28]:=50;
      Cells[0,28]:=' \left[ \begin{array}\cos\theta & -\sin\theta\\  \sin\theta & \cos\theta \end{array} \right]';
      RowHeights[29]:=50;
      Cells[0,29]:='\left| \begin{matrix} a & c \\ b & d \end{matrix} \right| \overset{\rm def}= ad-bc';
      RowHeights[30]:=50;
      Cells[0,30]:='\{\array{3x+2y=16\\5x-3y= -5}';
      Cells[0,31]:='\fbox{ \text{Loi normale}}';
      RowHeights[32]:=50;
      Cells[0,32]:='3$ \rotatebox{90}{f(x)}';
      Cells[0,33]:='\text{H_2+\frac{1}{2} O_2 \longrightarrow  H_2O}';
      Cells[0,34]:='\text{\raisebox{20}{^{238}_{92}}U}';
      Cells[0,35]:='\text{Cu^{2+}_{(aq)}+Zn_{(s)}\longrightarrow Cu_{(s)}+Zn^{2+}_{(aq)}}';
      RowHeights[36]:=90;
      Cells[0,36]:='2$ \begin{tabular}{|c|cccccc||} \hline x&-\infty&&-3&&+\infty \\ \hline {f''(x)}& &-&0&+& \\ \hline {f(x)}&+\infty & \searrow &2& \nearrow &+\infty &\\ \hline \end{tabular}';
      Cells[0,37]:='';
      Cells[0,38]:='';
      Cells[0,39]:='';
      Cells[0,40]:='';
   end;
end;

procedure TfmLatex.asgLatexDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var ch : string;
begin
   ch:=asgLatex.cells[ACol,ARow];
   if ACol*ARow=0 then GrilleCouleur(asgLatex,Rect,ch,taCenter,clBtnFace,clBlack,[]);
   if (ACol=1) and (ARow>0) then GrilleCouleur(asgLatex,Rect,ch,taLeftJustify,clWindow,clBlack,[]);
   if (ACol>1) and (ARow>0) then GrilleCouleur(asgLatex,Rect,ch,taCenter,clWindow,clBlack,[]);
end;

procedure TfmLatex.asgLatexKeyPress(Sender: TObject; var Key: Char);
var i : integer;
begin
   i:=asgLatex.Col;
   if (Key='.')and(i>1) then key:=',';
end;

procedure TfmLatex.asgLatexKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i,j : integer;
begin
   i:=asgLatex.Col;
   j:=asgLatex.Row;
   if (Key=vk_Return)or((Key=vk_right)and asgLatex.EditorMode) then
   begin
      if i<3 then inc(i)
             else begin i:=1;inc(j);end;
   end;
   asgLatex.Col:=i;
   asgLatex.Row:=j;
end;

procedure TfmLatex.btnAideClick(Sender: TObject);
begin
   Aide(41);
end;

end.
