unit uLoiBinomiale;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Grids, shellAPI;

type
  TfmLoiBinomiale = class(TForm)
    Label2: TLabel;
    edN: TEdit;
    udN: TUpDown;
    Label3: TLabel;
    edP: TEdit;
    gbTypeCalcul: TGroupBox;
    rbEgal: TRadioButton;
    rbInferieur: TRadioButton;
    rbSuperieur: TRadioButton;
    rbIntervalle: TRadioButton;
    edK: TEdit;
    udK: TUpDown;
    edA: TEdit;
    udA: TUpDown;
    edB: TEdit;
    udB: TUpDown;
    lblA: TLabel;
    lblB: TLabel;
    lblK: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    gbCouleurs: TGroupBox;
    Label1: TLabel;
    Label4: TLabel;
    pnCouleurHistogramme: TPanel;
    pnCouleurZone: TPanel;
    cdHistogramme: TColorDialog;
    cdZone: TColorDialog;
    rgEpaisseur: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    btOK: TButton;
    btAnnuler: TButton;
    edTitre: TEdit;
    Label5: TLabel;
    cbAffichageResultat: TCheckBox;
    cbAffichageParametres: TCheckBox;
    asgResultats: TStringGrid;
    FooterResultats: TStringGrid;
    btnAide: TButton;
    procedure edPKeyPress(Sender: TObject; var Key: Char);
    procedure rbEgalClick(Sender: TObject);
    procedure rbInferieurClick(Sender: TObject);
    procedure rbSuperieurClick(Sender: TObject);
    procedure rbIntervalleClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure edNChange(Sender: TObject);
    procedure edAChange(Sender: TObject);
    procedure edBChange(Sender: TObject);
    procedure pnCouleurHistogrammeClick(Sender: TObject);
    procedure pnCouleurZoneClick(Sender: TObject);
    procedure edKChange(Sender: TObject);
    procedure edPChange(Sender: TObject);
    procedure btAnnulerClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure asgResultatsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure FooterResultatsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmLoiBinomiale: TfmLoiBinomiale;

implementation

uses uDessin;

{$R *.DFM}

Function Cnp(n,p : integer):extended;
var r : extended;
    i : integer;
begin
   r:=1;
   for i:=1 to p do r:=r*(n-p+i)/i;
   result:=r;
end;

Function Prob(n,k : integer; p:real):extended;
begin
   result:=Cnp(n,k)*exp(k*ln(p))*exp((n-k)*ln(1-p));
end;

Function EstDansZone(i,n,k,a,b : integer):boolean;
begin
   result:=(fmLoiBinomiale.rbEgal.Checked and (i=k))
           or (fmLoiBinomiale.rbInferieur.Checked and (i<=k))
           or (fmLoiBinomiale.rbSuperieur.Checked and (i>=k))
           or (fmLoiBinomiale.rbIntervalle.Checked and (i>=a)and(i<=b));
end;


Procedure Calculs;
var i,n,k,a,b : integer;
    p,r,total : extended;
begin
   with fmLoiBinomiale do
   begin
      n:=udN.Position;
      k:=udK.Position;
      try
         p:=StrToFloat(edP.Text);
      except
         exit;
      end;
      if p=0 then exit;
      a:=udA.Position;
      b:=udB.Position;
      Total:=0;
      for i:=0 to n do
      begin
         asgResultats.cells[0,i+1]:=intToStr(i);
         r:=Prob(n,i,p);
         asgResultats.cells[1,i+1]:=FloatToStrF(r,ffGeneral,8,10);
         if (rbEgal.Checked and (i=k))
           or (rbInferieur.Checked and (i<=k))
           or (rbSuperieur.Checked and (i>=k))
           or (rbIntervalle.Checked and (i>=a)and(i<=b))
         then Total:=Total+r;
      end;
      FooterResultats.Cells[1,0]:=FloatToStrF(Total,ffGeneral,8,10);
   end;
end;

procedure TfmLoiBinomiale.edPKeyPress(Sender: TObject; var Key: Char);
begin
   if key='.' then key:=DecimalSeparator;
end;

procedure TfmLoiBinomiale.rbEgalClick(Sender: TObject);
begin
   lblK.Visible:=true;
   udK.Visible:=true;
   edK.Visible:=true;
   lblA.Visible:=false;
   lblB.Visible:=false;
   udA.Visible:=false;
   udB.Visible:=false;
   edA.Visible:=false;
   edB.Visible:=false;
   Calculs;
end;

procedure TfmLoiBinomiale.rbInferieurClick(Sender: TObject);
begin
   lblK.Visible:=true;
   udK.Visible:=true;
   edK.Visible:=true;
   lblA.Visible:=false;
   lblB.Visible:=false;
   udA.Visible:=false;
   udB.Visible:=false;
   edA.Visible:=false;
   edB.Visible:=false;
   Calculs;
end;

procedure TfmLoiBinomiale.rbSuperieurClick(Sender: TObject);
begin
   lblK.Visible:=true;
   udK.Visible:=true;
   edK.Visible:=true;
   lblA.Visible:=false;
   lblB.Visible:=false;
   udA.Visible:=false;
   udB.Visible:=false;
   edA.Visible:=false;
   edB.Visible:=false;
   Calculs;
end;

procedure TfmLoiBinomiale.rbIntervalleClick(Sender: TObject);
begin
   lblK.Visible:=false;
   udK.Visible:=false;
   edK.Visible:=false;
   lblA.Visible:=true;
   lblB.Visible:=true;
   udA.Visible:=true;
   udB.Visible:=true;
   edA.Visible:=true;
   edB.Visible:=true;
   Calculs;
end;

procedure TfmLoiBinomiale.Image1Click(Sender: TObject);
begin
   rbInferieur.Checked:=true;
end;

procedure TfmLoiBinomiale.Image2Click(Sender: TObject);
begin
   rbSuperieur.Checked:=true;
end;

procedure TfmLoiBinomiale.Image3Click(Sender: TObject);
begin
   rbIntervalle.Checked:=true;
end;

procedure TfmLoiBinomiale.edNChange(Sender: TObject);
begin
   udB.Max:=udN.Position;
   udK.Max:=udN.Position;
   asgResultats.RowCount:=udN.Position+3;
   Calculs;
end;

procedure TfmLoiBinomiale.edAChange(Sender: TObject);
begin
   udB.Min:=udA.Position;
   Calculs;
end;

procedure TfmLoiBinomiale.edBChange(Sender: TObject);
begin
   udA.Max:=udB.Position;
   Calculs;
end;

procedure TfmLoiBinomiale.pnCouleurHistogrammeClick(Sender: TObject);
begin
   cdHistogramme.Color:=pnCouleurHistogramme.Color;
   if cdHistogramme.Execute then pnCouleurHistogramme.Color:=cdHistogramme.Color;
   calculs;
end;

procedure TfmLoiBinomiale.pnCouleurZoneClick(Sender: TObject);
begin
   cdZone.Color:=pnCouleurZone.Color;
   if cdZone.Execute then pnCouleurZone.Color:=cdZone.Color;
   calculs;
end;

procedure TfmLoiBinomiale.edKChange(Sender: TObject);
begin
   Calculs;
end;

procedure TfmLoiBinomiale.edPChange(Sender: TObject);
var p   : extended;
    i,n : integer;
begin
   p:=0;
   n:=udN.Position;
   try
      p:=StrToFloat(edP.text);
   except
   end;
   if (p>0)and(p<1) then Calculs
                    else for i:=0 to n+1 do asgResultats.cells[1,i+1]:='';
end;

procedure TfmLoiBinomiale.btAnnulerClick(Sender: TObject);
begin
   edP.Text:='0';calculs;
end;

procedure TfmLoiBinomiale.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmLoiBinomiale.asgResultatsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var i,k,n,a,b : integer;
    p         : extended;
    Texte : String;
begin
   p:=0;    //p=total des probabilits de la "zone" concerne
   with fmLoiBinomiale do
   begin
      Texte:=asgResultats.cells[ACol,ARow];
      n:=udN.Position;
      k:=udK.Position;
      a:=udA.Position;
      b:=udB.Position;
      if Arow*Acol=0 then GrilleCouleur(asgResultats,Rect,Texte,taCenter,clbtnFace,clBlack,[])
      else
         if (rbEgal.Checked and (ARow-1=k))
           or (rbInferieur.Checked and (ARow-1<=k))
           or (rbSuperieur.Checked and (Arow-1>=k))
           or (rbIntervalle.Checked and (ARow-1>=a)and(ARow-1<=b))
         then GrilleCouleur(asgResultats,Rect,Texte,taCenter,pnCouleurZone.Color,clBlack,[])
         else GrilleCouleur(asgResultats,Rect,Texte,taCenter,pnCouleurHistogramme.Color,clBlack,[]);
   end;
end;

procedure TfmLoiBinomiale.FormCreate(Sender: TObject);
begin
   asgResultats.cells[0,0]:='k';
   asgResultats.cells[1,0]:='P(X=k)';
   asgResultats.ColWidths[0]:=asgResultats.Canvas.textWidth('1000');
   asgResultats.ColWidths[1]:=asgResultats.Width-asgResultats.ColWidths[0]-3;
   FooterResultats.ColWidths[0]:=asgResultats.ColWidths[0];
   FooterResultats.ColWidths[1]:=asgResultats.ColWidths[1];
   FooterResultats.Cells[0,0]:='P =';
end;

procedure TfmLoiBinomiale.FooterResultatsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var Texte : string;
begin
   Texte:=FooterResultats.Cells[ACol,ARow];
   GrilleCouleur(FooterResultats,Rect,Texte,taCenter,clBtnFace,clBlack,[fsBold]);
end;

procedure TfmLoiBinomiale.btnAideClick(Sender: TObject);
begin
   Aide(54);
end;

end.
