unit uLoiNormale;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, shellAPI;

type
  TfmLoiNormale = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edMoyenne: TEdit;
    edSigma: TEdit;
    gbTypeCalcul: TGroupBox;
    lblA: TLabel;
    lblB: TLabel;
    rbInferieur: TRadioButton;
    rbSuperieur: TRadioButton;
    rbIntervalle: TRadioButton;
    edA: TEdit;
    edB: TEdit;
    rbIntervalleConfiance: TRadioButton;
    lblDegre: TLabel;
    edDegre: TEdit;
    udDegre: TUpDown;
    rgEpaisseur: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    pnCourbe: TPanel;
    lblCourbe: TLabel;
    lblZone: TLabel;
    pnZone: TPanel;
    cdCourbe: TColorDialog;
    cdZone: TColorDialog;
    cbDessiner: TCheckBox;
    btOK: TButton;
    lblResultat: TLabel;
    Label4: TLabel;
    lblConfiance: TLabel;
    lblResultatConfiance: TLabel;
    cbAfficher: TCheckBox;
    Label5: TLabel;
    edTitre: TEdit;
    rbEquation: TRadioButton;
    lblPegal: TLabel;
    edProb: TEdit;
    btAnnuler: TButton;
    Label6: TLabel;
    Label8: TLabel;
    Image1: TImage;
    btnAide: TButton;
    procedure lblZoneClick(Sender: TObject);
    procedure pnZoneClick(Sender: TObject);
    procedure lblCourbeClick(Sender: TObject);
    procedure pnCourbeClick(Sender: TObject);
    procedure rbInferieurClick(Sender: TObject);
    procedure rbSuperieurClick(Sender: TObject);
    procedure rbIntervalleClick(Sender: TObject);
    procedure rbIntervalleConfianceClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure udDegreClick(Sender: TObject; Button: TUDBtnType);
    procedure FormShow(Sender: TObject);
    procedure edSigmaKeyPress(Sender: TObject; var Key: Char);
    procedure edMoyenneKeyPress(Sender: TObject; var Key: Char);
    procedure edAKeyPress(Sender: TObject; var Key: Char);
    procedure edBKeyPress(Sender: TObject; var Key: Char);
    procedure edAChange(Sender: TObject);
    procedure edBChange(Sender: TObject);
    procedure edSigmaChange(Sender: TObject);
    procedure edMoyenneChange(Sender: TObject);
    procedure edDegreChange(Sender: TObject);
    procedure edDegreKeyPress(Sender: TObject; var Key: Char);
    procedure rbEquationClick(Sender: TObject);
    procedure edProbKeyPress(Sender: TObject; var Key: Char);
    procedure edProbChange(Sender: TObject);
    procedure btAnnulerClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  Function Prob(m,sigma,x:extended):extended;
  Function SeuilConfiance(m,sigma,degre : extended):extended;
  Function ReciproqueProb(m,sigma,x:extended):extended;

var
  fmLoiNormale: TfmLoiNormale;

implementation

uses uDessin;

{$R *.DFM}

Function Prob(m,sigma,x:extended):extended;   //calcul de p(X<x)
var r,t,dt,a,b : extended;
    n,k : integer;
    function f(t:extended):extended;
    begin
       result:=exp(-0.5*sqr((t-m)/sigma))/(sigma*sqrt(2*pi));
    end;
begin
   n:=20;
   a:=m-5*sigma; //borne infrieure de l'intervalle d'intgration
   b:=x;         //borne suprieure
   dt:=(b-a)/n;  //mthode de Simpson
   r:=f(a)+f(b);
   t:=a;
   for k:=1 to n-1 do
   begin
      t:=t+dt/2;
      r:=r+4*f(t);
      t:=t+dt/2;
      r:=r+2*f(t);
   end;
   t:=t+dt/2;
   r:=r+4*f(t);
   r:=dt/6*r;
   result:=r;
end;

Function ReciproqueProb(m,sigma,x:extended):extended;
var a,b : real;
begin
   a:=m-5*sigma;
   b:=m+5*sigma;
   while b-a>0.000001 do
      if Prob(m,sigma,(a+b)/2)>x then b:=(a+b)/2
                                 else a:=(a+b)/2;
   result:=(a+b)/2;
end;

Function SeuilConfiance(m,sigma,degre : extended):extended;
//retourne la borne suprieure de l'intervalle de confiance de degr de confiance donn
var a,b : real;
begin
   a:=m;
   b:=m+5*sigma;
   while (b-a>0.000001) do
   begin
      if (Prob(m,sigma,(a+b)/2)-0.5)>degre/2 then b:=(a+b)/2
                                             else a:=(a+b)/2;
   end;
   result:=(a+b)/2-m;
end;

Procedure Calculs;
var m,sigma,Seuil,a,b,degre,p : extended;
begin
   m:=0;sigma:=0;a:=0;b:=0;degre:=0;p:=0;
   try
      m:=StrToFloat(fmLoiNormale.edMoyenne.text);
      sigma:=StrToFloat(fmLoiNormale.edSigma.text);
      a:=StrToFloat(fmLoiNormale.edA.text);
      b:=StrToFloat(fmLoiNormale.edB.text);
      degre:=fmLoiNormale.udDegre.Position/10;
      p:=StrToFloat(fmLoiNormale.edProb.Text);
   except
   end;
   if sigma=0 then exit;
   if fmLoiNormale.rbInferieur.Checked then fmLoiNormale.lblResultat.Caption:=FloatToStrF(Prob(m,sigma,a),ffGeneral,6,6);
   if fmLoiNormale.rbSuperieur.Checked then fmLoiNormale.lblResultat.Caption:=FloatToStrF(1-Prob(m,sigma,a),ffGeneral,6,6);
   if fmLoiNormale.rbIntervalle.Checked then fmLoiNormale.lblResultat.Caption:=FloatToStrF(Prob(m,sigma,b)-Prob(m,sigma,a),ffGeneral,6,6);
   if fmLoiNormale.rbIntervalleConfiance.Checked then
   begin
      Seuil:=SeuilConfiance(m,sigma,degre/100);
      fmLoiNormale.lblResultat.Caption:=FloatToStrF(degre/100,ffGeneral,6,6);
      fmLoiNormale.lblConfiance.Visible:=true;
      fmLoiNormale.lblResultatConfiance.visible:=true;
      fmLoiNormale.lblResultatConfiance.Caption:='['+FloatToStrF(m-seuil,ffGeneral,6,6)+' ; '+
                                                     FloatToStrF(m+seuil,ffGeneral,6,6)+']';
   end;
   if fmLoiNormale.rbEquation.Checked then
   begin
      if p>0.5 then
      begin
         Seuil:=SeuilConfiance(m,sigma,(p-0.5)*2);
         fmLoiNormale.edA.Text:=FloatToStrF(m+Seuil,ffGeneral,6,6);
      end
      else
      begin
         Seuil:=SeuilConfiance(m,sigma,(0.5-p)*2);
         fmLoiNormale.edA.Text:=FloatToStrF(m-Seuil,ffGeneral,6,6);
      end;
   end;
end;

procedure TfmLoiNormale.lblZoneClick(Sender: TObject);
begin
   cdZone.Color:=pnZone.Color;
   if cdZone.Execute then pnZone.Color:=cdZone.Color;
end;

procedure TfmLoiNormale.pnZoneClick(Sender: TObject);
begin
   cdZone.Color:=pnZone.Color;
   if cdZone.Execute then pnZone.Color:=cdZone.Color;
end;

procedure TfmLoiNormale.lblCourbeClick(Sender: TObject);
begin
   cdCourbe.Color:=pnCourbe.Color;
   if cdCourbe.Execute then pnCourbe.Color:=cdCourbe.Color;
end;

procedure TfmLoiNormale.pnCourbeClick(Sender: TObject);
begin
   cdCourbe.Color:=pnCourbe.Color;
   if cdCourbe.Execute then pnCourbe.Color:=cdCourbe.Color;
end;

procedure TfmLoiNormale.rbInferieurClick(Sender: TObject);
begin
   lblA.Visible:=true;
   edA.Visible:=true;
   edA.ReadOnly:=false;
   lblB.Visible:=false;
   edB.Visible:=false;
   edDegre.Visible:=false;
   lblDegre.Visible:=false;
   udDegre.Visible:=false;
   lblConfiance.Visible:=false;
   lblResultatConfiance.Visible:=false;
   lblPegal.Visible:=false;
   edProb.Visible:=false;
   calculs;
end;

procedure TfmLoiNormale.rbSuperieurClick(Sender: TObject);
begin
   lblA.Visible:=true;
   edA.Visible:=true;
   edA.ReadOnly:=false;
   lblB.Visible:=false;
   edB.Visible:=false;
   edDegre.Visible:=false;
   lblDegre.Visible:=false;
   udDegre.Visible:=false;
   lblConfiance.Visible:=false;
   lblResultatConfiance.Visible:=false;
   lblPegal.Visible:=false;
   edProb.Visible:=false;
   calculs;
end;

procedure TfmLoiNormale.rbIntervalleClick(Sender: TObject);
begin
   lblA.Visible:=true;
   edA.Visible:=true;
   edA.ReadOnly:=false;
   lblB.Visible:=true;
   edB.Visible:=true;
   edDegre.Visible:=false;
   lblDegre.Visible:=false;
   udDegre.Visible:=false;
   lblConfiance.Visible:=false;
   lblResultatConfiance.Visible:=false;
   lblPegal.Visible:=false;
   edProb.Visible:=false;
   calculs;
end;

procedure TfmLoiNormale.rbIntervalleConfianceClick(Sender: TObject);
begin
   lblA.Visible:=false;
   edA.Visible:=false;
   edA.ReadOnly:=false;
   lblB.Visible:=false;
   edB.Visible:=false;
   edDegre.Visible:=true;
   lblDegre.Visible:=true;
   udDegre.Visible:=true;
   edDegre.Text:=floatToStr(udDegre.position/10);
   lblConfiance.Visible:=true;
   lblResultatConfiance.Visible:=true;
   lblPegal.Visible:=false;
   edProb.Visible:=false;
   Calculs;
end;

procedure TfmLoiNormale.FormActivate(Sender: TObject);
begin
//   rbInferieurClick(sender);
end;

procedure TfmLoiNormale.udDegreClick(Sender: TObject; Button: TUDBtnType);
begin
  edDegre.Text:=floatToStr(udDegre.position/10);
end;

procedure TfmLoiNormale.FormShow(Sender: TObject);
begin
  if rbInferieur.Checked then rbInferieurClick(sender);
  if rbSuperieur.Checked then rbSuperieurClick(sender);
  if rbIntervalle.Checked then rbIntervalleClick(sender);
  if rbIntervalleConfiance.Checked then rbIntervalleConfianceClick(sender);
  cbDessiner.Checked:=true;
end;

procedure TfmLoiNormale.edSigmaKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiNormale.edMoyenneKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiNormale.edAKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiNormale.edBKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiNormale.edAChange(Sender: TObject);
var A : real;
begin
   Try
      A:=StrToFloat(edA.text);
   except;
      exit;
   end;
   Calculs;
end;

procedure TfmLoiNormale.edBChange(Sender: TObject);
var B : real;
begin
   Try
      B:=StrToFloat(edB.text);
   except;
      exit;
   end;
   Calculs;
end;

procedure TfmLoiNormale.edSigmaChange(Sender: TObject);
var sigma : real;
begin
   try
      sigma:=StrToFloat(edSigma.text);
   except
      exit;
   end;
   Calculs;
end;

procedure TfmLoiNormale.edMoyenneChange(Sender: TObject);
var m : real;
begin
   try
      m:=StrToFloat(edMoyenne.text);
   except
      exit;
   end;
   calculs;
end;

procedure TfmLoiNormale.edDegreChange(Sender: TObject);
var degre : real;
begin
   try
      degre:=StrToFloat(edDegre.text);
      udDegre.Position:=round(degre*10);
   except
   end;
   Calculs;
end;

procedure TfmLoiNormale.edDegreKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiNormale.rbEquationClick(Sender: TObject);
begin
   lblA.Visible:=true;
   edA.Visible:=true;
   edA.ReadOnly:=true;
   lblB.Visible:=false;
   edB.Visible:=false;
   edDegre.Visible:=true;
   lblDegre.Visible:=true;
   udDegre.Visible:=true;
   edDegre.Text:=floatToStr(udDegre.position/10);
   lblConfiance.Visible:=false;
   lblResultatConfiance.Visible:=false;
   lblPegal.Visible:=true;
   edProb.Visible:=true;
end;

procedure TfmLoiNormale.edProbKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmLoiNormale.edProbChange(Sender: TObject);
var p : real;
begin
   try
      p:=StrToFloat(edProb.text);
      lblResultat.Caption:=FloatToStrF(p,ffGeneral,6,6);
   except
   end;
   Calculs;
end;

procedure TfmLoiNormale.btAnnulerClick(Sender: TObject);
//remet tous les composants dans leur tat standard
begin
   edMoyenne.Text:='0';
   edSigma.Text:='1';
   edA.Text:='0';
   edB.Text:='5';
   edTitre.Text:='';
   rbInferieur.Checked:=true;
   rgEpaisseur.ItemIndex:=0;
   lblResultat.Caption:='';
   cbAfficher.Checked:=false;
   cbDessiner.Checked:=true;
   calculs;
end;

procedure TfmLoiNormale.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmLoiNormale.btnAideClick(Sender: TObject);
begin
   Aide(57);
end;

end.
