unit uLoiPoisson;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ExtCtrls, ComCtrls, shellAPI;

type
  TfmLoiPoisson = class(TForm)
    Label1: TLabel;
    edLambda: TEdit;
    gbTypeCalcul: TGroupBox;
    lblA: TLabel;
    lblB: TLabel;
    lblK: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;             
    rbEgal: TRadioButton;
    rbInferieur: TRadioButton;
    rbSuperieur: TRadioButton;
    rbIntervalle: TRadioButton;
    edK: TEdit;
    udK: TUpDown;
    edA: TEdit;
    udA: TUpDown;
    edB: TEdit;
    udB: TUpDown;
    rgEpaisseur: TRadioGroup;
    gbCouleurs: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    pnCouleurHistogramme: TPanel;
    pnCouleurZone: TPanel;
    edTitre: TEdit;
    cbAffichageResultat: TCheckBox;
    cbAffichageParametres: TCheckBox;
    btAnnuler: TButton;
    btOK: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    cdHistogramme: TColorDialog;
    cdZone: TColorDialog;
    asgResultats: TStringGrid;
    FooterResultats: TStringGrid;
    Image4: TImage;
    Image5: TImage;
    btnAide: TButton;
    procedure edLambdaKeyPress(Sender: TObject; var Key: Char);
    procedure rbEgalClick(Sender: TObject);
    procedure rbInferieurClick(Sender: TObject);
    procedure rbSuperieurClick(Sender: TObject);
    procedure rbIntervalleClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure edAChange(Sender: TObject);
    procedure edBChange(Sender: TObject);
    procedure pnCouleurHistogrammeClick(Sender: TObject);
    procedure pnCouleurZoneClick(Sender: TObject);
    procedure edKChange(Sender: TObject);
    procedure edLambdaChange(Sender: TObject);
    procedure btAnnulerClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure asgResultatsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FooterResultatsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmLoiPoisson: TfmLoiPoisson;

implementation

uses uDessin;
{$R *.DFM}

Function Prob(k : integer;lambda : real):extended;
var n : integer;
    r : extended;
begin
   r:=1;
   for n:=1 to k do r:=r*n;   //calcul de k!
   result:=exp(-lambda)*exp(k*ln(lambda))/r;
end;

Function EstDansZone(i,k,a,b : integer):boolean;
begin
   result:=(fmLoiPoisson.rbEgal.Checked and (i=k))
           or (fmLoiPoisson.rbInferieur.Checked and (i<=k))
           or (fmLoiPoisson.rbSuperieur.Checked and (i>=k))
           or (fmLoiPoisson.rbIntervalle.Checked and (i>=a)and(i<=b));
end;

Procedure Calculs;
var i,n,k,a,b : integer;
    lambda,r,total : extended;
begin
   with fmLoiPoisson do
   begin
      try
         Lambda:=StrToFloat(edLambda.Text);
      except
         exit;
      end;
      i:=0;while prob(i,lambda)>0.000001 do inc(i);
      n:=i;
      asgResultats.rowcount:=n+2;
      k:=udK.Position;
      a:=udA.Position;
      b:=udB.Position;
      Total:=0;
      for i:=0 to n do
      begin
         asgResultats.cells[0,i+1]:=intToStr(i);
         r:=Prob(i,lambda);
         asgResultats.cells[1,i+1]:=FloatToStrF(r,ffGeneral,8,10);
         if (rbEgal.Checked and (i=k))
           or (rbInferieur.Checked and (i<=k))
           or (rbSuperieur.Checked and (i>=k))
           or (rbIntervalle.Checked and (i>=a)and(i<=b))
         then Total:=Total+r;
      end;
      FooterResultats.Cells[1,0]:=FloatToStrF(Total,ffGeneral,8,10);
   end;
end;


procedure TfmLoiPoisson.edLambdaKeyPress(Sender: TObject; var Key: Char);
begin
   if key='.' then key:=DecimalSeparator;
end;

procedure TfmLoiPoisson.rbEgalClick(Sender: TObject);
begin
   lblK.Visible:=true;
   udK.Visible:=true;
   edK.Visible:=true;
   lblA.Visible:=false;
   lblB.Visible:=false;
   udA.Visible:=false;
   udB.Visible:=false;
   edA.Visible:=false;
   edB.Visible:=false;
   Calculs;
end;

procedure TfmLoiPoisson.rbInferieurClick(Sender: TObject);
begin
   lblK.Visible:=true;
   udK.Visible:=true;
   edK.Visible:=true;
   lblA.Visible:=false;
   lblB.Visible:=false;
   udA.Visible:=false;
   udB.Visible:=false;
   edA.Visible:=false;
   edB.Visible:=false;
   Calculs;
end;

procedure TfmLoiPoisson.rbSuperieurClick(Sender: TObject);
begin
   lblK.Visible:=true;
   udK.Visible:=true;
   edK.Visible:=true;
   lblA.Visible:=false;
   lblB.Visible:=false;
   udA.Visible:=false;
   udB.Visible:=false;
   edA.Visible:=false;
   edB.Visible:=false;
   Calculs;
end;

procedure TfmLoiPoisson.rbIntervalleClick(Sender: TObject);
begin
   lblK.Visible:=false;
   udK.Visible:=false;
   edK.Visible:=false;
   lblA.Visible:=true;
   lblB.Visible:=true;
   udA.Visible:=true;
   udB.Visible:=true;
   edA.Visible:=true;
   edB.Visible:=true;
   Calculs;
end;

procedure TfmLoiPoisson.Image1Click(Sender: TObject);
begin
   rbInferieur.Checked:=true;
end;

procedure TfmLoiPoisson.Image2Click(Sender: TObject);
begin
   rbSuperieur.Checked:=true;
end;

procedure TfmLoiPoisson.Image3Click(Sender: TObject);
begin
   rbIntervalle.Checked:=true;
end;

procedure TfmLoiPoisson.edAChange(Sender: TObject);
begin
   udB.Min:=udA.Position;
   Calculs;
end;

procedure TfmLoiPoisson.edBChange(Sender: TObject);
begin
   udA.Max:=udB.Position;
   Calculs;
end;

procedure TfmLoiPoisson.pnCouleurHistogrammeClick(Sender: TObject);
begin
   cdHistogramme.Color:=pnCouleurHistogramme.Color;
   if cdHistogramme.Execute then pnCouleurHistogramme.Color:=cdHistogramme.Color;
end;

procedure TfmLoiPoisson.pnCouleurZoneClick(Sender: TObject);
begin
   cdZone.Color:=pnCouleurZone.Color;
   if cdZone.Execute then pnCouleurZone.Color:=cdZone.Color;
end;

procedure TfmLoiPoisson.edKChange(Sender: TObject);
begin
   Calculs;
end;

procedure TfmLoiPoisson.edLambdaChange(Sender: TObject);
var Lambda : real;
    i : integer;
begin
   Lambda:=0;
   try
      Lambda:=StrToFloat(edLambda.Text);
   except
   end;
   if (Lambda>0)and(Lambda<15) then Calculs
                               else for i:=1 to asgResultats.rowcount-1 do asgResultats.cells[1,i]:='';
end;

procedure TfmLoiPoisson.btAnnulerClick(Sender: TObject);
begin
   edLambda.Text:='0';
end;

procedure TfmLoiPoisson.FormShow(Sender: TObject);
begin
   if edLambda.Text='0' then edLambda.Text:='1';
end;

procedure TfmLoiPoisson.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmLoiPoisson.FormCreate(Sender: TObject);
begin
   asgResultats.cells[0,0]:='k';
   asgResultats.cells[1,0]:='P(X=k)';
   asgResultats.ColWidths[0]:=asgResultats.Canvas.textWidth('1000');
   asgResultats.ColWidths[1]:=asgResultats.Width-asgResultats.ColWidths[0]-3;
   FooterResultats.ColWidths[0]:=asgResultats.ColWidths[0];
   FooterResultats.ColWidths[1]:=asgResultats.ColWidths[1];
   FooterResultats.Cells[0,0]:='P =';
end;

procedure TfmLoiPoisson.asgResultatsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var i,k,a,b : integer;
    Texte   : String;
begin
   with fmLoiPoisson do
   begin
      Texte:=asgResultats.cells[ACol,ARow];
      k:=udK.Position;
      a:=udA.Position;
      b:=udB.Position;
      if Arow*Acol=0 then GrilleCouleur(asgResultats,Rect,Texte,taCenter,clbtnFace,clBlack,[])
      else
         if (rbEgal.Checked and (ARow-1=k))
           or (rbInferieur.Checked and (ARow-1<=k))
           or (rbSuperieur.Checked and (Arow-1>=k))
           or (rbIntervalle.Checked and (ARow-1>=a)and(ARow-1<=b))
         then GrilleCouleur(asgResultats,Rect,Texte,taCenter,pnCouleurZone.Color,clBlack,[])
         else GrilleCouleur(asgResultats,Rect,Texte,taCenter,pnCouleurHistogramme.Color,clBlack,[]);
   end;
end;

procedure TfmLoiPoisson.FooterResultatsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var Texte : string;
begin
   Texte:=FooterResultats.Cells[ACol,ARow];
   GrilleCouleur(FooterResultats,Rect,Texte,taCenter,clBtnFace,clBlack,[fsBold]);
end;

procedure TfmLoiPoisson.btnAideClick(Sender: TObject);
begin
   Aide(55);
end;

end.
