unit uMiseEnPage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ColorGrd, shellAPI;

type
  TfmMiseEnPage = class(TForm)
    rgOrientation: TRadioGroup;
    GroupBox1: TGroupBox;
    LabelLargeurMax: TLabel;
    LabelHauteurMax: TLabel;
    Label1: TLabel;
    edLargeur: TEdit;
    Label2: TLabel;
    edHauteur: TEdit;
    gbMarges: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    edMargeGauche: TEdit;
    edMargeHaute: TEdit;
    labelMargeGaucheMinimale: TLabel;
    LabelMargeHauteMinimale: TLabel;
    udMargeGauche: TUpDown;
    edmg: TEdit;
    edmh: TEdit;
    udMargeHaute: TUpDown;
    edLarg: TEdit;
    udLargeur: TUpDown;
    edHaut: TEdit;
    udHauteur: TUpDown;
    btnAnnuler: TButton;
    btnOK: TButton;
    Memo1: TMemo;
    cbCentrerHorizontalement: TCheckBox;
    cbCentrerVerticalement: TCheckBox;
    cbCadre: TCheckBox;
    cgCadre: TColorGrid;
    Label5: TLabel;
    pnCouleurFond: TPanel;
    cdFond: TColorDialog;
    btnAide: TButton;
    procedure edmgChange(Sender: TObject);
    procedure edmhChange(Sender: TObject);
    procedure edLargChange(Sender: TObject);
    procedure edHautChange(Sender: TObject);
    procedure edLargeurExit(Sender: TObject);
    procedure edHauteurExit(Sender: TObject);
    procedure edMargeGaucheExit(Sender: TObject);
    procedure edMargeHauteExit(Sender: TObject);
    procedure rgOrientationClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cbCentrerHorizontalementClick(Sender: TObject);
    procedure cbCentrerVerticalementClick(Sender: TObject);
    procedure cbCadreClick(Sender: TObject);
    procedure cgCadreClick(Sender: TObject);
    procedure pnCouleurFondClick(Sender: TObject);
    procedure cdFondShow(Sender: TObject);
    procedure edLargeurKeyPress(Sender: TObject; var Key: Char);
    procedure edHauteurKeyPress(Sender: TObject; var Key: Char);
    procedure edMargeGaucheKeyPress(Sender: TObject; var Key: Char);
    procedure edMargeHauteKeyPress(Sender: TObject; var Key: Char);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmMiseEnPage: TfmMiseEnPage;

implementation
uses uDessin;
{$R *.DFM}

procedure TfmMiseEnPage.edmgChange(Sender: TObject);
var ch,chLargeurMax : string;
begin
   ch:=FloatToStrF(udMargeGauche.position/10,ffFixed,4,1);
   if cbCentrerHorizontalement.checked
   then chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX,ffFixed,3,1)
   else chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX-udMargeGauche.position/10,ffFixed,3,1);
   labelLargeurMax.Caption:='( Largeur maximale : '+chLargeurMax+' cm )';
   edMargeGauche.Text:=ch+' cm';
   if cbCentrerHorizontalement.checked then udLargeur.Max:=Trunc(LargeurImprimable*25.4/ResX)
   else udLargeur.Max:=Trunc(LargeurImprimable*25.4/ResX-udMargeGauche.position);
   MargeGauche_mm:=udMargeGauche.position;
end;

procedure TfmMiseEnPage.edmhChange(Sender: TObject);
var ch,chHauteurMax : string;
begin
   ch:=FloatToStrF(udMargeHaute.position/10,ffFixed,4,1);
   if cbCentrerVerticalement.Checked
   then chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY,ffFixed,3,1)
   else chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY-udMargeHaute.position/10,ffFixed,3,1);
   labelHauteurMax.Caption:='( Hauteur maximale : '+chHauteurMax+' cm )';
   edMargeHaute.Text:=ch+' cm';
   if cbCentrerVerticalement.Checked then udHauteur.Max:=Trunc(HauteurImprimable*25.4/ResY)
   else udHauteur.Max:=Trunc(HauteurImprimable*25.4/ResY-udMargeHaute.position);
   MargeHaute_mm:=udMargeHaute.position;
end;

procedure TfmMiseEnPage.edLargChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udLargeur.position/10,ffFixed,4,1);
   edLargeur.Text:=ch+' cm';
   LargeurDessin_mm:=udLargeur.Position;
   if cbCentrerHorizontalement.checked then
      udMargeGauche.Position:=round((LargeurTotale/ResX*25.4-LargeurDessin_mm)/2);
   udMargeGauche.Max:=round(LargeurImprimable/ResX*25.4-udLargeur.position);
end;

procedure TfmMiseEnPage.edHautChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udHauteur.position/10,ffFixed,4,1);
   edHauteur.Text:=ch+' cm';
   HauteurDessin_mm:=udHauteur.Position;
   if cbCentrerVerticalement.Checked then
      udMargeHaute.Position:=round((HauteurTotale/ResY*25.4-HauteurDessin_mm)/2);
   udMargeHaute.Max:=round(HauteurImprimable*25.4/ResY-udHauteur.position);
end;

procedure TfmMiseEnPage.edLargeurExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edLargeur.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udLargeur.Position:=round(r);
end;

procedure TfmMiseEnPage.edHauteurExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edHauteur.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udHauteur.Position:=round(r);
end;

procedure TfmMiseEnPage.edMargeGaucheExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edMargeGauche.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udMargeGauche.Position:=round(r);
end;

procedure TfmMiseEnPage.edMargeHauteExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edMargeHaute.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udMargeHaute.Position:=round(r);
end;

procedure TfmMiseEnPage.rgOrientationClick(Sender: TObject);
var chMargeGaucheMin,chMargeHauteMin : string;
    mgMin_mm,mhMin_mm : integer; //marges gauche et haute minimales en millimtres
begin
   blPortrait:=rgOrientation.ItemIndex=0;
   fmDessin.InitialiserCanvasSortie;
   mgMin_mm:=trunc(MargeGaucheMin*25.4/resX)+1;
   mhMin_mm:=trunc(MargeHauteMin*25.4/ResY)+1;
   chMargeGaucheMin:=FloatToStrF(mgMin_mm/10,ffFixed,2,1);
   chMargeHauteMin:=FloatToStrF(mhMin_mm/10,ffFixed,2,1);
   labelMargeGaucheMinimale.Caption:='( Minimum : '+chMargeGaucheMin+' cm )';
   labelMargeHauteMinimale.Caption:='( Minimum : '+chMargeHauteMin+' cm )';
   edmgChange(sender);
   edmhChange(sender);
end;

procedure TfmMiseEnPage.FormShow(Sender: TObject);
var chLargeurMax,chHauteurMax,
    chMargeGaucheMin,chMargeHauteMin : string;
    mgMin_mm,mhMin_mm : integer; //marges gauche et haute minimales en millimtres
begin
   //on transmet les paramtres cls  la fiche de mise en page
   if blPortrait then rgOrientation.ItemIndex:=0 else rgOrientation.ItemIndex:=1;
   cbCadre.Checked:=blCadre;
   cgCadre.ForeGroundIndex:=cgCadre.ColorToIndex(clCadre);
   pnCouleurFond.Color:=clFond;
   mgMin_mm:=trunc(MargeGaucheMin*25.4/resX)+1;
   mhMin_mm:=trunc(MargeHauteMin*25.4/ResY)+1;
   if cbCentrerHorizontalement.checked
   then chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX,ffFixed,3,1)
   else chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX-MargeGauche_mm/10,ffFixed,3,1);
   if cbCentrerVerticalement.checked
   then chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY,ffFixed,3,1)
   else chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY-MargeHaute_mm/10,ffFixed,3,1);
   chMargeGaucheMin:=FloatToStrF(mgMin_mm/10,ffFixed,2,1);
   chMargeHauteMin:=FloatToStrF(mhMin_mm/10,ffFixed,2,1);
   labelLargeurMax.Caption:='( Largeur maximale : '+chLargeurMax+' cm )';
   labelHauteurMax.Caption:='( Hauteur maximale : '+chHauteurMax+' cm )';
   labelMargeGaucheMinimale.Caption:='( Minimum : '+chMargeGaucheMin+' cm )';
   labelMargeHauteMinimale.Caption:='( Minimum : '+chMargeHauteMin+' cm )';
   udMargeGauche.Min:=mgMin_mm;
   udMargeGauche.Max:=trunc(LargeurImprimable*25.4/ResX-LargeurDessin_mm);
   udMargeGauche.Position:=MargeGauche_mm;
   udMargeHaute.Min:=mhMin_mm;
   udMargeHaute.Max:=trunc(HauteurImprimable*25.4/ResY-HauteurDessin_mm);
   udMargeHaute.Position:=MargeHaute_mm;
   if cbCentrerHorizontalement.checked
      then udLargeur.Max:=trunc(LargeurImprimable*25.4/ResX)
      else udLargeur.Max:=trunc(LargeurImprimable*25.4/ResX-MargeGauche_mm);
   udLargeur.Position:=LargeurDessin_mm;
   if cbCentrerVerticalement.checked
      then udHauteur.Max:=trunc(HauteurImprimable*25.4/ResX)
      else udHauteur.Max:=trunc(HauteurImprimable*25.4/ResX-MargeHaute_mm);
   udHauteur.Position:=HauteurDessin_mm;
end;

procedure TfmMiseEnPage.cbCentrerHorizontalementClick(Sender: TObject);
begin
   if cbCentrerHorizontalement.Checked then
   begin
      udMargeGauche.position:=round((LargeurTotale/ResX*25.4-LargeurDessin_mm)/2);
      udMargeGauche.Enabled:=false;
      edMargeGauche.Enabled:=false;
   end
   else
   begin
      udMargeGauche.enabled:=true;
      edMargeGauche.Enabled:=true;
   end;
end;

procedure TfmMiseEnPage.cbCentrerVerticalementClick(Sender: TObject);
begin
   if cbCentrerVerticalement.checked then
   begin
      udMargeHaute.Position:=round((HauteurTotale/ResY*25.4-HauteurDessin_mm)/2);
      udMargeHaute.Enabled:=false;
      edMargeHaute.Enabled:=false;
   end
   else
   begin
      udMargeHaute.Enabled:=true;
      edMargeHaute.Enabled:=true;
   end;
end;

procedure TfmMiseEnPage.cbCadreClick(Sender: TObject);
begin
   blCadre:=cbCadre.checked;
end;

procedure TfmMiseEnPage.cgCadreClick(Sender: TObject);
begin
   clCadre:=cgCadre.ForegroundColor;
end;

procedure TfmMiseEnPage.pnCouleurFondClick(Sender: TObject);
begin
   cdFond.Color:=clFond;
   if cdFond.Execute then
   begin
      pnCouleurFond.Color:=cdFond.Color;
      clFond:=cdFond.Color;
   end;
end;

procedure TfmMiseEnPage.cdFondShow(Sender: TObject);
var titleColorDlg : Pchar;
begin
   titleColorDlg := Pchar('Slection d''une couleur pour l''arrire-plan du dessin');
   SendMessage(cdFond.Handle, WM_SetText, 0, Integer(titleColorDlg));
end;

procedure TfmMiseEnPage.edLargeurKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmMiseEnPage.edHauteurKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmMiseEnPage.edMargeGaucheKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmMiseEnPage.edMargeHauteKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmMiseEnPage.btnAideClick(Sender: TObject);
begin
   Aide(8);
end;

end.
