unit uObjDroite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, shellAPI;

type
  TfmObjDroite = class(TForm)
    Label1: TLabel;
    edNom: TEdit;
    rgDefinition: TRadioGroup;
    gbDefinition: TGroupBox;
    btAnnuler: TButton;
    btOK: TButton;
    LabelNomPoint1: TLabel;
    LabelNomPoint2: TLabel;
    LabelNomVecteurDirecteur: TLabel;
    LabelNomVecteurNormal: TLabel;
    LabelNomDroiteParallele: TLabel;
    LabelNomDroitePerpendiculaire: TLabel;
    LabelNomSegment: TLabel;
    LabelNomAngle3Points: TLabel;
    edPoint1: TEdit;
    edPoint2: TEdit;
    edVecteurDirecteur: TEdit;
    edVecteurNormal: TEdit;
    edDroiteParallele: TEdit;
    edDroitePerpendiculaire: TEdit;
    edSegment: TEdit;
    edAngle3Points: TEdit;
    LabelNomAngle2Vecteurs: TLabel;
    edAngle2Vecteurs: TEdit;
    rgEpaisseur: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    ColorGrid1: TColorGrid;
    Memo1: TMemo;
    btnAide: TButton;
    procedure rgDefinitionClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edNomExit(Sender: TObject);
    procedure edPoint1Exit(Sender: TObject);
    procedure edPoint2Exit(Sender: TObject);
    procedure edVecteurDirecteurExit(Sender: TObject);
    procedure edVecteurNormalExit(Sender: TObject);
    procedure edDroiteParalleleExit(Sender: TObject);
    procedure edDroitePerpendiculaireExit(Sender: TObject);
    procedure edSegmentExit(Sender: TObject);
    procedure edAngle3PointsExit(Sender: TObject);
    procedure edAngle2VecteursExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmObjDroite: TfmObjDroite;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmObjDroite.rgDefinitionClick(Sender: TObject);
var k : integer;
begin
   for k:=2 to ComponentCount-1 do
   //les composants 0 et 1 restent actifs : ce sont le label et le nom de la droite
   begin
      if Components[k] is TLabel then (Components[k] as TLabel).Enabled:=false;
      if Components[k] is TEdit then
      begin
         (Components[k] as TEdit).color:=clBtnFace;
         (Components[k] as TEdit).Enabled:=false;
      end;
   end;
   case rgDefinition.ItemIndex of
      0 : begin
             LabelNomPoint1.Caption:='Nom du premier point';
             LabelNomPoint1.Enabled:=true;
             LabelNomPoint2.Enabled:=true;
             edPoint1.Color:=clWindow;edPoint1.enabled:=true;
             edPoint2.Color:=clWindow;edPoint2.enabled:=true;
             if self.Visible then edPoint1.SetFocus;
          end;
      1 : begin
             LabelNomPoint1.Caption:='Nom du point';
             LabelNomPoint1.Enabled:=true;
             LabelNomVecteurDirecteur.Enabled:=true;
             edPoint1.Color:=clWindow;edPoint1.enabled:=true;
             edVecteurDirecteur.Color:=clWindow;edVecteurDirecteur.enabled:=true;
             if self.Visible then edPoint1.SetFocus;
          end;
      2 : begin
             LabelNomPoint1.Caption:='Nom du point';
             LabelNomPoint1.Enabled:=true;
             LabelNomVecteurNormal.Enabled:=true;
             edPoint1.Color:=clWindow;edPoint1.enabled:=true;
             edVecteurNormal.Color:=clWindow;edVecteurNormal.enabled:=true;
             if self.Visible then edPoint1.SetFocus;
          end;
      3 : begin
             LabelNomPoint1.Caption:='Nom du point';
             LabelNomPoint1.Enabled:=true;
             LabelNomDroiteParallele.Enabled:=true;
             edPoint1.Color:=clWindow;edPoint1.enabled:=true;
             edDroiteParallele.Color:=clWindow;edDroiteParallele.enabled:=true;
             if self.Visible then edPoint1.SetFocus;
          end;
      4 : begin
             LabelNomPoint1.Caption:='Nom du point';
             LabelNomPoint1.Enabled:=true;
             LabelNomDroitePerpendiculaire.Enabled:=true;
             edPoint1.Color:=clWindow;edPoint1.enabled:=true;
             edDroitePerpendiculaire.Color:=clWindow;edDroitePerpendiculaire.enabled:=true;
             if self.Visible then edPoint1.SetFocus;
          end;
      5 : begin
             LabelNomSegment.Enabled:=true;
             edSegment.Color:=clWindow;edSegment.enabled:=true;
             if self.Visible then edSegment.setFocus;
          end;
      6 : begin
             LabelNomAngle3Points.Enabled:=true;
             edAngle3Points.Color:=clWindow;edAngle3Points.enabled:=true;
             if self.Visible then edAngle3Points.SetFocus;
          end;
      7 : begin
             LabelNomAngle2Vecteurs.Enabled:=true;
             edAngle2Vecteurs.Color:=clWindow;edAngle2Vecteurs.enabled:=true;
             if self.Visible then edAngle2Vecteurs.SetFocus;
          end;
   end;
end;

procedure TfmObjDroite.FormActivate(Sender: TObject);
begin
   rgDefinitionClick(sender);
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmObjDroite.edNomExit(Sender: TObject);
begin
   edNom.Text:=SansEspace(edNom.Text);
end;

procedure TfmObjDroite.edPoint1Exit(Sender: TObject);
begin
   edPoint1.Text:=SansEspace(edPoint1.Text);
end;

procedure TfmObjDroite.edPoint2Exit(Sender: TObject);
begin
   edPoint2.Text:=SansEspace(edPoint2.Text);
end;

procedure TfmObjDroite.edVecteurDirecteurExit(Sender: TObject);
begin
   edVecteurDirecteur.Text:=SansEspace(edVecteurDirecteur.Text);
end;

procedure TfmObjDroite.edVecteurNormalExit(Sender: TObject);
begin
   edVecteurNormal.Text:=SansEspace(edVecteurNormal.Text);
end;

procedure TfmObjDroite.edDroiteParalleleExit(Sender: TObject);
begin
   edDroiteParallele.Text:=SansEspace(edDroiteParallele.Text);
end;

procedure TfmObjDroite.edDroitePerpendiculaireExit(Sender: TObject);
begin
   edDroitePerpendiculaire.Text:=SansEspace(edDroitePerpendiculaire.Text);
end;

procedure TfmObjDroite.edSegmentExit(Sender: TObject);
begin
   edSegment.Text:=SansEspace(edSegment.Text);
end;

procedure TfmObjDroite.edAngle3PointsExit(Sender: TObject);
begin
   edAngle3Points.Text:=SansEspace(edAngle3Points.Text);
end;

procedure TfmObjDroite.edAngle2VecteursExit(Sender: TObject);
begin
   edAngle2Vecteurs.Text:=SansEspace(edAngle2Vecteurs.Text);
end;

procedure TfmObjDroite.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmObjDroite.btnAideClick(Sender: TObject);
begin
   Aide(31);
end;

end.
