unit uPointParPoint;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ColorGrd, ExtCtrls, ComCtrls, Tabs, shellAPI, Menus,Printers,
  Buttons;

type
  TfmPointParPoint = class(TForm)
    GroupBox1: TGroupBox;
    Panel4: TPanel;
    Label1: TLabel;
    cgCouleur: TColorGrid;
    btAnnuler: TButton;
    btOK: TButton;
    Memo1: TMemo;
    cbLignesCotes: TCheckBox;
    GroupBox2: TGroupBox;
    rbPoint: TRadioButton;
    rbPlus: TRadioButton;
    rbCroix: TRadioButton;
    rbEtoile: TRadioButton;
    rbCarre: TRadioButton;
    rbLosange: TRadioButton;
    rgTaille: TRadioGroup;
    rbAucuneMarque: TRadioButton;
    Label2: TLabel;
    Label3: TLabel;
    rgType: TRadioGroup;
    MemoBezier: TMemo;
    edCoef: TEdit;
    udCoef: TUpDown;
    lblCoef: TLabel;
    grCourbesPentes: TStringGrid;
    grCourbesLissees: TStringGrid;
    TabControl1: TTabControl;
    Memo2: TMemo;
    rgTypeTangente: TRadioGroup;
    sgPoints: TStringGrid;
    sgBezier: TStringGrid;
    Label10: TLabel;
    edEpaisseur: TEdit;
    Edit1: TEdit;
    udEpaisseur: TUpDown;
    btnAide: TButton;
    pmPoints: TPopupMenu;
    mnCouperDonneesPoints: TMenuItem;
    mnCopierDonneesPoints: TMenuItem;
    mnCollerDonneesPoints: TMenuItem;
    pmBezier: TPopupMenu;
    mnCouperDonneesBezier: TMenuItem;
    mnCopierDonneesBezier: TMenuItem;
    mnCollerDonneesBezier: TMenuItem;
    BitBtnOuvrirCSV: TBitBtn;
    OpenDialog1: TOpenDialog;
    rbRond: TRadioButton;
    rbcarre2: TRadioButton;
    rbLosange2: TRadioButton;
    Image1: TImage;
    Label35: TLabel;
    mnSupprimertoutPoints: TMenuItem;
    mnSupprimertoutBezier: TMenuItem;
    Image2: TImage;
    Apercu: TImage;
    cbEchelleAutomatique: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure rgTypeClick(Sender: TObject);
    procedure TabControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure TabControl1Change(Sender: TObject);
    procedure btOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sgPointsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure sgPointsKeyPress(Sender: TObject; var Key: Char);
    procedure sgPointsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TabControl1DrawTab(Control: TCustomTabControl;
      TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure sgBezierDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure sgBezierKeyPress(Sender: TObject; var Key: Char);
    procedure sgBezierKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
    procedure mnCouperDonneesBezierClick(Sender: TObject);
    procedure mnCouperDonneesPointsClick(Sender: TObject);
    procedure mnCopierDonneesBezierClick(Sender: TObject);
    procedure mnCopierDonneesPointsClick(Sender: TObject);
    procedure mnCollerDonneesBezierClick(Sender: TObject);
    procedure mnCollerDonneesPointsClick(Sender: TObject);
    procedure BitBtnOuvrirCSVClick(Sender: TObject);
    procedure mnSupprimertoutPointsClick(Sender: TObject);
    procedure mnSupprimertoutBezierClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  Xmini,Xmaxi,Ymini,Ymaxi:  Real;
  end;

var
  fmPointParPoint: TfmPointParPoint;

implementation
uses uDessin;

{$R *.DFM}

procedure TfmPointParPoint.FormActivate(Sender: TObject);
var i : integer;
begin
   with sgPoints do
   begin
      //for i:=0 to 20 do for j:=0 to 4 do Alignments[j,i]:=taCenter;
      cells[0,0]:='n point';
      cells[1,0]:='x';
      cells[2,0]:='y';
      cells[3,0]:='y''';
      for i:=1 to 20 do cells[0,i]:=IntToStr(i);
   end;
   with sgBezier do
   begin
      //for i:=0 to 20 do for j:=0 to 3 do Alignments[j,i]:=taCenter;
      for i:=1 to 20 do cells[0,i]:=inttostr(i);
      cells[0,0]:='n point';
      cells[1,0]:='x';
      cells[2,0]:='y';
   end;
   if rgType.ItemIndex=0 then
   begin
      Memo1.Visible:=true;
      sgPoints.Visible:=true;
      rgTypeTangente.Visible:=true;
      MemoBezier.Visible:=false;
      sgBezier.Visible:=false;
      lblCoef.Visible:=false;
      edCoef.Visible:=false;
      udCoef.Visible:=false;
   end
   else
   begin
      Memo1.Visible:=false;
      sgPoints.Visible:=false;
      rgTypeTangente.Visible:=false;
      MemoBezier.Visible:=true;
      sgBezier.Visible:=true;
      lblCoef.Visible:=true;
      edCoef.Visible:=true;
      udCoef.Visible:=true;
   end;
  // rgTypeClick(sender);
  Xmini:=-9; Xmaxi:=9;
  Ymini:=-6; Ymini:=6;
end;

procedure TfmPointParPoint.rgTypeClick(Sender: TObject);
var n,i : integer;
begin
   n:=TabControl1.TabIndex;
   if rgType.ItemIndex=0 then
   begin
      Memo1.Visible:=true;
      sgPoints.Visible:=true;
      rgTypeTangente.Visible:=true;
      MemoBezier.Visible:=false;
      sgBezier.Visible:=false;
      lblCoef.Visible:=false;
      edCoef.Visible:=false;
      udCoef.Visible:=false;
      for i:=1 to 20 do //sauvegarde des donnes de la courbe lisse n n
      begin
         grCourbesLissees.cells[2*n,i]:=sgBezier.cells[1,i];     //abscisse du point i
         grCourbesLissees.cells[2*n+1,i]:=sgBezier.cells[2,i];   //ordonne
      end;
      grCourbesLissees.Cells[2*n,0]:=inttostr(cgCouleur.ForegroundColor);
      grCourbesLissees.Cells[2*n+1,0]:=inttostr(cgCouleur.BackgroundColor);
      if rbAucuneMarque.Checked then grCourbesLissees.cells[2*n,21]:='0';
      if rbPoint.Checked then grCourbesLissees.cells[2*n,21]:='1';
      if rbPlus.Checked then grCourbesLissees.cells[2*n,21]:='2';
      if rbCroix.Checked then grCourbesLissees.cells[2*n,21]:='3';
      if rbEtoile.Checked then grCourbesLissees.cells[2*n,21]:='4';
      if rbCarre.Checked then grCourbesLissees.cells[2*n,21]:='5';
      if rbLosange.Checked then grCourbesLissees.cells[2*n,21]:='6';
      if rbRond.Checked then grCourbesLissees.cells[2*n,21]:='7';
      if rbCarre2.Checked then grCourbesLissees.cells[2*n,21]:='8';
      if rbLosange2.Checked then grCourbesLissees.cells[2*n,21]:='9';
      grCourbesLissees.cells[2*n+1,21]:=IntToStr(udEpaisseur.Position-1);
      grCourbesLissees.cells[2*n,22]:=IntToStr(rgTaille.ItemIndex);
      if cbLignesCotes.Checked then grCourbesLissees.Cells[2*n+1,22]:='1'
                               else grCourbesLissees.Cells[2*n+1,22]:='0';
      grCourbesLissees.Cells[2*n,23]:=edCoef.Text;

      for i:=1 to 20 do  //rcupration des donnes de la courbe avec points et pentes n n
      begin
         sgPoints.cells[1,i]:=grCourbesPentes.cells[3*n,i];     //abscisse du point i
         sgPoints.cells[2,i]:=grCourbesPentes.cells[3*n+1,i];   //ordonne
         sgPoints.cells[3,i]:=grCourbesPentes.cells[3*n+2,i];   //pente
      end;
      if grCourbesPentes.cells[3*n,0]<>''
         then cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesPentes.Cells[3*n,0]))
         else cgCouleur.ForegroundIndex:=0;
      if grCourbesPentes.cells[3*n+1,0]<>''
         then cgCouleur.BackgroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesPentes.Cells[3*n+1,0]))
         else cgCouleur.BackgroundIndex:=0;
      rbAucuneMarque.Checked:=(grCourbesPentes.cells[3*n+2,0]='0')or(grCourbesPentes.cells[3*n+2,0]='');
      rbPoint.Checked:=(grCourbesPentes.cells[3*n+2,0]='1');
      rbPlus.Checked:=(grCourbesPentes.cells[3*n+2,0]='2');
      rbCroix.Checked:=(grCourbesPentes.cells[3*n+2,0]='3');
      rbEtoile.Checked:=(grCourbesPentes.cells[3*n+2,0]='4');
      rbCarre.Checked:=(grCourbesPentes.cells[3*n+2,0]='5');
      rbLosange.Checked:=(grCourbesPentes.cells[3*n+2,0]='6');
      rbRond.Checked:=(grCourbesPentes.cells[3*n+2,0]='7');
      rbCarre2.Checked:=(grCourbesPentes.cells[3*n+2,0]='8');
      rbLosange2.Checked:=(grCourbesPentes.cells[3*n+2,0]='9');
      if grCourbesPentes.cells[3*n,21]='' then i:=1 else i:=StrToInt(grCourbesPentes.cells[3*n,21])mod 10;
      udEpaisseur.Position:=i+1;
      if grCourbesPentes.cells[3*n,21]='' then i:=0 else i:=StrToInt(grCourbesPentes.cells[3*n,21])div 10;
      rgTypeTangente.Itemindex:=i;
      if grCourbesPentes.cells[3*n+1,21]='' then i:=0 else i:=StrToInt(grCourbesPentes.cells[3*n+1,21]);
      rgTaille.ItemIndex:=i;
      cbLignesCotes.Checked:=(grCourbesPentes.Cells[3*n+2,21]='1');
   end
   else
   begin
      Memo1.Visible:=false;
      sgPoints.Visible:=false;
      rgTypeTangente.Visible:=false;
      MemoBezier.Visible:=true;
      sgBezier.Visible:=true;
      lblCoef.Visible:=true;
      edCoef.Visible:=true;
      udCoef.Visible:=true;
      for i:=1 to 20 do   //sauvegarde des donnes de la courbe dfinie par points et pentes
      begin
         grCourbesPentes.cells[3*n,i]:=sgPoints.cells[1,i];     //abscisse du point i
         grCourbesPentes.cells[3*n+1,i]:=sgPoints.cells[2,i];   //ordonne
         grCourbesPentes.cells[3*n+2,i]:=sgPoints.cells[3,i];   //pente
      end;
      grCourbesPentes.Cells[3*n,0]:=inttostr(cgCouleur.ForegroundColor);
      grCourbesPentes.Cells[3*n+1,0]:=inttostr(cgCouleur.BackgroundColor);
      if rbAucuneMarque.Checked then grCourbesPentes.cells[3*n+2,0]:='0';
      if rbPoint.Checked then grCourbesPentes.cells[3*n+2,0]:='1';
      if rbPlus.Checked then grCourbesPentes.cells[3*n+2,0]:='2';
      if rbCroix.Checked then grCourbesPentes.cells[3*n+2,0]:='3';
      if rbEtoile.Checked then grCourbesPentes.cells[3*n+2,0]:='4';
      if rbCarre.Checked then grCourbesPentes.cells[3*n+2,0]:='5';
      if rbLosange.Checked then grCourbesPentes.cells[3*n+2,0]:='6';
      if rbRond.Checked then grCourbesPentes.cells[3*n+2,0]:='7';
      if rbCarre2.Checked then grCourbesPentes.cells[3*n+2,0]:='8';
      if rbLosange2.Checked then grCourbesPentes.cells[3*n+2,0]:='9';
      grCourbesPentes.cells[3*n,21]:=IntToStr(udEpaisseur.Position-1+10*rgTypeTangente.ItemIndex);
      grCourbesPentes.cells[3*n+1,21]:=IntToStr(rgTaille.ItemIndex);
      if cbLignesCotes.Checked then grCourbesPentes.Cells[3*n+2,21]:='1'
                               else grCourbesPentes.Cells[3*n+2,21]:='0';

      for i:=1 to 20 do   //rcupration de la courbe lisse n n
      begin
         sgBezier.cells[1,i]:=grCourbesLissees.cells[2*n,i];     //abscisse du point i
         sgBezier.cells[2,i]:=grCourbesLissees.cells[2*n+1,i];   //ordonne
      end;
      if grCourbesLissees.cells[2*n,0]<>''
         then cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesLissees.Cells[2*n,0]))
         else cgCouleur.ForeGroundIndex:=0;
      if grCourbesLissees.cells[2*n+1,0]<>''
         then cgCouleur.BackgroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesLissees.Cells[2*n+1,0]))
         else cgCouleur.BackGroundIndex:=0;
      rbAucuneMarque.Checked:=(grCourbesLissees.cells[2*n,21]='0')or(grCourbesLissees.cells[2*n,21]='');
      rbPoint.Checked:=(grCourbesLissees.cells[2*n,21]='1');
      rbPlus.Checked:=(grCourbesLissees.cells[2*n,21]='2');
      rbCroix.Checked:=(grCourbesLissees.cells[2*n,21]='3');
      rbEtoile.Checked:=(grCourbesLissees.cells[2*n,21]='4');
      rbCarre.Checked:=(grCourbesLissees.cells[2*n,21]='5');
      rbLosange.Checked:=(grCourbesLissees.cells[2*n,21]='6');
      rbRond.Checked:=(grCourbesLissees.cells[2*n,21]='7');
      rbCarre2.Checked:=(grCourbesLissees.cells[2*n,21]='8');
      rbLosange2.Checked:=(grCourbesLissees.cells[2*n,21]='9');
      if grCourbesLissees.cells[2*n+1,21]='' then i:=1 else i:=StrToInt(grCourbesLissees.cells[2*n+1,21]);
      udEpaisseur.Position:=i+1;
      if grCourbesLissees.cells[2*n,22]='' then i:=0 else i:=StrToInt(grCourbesLissees.cells[2*n,22]);
      rgTaille.ItemIndex:=i;
      cbLignesCotes.Checked:=(grCourbesLissees.Cells[2*n+1,22]='1');
      if grCourbeslissees.cells[2*n,23]='' then udCoef.Position:=50
                                           else udCoef.Position:=StrToInt(grCourbesLissees.Cells[2*n,23]);
   end;
end;

Procedure TrierGrilleCourbesPentes(n:integer);
//tri en ordre croissant automatique des absccises des points de la courbe n n avec pentes
var i,j,k : integer;
    s : string;
begin
   i:=20;
   with fmPointParPoint do
   begin
      while (grCourbesPentes.cells[3*n,i]='')and(i>0) do dec(i);
      if i=0 then exit
      else
      begin
         for j:=i-1 downto 1 do for k:=1 to j do
         if strtofloat(grCourbesPentes.cells[3*n,k])>strtofloat(grCourbesPentes.cells[3*n,k+1]) then
         begin
            s:=grCourbesPentes.cells[3*n,k];grCourbesPentes.cells[3*n,k]:=grCourbesPentes.cells[3*n,k+1];grCourbesPentes.cells[3*n,k+1]:=s;
            s:=grCourbesPentes.cells[3*n+1,k];grCourbesPentes.cells[3*n+1,k]:=grCourbesPentes.cells[3*n+1,k+1];grCourbesPentes.cells[3*n+1,k+1]:=s;
            s:=grCourbesPentes.cells[3*n+2,k];grCourbesPentes.cells[3*n+2,k]:=grCourbesPentes.cells[3*n+2,k+1];grCourbesPentes.cells[3*n+2,k+1]:=s;
         end;
      end;
   end;
end;

procedure TfmPointParPoint.TabControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
  //permet de sauvegarder les points de la courbe courante avant de changer de courbe
  var i,n,p : integer;
begin
   n:=TabControl1.TabIndex;
   p:=rgType.ItemIndex;
   if p=0 then
   begin      //on sauvegarde la courbe dfinie avec points et pentes
      for i:=1 to 20 do
      begin
         grCourbesPentes.cells[3*n,i]:=sgPoints.cells[1,i];     //abscisse du point i
         grCourbesPentes.cells[3*n+1,i]:=sgPoints.cells[2,i];   //ordonne
         grCourbesPentes.cells[3*n+2,i]:=sgPoints.cells[3,i];   //pente
      end;
      TrierGrilleCourbesPentes(n);
      grCourbesPentes.Cells[3*n,0]:=inttostr(cgCouleur.ForegroundColor);
      grCourbesPentes.Cells[3*n+1,0]:=inttostr(cgCouleur.BackgroundColor);
      if rbAucuneMarque.Checked then grCourbesPentes.cells[3*n+2,0]:='0';
      if rbPoint.Checked then grCourbesPentes.cells[3*n+2,0]:='1';
      if rbPlus.Checked then grCourbesPentes.cells[3*n+2,0]:='2';
      if rbCroix.Checked then grCourbesPentes.cells[3*n+2,0]:='3';
      if rbEtoile.Checked then grCourbesPentes.cells[3*n+2,0]:='4';
      if rbCarre.Checked then grCourbesPentes.cells[3*n+2,0]:='5';
      if rbLosange.Checked then grCourbesPentes.cells[3*n+2,0]:='6';
      if rbRond.Checked then grCourbesPentes.cells[3*n+2,0]:='7';
      if rbCarre2.Checked then grCourbesPentes.cells[3*n+2,0]:='8';
      if rbLosange2.Checked then grCourbesPentes.cells[3*n+2,0]:='9';
      grCourbesPentes.cells[3*n,21]:=IntToStr(udEpaisseur.Position-1+10*rgTypeTangente.ItemIndex);
      grCourbesPentes.cells[3*n+1,21]:=IntToStr(rgTaille.ItemIndex);
      if cbLignesCotes.Checked then grCourbesPentes.Cells[3*n+2,21]:='1'
                               else grCourbesPentes.Cells[3*n+2,21]:='0';
   end
   else
   begin   //on sauvegarde la courbe dfinie avec points et lissage
      for i:=1 to 20 do
      begin
         grCourbesLissees.cells[2*n,i]:=sgBezier.cells[1,i];     //abscisse du point i
         grCourbesLissees.cells[2*n+1,i]:=sgBezier.cells[2,i];   //ordonne
      end;
      grCourbesLissees.Cells[2*n,0]:=inttostr(cgCouleur.ForegroundColor);
      grCourbesLissees.Cells[2*n+1,0]:=inttostr(cgCouleur.BackgroundColor);
      if rbAucuneMarque.Checked then grCourbesLissees.cells[2*n,21]:='0';
      if rbPoint.Checked then grCourbesLissees.cells[2*n,21]:='1';
      if rbPlus.Checked then grCourbesLissees.cells[2*n,21]:='2';
      if rbCroix.Checked then grCourbesLissees.cells[2*n,21]:='3';
      if rbEtoile.Checked then grCourbesLissees.cells[2*n,21]:='4';
      if rbCarre.Checked then grCourbesLissees.cells[2*n,21]:='5';
      if rbLosange.Checked then grCourbesLissees.cells[2*n,21]:='6';
      if rbRond.Checked then grCourbesLissees.cells[2*n,21]:='7';
      if rbCarre2.Checked then grCourbesLissees.cells[2*n,21]:='8';
      if rbLosange2.Checked then grCourbesLissees.cells[2*n,21]:='9';
      grCourbesLissees.cells[2*n+1,21]:=IntToStr(udEpaisseur.Position-1);
      grCourbesLissees.cells[2*n,22]:=IntToStr(rgTaille.ItemIndex);
      if cbLignesCotes.Checked then grCourbesLissees.Cells[2*n+1,22]:='1'
                               else grCourbesLissees.Cells[2*n+1,22]:='0';
      grCourbesLissees.Cells[2*n,23]:=edCoef.Text;
   end;
end;

procedure TfmPointParPoint.TabControl1Change(Sender: TObject);
//permet de remplir les 2 grilles sgPoints et sgBezier avec les valeurs sauvegardes de la courbe indique
var i,n,p : integer;
begin
   n:=TabControl1.TabIndex;
   p:=rgType.ItemIndex;
   if p=0 then  //on rcupre la courbe dfinie avec points et pentes
   begin
      for i:=1 to 20 do
      begin
         sgPoints.cells[1,i]:=grCourbesPentes.cells[3*n,i];     //abscisse du point i
         sgPoints.cells[2,i]:=grCourbesPentes.cells[3*n+1,i];   //ordonne
         sgPoints.cells[3,i]:=grCourbesPentes.cells[3*n+2,i];   //pente
      end;
      if grCourbesPentes.cells[3*n,0]<>''
         then cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesPentes.Cells[3*n,0]))
         else cgCouleur.ForegroundIndex:=0;
      if grCourbesPentes.cells[3*n+1,0]<>''
         then cgCouleur.BackgroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesPentes.Cells[3*n+1,0]))
         else cgCouleur.BackgroundIndex:=0;
      rbAucuneMarque.Checked:=(grCourbesPentes.cells[3*n+2,0]='0')or(grCourbesPentes.cells[3*n+2,0]='');
      rbPoint.Checked:=(grCourbesPentes.cells[3*n+2,0]='1');
      rbPlus.Checked:=(grCourbesPentes.cells[3*n+2,0]='2');
      rbCroix.Checked:=(grCourbesPentes.cells[3*n+2,0]='3');
      rbEtoile.Checked:=(grCourbesPentes.cells[3*n+2,0]='4');
      rbCarre.Checked:=(grCourbesPentes.cells[3*n+2,0]='5');
      rbLosange.Checked:=(grCourbesPentes.cells[3*n+2,0]='6');
      rbRond.Checked:=(grCourbesPentes.cells[3*n+2,0]='7');
      rbCarre2.Checked:=(grCourbesPentes.cells[3*n+2,0]='8');
      rbLosange2.Checked:=(grCourbesPentes.cells[3*n+2,0]='9');
      if grCourbesPentes.cells[3*n,21]='' then i:=1 else i:=StrToInt(grCourbesPentes.cells[3*n,21])mod 10;
      udEpaisseur.Position:=i+1;
      if grCourbesPentes.cells[3*n,21]='' then i:=0 else i:=StrToInt(grCourbesPentes.cells[3*n,21])div 10;
      rgTypeTangente.Itemindex:=i;
      if grCourbesPentes.cells[3*n+1,21]='' then i:=0 else i:=StrToInt(grCourbesPentes.cells[3*n+1,21]);
      rgTaille.ItemIndex:=i;
      cbLignesCotes.Checked:=(grCourbesPentes.Cells[3*n+2,21]='1');
   end
   else
   begin   //on rcupre la courbe dfinie avec points et lissage
      for i:=1 to 20 do
      begin
         sgBezier.cells[1,i]:=grCourbesLissees.cells[2*n,i];     //abscisse du point i
         sgBezier.cells[2,i]:=grCourbesLissees.cells[2*n+1,i];   //ordonne
      end;
      if grCourbesLissees.cells[2*n,0]<>''
         then cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesLissees.Cells[2*n,0]))
         else cgCouleur.ForeGroundIndex:=0;
      if grCourbesLissees.cells[2*n+1,0]<>''
         then cgCouleur.BackgroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesLissees.Cells[2*n+1,0]))
         else cgCouleur.BackGroundIndex:=0;
      rbAucuneMarque.Checked:=(grCourbesLissees.cells[2*n,21]='0')or(grCourbesLissees.cells[2*n,21]='');
      rbPoint.Checked:=(grCourbesLissees.cells[2*n,21]='1');
      rbPlus.Checked:=(grCourbesLissees.cells[2*n,21]='2');
      rbCroix.Checked:=(grCourbesLissees.cells[2*n,21]='3');
      rbEtoile.Checked:=(grCourbesLissees.cells[2*n,21]='4');
      rbCarre.Checked:=(grCourbesLissees.cells[2*n,21]='5');
      rbLosange.Checked:=(grCourbesLissees.cells[2*n,21]='6');
      rbRond.Checked:=(grCourbesLissees.cells[2*n,21]='7');
      rbCarre2.Checked:=(grCourbesLissees.cells[2*n,21]='8');
      rbLosange2.Checked:=(grCourbesLissees.cells[2*n,21]='9');
      if grCourbesLissees.cells[2*n+1,21]='' then i:=1 else i:=StrToInt(grCourbesLissees.cells[2*n+1,21]);
      udEpaisseur.Position:=i+1;
      if grCourbesLissees.cells[2*n,22]='' then i:=0 else i:=StrToInt(grCourbesLissees.cells[2*n,22]);
      rgTaille.ItemIndex:=i;
      cbLignesCotes.Checked:=(grCourbesLissees.Cells[2*n+1,22]='1');
      if grCourbeslissees.cells[2*n,23]='' then udCoef.Position:=50
                                           else udCoef.Position:=StrToInt(grCourbesLissees.Cells[2*n,23]);
   end;
end;

procedure TfmPointParPoint.btOKClick(Sender: TObject);
var
	n,p,i:  integer;
   x,y:    double;
   s:      string;

begin
   n:=TabControl1.TabIndex;
   p:=rgType.ItemIndex;
   if p=0 then
   begin      //on sauvegarde la courbe dfinie avec points et pentes
      for i:=1 to 20 do
      begin
         grCourbesPentes.cells[3*n,i]:=sgPoints.cells[1,i];     //abscisse du point i
         grCourbesPentes.cells[3*n+1,i]:=sgPoints.cells[2,i];   //ordonne
         grCourbesPentes.cells[3*n+2,i]:=sgPoints.cells[3,i];   //pente
      end;
      TrierGrilleCourbesPentes(n);
      grCourbesPentes.Cells[3*n,0]:=inttostr(cgCouleur.ForegroundColor);
      grCourbesPentes.Cells[3*n+1,0]:=inttostr(cgCouleur.BackgroundColor);
      if rbAucuneMarque.Checked then grCourbesPentes.cells[3*n+2,0]:='0';
      if rbPoint.Checked then grCourbesPentes.cells[3*n+2,0]:='1';
      if rbPlus.Checked then grCourbesPentes.cells[3*n+2,0]:='2';
      if rbCroix.Checked then grCourbesPentes.cells[3*n+2,0]:='3';
      if rbEtoile.Checked then grCourbesPentes.cells[3*n+2,0]:='4';
      if rbCarre.Checked then grCourbesPentes.cells[3*n+2,0]:='5';
      if rbLosange.Checked then grCourbesPentes.cells[3*n+2,0]:='6';
      if rbRond.Checked then grCourbesPentes.cells[3*n+2,0]:='7';
      if rbCarre2.Checked then grCourbesPentes.cells[3*n+2,0]:='8';
      if rbLosange2.Checked then grCourbesPentes.cells[3*n+2,0]:='9';
      grCourbesPentes.cells[3*n,21]:=IntToStr(udEpaisseur.Position-1+10*rgTypeTangente.ItemIndex);
      grCourbesPentes.cells[3*n+1,21]:=IntToStr(rgTaille.ItemIndex);
      if cbLignesCotes.Checked then grCourbesPentes.Cells[3*n+2,21]:='1'
                               else grCourbesPentes.Cells[3*n+2,21]:='0';
   end
   else
   begin   //on sauvegarde la courbe dfinie avec points et lissage
      for i:=1 to 20 do
      begin
         grCourbesLissees.cells[2*n,i]:=sgBezier.cells[1,i];     //abscisse du point i
         grCourbesLissees.cells[2*n+1,i]:=sgBezier.cells[2,i];   //ordonne
      end;
      grCourbesLissees.Cells[2*n,0]:=inttostr(cgCouleur.ForegroundColor);
      grCourbesLissees.Cells[2*n+1,0]:=inttostr(cgCouleur.BackgroundColor);
      if rbAucuneMarque.Checked then grCourbesLissees.cells[2*n,21]:='0';
      if rbPoint.Checked then grCourbesLissees.cells[2*n,21]:='1';
      if rbPlus.Checked then grCourbesLissees.cells[2*n,21]:='2';
      if rbCroix.Checked then grCourbesLissees.cells[2*n,21]:='3';
      if rbEtoile.Checked then grCourbesLissees.cells[2*n,21]:='4';
      if rbCarre.Checked then grCourbesLissees.cells[2*n,21]:='5';
      if rbLosange.Checked then grCourbesLissees.cells[2*n,21]:='6';
      if rbRond.Checked then grCourbesLissees.cells[2*n,21]:='7';
      if rbCarre2.Checked then grCourbesLissees.cells[2*n,21]:='8';
      if rbLosange2.Checked then grCourbesLissees.cells[2*n,21]:='9';
      grCourbesLissees.cells[2*n+1,21]:=IntToStr(udEpaisseur.Position-1);
      grCourbesLissees.cells[2*n,22]:=IntToStr(rgTaille.ItemIndex);
      if cbLignesCotes.Checked then grCourbesLissees.Cells[2*n+1,22]:='1'
                               else grCourbesLissees.Cells[2*n+1,22]:='0';
      grCourbesLissees.Cells[2*n,23]:=edCoef.Text;
   end;
   //dtermination des bornes pour la dfinition de la fentre
   Xmini:=1E100;Xmaxi:=-1E100;Ymini:=1E100;Ymaxi:=-1E100;
   for n:=0 to 9        
   	do begin
      if p=0            //si points et pentes
      	then begin
         for i:=1 to 20
				do begin
   			s:=grCourbesPentes.cells[3*n,i];
   			if TryStrToFloat(s,x)  //si s est bien numrique
   				then begin
               if x<Xmini then Xmini:=x;
               if x>Xmaxi then Xmaxi:=x;
               end;
   			s:=grCourbesPentes.cells[3*n+1,i];
   			if TryStrToFloat(s,y)  //si s est bien numrique
   				then begin
               if y<Ymini then Ymini:=y;
               if y>Ymaxi then Ymaxi:=y;
               end;
   			end;
         end else begin  // si Bzier
         for i:=1 to 20
				do begin
   			s:=grCourbesLissees.cells[2*n,i];
   			if TryStrToFloat(s,x)  //si s est bien numrique
   				then begin
               if x<Xmini then Xmini:=x;
               if x>Xmaxi then Xmaxi:=x;
               end;
   			s:=grCourbesLissees.cells[2*n+1,i];
   			if TryStrToFloat(s,y)  //si s est bien numrique
   				then begin
               if y<Ymini then Ymini:=y;
               if y>Ymaxi then Ymaxi:=y;
               end;
   			end;
         end;
      end;
   if Xmini>1E100 then Xmini:=-9;
   if Xmaxi<-1E100 then Xmaxi:=9;
   if Ymini>1E100 then Ymini:=-6;
   if Ymaxi<-1E100 then Ymaxi:=6;
end;

procedure TfmPointParPoint.FormShow(Sender: TObject);
var n,i : integer;
begin
   n:=TabControl1.TabIndex;
   if rgType.ItemIndex=0 then
   begin
      Memo1.Visible:=true;
      sgPoints.Visible:=true;
      MemoBezier.Visible:=false;
      sgBezier.Visible:=false;
      lblCoef.Visible:=false;
      edCoef.Visible:=false;
      udCoef.Visible:=false;

      for i:=1 to 20 do  //rcupration des donnes de la courbe avec points et pentes n n
      begin
         sgPoints.cells[1,i]:=grCourbesPentes.cells[3*n,i];     //abscisse du point i
         sgPoints.cells[2,i]:=grCourbesPentes.cells[3*n+1,i];   //ordonne
         sgPoints.cells[3,i]:=grCourbesPentes.cells[3*n+2,i];   //pente
      end;
      if grCourbesPentes.cells[3*n,0]<>''
         then cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesPentes.Cells[3*n,0]))
         else cgCouleur.ForegroundIndex:=0;
      if grCourbesPentes.cells[3*n+1,0]<>''
         then cgCouleur.BackgroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesPentes.Cells[3*n+1,0]))
         else cgCouleur.BackgroundIndex:=0;
      rbAucuneMarque.Checked:=(grCourbesPentes.cells[3*n+2,0]='0')or(grCourbesPentes.cells[3*n+2,0]='');
      rbPoint.Checked:=(grCourbesPentes.cells[3*n+2,0]='1');
      rbPlus.Checked:=(grCourbesPentes.cells[3*n+2,0]='2');
      rbCroix.Checked:=(grCourbesPentes.cells[3*n+2,0]='3');
      rbEtoile.Checked:=(grCourbesPentes.cells[3*n+2,0]='4');
      rbCarre.Checked:=(grCourbesPentes.cells[3*n+2,0]='5');
      rbLosange.Checked:=(grCourbesPentes.cells[3*n+2,0]='6');
      rbRond.Checked:=(grCourbesPentes.cells[3*n+2,0]='7');
      rbCarre2.Checked:=(grCourbesPentes.cells[3*n+2,0]='8');
      rbLosange2.Checked:=(grCourbesPentes.cells[3*n+2,0]='9');
      if grCourbesPentes.cells[3*n,21]='' then i:=1 else i:=StrToInt(grCourbesPentes.cells[3*n,21])mod 10;
      udEpaisseur.Position:=i+1;
      if grCourbesPentes.cells[3*n,21]='' then i:=0 else i:=StrToInt(grCourbesPentes.cells[3*n,21])div 10;
      rgTypeTangente.Itemindex:=i;
      if grCourbesPentes.cells[3*n+1,21]='' then i:=0 else i:=StrToInt(grCourbesPentes.cells[3*n+1,21]);
      rgTaille.ItemIndex:=i;
      cbLignesCotes.Checked:=(grCourbesPentes.Cells[3*n+2,21]='1');
   end
   else
   begin
      Memo1.Visible:=false;
      sgPoints.Visible:=false;
      MemoBezier.Visible:=true;
      sgBezier.Visible:=true;
      lblCoef.Visible:=true;
      edCoef.Visible:=true;
      udCoef.Visible:=true;

      for i:=1 to 20 do   //rcupration de la courbe lisse n n
      begin
         sgBezier.cells[1,i]:=grCourbesLissees.cells[2*n,i];     //abscisse du point i
         sgBezier.cells[2,i]:=grCourbesLissees.cells[2*n+1,i];   //ordonne
      end;
      if grCourbesLissees.cells[2*n,0]<>''
         then cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesLissees.Cells[2*n,0]))
         else cgCouleur.ForeGroundIndex:=0;
      if grCourbesLissees.cells[2*n+1,0]<>''
         then cgCouleur.BackgroundIndex:=cgCouleur.ColorToIndex(StrToInt(grCourbesLissees.Cells[2*n+1,0]))
         else cgCouleur.BackGroundIndex:=0;
      rbAucuneMarque.Checked:=(grCourbesLissees.cells[2*n,21]='0')or(grCourbesLissees.cells[2*n,21]='');
      rbPoint.Checked:=(grCourbesLissees.cells[2*n,21]='1');
      rbPlus.Checked:=(grCourbesLissees.cells[2*n,21]='2');
      rbCroix.Checked:=(grCourbesLissees.cells[2*n,21]='3');
      rbEtoile.Checked:=(grCourbesLissees.cells[2*n,21]='4');
      rbCarre.Checked:=(grCourbesLissees.cells[2*n,21]='5');
      rbLosange.Checked:=(grCourbesLissees.cells[2*n,21]='6');
      rbRond.Checked:=(grCourbesLissees.cells[2*n,21]='7');
      rbCarre2.Checked:=(grCourbesLissees.cells[2*n,21]='8');
      rbLosange2.Checked:=(grCourbesLissees.cells[2*n,21]='9');
      if grCourbesLissees.cells[2*n+1,21]='' then i:=1 else i:=StrToInt(grCourbesLissees.cells[2*n+1,21]);
      udEpaisseur.Position:=i+1;
      if grCourbesLissees.cells[2*n,22]='' then i:=0 else i:=StrToInt(grCourbesLissees.cells[2*n,22]);
      rgTaille.ItemIndex:=i;
      cbLignesCotes.Checked:=(grCourbesLissees.Cells[2*n+1,22]='1');
      if grCourbeslissees.cells[2*n,23]='' then udCoef.Position:=50
                                           else udCoef.Position:=StrToInt(grCourbesLissees.Cells[2*n,23]);
   end;
end;

procedure TfmPointParPoint.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmPointParPoint.sgPointsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
  var txt : string;
begin
   txt:=sgPoints.cells[Acol,Arow];
   if (ARow=0) or (ACol=0) then GrilleCouleur(sgPoints,Rect,txt,taCenter,clBtnFace,clBlack,[])
      else if gdSelected in State then GrilleCouleur(sgPoints, rect, txt, taCenter, clBlue, clWhite, [])
                                  else GrilleCouleur(sgPoints, rect, txt, taCenter, clWindow, clBlack, []);
end;

procedure TfmPointParPoint.sgPointsKeyPress(Sender: TObject;
  var Key: Char);
begin
    if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmPointParPoint.sgPointsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (key=vk_Return)or((key=vk_right)and sgPoints.EditorMode)then
      if sgPoints.Col=3 then
      begin
         sgPoints.Col:=1;
         sgPoints.Row:=sgPoints.Row+1;
      end
      else sgPoints.Col:=sgPoints.Col+1;
   if (key=vk_left)and sgPoints.EditorMode then if sgPoints.Col>1 then sgPoints.Col:=sgPoints.Col-1;
end;

procedure TfmPointParPoint.TabControl1DrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
  var Texte : string;
begin
  Texte:=TabControl1.Tabs[TabIndex];
  if Active then
  begin
    TabControl1.Canvas.Brush.Color := clBlue;
    TabControl1.Canvas.font.Style := [fsBold];
    TabControl1.Canvas.font.Color := clWhite;
  end else
  begin
    TabControl1.Canvas.Brush.Color := clBtnFace;
    TabControl1.Canvas.font.Style := [];
    TabControl1.Canvas.font.Color := clBlack;
  end;
  TabControl1.Canvas.FillRect(Rect);
  TextOutAngle(TabControl1.Canvas,Texte,Rect.left+2,Rect.top+20,90,TabControl1.Font);
end;

procedure TfmPointParPoint.sgBezierDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var txt : string;
begin
   txt:=sgBezier.cells[Acol,Arow];
   if (ARow=0) or (ACol=0) then GrilleCouleur(sgBezier,Rect,txt,taCenter,clBtnFace,clBlack,[])
      else if gdSelected in State then GrilleCouleur(sgBezier, rect, txt, taCenter, clBlue, clWhite, [])
                                  else GrilleCouleur(sgBezier, rect, txt, taCenter, clWindow, clBlack, []);
end;

procedure TfmPointParPoint.sgBezierKeyPress(Sender: TObject;
  var Key: Char);
begin
   if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmPointParPoint.sgBezierKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (key=vk_Return)or((key=vk_right)and sgBezier.EditorMode)then
      if sgBezier.Col=2 then
      begin
         sgBezier.Col:=1;
         sgBezier.Row:=sgBezier.Row+1;
      end
      else sgBezier.Col:=sgBezier.Col+1;
   if (key=vk_left)and sgBezier.EditorMode then if sgBezier.Col>1 then sgBezier.Col:=sgBezier.Col-1;
end;

procedure TfmPointParPoint.Edit1Change(Sender: TObject);
begin
   edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
   Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,cgCouleur.ForegroundColor));

end;

procedure TfmPointParPoint.btnAideClick(Sender: TObject);
begin
   Aide(22);
end;

procedure TfmPointParPoint.mnCouperDonneesBezierClick(Sender: TObject);
var ZoneSelectionnee : TGridRect;
    i,j : integer;
begin
   ZoneSelectionnee.Top:=1;ZoneSelectionnee.Bottom:=sgBezier.Row;
   ZoneSelectionnee.Left:=1;ZoneSelectionnee.Right:=sgBezier.Col;
   StringGridCopyToClipBoard(sgBezier,ZoneSelectionnee.Top,ZoneSelectionnee.Bottom,
                             ZoneSelectionnee.Left,ZoneSelectionnee.Right);
   for i:=1 to sgBezier.Col do
      for j:=1 to sgBezier.Row do sgBezier.Cells[i,j]:='';
end;

procedure TfmPointParPoint.mnCouperDonneesPointsClick(Sender: TObject);
var ZoneSelectionnee : TGridRect;
    i,j : integer;
begin
   ZoneSelectionnee.Top:=1;ZoneSelectionnee.Bottom:=sgPoints.Row;
   ZoneSelectionnee.Left:=1;ZoneSelectionnee.Right:=sgPoints.Col;
   StringGridCopyToClipBoard(sgPoints,ZoneSelectionnee.Top,ZoneSelectionnee.Bottom,
                             ZoneSelectionnee.Left,ZoneSelectionnee.Right);
   for i:=1 to sgPoints.Col do
      for j:=1 to sgPoints.Row do sgPoints.Cells[i,j]:='';
end;

procedure TfmPointParPoint.mnCopierDonneesBezierClick(Sender: TObject);
var ZoneSelectionnee : TGridRect;
begin
   ZoneSelectionnee.Top:=1;ZoneSelectionnee.Bottom:=sgBezier.Row;
   ZoneSelectionnee.Left:=1;ZoneSelectionnee.Right:=sgBezier.Col;
   StringGridCopyToClipBoard(sgBezier,ZoneSelectionnee.Top,ZoneSelectionnee.Bottom,
                             ZoneSelectionnee.Left,ZoneSelectionnee.Right);
end;

procedure TfmPointParPoint.mnCopierDonneesPointsClick(Sender: TObject);
var ZoneSelectionnee : TGridRect;
begin
   ZoneSelectionnee.Top:=1;ZoneSelectionnee.Bottom:=sgPoints.Row;
   ZoneSelectionnee.Left:=1;ZoneSelectionnee.Right:=sgPoints.Col;
   StringGridCopyToClipBoard(sgPoints,ZoneSelectionnee.Top,ZoneSelectionnee.Bottom,
                             ZoneSelectionnee.Left,ZoneSelectionnee.Right);
end;

procedure TfmPointParPoint.mnCollerDonneesBezierClick(Sender: TObject);
begin
StringGridPasteFromClipBoard(sgBezier,1,1);
end;

procedure TfmPointParPoint.mnCollerDonneesPointsClick(Sender: TObject);
begin
StringGridPasteFromClipBoard(sgPoints,1,1);
end;

procedure TfmPointParPoint.BitBtnOuvrirCSVClick(Sender: TObject);
var
	NomFichier:string;
begin
if OpenDialog1.execute
	then begin
	NomFichier:=OpenDialog1.FileName;
   if sgBezier.Visible
   	then LoadStringGridFromCSVFile(sgBezier , NomFichier,1,1)
      else LoadStringGridFromCSVFile(sgPoints , NomFichier,1,1) ;
   end;
end;

procedure TfmPointParPoint.mnSupprimertoutPointsClick(Sender: TObject);
var
	i,j:integer;
begin
   for i:=1 to 3 do for j:=1 to 20 do sgPoints.Cells[i,j]:='';
end;

procedure TfmPointParPoint.mnSupprimertoutBezierClick(Sender: TObject);
var
	i,j:integer;
begin
   for i:=1 to 2 do for j:=1 to 20 do sgBezier.Cells[i,j]:='';
end;

end.
