unit uSchema;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, shellAPI;

type TObjPoint = record
                      Nom               : string;
                      Nature            : byte; //0=coordonnes cartsiennes, 1=donn par son abscisse sur une droite
                                                //2=intersection, 3=barycentre, 4=isobarycentre, 5=4me point paralllogramme
                                                //6=projet, 7=image par rotation, 8=coordonnes polaires
                      chDefinition      : string;//si nature>0
                      Position          : byte;
                      x,y               : real;  //coordonnes cartsiennes (mme si le point est dfini en coordonnes polaires)
                      style,epaisseur,lignecote : byte;
                      couleur           : TColor;
                 end;
     TObjSegment = record
                      nature            : byte;   //0= [AB], 1=coordonnes, 2=mdiane, 3=hauteur
                      Origine,Extremite : string; //si nature=0
                      x1,y1,x2,y2       : real;   //si nature=1
                      A,B,C             : string; //nom des 3 sommets si nature=2 ou 3
                      Sommet            : string; //nom du sommet duquel est issu le segment
                      style,epaisseur   : byte;   //continu, tirets, points, ronds
                      couleur           : TColor; //de 1  15
                      format,                     //sans marque, flches simples, pleines, lancoles, crochets, arcs
                      fermeture,                  //ferm, ouvert, semi-ouvert  (chiffre des units)
                      taille,                     //taille des extrmits de 1  9  (chiffre des dizaines)
                      codage            : byte;   //le codage, de 0  3, est le chiffre des centaines
                   end;
     TObjVecteur = record
                      Nom               : string;  //nom du vecteur (facultatif)
                      Position          : byte;    //position de l'affichage du nom
                      Nature            : byte;    //0=abscisse+ordonne, 1=origine+extrmit
                      Abscisse,Ordonnee : real;    //si nature=0
                      Origine,Extremite : string;  //si nature=1
                      blDessinFleche    : boolean; //vrai si le vecteur doit tre dessin
                      style,epaisseur   : byte;
                      couleur           : TColor;
                      x,y               : real;    //coordonnes du point origine du dessin
                      TailleFleche      : byte;    //taille de la flche de 1  9
                   end;
     TObjDroite = record
                      Nom               : string; // nom de la droite (facultatif)
                      Nature            : byte;   //de 0  7 selon la dfinition
                      Point1,Point2     : string;
                      VecteurDirecteur,
                      VecteurNormal     : string;
                      DroiteParallele,
                      DroitePerpendiculaire : string;
                      Segment           : string;  //cas o il s'agit d'une mdiatrice
                      Angle3Points      : string;  //cas o il s'agit d'une bissectrice
                      Angle2Vecteurs    : string;  // idem
                      Style,epaisseur   : byte;
                      Couleur           : TColor;
                      x,y               : real;    //coordonnes de son vecteur directeur
                      x0,y0             : real;    //coordonnes d'un point de la droite
                   end;
     TObjDemiDroite = record
                      Origine           : string;
                      Nature            : byte;   //0:point, 1:vecteurdirecteur, 2:anglepolaire
                      Point             : string;
                      VecteurDirecteur  : string;
                      AnglePolaire      : string;
                      blDegres          : boolean;
                      Style,epaisseur   : byte;
                      Couleur           : TColor;
                      x,y               : real;    //coordonnes de son vecteur directeur
                      x0,y0             : real;    //coordonnes de son origine
                   end;
     TObjCercle = record
                      Centre,rayon,point1,point2,
                      Triangle,Droite   : string;  //lments de dfinition
                      Nature            : byte;
                      x,y,r             : real;  //coordonnes du centre et rayon
                      epaisseur,style   : byte;
                      clBord,clInterieur: TColor;
                  end;
     TObjEllipse= record
                      Centre,AxeHorizontal,AxeVertical,Sommet1,Sommet2 : string;
                      Nature            : byte;  //0=centre+"rayons"  1=rectangle
                      x,y,rx,ry         : real;  //coordonnes du centre et "rayons"
                      epaisseur,style   : byte;
                      clBord,clInterieur: TColor;
                  end;
     TObjCarre =  Record
                      Centre,Cote,Rayon,Sommet1,Sommet2 : string;
                      Nature            : byte; //0=centre+cte, 1=centre+rayon,
                                                //2=sommets opposs,  3=carr direct
                      x1,y1,x2,y2       : real; //coordonnes de 2 sommets opposs
                      epaisseur,style   : byte;
                      clBord,clInterieur: TColor;
                  end;
     TObjPolygonePredefini = record
                      Sommets           : string;  //nom des sommets spars par des virgule
                      A,B,C,D           : string;  //noms des 3 ou 4 sommets
                      nature            : byte;    //0  12
                      option            : byte;    //0 ou 1
                      caracteristiques  : array[1..5] of string;
                      epaisseur,style   : byte;
                      clBord,clInterieur: TColor;
                   end;
     TObjPolygone = Record
                       Sommets           : string;  //nom des sommets spars par des virgules
                       nature            : byte;    //0  3
                       nbSommets         : byte;
                       epaisseur,style   : byte;
                       clBord,clInterieur: TColor;
                       hachures          : byte;
                    end;
     TObjConique = Record
                     nature                                      : byte;   // 0 = foyer + directrice + excentricit, 1= quation
                     Foyer,Directrice,point1,point2              : string; // noms du foyer, de la directrice, et de deux points de la directrice
                     xf,yf,ad,bd,cd,                            // coordonnes du foyer, coefficients de l'quation de la directrice,
                     excentricite,A,B,C,D,E,F                    : Real;   // excentricit, et coefficients de l'quation de la conique
                     Foy,Dir,Axe,Som,Cen,Asy,                   // trace ou non foyer, directrice, axes, sommet, centre, asymptotes
                     exc,met,coo,equ,exa                         : boolean;// affiche ou non rsultats de l'analyse de la conique, exacts ou non
                     Epaisseur,EpaisseurDroites,TaillePoints,
                     Style,StyleDroites,StylePoints              : byte;
                     Couleur,CouleurDroites,CouleurPoints        : TColor;
                  end;
     TObjBezier = Record
                     Sommets : string; //noms des sommets spars par des virgules
                     nature  : byte;   //0 = Courbe de Bzier normale, 1= polybzier
                     nbSommets : byte;
                     Epaisseur : byte;
                     Couleur   : TColor;
                  end;
     TObjAngle = Record
                    Sommet : string;   //nom du sommet lorsque l'angle est dfini avec sommet+angles
                    A,B,C   : string;   //nom des 3 points lorsque l'angle est dfini par 3 points
                    AngleDebut,AngleFin : integer;  //exprims en degrs positifs
                    nature : byte;      //0=dfini par 3 points;   1=dfini par sommet et angles
                    epaisseur,style,taille : byte;
                    Couleur :TColor;
                    Oriente : byte;    //0=non orient, 1=positif, 2=ngatif
                 end;
type
  TfmSchema = class(TForm)
    Label1: TLabel;
    btModifier: TButton;
    btSupprimer: TButton;
    btAnnuler: TButton;
    btOK: TButton;
    GroupBox1: TGroupBox;
    btPoint: TButton;
    btSegment: TButton;
    btVecteur: TButton;
    btDroite: TButton;
    btDemiDroite: TButton;
    btCercle: TButton;
    btEllipse: TButton;
    btCarre: TButton;
    btAutresPolygones: TButton;
    ListeObjets: TListBox;
    btPolygonesPredefinis: TButton;
    btConique: TButton;
    btPolice: TButton;
    Label2: TLabel;
    FontDialog1: TFontDialog;
    btBezier: TButton;
    btAngle: TButton;
    cbDessiner: TCheckBox;
    btColorier: TButton;
    btnAide: TButton;
    procedure btPointClick(Sender: TObject);
    procedure btSupprimerClick(Sender: TObject);
    procedure btModifierClick(Sender: TObject);
    procedure btSegmentClick(Sender: TObject);
    procedure btVecteurClick(Sender: TObject);
    procedure btDroiteClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btDemiDroiteClick(Sender: TObject);
    procedure btCercleClick(Sender: TObject);
    procedure btEllipseClick(Sender: TObject);
    procedure btCarreClick(Sender: TObject);
    procedure btPolygonesPredefinisClick(Sender: TObject);
    procedure ListeObjetsClick(Sender: TObject);
    procedure btAutresPolygonesClick(Sender: TObject);
    procedure btConiqueClick(Sender: TObject);
    procedure btPoliceClick(Sender: TObject);
    procedure btBezierClick(Sender: TObject);
    procedure btAngleClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btColorierClick(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
     Function ExistePoint(Nom:string;var x,y : real):boolean;
     Function ExisteVecteur(Nom:string;var x,y : real):boolean;
     Function ExisteDroite(Nom:string;var x,y,x0,y0 : real):boolean;
     Function DecomposeChainePoint(ch:string;var point:TObjPoint):boolean;
     Function DecomposeChaineSegment(ch:string;var Segment:TObjSegment):boolean;
     Function DecomposeChaineVecteur(ch:string;var Vecteur:TObjVecteur):boolean;
     Function DecomposeChaineDroite(ch:string):TObjDroite;
     Function DecomposeChaineDemiDroite(ch:string):TObjDemiDroite;
     Function DecomposeChaineCercle(ch:string):TObjCercle;
     Function DecomposeChaineEllipse(ch:string):TObjEllipse;
     Function DecomposeChaineCarre(ch:string):TObjCarre;
     Function DecomposeChainePolygonePredefini(ch:string):TObjPolygonePredefini;
     Function DecomposeChainePolygone(ch:string):TObjPolygone;
     Function DecomposeChaineConique(ch:string):TObjconique;
     Function DecomposeChaineBezier(ch:string):TObjBezier;
     Function DecomposeChaineAngle(ch:string):TObjAngle;
     Function ConstruitChainePoint:string;
     Function ConstruitChaineSegment:string;
     Function ConstruitChaineVecteur:string;
     Function ConstruitChaineDroite:string;
     Function ConstruitChaineDemiDroite:string;
     Function ConstruitChaineCercle:string;
     Function ConstruitChaineEllipse:string;
     Function ConstruitChaineCarre:string;
     Function ConstruitChainePolygonePredefini:string;
     Function ConstruitChainePolygone:string;
     Function ConstruitChaineConique:string;
     Function ConstruitChaineBezier:string;
     Function ConstruitChaineAngle:string;
  end;

var
  fmSchema: TfmSchema;

implementation

uses uDessin,uPoint,uFonctions, uSegment, uVecteur, uObjDroite, uDemiDroite,
  uCercle, uEllipse, uCarre, uPolygonePredefini, uPolygone, uBezier, uAngle, uPaint,
  uConique;

{$R *.DFM}

procedure IntersectionDroites(xa,ya,xb,yb,xc,yc,xd,yd : real;var x,y : real);
//reoit les coordones des points A,B,C,D et calcule les coordonnes x,y du
//point d'intersection des droites (AB) et (CD)
var a,b,c,d : real;
begin
   a:=xb-xa;b:=yb-ya;//(a,b) sont les coordonnes du vecteur AB
   c:=xd-xc;d:=yd-yc;//(c,d) sont les coordonnes du vecteur CD
   if a*d-b*c=0 then
   begin
      x:=0;y:=0;
   end
   else
   begin
      x:=(a*(d*xc-c*yc)-c*(b*xa-a*ya))/(a*d-b*c);
      y:=(b*(d*xc-c*yc)-d*(b*xa-a*ya))/(a*d-b*c);
   end;
end;

function ExtraitItem(chaine : string ; i : integer) : string;
var
	liste : TStringList;
   item  : string;
begin
	liste:=TStringList.Create;
   liste.CommaText:=chaine;
   Result:=liste[i];
   liste.Free;
end;


Function TfmSchema.DecomposeChainePoint(ch:string;var point:TObjPoint):boolean;
var chx,chy,chStyle,chNature,chPosition,chEpaisseur,chLigneCote : string;
    chDroite1,chDroite2,chA,chB,chC,chD : string;
    err : byte;
    xA,yA,xB,yB,xC,yC,xD,yD : real;//pour le calcul du point d'intersection
    SommeX,SommeY,SommeCoef : real;//pour le calcul du barycentre
    Coef,angle              : real;
begin
   result:=true;
   delete(ch,1,6);
   with Point do
   begin
      Nom:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
      chNature:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
      Nature:=StrToInt(chNature);
      case nature of
         0 : begin             //point dfini par ses coordonnes cartsiennes
                chx:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chx:=traduction(chx,err);
                if (err>0)or(chx='') then
                begin
                   showmessage('Erreur sur l''abscisse du point '+Nom);
                   result:=false;
                   exit;
                end;
                chy:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chy:=traduction(chy,err);
                if (err>0)or(chy='') then
                begin
                   showmessage('Erreur sur l''ordonne du point '+Nom);
                   result:=false;
                   exit;
                end;
                x:=f(chx,1);result:=result and ok;
                y:=f(chy,1);result:=result and ok;
                chDefinition:='';
             end;
         1 : begin     //point dfini par son abscisse x sur une droite de repre (A,B)
                chx:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chDefinition:=chx;
                chx:=traduction(chx,err);
                if err>0 then
                begin
                   showmessage('Erreur sur l''abscisse du point '+Nom);
                   result:=false;
                   exit;
                end;
                Coef:=f(chx,1);result:=result and ok; //calcul de l'abscisse x
                chA:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
                chB:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chDefinition:=chDefinition+';'+chA+','+chB;
                if chA<>Nom then //le point ne peut pas tre dfini  partir de lui-mme !
                begin
                   if not ExistePoint(chA,xA,yA) then begin result:=false;xA:=0;yA:=0;end;
                end else begin result:=false;xA:=0;yA:=0;end;
                if chB<>nom then
                begin
                   if not ExistePoint(chB,xB,yB) then begin result:=false;xB:=0;yB:=0;end;
                end else begin result:=false;xA:=0;yA:=0;end;
                x:=xA+coef*(xB-xA);
                y:=yA+coef*(yB-yA);
             end;
         2 : begin   //point dfini comme intersection de 2 droites
                chDefinition:=Copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chx:=chDefinition;
                chDroite1:=Copy(chx,1,pos(')',chx)-1);
                delete(chDroite1,1,1);//on enlve la parenthse gauche
                delete(chx,1,Pos(')',chx)+2); //on enlve la 1re droite
                //+2 car il y a une virgule suivie d'une parenthse gauche avant la 2 droite
                chDroite2:=Copy(chx,1,pos(')',chx)-1);//parenthse droite
                if pos(',',chDroite1)>0 then //1re droite dfinie par 2 points A et B
                begin
                   chA:=Copy(chDroite1,1,pos(',',chDroite1)-1);
                   delete(chDroite1,1,pos(',',chDroite1));
                   chB:=chDroite1;
                   if chA<>Nom then //le point ne peut pas tre dfini  partir de lui-mme !
                   begin
                      if not ExistePoint(chA,xA,yA) then begin result:=false;xA:=0;yA:=0;end;
                   end else begin result:=false;xA:=0;yA:=0;end;
                   if chB<>nom then
                   begin
                      if not ExistePoint(chB,xB,yB) then begin result:=false;xB:=0;yB:=0;end;
                   end else begin result:=false;xA:=0;yA:=0;end;
                end
                else if ExisteDroite(chDroite1,xB,yB,xA,yA) then
                begin
                   xB:=xA+xB;
                   yB:=yA+yB;
                end
                else begin result:=false;xA:=0;yA:=0;xB:=0;yB:=0;end;
                if pos(',',chDroite2)>0 then //2me droite dfinie par 2 points C et D
                begin
                   chC:=Copy(chDroite2,1,pos(',',chDroite2)-1);
                   delete(chDroite2,1,pos(',',chDroite2));
                   chD:=chDroite2;
                   if chC<>Nom then //le point ne peut pas tre dfini  partir de lui-mme !
                   begin
                      if not ExistePoint(chC,xC,yC) then begin result:=false;xC:=0;yC:=0;end;
                   end else begin result:=false;xC:=0;yC:=0;end;
                   if chD<>nom then
                   begin
                      if not ExistePoint(chD,xD,yD) then begin result:=false;xD:=0;yD:=0;end;
                   end else begin result:=false;xC:=0;yC:=0;end;
                end
                else if ExisteDroite(chDroite2,xD,yD,xC,yC) then
                begin
                   xD:=xC+xD;
                   yD:=yC+yD;
                end
                else begin result:=false;xC:=0;yC:=0;xD:=0;yD:=0;end;
                IntersectionDroites(xA,yA,xB,yB,xC,yC,xD,yD,x,y);
             end;
         3 : begin //point dfini comme barycentre
                chDefinition:=Copy(ch,1,pos(':',ch)-1);delete(ch,1,pos(':',ch));
                chx:=chDefinition;
                SommeX:=0;SommeY:=0;SommeCoef:=0;Coef:=0;
                while chx<>'' do
                begin
                   delete(chx,1,1);//on enlve la parenthse de gauche
                   chA:=copy(chx,1,pos(';',chx)-1);//nom du point
                   delete(chx,1,pos(';',chx));//on enlve le nom et le point-virgule
                   chB:=Copy(chx,1,pos(')',chx)-1);//coefficient du point
                   delete(chx,1,pos(')',chx));//on enlve le coef et la parenthse
                   if chA<>Nom then
                   begin
                      if not existePoint(chA,xA,yA) then result:=false;
                   end else result:=false;
                   chB:=Traduction(chB,err);
                   if err=0 then begin coef:=f(chB,1);result:=result and ok;end
                            else result:=false;
                   SommeX:=SommeX+coef*xA;
                   SommeY:=SommeY+coef*yA;
                   SommeCoef:=SommeCoef+coef;
                   if chx<>'' then delete(chx,1,1);//on enlve la virgule
                end;
                if SommeCoef<>0 then
                begin
                   x:=SommeX/SommeCoef;
                   y:=SommeY/SommeCoef;
                end else result:=false;
             end;
         4 : begin   //point dfini comme isobarycentre
                chDefinition:=Copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chx:=chDefinition;
                SommeX:=0;SommeY:=0;SommeCoef:=0;
                while chx<>'' do
                begin
                   if pos(',',chx)>0 then
                   begin //ce n'est pas le dernier point de la liste
                      chA:=copy(chx,1,pos(',',chx)-1);
                      delete(chx,1,pos(',',chx));
                   end
                   else
                   begin  //c'est le dernier point de la liste
                      chA:=chx;
                      chx:='';
                   end;
                   if chA<>Nom then
                   begin
                      if not existePoint(chA,xA,yA) then result:=false;
                   end else result:=false;
                   SommeX:=SommeX+xA;
                   SommeY:=SommeY+yA;
                   SommeCoef:=SommeCoef+1;
                end;
                if SommeCoef<>0 then
                begin
                   x:=SommeX/SommeCoef;
                   y:=SommeY/SommeCoef;
                end else result:=false;
             end;
         5 : begin   //point dfini comme 4me point d'un paralllogramme
                chDefinition:=Copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chx:=chDefinition;
                chA:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));
                chB:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));
                chC:=chx;
                if not ExistePoint(chA,xA,yA) or
                   not ExistePoint(chB,xB,yB) or
                   not ExistePoint(chC,xC,yC) then
                   begin
                      result:=false;
                      x:=0;y:=0;
                   end
                   else
                   begin
                      result:=true;
                      x:=xA+xC-xB;
                      y:=yA+yC-yB;
                   end;
             end;
         6 : begin     //image d'un point par une projection sur une droite
                chDefinition:=Copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chx:=chDefinition;
                chA:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));  // cha=nom du point  projeter
                if pos(',',chx)>0 then //droite dfinie par 2 points spars par une virgule
                begin
                   chB:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));
                   chC:=chX;
                   if not ExistePoint(chA,xA,yA) or
                   not ExistePoint(chB,xB,yB) or
                   not ExistePoint(chC,xC,yC) then
                   begin
                      result:=false;
                      x:=0;y:=0;
                   end
                   else
                   begin
                      result:=true;
                      //calcul de l'abscisse du projet de A sur (BC)
                      x:=((yc-yb)*(xb*(yc-yb)-yb*(xc-xb))+(xc-xb)*(xa*(xc-xb)+ya*(yc-yb)))/(sqr(xc-xb)+sqr(yc-yb));
                      //calcul de l'ordonne du projet de A sur (BC)
                      y:=((xc-xb)*(xb*(yc-yb)-yb*(xc-xb))-(yc-yb)*(xa*(xc-xb)+ya*(yc-yb)))/(-sqr(xc-xb)-sqr(yc-yb));
                   end;
                end
                else                   //droite dfinie par son nom
                begin
                   if not ExistePoint(chA,xA,yA)or not ExisteDroite(chx,xb,yb,xc,yc) then
                   begin
                      result:=false;
                      x:=0;y:=0;
                   end
                   else
                   begin
                      result:=true;
                      xb:=xb+xc;yb:=yb+yc;
                      x:=((yc-yb)*(xb*(yc-yb)-yb*(xc-xb))+(xc-xb)*(xa*(xc-xb)+ya*(yc-yb)))/(sqr(xc-xb)+sqr(yc-yb));
                      y:=((xc-xb)*(xb*(yc-yb)-yb*(xc-xb))-(yc-yb)*(xa*(xc-xb)+ya*(yc-yb)))/(-sqr(xc-xb)-sqr(yc-yb));
                   end;
                end;
             end;
         7 : begin   //image d'un point par une rotation de centre donn et d'angle donn
                chDefinition:=Copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chx:=chDefinition;
                chA:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));  // cha=nom du point  projeter
                chB:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));  // chb=nom du centre de la rotation
                result:=true;
                Angle:=0; //initialisation bidon
                try
                   angle:=StrToFloat(chx);
                except
                   result:=false;
                   x:=0;y:=0;
                end;
                if ExistePoint(chA,xa,ya) and ExistePoint(chB,xb,yb) then
                begin
                   x:=xb+cos(angle/180*pi)*(xa-xb)-sin(angle/180*pi)*(ya-yb);
                   y:=yb+sin(angle/180*pi)*(xa-xb)+cos(angle/180*pi)*(ya-yb);
                end
                else
                begin
                   result:=false;
                   x:=0;y:=0;
                end;
             end;
         8 : begin             //point dfini par ses coordonnes polaires
                chx:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chx:=traduction(chx,err);
                if (err>0)or(chx='') then
                begin
                   showmessage('Erreur sur la distance polaire du point '+Nom);
                   result:=false;
                   exit;
                end;
                chy:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
                chy:=traduction(chy,err);
                if (err>0)or(chy='') then
                begin
                   showmessage('Erreur sur l''angle polaire du point '+Nom);
                   result:=false;
                   exit;
                end;
                xA:=f(chx,1);result:=result and ok and (xA>0);        //xA est ici la distance polaire
                yA:=f(chy,1);result:=result and ok;                  //yA est ici l'angle polaire
                if ok then begin x:=xA*cos(yA*pi/180);y:=xA*sin(yA*pi/180);end;
                //x et y sont maintenant les coordonnes cartsiennes
                fmPoint.edAbscisse.text:=FloatToStr(x);
                fmPoint.edOrdonnee.Text:=FloatToStr(y);
                chDefinition:='';
             end;
      end; //case nature of
      chStyle:=copy(ch,1,1);style:=strtoint(chStyle);delete(ch,1,pos(',',ch));
      chPosition:=copy(ch,1,1);Position:=strtoint(chPosition);delete(ch,1,pos(',',ch));
      chEpaisseur:=copy(ch,1,1);Epaisseur:=strtoint(chEpaisseur);delete(ch,1,pos(',',ch));
      chLigneCote:=copy(ch,1,1);LigneCote:=strtoint(chLigneCote);delete(ch,1,pos(',',ch));
      err:=strtoint(ch); //err est le n de la couleur du point
      fmPoint.ColorGrid1.ForegroundIndex:=err;
      couleur:=fmPoint.ColorGrid1.ForegroundColor;
   end;
   DecomposeChainePoint:=result;
end;

Function TfmSchema.ConstruitChainePoint:string;
//construit la chane qui dfinit un point  partir des informations de fmPoint
var ch : string;
    point : TObjPoint;
    nature : byte;
begin
   with fmPoint do
   begin
      nature:=rgNature.ItemIndex;
      if (nature=0)and cbPolaires.Checked then nature:=8;
      ch:='Point '+edNom.text+','+inttostr(Nature)+',';
      case  nature of
         0 : ch:=ch+edAbscisse.text+';'+edOrdonnee.text+';';
         1 : ch:=ch+edXAB.Text+';';
         2 : ch:=ch+edNomsDroites.text+';';
         3 : ch:=ch+edPointsPonderes.text+':';
         4 : ch:=ch+edIsobarycentre.Text+';';
         5 : ch:=ch+ed4Point.Text+';';
         6 : ch:=ch+edPoint.Text+','+edDroite.Text+';';
         7 : ch:=ch+edPointRotation.Text+','+edCentre.Text+','+edAngle.Text+';';
         8 : ch:=ch+edr.text+';'+edTheta.text+';';
      end;
      if rbAucuneMarque.Checked then ch:=ch+('0');   //aucune marque du point
      if rbPoint.Checked then ch:=ch+('1');    //style point=1
      if rbPlus.Checked then ch:=ch+('2');     //style plus=2
      if rbCroix.Checked then ch:=ch+('3');    //style croix=3
      if rbEtoile.Checked then ch:=ch+('4');   //style toile=4
      if rbCarre.Checked then ch:=ch+('5');    //style carr=5
      if rbLosange.Checked then ch:=ch+('6');  //style losange=6
      if rbRond.Checked then ch:=ch+('7');     //style rond=7
      if rbCarre2.Checked then ch:=ch+('8');   //style carr2=8
      if rbLosange2.Checked then ch:=ch+('9'); //style losange2=9
      ch:=ch+','+inttostr(gbPositionNom.tag);  //position du nom (0= droite, 1=45...)
      ch:=ch+','+inttostr(rgTaille.ItemIndex); //taille du point (0=petit, 1=moyen 2=gros)
      if cbLigneCote.checked then ch:=ch+',1'  //prsence de lignes de cote
                             else ch:=ch+',0'; //absence de lignes de cote
      ch:=ch+','+inttostr(ColorGrid1.ForeGroundIndex);
   end;
   if not DecomposeChainePoint(ch,point) then ch:='';   //vrification avant de valider
   ConstruitChainePoint:=ch;
end;

Function TfmSchema.ExistePoint(Nom:string;var x,y : real):boolean;
var i : integer;
    ch,ch1 : string;
    point : TObjPoint;
begin
   result:=false;
   if ListeObjets.Items.Count>0 then
   for i:=0 to ListeObjets.Items.Count-1 do
   begin
      ch:=ListeObjets.Items[i];
      if Pos('Point',ch)>0 then
      begin
         {on commence par extraire le nom de ch, dans la variable ch1, sans
          appeler la fonction DecomposeChainePoint... pour viter la rcursivit}
         ch1:=ch;delete(ch1,1,6);ch1:=copy(ch1,1,pos(',',ch1)-1);
         if ch1=Nom then
         begin
            result:=DecomposeChainePoint(ch,point);
            x:=point.x;
            y:=point.y;
         end;
      end;
   end;
end;

Function TfmSchema.ConstruitChaineSegment:string;
var ch : string;
    Segment : TObjSegment;
begin
   with fmSegment do
   begin
      if edNomTriangle.Text='' then edNomTriangle.Text:=',,';
      ch:='Segment,'+inttostr(rgDefinition.ItemIndex)
          +',['+edOrigine.Text+','+edExtremite.text+'],'
          +edX1.text+';'+edY1.text+';'+edX2.text+';'+edY2.text+';'
          +edNomTriangle.text+','+edSommet.text+','
          +inttostr(rgEpaisseur.ItemIndex+10*rgCodage.ItemIndex)+','+inttostr(rgStyle.itemindex)+','
          +inttostr(ColorGrid1.ForeGroundColor)+','+intToStr(rgFormatSegment.ItemIndex)
          +','+inttostr(rgNature.ItemIndex+10*spinEditTaille.Value);
   end;
   if not DecomposeChaineSegment(ch,segment) then ch:=''; //vrification avant de valider
   ConstruitChaineSegment:=ch;
end;

Function TfmSchema.DecomposeChaineSegment(ch:string;var Segment:TObjSegment):boolean;
var chNature,chx : string;
    err,taille,ep: byte;
begin
   delete(ch,1,8);result:=true;
   chNature:=copy(ch,1,1);Segment.nature:=strtoint(chNature);
   delete(ch,1,pos('[',ch));Segment.origine:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Segment.extremite:=copy(ch,1,pos(']',ch)-1);
   delete(ch,1,pos(',',ch));chx:=copy(ch,1,pos(';',ch)-1);chx:=traduction(chx,err);
   if (err=0)and(chx<>'') then Segment.x1:=f(chx,1)else Segment.x1:=0;
   delete(ch,1,pos(';',ch));chx:=copy(ch,1,pos(';',ch)-1);chx:=traduction(chx,err);
   if (err=0)and(chx<>'') then Segment.y1:=f(chx,1)else Segment.y1:=0;
   delete(ch,1,pos(';',ch));chx:=copy(ch,1,pos(';',ch)-1);chx:=traduction(chx,err);
   if (err=0)and(chx<>'') then Segment.x2:=f(chx,1)else Segment.x2:=0;
   delete(ch,1,pos(';',ch));chx:=copy(ch,1,pos(';',ch)-1);chx:=traduction(chx,err);
   if (err=0)and(chx<>'') then Segment.y2:=f(chx,1)else Segment.y2:=0;
   delete(ch,1,pos(';',ch));Segment.A:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Segment.B:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Segment.C:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Segment.Sommet:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));chx:=Copy(ch,1,pos(',',ch)-1);ep:=strtoint(chx); //contient  la fois l'aisseur et le codage
   Segment.codage:=ep div 10;                                    //le codage est le chiffre des dizaines  (de 0  3)
   Segment.epaisseur:=ep mod 10;                                 //l'paisseur est le chiffre des units (de 0  2)
   delete(ch,1,pos(',',ch));chx:=Copy(ch,1,1);Segment.style:=strtoint(chx);
   delete(ch,1,pos(',',ch));if pos(',',ch)=0 then Segment.Couleur:=strToInt(ch)
   else
   begin
      chx:=Copy(ch,1,pos(',',ch)-1);Segment.couleur:=strtoint(chx);
      delete(ch,1,pos(',',ch));chx:=Copy(ch,1,1);Segment.format:=strtoint(chx);
      delete(ch,1,pos(',',ch));chx:=Copy(ch,1,2);
      taille:=strtoint(chx);              //le nombre taille contient 2 chiffres
      Segment.fermeture:=taille mod 10;   //le chiffre des units est la "fermeture"
      Segment.taille:=taille div 10;      //le chiffre des dizaine est la taille des flches  (1  9)
      if Segment.taille=0 then Segment.Taille:=5;
   end;
   fmSegment.ColorGrid1.ForegroundIndex:=fmSegment.ColorGrid1.ColorToIndex(Segment.couleur);
   with segment do if(nature=1)and(x1=0)and(y1=0)and(x2=0)and(y2=0)then result:=false;
   DecomposeChaineSegment:=result;
end;

Function TfmSchema.ConstruitChaineVecteur:string;
var ch : string;
begin
   with fmVecteur do
   begin
      ch:='Vecteur,'+edNom.Text+','+IntToStr(cbPositionNom.ItemIndex)+','
          +IntToStr(rgNature.ItemIndex)+','+edX.text+';'+edY.Text+';'
          +edOrigine.Text+','+edExtremite.Text+',';
      if cbDessinFleche.Checked then ch:=ch+'1,' else ch:=ch+'0,';
      ch:=ch+IntToStr(10*SpinEdit1.value+rgEpaisseur.itemIndex)+',';
      if rbStyle1.Checked then ch:=ch+'1,';
      if rbStyle2.Checked then ch:=ch+'2,';
      if rbStyle3.Checked then ch:=ch+'3,';
      ch:=ch+IntToStr(ColorGrid1.ForeGroundIndex)+','
          +edXOrigine.Text+';'+edYorigine.Text;
   end;
   //il n'y a pas vrification avant de valider car c'est au moment de dessiner que le vecteur est vrifi
   ConstruitChaineVecteur:=ch;
end;

Function TfmSchema.DecomposeChaineVecteur(ch:string;var vecteur:TObjVecteur):boolean;
var ch1     : string;
    err     : byte;
    TailleEpaisseur : integer;
begin
   result:=true;
   Delete(ch,1,8);Vecteur.Nom:=Copy(ch,1,Pos(',',ch)-1);Delete(ch,1,Pos(',',ch));
   ch1:=copy(ch,1,pos(',',ch)-1);Vecteur.Position:=StrToInt(ch1);Delete(ch,1,Pos(',',ch));
   ch1:=copy(ch,1,1);Vecteur.Nature:=StrToInt(ch1);Delete(ch,1,Pos(',',ch));
   ch1:=copy(ch,1,Pos(';',ch)-1);ch1:=traduction(ch1,err);
   if(err=0)and(ch1<>'') then Vecteur.Abscisse:=f(ch1,1) else Vecteur.Abscisse:=0;
   Delete(ch,1,Pos(';',ch));
   ch1:=copy(ch,1,Pos(';',ch)-1);ch1:=traduction(ch1,err);
   if(err=0)and(ch1<>'') then Vecteur.Ordonnee:=f(ch1,1) else Vecteur.Ordonnee:=0;
   Delete(ch,1,Pos(';',ch));Vecteur.Origine:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Vecteur.Extremite:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Vecteur.blDessinFleche:=copy(ch,1,1)='1';
   delete(ch,1,pos(',',ch));ch1:=copy(ch,1,pos(',',ch)-1);TailleEpaisseur:=StrToInt(ch1);
   Vecteur.epaisseur:=TailleEpaisseur mod 10;Vecteur.tailleFleche:=TailleEpaisseur div 10;
   if Vecteur.TailleFleche=0 then Vecteur.TailleFleche:=5;
   delete(ch,1,pos(',',ch));ch1:=copy(ch,1,1);Vecteur.style:=StrToInt(ch1);
   delete(ch,1,pos(',',ch));ch1:=Copy(ch,1,Pos(',',ch)-1);Vecteur.couleur:=strtoint(ch1);
   fmVecteur.ColorGrid1.ForegroundIndex:=Vecteur.couleur;
   Vecteur.couleur:=fmVecteur.ColorGrid1.ForegroundColor;
   delete(ch,1,pos(',',ch));
   ch1:=copy(ch,1,Pos(';',ch)-1);ch1:=traduction(ch1,err);
   if(err=0)and(ch1<>'') then Vecteur.x:=f(ch1,1) else Vecteur.x:=0;
   Delete(ch,1,Pos(';',ch));ch:=traduction(ch,err);
   if(err=0)and(ch<>'') then Vecteur.y:=f(ch,1) else Vecteur.y:=0;
   DecomposeChaineVecteur:=result;
   //La fonction retourne toujours true car c'est au moment de dessiner le vecteur
   //que celui-ci est vrifi.
end;

Function TfmSchema.ExisteVecteur(Nom:string;var x,y : real):boolean;
var i           : integer;
    Vecteur     : TObjVecteur;
    x1,y1,x2,y2 : real;
    ch          : string;
begin
   result:=false;
   for i:=0 to ListeObjets.Items.Count-1 do
   begin
      ch:=ListeObjets.Items[i];
      if Pos('Vecteur',ch)>0 then
      begin
         if not DecomposeChaineVecteur(ch,vecteur)then exit;
         if Vecteur.Nom=Nom then case Vecteur.nature of
            0 : begin
                   result:=true;
                   x:=Vecteur.Abscisse;
                   y:=Vecteur.Ordonnee;
                end;
            1 : if ExistePoint(Vecteur.Origine,x1,y1) and ExistePoint(Vecteur.extremite,x2,y2) then
                begin
                   result:=true;
                   x:=x2-x1;
                   y:=y2-y1;
                end;
            end;
      end;
   end;
end;

Function TfmSchema.ConstruitChaineDroite:string;
var ch,ch1,ch2,ch3        : string;
    x,y,x1,y1,x2,y2,x3,y3,x0,y0 : real;
    normeBA,normeBC       : real;
begin
   with fmObjDroite do
   begin
      ch:='Droite,'+edNom.Text+','+inttostr(rgDefinition.itemIndex)+','
          +edPoint1.Text+','+edPoint2.Text+','+edVecteurDirecteur.Text+';'
          +edVecteurNormal.Text+';'+edDroiteParallele.Text+';'
          +edDroitePerpendiculaire.Text+';';
      if edSegment.Text='' then ch:=ch+',,' else ch:=ch+edSegment.Text+',';
      if edAngle3Points.Text='' then ch:=ch+',,,' else ch:=ch+edAngle3Points.Text+',';
      if edAngle2Vecteurs.Text='' then ch:=ch+',,,' else ch:=ch+edAngle2Vecteurs.Text+',';
      ch:=ch+inttostr(rgEpaisseur.itemindex)+','+inttostr(rgStyle.itemindex)+','
          +inttostr(ColorGrid1.ForeGroundIndex);
      x:=0;y:=0; //initialisation du vecteur directeur de la droite
      x0:=0;y0:=0; //initialisation des coordonnes du point de la droite
      case rgDefinition.ItemIndex of
         0 : if ExistePoint(edPoint1.Text,x1,y1)and ExistePoint(edPoint2.Text,x2,y2) then
             begin
                x:=x2-x1;y:=y2-y1;
                x0:=x1;y0:=y1;
             end
             else ShowMessage('L''un des 2 points, '+edPoint1.Text+' ou '+edPoint2.Text+
                              ' n''est pas (ou mal) dfini');
         1 : begin
                ch2:=edVecteurDirecteur.Text;
                if ExistePoint(edPoint1.Text,x1,y1) then
                begin x0:=x1;y0:=y1;end
                else ShowMessage('Le point '+edPoint1.text+' n''est pas (ou mal) dfini');
                if pos(',',ch2)>0 then
                begin
                   ch1:=Copy(ch2,1,pos(',',ch2)-1);delete(ch2,1,pos(',',ch2));
                   if ExistePoint(ch1,x1,y1)and ExistePoint(ch2,x2,y2) then
                   begin
                      x:=x2-x1;y:=y2-y1;
                   end
                   else ShowMessage('L''un des 2 points, '+edVecteurDirecteur.Text+
                              ' n''est pas (ou mal) dfini');
                end
                else
                if ExisteVecteur(edVecteurDirecteur.text,x1,y1) then
                begin
                   x:=x1;y:=y1;
                end
                else ShowMessage('Le vecteur directeur '+edVecteurDirecteur.text+
                              ' n''est pas (ou mal) dfini');
             end;
         2 : begin
                ch2:=edVecteurNormal.Text;
                if ExistePoint(edPoint1.Text,x1,y1) then
                begin x0:=x1;y0:=y1;end
                else ShowMessage('Le point '+edPoint1.text+' n''est pas (ou mal) dfini');
                if pos(',',ch2)>0 then
                begin
                   ch1:=Copy(ch2,1,pos(',',ch2)-1);delete(ch2,1,pos(',',ch2));
                   if ExistePoint(ch1,x1,y1)and ExistePoint(ch2,x2,y2) then
                   begin
                      y:=x2-x1;x:=y1-y2;
                   end
                   else ShowMessage('L''un des 2 points, '+edVecteurNormal.Text+
                              ' n''est pas (ou mal) dfini');
                end
                else
                if ExisteVecteur(edVecteurNormal.text,x1,y1) then
                begin
                   x:=x1;y:=y1;
                end
                else ShowMessage('Le vecteur normal '+edVecteurNormal.text+
                              ' n''est pas (ou mal) dfini');
             end;
         3 : begin
                ch2:=edDroiteParallele.Text;
                if ExistePoint(edPoint1.Text,x1,y1) then
                begin x0:=x1;y0:=y1;end
                else ShowMessage('Le point '+edPoint1.text+' n''est pas (ou mal) dfini');
                if pos(',',ch2)>0 then
                begin
                   ch1:=Copy(ch2,1,pos(',',ch2)-1);delete(ch2,1,pos(',',ch2));
                   if ExistePoint(ch1,x1,y1)and ExistePoint(ch2,x2,y2) then
                   begin
                      x:=x2-x1;y:=y2-y1;
                   end
                   else ShowMessage('L''un des 2 points, '+edDroiteParallele.Text+
                              ' n''est pas (ou mal) dfini');
                end
                else
                if ExisteDroite(edDroiteParallele.text,x1,y1,x2,y2) then
                begin
                   x:=x1;y:=y1;
                end
                else ShowMessage('La droite parallle '+edVecteurDirecteur.text+
                              ' n''est pas (ou mal) dfinie');
             end;
         4 : begin
                ch2:=edDroitePerpendiculaire.Text;
                if ExistePoint(edPoint1.Text,x1,y1) then
                begin x0:=x1;y0:=y1;end
                else ShowMessage('Le point '+edPoint1.text+' n''est pas (ou mal) dfini');
                if pos(',',ch2)>0 then
                begin
                   ch1:=Copy(ch2,1,pos(',',ch2)-1);delete(ch2,1,pos(',',ch2));
                   if ExistePoint(ch1,x1,y1)and ExistePoint(ch2,x2,y2) then
                   begin
                      y:=x2-x1;x:=y1-y2;
                   end
                   else ShowMessage('L''un des 2 points, '+edDroitePerpendiculaire.Text+
                              ' n''est pas (ou mal) dfini');
                end
                else
                if ExisteDroite(edDroitePerpendiculaire.text,x1,y1,x2,y2) then
                begin
                   y:=x1;x:=-y1;
                end
                else ShowMessage('La droite perpendiculaire '+edVecteurDirecteur.text+
                              ' n''est pas (ou mal) dfinie');
             end;
         5 : begin
                ch2:=edSegment.Text;
                ch1:=copy(ch2,1,pos(',',ch2)-1);delete(ch2,1,pos(',',ch2));
                if ExistePoint(ch1,x1,y1)and ExistePoint(ch2,x2,y2) then
                begin
                   x:=y1-y2;y:=x2-x1;
                   x0:=(x1+x2)/2;y0:=(y1+y2)/2;
                end
                else ShowMessage('Le segment '+edSegment.text+
                              ' n''est pas (ou mal) dfini');
             end;
         6 : begin
                ch3:=edAngle3Points.Text;
                ch1:=copy(ch3,1,pos(',',ch3)-1);delete(ch3,1,pos(',',ch3));
                ch2:=copy(ch3,1,pos(',',ch3)-1);delete(ch3,1,pos(',',ch3));
                if ExistePoint(ch1,x1,y1)and ExistePoint(ch2,x2,y2)and ExistePoint(ch3,x3,y3)then
                begin
                   x0:=x2;y0:=y2;
                   normeBA:=sqrt(sqr(x2-x1)+sqr(y2-y1));
                   normeBC:=sqrt(sqr(x2-x3)+sqr(y2-y3));
                   if (normeBA>0)and(normeBC>0) then
                   begin
                      x3:=x2+(NormeBA/NormeBC)*(x3-x2);
                      y3:=y2+(NormeBA/NormeBC)*(y3-y2);
                      x:=x1+x3-2*x2;
                      y:=y1+y3-2*y2;
                   end
                   else ShowMessage('Au moins 2 des 3 points '+edAngle3Points.Text+
                         'sont confondus, donc l''angle n''est pas dfini');
                end
                else ShowMessage('Au moins l''un des 3 points '+edAngle3Points.Text+
                         ' n''est pas (ou mal) dfini');
             end;
         7 : begin
                ch3:=edAngle2Vecteurs.Text;
                ch1:=copy(ch3,1,pos(',',ch3)-1);delete(ch3,1,pos(',',ch3));
                ch2:=copy(ch3,1,pos(',',ch3)-1);delete(ch3,1,pos(',',ch3));
                if ExistePoint(ch1,x1,y1)and ExisteVecteur(ch2,x2,y2)and ExisteVecteur(ch3,x3,y3)then
                begin
                   x0:=x1;y0:=y1;
                   normeBA:=sqrt(sqr(x2)+sqr(y2));
                   normeBC:=sqrt(sqr(x3)+sqr(y3));
                   if (normeBA>0)and(normeBC>0) then
                   begin
                      x3:=(NormeBA/NormeBC)*x3;
                      y3:=(NormeBA/NormeBC)*y3;
                      x:=x2+x3;
                      y:=y2+y3;
                   end
                   else ShowMessage('Au moins l''un des 2 vecteurs '+ch2+' ou '+ch3+
                         ' est le vecteur nul, donc l''angle n''est pas dfini');
                end
                else ShowMessage('Le point '+ch1+' ou l''un des 2 vecteurs '+ch2+' ou '+ch3+
                         ' n''est pas (ou mal) dfini');
             end;
      end;//case
      ch:=ch+','+FloatToStrF(x,ffGeneral,4,4)+';'+FloatToStrF(y,ffGeneral,4,4)+';'
                +FloatToStrF(x0,ffGeneral,4,4)+';'+FloatToStrF(y0,ffGeneral,4,4);
   end;
   ConstruitChaineDroite:=ch;
end;

Function TfmSchema.DecomposeChaineDroite(ch:string):TObjDroite;
var Droite : TObjDroite;
    chx,chPt1,chPt2    : string;
    a,b,x1,y1,x2,y2    : real;
begin
   delete(ch,1,7);Droite.Nom:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));chx:=Copy(ch,1,pos(',',ch)-1);Droite.Nature:=StrToInt(chx);
   delete(ch,1,pos(',',ch));Droite.Point1:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Droite.Point2:=copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Droite.VecteurDirecteur:=copy(ch,1,pos(';',ch)-1);
   delete(ch,1,pos(';',ch));Droite.VecteurNormal:=copy(ch,1,pos(';',ch)-1);
   delete(ch,1,pos(';',ch));Droite.DroiteParallele:=copy(ch,1,pos(';',ch)-1);
   delete(ch,1,pos(';',ch));Droite.DroitePerpendiculaire:=copy(ch,1,pos(';',ch)-1);
   delete(ch,1,pos(';',ch));Droite.Segment:=copy(ch,1,pos(',',ch));//la virgule incluse
   delete(ch,1,pos(',',ch));Droite.Segment:=Droite.Segment+copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Droite.Angle3Points:=copy(ch,1,pos(',',ch));//la virgule incluse
   delete(ch,1,pos(',',ch));Droite.Angle3Points:=Droite.Angle3Points+copy(ch,1,pos(',',ch));
   delete(ch,1,pos(',',ch));Droite.Angle3Points:=Droite.Angle3Points+copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));Droite.Angle2Vecteurs:=copy(ch,1,pos(',',ch));//la virgule incluse
   delete(ch,1,pos(',',ch));Droite.Angle2Vecteurs:=Droite.Angle2Vecteurs+copy(ch,1,pos(',',ch));
   delete(ch,1,pos(',',ch));Droite.Angle2Vecteurs:=Droite.Angle2Vecteurs+copy(ch,1,pos(',',ch)-1);
   delete(ch,1,pos(',',ch));chx:=Copy(ch,1,pos(',',ch)-1);Droite.epaisseur:=StrToInt(chx);
   delete(ch,1,pos(',',ch));chx:=Copy(ch,1,pos(',',ch)-1);Droite.Style:=StrToInt(chx);
   delete(ch,1,pos(',',ch));chx:=Copy(ch,1,pos(',',ch)-1);Droite.Couleur:=strtoint(chx);
   delete(ch,1,pos(',',ch));Droite.x:=StrToFloat(Copy(ch,1,Pos(';',ch)-1));
   delete(ch,1,pos(';',ch));Droite.y:=StrToFloat(Copy(ch,1,Pos(';',ch)-1));
   delete(ch,1,pos(';',ch));Droite.x0:=StrToFloat(Copy(ch,1,Pos(';',ch)-1));
   delete(ch,1,pos(';',ch));Droite.y0:=StrToFloat(ch);
   fmObjDroite.ColorGrid1.ForegroundIndex:=Droite.couleur;
   Droite.couleur:=fmObjDroite.ColorGrid1.ForegroundColor;
   //reconstitution des valeurs (x,y) du vecteur directeur et (x0,y0) du point
   case Droite.Nature of
      0 :   begin   //droite dfinie par 2 points
               if ExistePOint(Droite.Point1,a,b) then begin Droite.x0:=a;Droite.y0:=b;end;
               if ExistePoint(Droite.Point2,a,b) then begin Droite.x:=a-Droite.x0;Droite.y:=b-Droite.y0;end;
            end;
      1 :   begin   //droite dfinie par un point et un vecteur directeur
               if ExistePOint(Droite.point1,a,b) then begin Droite.x0:=a;Droite.y0:=b;end;
               if ExisteVecteur(Droite.VecteurDirecteur,a,b) then begin Droite.x:=a;Droite.y:=b;end;
            end;
      2 :   begin   //droite dfinie par un point et un vecteur normal
               if ExistePOint(Droite.point1,a,b) then begin Droite.x0:=a;Droite.y0:=b;end;
               if ExisteVecteur(Droite.VecteurNormal,a,b) then begin Droite.x:=-b;Droite.y:=a;end;
            end;
      3 : begin    //droite dfinie par un point et parallle  une autre droite
             if ExistePoint(Droite.Point1,a,b) then begin Droite.x0:=a;Droite.y0:=b;end;
             if pos(',',Droite.DroiteParallele)>0 then
             begin
                chPt1:=Copy(Droite.DroiteParallele,1,pos(',',Droite.DroiteParallele)-1);
                chPt2:=Copy(Droite.DroiteParallele,Pos(',',Droite.DroiteParallele)+1,3);
                if ExistePoint(chPt1,x1,y1)and ExistePoint(chPt2,x2,y2) then
                begin
                   Droite.x:=x2-x1;Droite.y:=y2-y1;
                end;
             end;
          end;
      4 : begin   //droite dfinie par un point et perpendiculaire  une autre droite
             if ExistePoint(Droite.Point1,a,b) then begin Droite.x0:=a;Droite.y0:=b;end;
             if pos(',',Droite.DroitePerpendiculaire)>0 then
             begin
                chPt1:=Copy(Droite.DroitePerpendiculaire,1,pos(',',Droite.DroitePerpendiculaire)-1);
                chPt2:=Copy(Droite.DroitePerpendiculaire,Pos(',',Droite.DroitePerpendiculaire)+1,3);
                if ExistePoint(chPt1,x1,y1)and ExistePoint(chPt2,x2,y2) then
                begin
                   Droite.y:=x2-x1;Droite.x:=y1-y2;
                end;
             end;
          end;
      5 : begin    //mdiatrice d'un segment
             if Pos(',',Droite.Segment)>0 then
             begin
                chPt1:=Copy(Droite.segment,1,Pos(',',Droite.segment)-1);
                chPt2:=Copy(Droite.Segment,Pos(',',Droite.segment)+1,3);
                if ExistePoint(chPt1,x1,y1)and ExistePoint(chPt2,x2,y2) then
                begin
                   Droite.x0:=(x1+x2)/2;Droite.y0:=(y1+y2)/2;
                   Droite.x:=y1-y2;Droite.y:=x2-x1;
                end;
             end;
          end;
      6 : begin   //bissectrice d'un angle donn par 3 points
          end;
      end;
   DecomposeChaineDroite:=Droite;
end;

Function TfmSchema.ExisteDroite(Nom:string;var x,y,x0,y0 : real):boolean;
//Dtermine si la droite nomme existe et si oui retourne dans x,y son vecteur directeur
//et dans x0,y0, les coordonnes d'un point de la droite
var Droite      : TObjDroite;
    k           : integer;
    ch          : string;
begin
   result:=false;
   for k:=0 to ListeObjets.Items.Count-1 do
   begin
      ch:=ListeObjets.Items[k];
      if Pos('Droite',ch)>0 then
      begin
         Droite:=DecomposeChaineDroite(ch);
         if Droite.Nom=Nom then
         begin
            Result:=(Droite.x<>0)or(Droite.y<>0);
            x:=Droite.x;
            y:=Droite.y;
            x0:=Droite.x0;
            y0:=Droite.y0;
         end;
      end;
   end;
end;

Function TfmSchema.ConstruitChaineDemiDroite:string;
var ch : string;
begin
   with fmDemiDroite do
   begin
      ch:='Demi-droite,'+edOrigine.Text+','+IntToStr(rgDefinition.ItemIndex)+','
           +edPoint.Text+','+edVecteurDirecteur.Text+','+edAnglePolaire.Text+';'
           +IntToStr(rgEpaisseur.itemindex)+','+IntToStr(rgStyle.itemindex)+','
           +inttostr(ColorGrid1.ForeGroundIndex)+',';
      if rbDegres.Checked then ch:=ch+'1' else ch:=ch+'0';
   end;
   ConstruitChaineDemiDroite:=ch;
end;

function TfmSchema.DecomposeChaineDemiDroite(ch:string):TObjDemiDroite;
var DemiDroite : TObjDemiDroite;
    chOrigine,chPoint,chVecteurDirecteur,chAnglePolaire,chx,chy : string;
    err : byte;
    Angle : real;
begin
   delete(ch,1,12);
   if copy(ch,1,1)='(' then //l'origine est de la forme (3,5;2)
   begin
      DemiDroite.Origine:=copy(ch,1,pos(')',ch));
      chOrigine:=copy(ch,1,pos(')',ch)-1);
      delete(chOrigine,1,1);//on enlve la parenthse de gauche
      chx:=copy(chOrigine,1,pos(';',chOrigine)-1);delete(chOrigine,1,pos(';',chOrigine));
      chy:=chOrigine;
      chx:=Traduction(chx,err);if err=0 then DemiDroite.x0:=f(chx,1)
                                        else DemiDroite.x0:=0;
      chy:=Traduction(chy,err);if err=0 then DemiDroite.y0:=f(chy,1)
                                        else DemiDroite.y0:=0;
      delete(ch,1,pos(')',ch)+1);
   end
   else
   begin //l'origine est le nom d'un point
      DemiDroite.Origine:=copy(ch,1,pos(',',ch)-1);
      if not ExistePoint(DemiDroite.Origine,DemiDroite.x0,DemiDroite.y0) then
      begin
         DemiDroite.x0:=0;
         DemiDroite.y0:=0;
      end;
      delete(ch,1,pos(',',ch));
   end;

   chx:=Copy(ch,1,pos(',',ch)-1);DemiDroite.Nature:=StrToInt(chx);
   delete(ch,1,pos(',',ch));

   if copy(ch,1,1)='(' then //le second point est de la forme (3,5;2)
   begin
      DemiDroite.Point:=copy(ch,1,pos(')',ch));
      chPoint:=copy(ch,1,pos(')',ch)-1);
      delete(chPoint,1,1);//on enlve la parenthse de gauche
      chx:=copy(chPoint,1,pos(';',chPoint)-1);
      delete(chPoint,1,pos(';',chPoint));
      chy:=chPoint;
      delete(ch,1,pos(')',ch)+1);
      if DemiDroite.Nature=0 then
      begin
         chx:=Traduction(chx,err);if err=0 then DemiDroite.x:=f(chx,1)
                                           else DemiDroite.x:=0;
         chy:=Traduction(chy,err);if err=0 then DemiDroite.y:=f(chy,1)
                                           else DemiDroite.y:=0;
         DemiDroite.x:=DemiDroite.x-DemiDroite.x0;
         DemiDroite.y:=DemiDroite.y-DemiDroite.y0;
      end;
   end
   else
   begin //le second point est donn par son nom
      DemiDroite.Point:=copy(ch,1,pos(',',ch)-1);
      delete(ch,1,pos(',',ch));
      if DemiDroite.Nature=0 then
      begin
         if not ExistePoint(DemiDroite.Point,DemiDroite.x,DemiDroite.y) then
         begin
            DemiDroite.x:=0;
            DemiDroite.y:=0;
         end;
         DemiDroite.x:=DemiDroite.x-DemiDroite.x0;
         DemiDroite.y:=DemiDroite.y-DemiDroite.y0;
      end;
   end;
   if copy(ch,1,1)='(' then //le vecteur directeur est de la forme (3,5;2)
   begin
      DemiDroite.VecteurDirecteur:=copy(ch,1,pos(')',ch));
      chVecteurDirecteur:=copy(ch,1,pos(')',ch)-1);
      delete(chVecteurDirecteur,1,1);//on enlve la parenthse de gauche
      chx:=copy(chVecteurDirecteur,1,pos(';',chVecteurDirecteur)-1);
      delete(chVecteurDirecteur,1,pos(';',chVecteurDirecteur));
      chy:=chVecteurDirecteur;
      delete(ch,1,pos(')',ch)+1);
      if DemiDroite.Nature=1 then
      begin
         chx:=Traduction(chx,err);if err=0 then DemiDroite.x:=f(chx,1)
                                           else DemiDroite.x:=0;
         chy:=Traduction(chy,err);if err=0 then DemiDroite.y:=f(chy,1)
                                           else DemiDroite.y:=0;
      end;
   end
   else
   begin //le VecteurDirecteur est donn par son nom
      DemiDroite.VecteurDirecteur:=copy(ch,1,pos(',',ch)-1);
      if DemiDroite.Nature=1 then
      begin
         if not ExisteVecteur(DemiDroite.VecteurDirecteur,DemiDroite.x,DemiDroite.y) then
         begin
            DemiDroite.x:=0;
            DemiDroite.y:=0;
         end;
      end;
      delete(ch,1,pos(',',ch));
   end;
   DemiDroite.AnglePolaire:=copy(ch,1,pos(';',ch)-1);
   chAnglePolaire:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
   chAnglePolaire:=traduction(chAnglePolaire,err);
   if (err=0)and(chAnglePolaire<>'')   //correction bug 8/01/04
      then Angle:=f(chAnglePolaire,1) else Angle:=0;
   chx:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));DemiDroite.epaisseur:=strtoint(chx);
   chx:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));DemiDroite.style:=strtoint(chx);
   chx:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));DemiDroite.couleur:=strtoint(chx);
   fmDemiDroite.ColorGrid1.ForegroundIndex:=DemiDroite.couleur;
   DemiDroite.couleur:=fmDemiDroite.ColorGrid1.ForegroundColor;
   DemiDroite.blDegres:=ch='1';
   if DemiDroite.blDegres then Angle:=Angle/180*pi;
   if DemiDroite.Nature=2 then
   begin
      DemiDroite.x:=cos(Angle);
      DemiDroite.y:=sin(Angle);
   end;
   DecomposeChaineDemiDroite:=DemiDroite;
end;

Function TfmSchema.ConstruitChaineCercle:string;
var ch : string;
begin
   with fmCercle do
   begin
      ch:='Cercle,'+inttostr(rgDefinition.ItemIndex)+',';
      case rgDefinition.itemIndex of
         0 : ch:=ch+edCentre1.text+','+edRayon.Text+';';
         1 : ch:=ch+edCentre2.Text+','+edPoint.Text+',';
         2 : ch:=ch+edPoint1.Text+','+edPoint2.Text+',';
         3 : ch:=ch+edTriangle1.Text+',';
         4 : ch:=ch+edTriangle2.Text+',';
         5 : ch:=ch+edCentre3.Text+','+edDroite.Text+';';
      end;
      ch:=ch+IntToStr(udEpaisseur.Position)+','+IntToStr(rgStyle.ItemIndex)
          +','+inttostr(ColorGrid1.ForeGroundIndex)
          +','+inttostr(ColorGrid2.ForeGroundIndex);
   end;
   ConstruitChaineCercle:=ch;
end;

function TfmSchema.DecomposeChaineCercle(ch:string):TObjCercle;
var cercle : TObjCercle;
    chx,chy,chz: string;
    err    : byte;
    x1,y1,x2,y2,x3,y3,xi,yi,xj,yj,xk,yk,xl,yl : real;
    normeAB,normeBC,normeAC : real;
begin
   delete(ch,1,7);
   chx:=Copy(ch,1,1);Cercle.Nature:=StrToInt(chx);
   case Cercle.Nature of
      0 : begin //cercle dfini par son centre et son rayon
             delete(ch,1,2);//on supprime '0,'
             cercle.centre:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             if not ExistePoint(Cercle.centre,cercle.x,cercle.y) then
             begin
                cercle.x:=0;
                cercle.y:=0;
             end;
             chx:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));
             cercle.rayon:=chx;
             chx:=traduction(chx,err);if err=0 then cercle.r:=f(chx,1)
                                               else cercle.r:=-1;
          end;
      1 : begin //cercle dfini par son centre et passant par un point donn
             delete(ch,1,2);//on supprime '1,'
             cercle.centre:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             if not ExistePoint(Cercle.centre,cercle.x,cercle.y) then
             begin
                cercle.x:=0;
                cercle.y:=0;
             end;
             cercle.Point1:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             if not ExistePoint(Cercle.Point1,x1,y1) then
             begin
                x1:=0;
                y1:=0;
             end;
             Cercle.r:=sqrt(sqr(x1-cercle.x)+sqr(y1-cercle.y));
          end;
      2 : begin  //cercle dfini par un diamtre [AB] donn
             delete(ch,1,2);//on supprime '2,'
             cercle.Point1:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             cercle.Point2:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             if not ExistePoint(Cercle.Point1,x1,y1)
                or not ExistePoint(Cercle.Point2,x2,y2) then
             begin
                cercle.x:=0;cercle.y:=0;cercle.r:=-1;
             end
             else
             begin
                cercle.x:=(x1+x2)/2;
                cercle.y:=(y1+y2)/2;
                Cercle.r:=sqrt(sqr(x1-cercle.x)+sqr(y1-cercle.y));
             end;
          end;
      3 : begin   //cercle circonscrit  un triangle ABC
             delete(ch,1,2);//on supprime '3,'
             chx:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             chy:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             chz:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             if not existePoint(chx,x1,y1)or not ExistePOint(chy,x2,y2)
                or not ExistePoint(chz,x3,y3) then
             begin
                cercle.x:=0;cercle.y:=0;cercle.r:=-1;
             end
             else
             begin
                xi:=(x1+x2)/2;yi:=(y1+y2)/2; //(xi,yi) est le milieu de [AB]
                xj:=(x1+x3)/2;yj:=(y1+y3)/2; //(xj,yj) est le milieu de [AC]
                xk:=xi+y2-y1;yk:=yi+x1-x2;   //(ik) est la mdiatrice de [AB]
                xl:=xj+y3-y1;yl:=yj+x1-x3;   //(jl) est la mdiatrice de [AC]
                IntersectionDroites(xi,yi,xk,yk,xj,yj,xl,yl,cercle.x,cercle.y);
                Cercle.r:=sqrt(sqr(x1-cercle.x)+sqr(y1-cercle.y));
                cercle.Triangle:=chx+','+chy+','+chz;
             end;
          end;
      4 : begin   //cercle inscrit dans un triangle ABC
             delete(ch,1,2);//on supprime '4,'
             chx:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             chy:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             chz:=copy(ch,1,pos(',',ch)-1);
             delete(ch,1,pos(',',ch));
             if ExistePoint(chx,x1,y1)and ExistePoint(chy,x2,y2)and ExistePoint(chz,x3,y3)then
             begin
                normeAB:=sqrt(sqr(x2-x1)+sqr(y2-y1));
                normeBC:=sqrt(sqr(x2-x3)+sqr(y2-y3));
                normeAC:=sqrt(sqr(x1-x3)+sqr(y1-y3));
                cercle.Triangle:=chx+','+chy+','+chz;
                if (normeAB>0)and(normeBC>0)and(normeAC>0) then
                begin
                   xi:=x2+(NormeAB/NormeBC)*(x3-x2);  //BA=BI et angle(ABI)=angle(ABC)
                   yi:=y2+(NormeAB/NormeBC)*(y3-y2);
                   xj:=(x1+xi)/2;yj:=(y1+yi)/2;       //(BJ) est la bissectrice de ABC

                   xk:=x3+(normeAC/normeBC)*(x2-x3);
                   yk:=y3+(normeAC/normeBC)*(y2-y3);
                   xl:=(x1+xk)/2;yl:=(y1+yk)/2;       //(CL) est la bissectrice de ACB

                   IntersectionDroites(x2,y2,xj,yj,x3,y3,xl,yl,cercle.x,cercle.y);
                                        //si on note M le centre du cercle inscrit,
                   xi:=cercle.x+y2-y3;  //IM est perpendiculaire  [BC]
                   yi:=cercle.y+x3-x2;
                   IntersectionDroites(xi,yi,cercle.x,cercle.y,x2,y2,x3,y3,xj,yj);
                   cercle.r:=sqrt(sqr(xj-cercle.x)+sqr(yj-cercle.y));
                end
                else begin cercle.x:=0;cercle.y:=0;cercle.r:=-1;end;
             end else begin cercle.x:=0;cercle.y:=0;cercle.r:=-1;end;
          end;
      5 : begin //cercle de centre A donn et tangent  une droite (BC) donne
             delete(ch,1,2);//on supprime le '5,'
             chx:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));  //nom du centre du cercle
             chy:=copy(ch,1,pos(';',ch)-1);delete(ch,1,pos(';',ch));  //nom de la droite tangente au cercle
             if pos(',',chy)>0 then //la droite est dfinie par 2 points spars par une virgule
             begin
                chz:=copy(chy,1,pos(',',chy)-1);delete(chy,1,pos(',',chy));
                if ExistePoint(chx,x1,y1) and ExistePoint(chy,x2,y2) and ExistePoint(chz,x3,y3) then
                if sqr(x3-x2)+sqr(y3-y2)>0 then    //si B et C ne sont pas confondus !
                begin //on dtermine le projet K(xk,yk) de A(x1,y1) sur (BC) avec B(x2,y2) et C(x3,y3)
                    xk:=(-(x3-x2)*(x1*(x3-x2)+y1*(y3-y2))-(y3-y2)*(x2*(y3-y2)-y2*(x3-x2)))/(-sqr(x3-x2)-sqr(y3-y2));
                    yk:=((x3-x2)*(x2*(y3-y2)-y2*(x3-x2))-(y3-y2)*(x1*(x3-x2)+y1*(y3-y2)))/(-sqr(x3-x2)-sqr(y3-y2));
                    cercle.x:=x1;
                    cercle.y:=y1;
                    cercle.r:=sqrt(sqr(xk-x1)+sqr(yk-y1));
                end
                else begin cercle.x:=0;cercle.y:=0;cercle.r:=-1;end;
             end
             else                  //la droite est dfinie par son nom
             begin
                if ExisteDroite(chy,x2,y2,x3,y3) and ExistePoint(chx,x1,y1) then
                begin
                   x2:=x2+x3;y2:=y2+y3;
                   xk:=(-(x3-x2)*(x1*(x3-x2)+y1*(y3-y2))-(y3-y2)*(x2*(y3-y2)-y2*(x3-x2)))/(-sqr(x3-x2)-sqr(y3-y2));
                   yk:=((x3-x2)*(x2*(y3-y2)-y2*(x3-x2))-(y3-y2)*(x1*(x3-x2)+y1*(y3-y2)))/(-sqr(x3-x2)-sqr(y3-y2));
                   cercle.x:=x1;
                   cercle.y:=y1;
                   cercle.r:=sqrt(sqr(xk-x1)+sqr(yk-y1));
                end
                else begin cercle.x:=0;cercle.y:=0;cercle.r:=-1;end;
             end;
          end;
   end;//case
   chx:=copy(ch,1,1);cercle.epaisseur:=strtoint(chx);delete(ch,1,2);
   chx:=copy(ch,1,1);cercle.style:=strtoint(chx);delete(ch,1,2);
   chx:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));Cercle.clBord:=strtoint(chx);
   fmCercle.ColorGrid1.ForegroundIndex:=Cercle.clBord;
   Cercle.clBord:=fmCercle.ColorGrid1.ForegroundColor;
   chx:=ch;Cercle.clInterieur:=strtoint(chx);
   fmCercle.ColorGrid2.ForegroundIndex:=Cercle.clInterieur;
   Cercle.clInterieur:=fmCercle.ColorGrid2.ForegroundColor;
   DecomposeChaineCercle:=cercle;
end;

Function TfmSchema.ConstruitChaineEllipse:string;
var ch : string;
begin
   with fmEllipse do
   begin
      ch:='Ellipse,'+IntToStr(rgDefinition.itemindex)+','+
        edCentre.Text+','+edAxeHorizontal.Text+','+edAxeVertical.Text+','+
        edSommet1.Text+','+edSommet2.Text+','+
        IntToStr(udEpaisseur.position)+','+IntToStr(rgStyle.ItemIndex)+','+
        inttostr(ColorGrid1.ForeGroundIndex)+','+inttostr(ColorGrid2.ForeGroundIndex);
      ConstruitChaineEllipse:=ch;
   end;
end;

Function TfmSchema.DecomposeChaineEllipse(ch:string):TObjEllipse;
var Ellipse : TObjEllipse;
    chx     : string;
    x,y,x1,y1 : real;
    err       : byte;
begin
   delete(ch,1,8);
   chx:=Copy(ch,1,1);Ellipse.Nature:=StrToInt(chx);delete(ch,1,2);
   Ellipse.Centre:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   Ellipse.AxeHorizontal:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   Ellipse.AxeVertical:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   Ellipse.Sommet1:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   Ellipse.Sommet2:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   chx:=Copy(ch,1,1);Ellipse.epaisseur:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,1);Ellipse.style:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));Ellipse.clBord:=strtoint(chx);
   fmEllipse.ColorGrid1.ForegroundIndex:=Ellipse.clBord;
   Ellipse.clBord:=fmEllipse.ColorGrid1.ForegroundColor;
   chx:=ch;Ellipse.clInterieur:=strtoint(chx);
   fmEllipse.ColorGrid2.ForegroundIndex:=Ellipse.clInterieur;
   Ellipse.clInterieur:=fmEllipse.ColorGrid2.ForegroundColor;
   case Ellipse.Nature of
      0 : begin
             if not ExistePoint(Ellipse.centre,Ellipse.x,Ellipse.y) then
             begin
                Ellipse.x:=0;
                Ellipse.y:=0;
                Ellipse.rx:=-1;
                Ellipse.ry:=-1;
             end;
             chx:=Traduction(Ellipse.AxeHorizontal,err);
             if err=0 then Ellipse.rx:=f(chx,1) else Ellipse.rx:=-1;
             chx:=Traduction(Ellipse.AxeVertical,err);
             if err=0 then Ellipse.ry:=f(chx,1) else Ellipse.ry:=-1;
          end;
      1 : if ExistePoint(Ellipse.Sommet1,x,y)and ExistePoint(Ellipse.Sommet2,x1,y1) then
          begin
             Ellipse.rx:=abs(x-x1)/2;
             Ellipse.ry:=abs(y-y1)/2;
             Ellipse.x:=(x+x1)/2;
             Ellipse.y:=(y+y1)/2;
          end
          else
          begin
             Ellipse.x:=0;
             Ellipse.y:=0;
             Ellipse.rx:=-1;
             Ellipse.ry:=-1;
          end;
      end; //case nature of
   DecomposeChaineEllipse:=Ellipse;
end;

Function TfmSchema.ConstruitChaineCarre:string;
var ch : string;
begin
   with fmCarre do
   begin
      ch:='Carr,'+IntToStr(rgDefinition.ItemIndex)+',';
      case rgDefinition.ItemIndex of
         0 : ch:=ch+edCentre1.Text+','+edCote.Text+',';
         1 : ch:=ch+edCentre2.Text+','+edRayon.Text+',';
         2 : ch:=ch+edSommet1.Text+','+edSommet2.Text+',';
         3 : ch:=ch+edSommet3.Text+','+edSommet4.Text+',';
      end;
      ch:=ch+IntToStr(rgEpaisseur.ItemIndex)+','+IntToStr(rgStyle.ItemIndex)+','+
        inttostr(ColorGrid1.ForeGroundIndex)+','+inttostr(ColorGrid2.ForeGroundIndex);
   end;
   ConstruitChaineCarre:=ch;
end;

Function TfmSchema.DecomposeChaineCarre(ch:string):TObjCarre;
var carre : TobjCarre;
    chx     : string;
    x1,y1,x2,y2,r : real;
    err       : byte;
    carreOK   : boolean;
begin
   Delete(ch,1,6);
   chx:=copy(ch,1,1);carre.Nature:=StrToInt(chx);delete(ch,1,2);
   case carre.Nature of
      0 : begin
             carre.Centre:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
             carre.Cote:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
          end;
      1 : begin
             carre.Centre:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
             carre.Rayon:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
          end;
      2,3 : begin
             carre.Sommet1:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
             carre.Sommet2:=copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
          end;
   end;
   chx:=Copy(ch,1,1);Carre.epaisseur:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,1);Carre.style:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));Carre.clBord:=strtoint(chx);
   fmCarre.ColorGrid1.ForegroundIndex:=Carre.clBord;
   Carre.clBord:=fmCarre.ColorGrid1.ForegroundColor;
   chx:=ch;Carre.clInterieur:=strtoint(chx);
   fmCarre.ColorGrid2.ForegroundIndex:=Carre.clInterieur;
   Carre.clInterieur:=fmCarre.ColorGrid2.ForegroundColor;
   CarreOK:=true;
   case carre.nature of  //calcul des coordonnes de 2 sommets opposs
      0 : begin
             CarreOK:=ExistePoint(carre.centre,x1,y1);
             chx:=Traduction(carre.cote,err);CarreOK:=CarreOK and (err=0);
             r:=0;
             if err=0 then r:=f(chx,1);CarreOK:=CarreOK and (r>0);
             carre.x1:=x1-r/2;carre.y1:=y1-r/2;
             carre.x2:=x1+r/2;carre.y2:=y1+r/2;
          end;
      1 : begin
             CarreOK:=ExistePoint(carre.centre,x1,y1);
             chx:=Traduction(carre.rayon,err);CarreOK:=CarreOK and (err=0);
             r:=0;
             if err=0 then r:=f(chx,1);CarreOK:=CarreOK and (r>0);
             carre.x1:=x1-r/sqrt(2);carre.y1:=y1-r/sqrt(2);
             carre.x2:=x1+r/sqrt(2);carre.y2:=y1+r/sqrt(2);
          end;
      2 : carreOK:=ExistePoint(carre.sommet1,carre.x1,carre.y1) and
                   ExistePoint(carre.sommet2,carre.x2,carre.y2);
      3 : begin
             carreOK:=ExistePoint(carre.sommet1,carre.x1,carre.y1) and
                   ExistePoint(carre.sommet2,x2,y2);
             if carreOK then
             begin
                carre.x2:=x2+carre.y1-y2;
                carre.y2:=y2+x2-carre.x1;
             end;
          end;
   end;
   if not CarreOK then
   begin
      carre.x1:=0;carre.y1:=0;
      carre.x2:=0;carre.y2:=0;
   end;
   DecomposeChaineCarre:=carre;
end;

procedure SupprimerPoint(NomPoint:string);
//supprime s'il existe dans ListeObjets, le point dont le nom est donn
var k : integer;
    ch : string;
begin
   k:=0;
   while fmSchema.ListeObjets.Items.Count>k do
   begin
      ch:=fmSchema.ListeObjets.Items[k];
      if copy(ch,1,5)='Point' then
      begin
         delete(ch,1,6);
         if copy(ch,1,pos('[',ch)-1)=NomPoint then fmSchema.ListeObjets.Items.Delete(k)
                                              else inc(k);
      end
      else inc(k);
   end;
end;

function TfmSchema.ConstruitChainePolygonePredefini:string;
var ch,chx,A,B,C,D : string;
    x1,y1,x2,y2,x3,y3,x4,y4,L,H,L1,L2,L3   : real;//coordones des sommets
    erreur : byte;
begin
   with fmPolygonePredefini do
   begin
      ch:='Polygone prdfini,'+inttostr(rgNature.itemindex)+',';
      if rgOptions.Visible then ch:=ch+inttostr(rgOptions.ItemIndex)+','
                           else ch:=ch+'0,';
      ch:=ch+edNomsSommets.Text+','+edit1.text+','+edit2.text+','+edit3.text
            +','+edit4.text+','+edit5.text+','
            +IntToStr(rgEpaisseur.ItemIndex)+','+IntToStr(rgStyle.ItemIndex)+','+
        inttostr(ColorGrid1.ForeGroundIndex)+','+inttostr(ColorGrid2.ForeGroundIndex);
      chx:=edNomsSommets.text;
      A:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));
      B:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));
      if rgNature.ItemIndex in [0..5] then begin C:=chx;D:='';end
      else
      begin
         C:=Copy(chx,1,pos(',',chx)-1);delete(chx,1,pos(',',chx));
         D:=chx;
      end;
      x1:=0;y1:=0;x2:=0;y2:=0;x3:=0;y3:=0;x4:=0;y4:=0;
      case rgNature.ItemIndex of
         0 : begin  //Triangle equilatral de ct edit1
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,-3;-3;0,5,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                L:=0;
                chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)//longueur du ct
                   else ch:='Erreur sur la longueur du ct du triangle quilatral';
                x2:=x1+L;       y2:=y1;
                x3:=(x1+x2)/2;  y3:=y1+L*sqrt(3)/2;
             end;
         1 : begin  //Triangle isocle de base edit1 de hauteur ou ct edit2
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,-3;-3;0,5,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                L:=0;
                chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)//longueur da la base
                   else ch:='Erreur sur la longueur de la base du triangle isocle';
                x2:=x1+L;        y2:=y1;
                H:=0;
                chx:=Traduction(edit2.text,erreur);
                if erreur=0 then H:=f(chx,1)// hauteur du triangle isocle
                   else ch:='Erreur sur la hauteur ou le ct du triangle isocle';
                if rgOptions.ItemIndex=1 then
                   if L<2*H then
                   begin
                      H:=sqrt(sqr(H)-sqr(L/2)); //cas o edit2=ct
                      x3:=(x1+x2)/2;   y3:=y1+H;
                   end else ch:='Erreur : il n''est pas possible de construire '+
                        'un triangle isocle dont la base est plus grande que la '+
                        'somme des 2 autres cts ('+edit1.text+' > 2x'+edit2.text+')';
             end;
         2 : begin  //Triangle rectangle de cts edit1 et edit2 (cts de l'angle droit)
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,-3;-3;0,5,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                L:=0;
                chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)// 1er ct du triangle rectangle
                   else ch:='Erreur sur le ct du triangle rectangle';
                x2:=x1+L;   y2:=y1;
                H:=0;
                chx:=Traduction(edit2.text,erreur);
                if erreur=0 then H:=f(chx,1)// 2me ct du triangle rectangle
                   else ch:='Erreur sur le ct du triangle rectangle';
                x3:=x1;y3:=y1+H;
             end;
         3 : begin  //Triangle rectangle isocle
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,-3;-3;0,5,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                L:=0;
                chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)// 2me ct du triangle rectangle
                   else ch:='Erreur sur le ct du triangle rectangle icocle';
                if rgOptions.ItemIndex=1 then L:=L/sqrt(2);  //cas o edit1=hypothnuse
                x2:=x1+L;   y2:=y1;
                x3:=x1;     y3:=y1+L;
             end;
         4 : begin  //triangle dfini par les longueurs des 3 cts
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,-3;-3;0,5,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                L1:=0;chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L1:=f(chx,1)//1er ct du triangle
                   else ch:='Erreur sur le premier ct du triangle';
                L2:=0;chx:=Traduction(edit2.text,erreur);
                if erreur=0 then L2:=f(chx,1)//2me ct du triangle
                   else ch:='Erreur sur le second ct du triangle';
                L3:=0;chx:=Traduction(edit3.text,erreur);
                if erreur=0 then L3:=f(chx,1)//3me ct du triangle
                   else ch:='Erreur sur le 3me ct du triangle';
                L:=(sqr(L1)+sqr(L3)-sqr(L2))/(2*L1);
                if (L<0)or(L3<L) then ch:='Erreur : il n''existe pas de triangle '
                     +'dont les cts ont pour longueurs '
                     +edit1.text+', '+edit2.text+' et '+edit3.text;
                if copy(ch,1,3)<>'Err' then H:=sqrt(sqr(L3)-sqr(L))
                                       else H:=0;
                x2:=x1+L1;     y2:=y1;
                x3:=x1+L;      y3:=y1+H;
             end;
         5 : begin    //triangle prdfini n'ayant aucune particularit
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,-3;-3;0,5,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+12.5;  y2:=y1+2.5;
                x3:=x1+8.5;   y3:=y1+8.5;
             end;
         6 : begin    //carr
                L:=0;chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)//ct du carr
                   else ch:='Erreur sur le ct du carr';
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-L/2;y1:=-L/2;
                   chx:='Point '+A+',0,'+FloatToStrF(x1,ffGeneral,4,4)+';'+
                                       FloatToStrF(y1,ffGeneral,4,4)+';0,5,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+L;   y2:=y1;
                x3:=x2;     y3:=y1+L;
                x4:=x1;     y4:=y3;
             end;
         7 : begin   //rectangle
                L:=0;chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)//longueur
                   else ch:='Erreur sur la longueur du rectangle';
                H:=0;chx:=Traduction(edit2.text,erreur);
                if erreur=0 then H:=f(chx,1)//largeur
                   else ch:='Erreur sur la largeur du rectangle';
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-L/2;y1:=-H/2;
                   chx:='Point '+A+',0,'+FloatToStrF(x1,ffGeneral,4,4)+';'+
                                       FloatToStrF(y1,ffGeneral,4,4)+';0,5,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+L;    y2:=y1;
                x3:=x2;      y3:=y2+H;
                x4:=x1;      y4:=y3;
             end;
         8 : begin   //paralllogramme
                L:=0;chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)//longueur du premier ct
                   else ch:='Erreur sur la longueur du 1er ct';
                H:=0;chx:=Traduction(edit2.text,erreur);
                if erreur=0 then H:=f(chx,1)//hauteur du paralllogramme
                   else ch:='Erreur sur la hauteur du paralllogramme';
                L1:=0;chx:=Traduction(edit3.text,erreur);
                if erreur=0 then L1:=f(chx,1)//tangente de l'angle du 1er sommet
                   else ch:='Erreur sur l''expression '+edit3.text;
                if L1=0 then ch:='Erreur : la tangente de l''angle ne peut tre nulle !';
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-L/2;y1:=-H/2;
                   chx:='Point '+A+',0,'+FloatToStrF(x1,ffGeneral,4,4)+';'+
                                       FloatToStrF(y1,ffGeneral,4,4)+';0,5,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+L;                 y2:=y1;
                if L1<>0 then x3:=x2+H/L1 else x3:=x2;  y3:=y2+H;
                x4:=x3-L;                 y4:=y3;
             end;
         9 : begin                //losange
                L:=0;chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L:=f(chx,1)//longueur
                   else ch:='Erreur sur la largeur du losange';
                H:=0;chx:=Traduction(edit2.text,erreur);
                if erreur=0 then H:=f(chx,1)//largeur
                   else ch:='Erreur sur la hauteur du losange';
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=0;y1:=-H/2;
                   chx:='Point '+A+',0,'+FloatToStrF(x1,ffGeneral,4,4)+';'+
                                       FloatToStrF(y1,ffGeneral,4,4)+';0,5,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+L/2;    y2:=y1+H/2;
                x3:=x1;        y3:=y1+H;
                x4:=x1-L/2;    y4:=y2;
             end;
         10 :begin    //trapze quelconque
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,-3;-3;0,5,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+8;   y2:=y1;
                x3:=x1+7;   y3:=y1+4;
                x4:=x1+2;   y4:=y1+4;
             end;
         11: begin   //trapze rectangle
                L1:=0;chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L1:=f(chx,1)
                   else ch:='Erreur sur la grande base du trapze : '+edit1.text;
                L2:=0;chx:=Traduction(edit2.text,erreur);
                if erreur=0 then L2:=f(chx,1)
                   else ch:='Erreur sur la petite base du trapze : '+edit2.text;
                H:=0;chx:=Traduction(edit3.text,erreur);
                if erreur=0 then H:=f(chx,1)
                   else ch:='Erreur sur la hauteur du trapze : '+edit3.text;
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,'+FloatToStrF(x1,ffGeneral,4,4)+';'+
                                       FloatToStrF(y1,ffGeneral,4,4)+';0,5,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+L1;     y2:=y1;
                x3:=x1+L2;     y3:=y1+H;
                x4:=x1;        y4:=y1+H;
             end;
          12: begin   //trapze isocle
                L1:=0;chx:=Traduction(edit1.text,erreur);
                if erreur=0 then L1:=f(chx,1)
                   else ch:='Erreur sur la grande base du trapze : '+edit1.text;
                L2:=0;chx:=Traduction(edit2.text,erreur);
                if erreur=0 then L2:=f(chx,1)
                   else ch:='Erreur sur la petite base du trapze : '+edit2.text;
                H:=0;chx:=Traduction(edit3.text,erreur);
                if erreur=0 then H:=f(chx,1)
                   else ch:='Erreur sur la hauteur du trapze : '+edit3.text;
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-L1/2;y1:=-H/2;
                   chx:='Point '+A+',0,'+FloatToStrF(x1,ffGeneral,4,4)+';'+
                                       FloatToStrF(y1,ffGeneral,4,4)+';0,5,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+L1;     y2:=y1;
                x3:=L2/2;      y3:=y1+H;
                x4:=-L2/2;     y4:=y1+H;
             end;
         13: begin
                if not ExistePoint(A,x1,y1) then
                begin
                   x1:=-3;y1:=-3;
                   chx:='Point '+A+',0,'+FloatToStrF(x1,ffGeneral,4,4)+';'+
                                       FloatToStrF(y1,ffGeneral,4,4)+';0,5,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                end;
                x2:=x1+8;    y2:=y1;
                x3:=x1+6;    y3:=y1+5;
                x4:=x1+3;    y4:=y1+6;
             end;
      end;
      if copy(ch,1,3)<>'Err' then
      begin
         SupprimerPoint(B);SupprimerPoint(C);
         if rgNature.ItemIndex>5 then SupprimerPoint(D);
         chx:='Point '+B+',0,'+FloatToStrF(x2,ffGeneral,4,4)+';'+
                          FloatToStrF(y2,ffGeneral,4,4)+';'
                         +'0,7,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
         ListeObjets.Items.Add(chx);
         chx:='Point '+C+',0,'+FloatToStrF(x3,ffGeneral,4,4)+';'+
                          FloatToStrF(y3,ffGeneral,4,4)+';'
                         +'0,1,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
         ListeObjets.Items.Add(chx);
         if rgNature.ItemIndex>5 then
         begin
            chx:='Point '+D+',0,'+FloatToStrF(x4,ffGeneral,4,4)+';'+
                          FloatToStrF(y4,ffGeneral,4,4)+';'
                         +'0,3,0,0,'+inttostr(ColorGrid1.foreGroundIndex);
            ListeObjets.Items.Add(chx);
         end;
      end;
   end;
   ConstruitChainePolygonePredefini:=ch;
end;

function TfmSchema.DecomposeChainePolygonePredefini(ch:string):TObjPolygonePredefini;
var PolygonePredefini : TObjPolygonePredefini;
    chx               : string;
begin
   delete(ch,1,pos(',',ch));
   chx:=copy(ch,1,pos(',',ch)-1);PolygonePredefini.Nature:=StrToInt(chx);delete(ch,1,pos(',',ch));
   chx:=copy(ch,1,pos(',',ch)-1);PolygonePredefini.Option:=StrToInt(chx);delete(ch,1,pos(',',ch));
   PolygonePredefini.A:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   PolygonePredefini.B:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   PolygonePredefini.C:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   if PolygonePredefini.Nature in [6..13] then
   begin
      PolygonePredefini.D:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   end;
   PolygonePredefini.caracteristiques[1]:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   PolygonePredefini.caracteristiques[2]:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   PolygonePredefini.caracteristiques[3]:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   PolygonePredefini.caracteristiques[4]:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   PolygonePredefini.caracteristiques[5]:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));
   chx:=Copy(ch,1,1);PolygonePredefini.epaisseur:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,1);PolygonePredefini.style:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,pos(',',ch)-1);delete(ch,1,pos(',',ch));PolygonePredefini.clBord:=strtoint(chx);
   fmPolygonePredefini.ColorGrid1.ForegroundIndex:=PolygonePredefini.clBord;
   PolygonePredefini.clBord:=fmPolygonePredefini.ColorGrid1.ForegroundColor;
   chx:=ch;PolygonePredefini.clInterieur:=strtoint(chx);
   fmPolygonePredefini.ColorGrid2.ForegroundIndex:=PolygonePredefini.clInterieur;
   PolygonePredefini.clInterieur:=fmPolygonePredefini.ColorGrid2.ForegroundColor;
   DecomposeChainePolygonePredefini:=PolygonePredefini;
end;

Function TfmSchema.ConstruitChainePolygone:string;
var ch,chSommets,chx : string;
    NomsSommets : array[1..40] of String[3];
    x1,y1,x2,y2,x3,y3,x4,y4 : real;
    k,n : integer;
    ErreurA,ErreurB : boolean;
begin
   with fmPolygone do
   begin
      ch:='Polygone de type '+inttostr(rgDefinition.ItemIndex)+',';
      case rgDefinition.ItemIndex of
         0 : begin //triangle equilateral
               ch:=ch+'3,';
               chSommets:=edSommets1.Text;
               ch:=ch+chSommets+',';
               NomsSommets[1]:=Copy(chSommets,1,pos(',',chSommets)-1);delete(chSommets,1,Pos(',',chSommets));
               NomsSommets[2]:=Copy(chSommets,1,pos(',',chSommets)-1);delete(chSommets,1,Pos(',',chSommets));
               NomsSommets[3]:=chSommets;
               if Not ExistePoint(NomsSommets[1],x1,y1) or not ExistePoint(NomsSommets[2],x2,y2)
               then ch:='Erreur : les 2 premiers sommets doivent tre pralablement dfinis'
               else
               begin
                  if not ExistePoint(NomsSommets[3],x3,y3) then
                  begin
                     x3:=0.5*(x2-x1)-sqrt(3)/2*(y2-y1)+x1;
                     y3:=0.5*(y2-y1)+sqrt(3)/2*(x2-x1)+y1;
                     chx:='Point '+NomsSommets[3]+',0,'+FloatToStrF(x3,ffGeneral,4,4)+';'+
                                       FloatToStrF(y3,ffGeneral,4,4)+';6,0,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                     ListeObjets.Items.Add(chx);
                  end;
               end;
             end;
         1 : begin  //paralllogramme
                ch:=ch+'4,';
                chSommets:=edSommets2.Text;
                ch:=ch+chSommets+',';
                NomsSommets[1]:=Copy(chSommets,1,pos(',',chSommets)-1);delete(chSommets,1,Pos(',',chSommets));
                NomsSommets[2]:=Copy(chSommets,1,pos(',',chSommets)-1);delete(chSommets,1,Pos(',',chSommets));
                NomsSommets[3]:=Copy(chSommets,1,pos(',',chSommets)-1);delete(chSommets,1,Pos(',',chSommets));
                NomsSommets[4]:=chSommets;
                if Not ExistePoint(NomsSommets[1],x1,y1) or not ExistePoint(NomsSommets[2],x2,y2)
                   or not ExistePoint(NomsSommets[3],x3,y3)
               then ch:='Erreur : les 3 premiers sommets doivent tre pralablement dfinis'
               else
               begin
                  if not ExistePoint(NomsSommets[4],x4,y4) then
                  begin
                     x4:=x1+x3-x2;
                     y4:=y1+y3-y2;
                     chx:='Point '+NomsSommets[4]+',0,'+FloatToStrF(x4,ffGeneral,4,4)+';'+
                                       FloatToStrF(y4,ffGeneral,4,4)+';6,0,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                     ListeObjets.Items.Add(chx);
                  end;
               end;
             end;
         2 : begin  //polygone rgulier
                chSommets:=edSommets3.Text;ErreurA:=false;ErreurB:=false;
                k:=0;
                while chSommets<>'' do
                begin
                   n:=Pos(',',chSommets);
                   if n=0 then
                   begin
                      inc(k);
                      NomsSommets[k]:=chSommets; //c'est le nom du dernier sommet : il n'y a pas de virgule aprs
                      chSommets:='';
                   end
                   else
                   begin
                      inc(k);
                      NomsSommets[k]:=Copy(chSommets,1,n-1);
                      Delete(chSommets,1,n);
                      if k=1 then ErreurA:=not ExistePoint(NomsSommets[1],x1,y1);
                      if k=2 then ErreurB:=not ExistePoint(NomsSommets[2],x2,y2);
                   end;
                end;
                ch:=ch+intToStr(k)+','+edSommets3.Text+',';
                if ErreurA or ErreurB then ch:='Erreur : les 2 premiers sommets doivent tre pralablement dfinis'
                else for n:=3 to k do
                begin
                   x3:=x2+(x2-x1)*cos((k-1)*2*pi/k)+(y2-y1)*sin((k-1)*2*pi/k);
                   y3:=y2-(x2-x1)*sin((k-1)*2*pi/k)+(y2-y1)*cos((k-1)*2*pi/k);
                   chx:='Point '+NomsSommets[n]+',0,'+FloatToStrF(x3,ffGeneral,4,4)+';'+
                                       FloatToStrF(y3,ffGeneral,4,4)+';6,0,0,0,'+
                                       inttostr(ColorGrid1.foreGroundIndex);
                   ListeObjets.Items.Add(chx);
                   x1:=x2;x2:=x3;
                   y1:=y2;y2:=y3;
                end;
             end;
         3 : begin
                chSommets:=edSommets4.Text;
                ErreurA:=false;
                k:=0;
                while chSommets<>'' do
                begin
                   n:=Pos(',',chSommets);
                   if n=0 then
                   begin
                      inc(k);
                      NomsSommets[k]:=chSommets; //c'est le nom du dernier sommet : il n'y a pas de virgule aprs
                      chSommets:='';
                   end
                   else
                   begin
                      inc(k);
                      NomsSommets[k]:=Copy(chSommets,1,n-1);
                      Delete(chSommets,1,n);
                      ErreurA:=ErreurA or not ExistePoint(NomsSommets[1],x1,y1);
                   end;
                end;
                ch:=ch+inttostr(k)+','+edSommets4.Text+',';
                if ErreurA then ch:='Erreur : l''un des sommets, au moins, n''existe pas ...';
             end;
      end;
      ch:=ch+inttostr(rgEpaisseur.ItemIndex)+',';
      ch:=ch+inttostr(rgStyle.ItemIndex)+',';                 // sytle de la bordure
      ch:=ch+inttostr(ColorGrid1.ForegroundIndex)+',';        // couleur du bord
      ch:=ch+inttostr(ColorGrid2.ForegroundIndex)+',';        // couleur de l'intrieur
      ch:=ch+inttostr(udStyle.position);                      // style des hachures
   end;
   ConstruitChainePolygone:=ch;
end;


function TfmSchema.DecomposeChainePolygone(ch:String):TObjPolygone;
var Polygone : TObjPolygone;
    chx      : string;
    n        : integer;
begin
   delete(ch,1,pos(',',ch)-3);
   chx:=copy(ch,1,pos(',',ch)-1);Polygone.nature:=StrToInt(chx);delete(ch,1,pos(',',ch));
   chx:=copy(ch,1,pos(',',ch)-1);Polygone.nbSommets:=StrToInt(chx);delete(ch,1,pos(',',ch));
   chx:='';
   for n:=1 to Polygone.nbSommets do
   begin
      chx:=chx+Copy(ch,1,pos(',',ch)-1);
      delete(ch,1,pos(',',ch));
      chx:=chx+',';
   end;
   delete(chx,length(chx),1);
   Polygone.Sommets:=chx;
   chx:=Copy(ch,1,1);Polygone.epaisseur:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,1);Polygone.style:=StrToInt(chx);delete(ch,1,2);
   chx:=Copy(ch,1,Pos(',',ch)-1);Polygone.clBord:=StrToInt(chx);delete(ch,1,Pos(',',ch));
   chx:=Copy(ch,1,Pos(',',ch)-1);Polygone.clInterieur:=StrToInt(chx);delete(ch,1,Pos(',',ch));
   Polygone.hachures:=StrToInt(ch);
   fmPolygone.ColorGrid1.ForegroundIndex:=Polygone.clBord;
   Polygone.clBord:=fmPolygone.ColorGrid1.ForegroundColor;
   fmPolygone.ColorGrid2.ForegroundIndex:=Polygone.clInterieur;
   Polygone.clInterieur:=fmPolygone.ColorGrid2.ForegroundColor;
   DecomposeChainePolygone:=Polygone;
end;

Function TfmSchema.ConstruitChaineConique:string;
var
	ch : string;
   i  : integer;
begin
   with fmConique do
   begin
      ch:='Conique,'+IntToStr(rgDefinition.itemindex)+','+
      pdec(edFoyer.Text)+','+pdec(edDirectrice.Text)+','+pdec(edExcentricite.Text)+','+
      pdec(edA.Text)+','+pdec(edB.Text)+','+pdec(edC.Text)+','+pdec(edD.Text)+','+pdec(edE.Text)+','+pdec(edF.Text)+',';
      if cbFoyer.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbDirectrice.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbAxe.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbSommet.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbCentre.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbAsymptote.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbExcentricite.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbMetriques.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbCoordonnees.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if cbEquations.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      if rbValeursExactes.Checked then ch:=ch+'1,'else ch:=ch+'0,';
      ch:=ch+IntToStr(udEpaisseur.position)+',';             // paisseur conique
      ch:=ch+'1,';                                           // style conique: pas encore implment
      ch:=ch+inttostr(cgCouleur.ForeGroundColor)+',';        // couleur conique
      ch:=ch+'1,';                                           // paisseur droites: pas encore implment
      i:=1;
      if rbStyleDroites1.Checked then i:=1;
      if rbStyleDroites2.Checked then i:=2;
      if rbStyleDroites3.Checked then i:=3;
      ch:=ch+intToStr(i)+',';                                 // style droites
      ch:=ch+inttostr(cgCouleurDroites.ForeGroundColor)+',';  // couleur droites
      ch:=ch+'2,';                                            // taille points: pas encore implment
      i:=7;
      if rbPoint.checked then i:=1;
      if rbPlus.checked then i:=2;
    	if rbCroix.checked then i:=3;
      if rbEtoile.Checked then i:=4;
      if rbCarre.Checked then i:=5;
      if rbLosange.Checked then i:=6;
      if rbRond.Checked then i:=7;
      if rbCarre2.Checked then i:=8;
      if rbLosange2.Checked then i:=9;
      ch:=ch+intToStr(i)+',';                                 // style points
      ch:=ch+'0';                                             // couleur points:  pas encore implment
      ConstruitChaineConique:=ch;
   end;
end;

Function TfmSchema.DecomposeChaineConique(ch:string):TObjConique;
var Conique                                   : TObjConique;
    Chx, ChaineFoyer, ChaineDirectrice        : string;
    x,y,x1,y1,x2,y2,z1,z2,e2                  : real;
    p,p1,p2,l                                 : integer;
    err : byte;
begin
with Conique do
	begin
   Nature:=StrToInt(ExtraitItem(ch,1));
   ChaineFoyer:=ExtraitItem(ch,2);
   ChaineDirectrice:=ExtraitItem(ch,3);
   Chx:=ExtraitItem(ch,4);
   if Chx<>'' then Excentricite:=ValConstante(Chx);
   Chx:=ExtraitItem(ch,5);
   if Chx<>'' then A:=ValConstante(Chx);
   Chx:=ExtraitItem(ch,6);
   if Chx<>'' then B:=ValConstante(Chx);
   Chx:=ExtraitItem(ch,7);
   if Chx<>'' then C:=ValConstante(Chx);
   Chx:=ExtraitItem(ch,8);
   if Chx<>'' then D:=ValConstante(Chx);
   Chx:=ExtraitItem(ch,9);
   if Chx<>'' then E:=ValConstante(Chx);
   Chx:=ExtraitItem(ch,10);
   if Chx<>'' then F:=ValConstante(Chx);
   Chx:=ExtraitItem(ch,11);
   if Chx='1' then Foy:=True else Foy:=False;
   Chx:=ExtraitItem(ch,12);
   if Chx='1' then Dir:=True else Dir:=False;
   Chx:=ExtraitItem(ch,13);
   if Chx='1' then Axe:=True else Axe:=False;
   Chx:=ExtraitItem(ch,14);
   if Chx='1' then Som:=True else Som:=False;
   Chx:=ExtraitItem(ch,15);
   if Chx='1' then Cen:=True else Cen:=False;
   Chx:=ExtraitItem(ch,16);
   if Chx='1' then Asy:=True else Asy:=False;
   Chx:=ExtraitItem(ch,17);
   if Chx='1' then Exc:=True else Exc:=False;
   Chx:=ExtraitItem(ch,18);
   if Chx='1' then Met:=True else Met:=False;
   Chx:=ExtraitItem(ch,19);
   if Chx='1' then Coo:=True else Coo:=False;
   Chx:=ExtraitItem(ch,20);
   if Chx='1' then Equ:=True else Equ:=False;
   Chx:=ExtraitItem(ch,21);
   if Chx='1' then Exa:=True else Exa:=False;
   Chx:=ExtraitItem(ch,22);
	Epaisseur:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,23);
   Style:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,24);
   Couleur:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,25);
	EpaisseurDroites:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,26);
   StyleDroites:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,27);
   CouleurDroites:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,28);
	TaillePoints:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,29);
   StylePoints:=StrToInt(Chx);
   Chx:=ExtraitItem(ch,30);
   CouleurPoints:=StrToInt(Chx);
   Foyer:='';
   Directrice:='';
   Point1:='';
   Point2:='';
   if Conique.Nature = 0  // si par foyer, directrice et excentricit
      then begin
      //////////foyer://////////////
      if pos('(',chaineFoyer)>0 // si foyer donn par ses coordonnes
      	then begin
        	delete(ChaineFoyer,1,1);
         p:=pos(';',ChaineFoyer);
         p1:=pos(')',ChaineFoyer);
        	Chx:=Copy(ChaineFoyer,1,p-1);
        	xf:=ValConstante(Chx);
        	Chx:=Copy(ChaineFoyer,p+1,p1-p-1);
        	yf:=ValConstante(Chx);
        	end else begin         //si nom du foyer
        	Foyer:=ChaineFoyer;
        	if ExistePoint(ChaineFoyer,x,y)
        		then begin
           	xf:=x;
           	yf:=y;
           	end; //pas de else, le point doit exister
        end;
      ///////////directrice;///////////////
	   if (copy (ChaineDirectrice,1,2)='x=')   //quation rduite d'une droite verticale
			or (copy (ChaineDirectrice,1,2)='X=')
				then begin
            	Chx:=ChaineDirectrice;
					delete(Chx,1,2); // suppression x=
            	ad:=1;
            	bd:=0;
            	cd:=Valconstante(Chx);
				end;
   	if (copy (ChaineDirectrice,1,2)='y=')    // quation rduite d'une droite oblique ou horizontale
   		or (copy (ChaineDirectrice,1,2)='Y=')
   			then begin
            	Chx:=ChaineDirectrice;
      			Delete(Chx,1,2);  // suppression y=
      			NomVar:='X';
         		Chx:=Traduction(Chx , err);
               ad:=uFonctions.F(Chx,0)-uFonctions.F(Chx,1);
         		bd:=1;
               cd:=uFonctions.F(Chx,0);
      		end;
    	l:=length(ChaineDirectrice);
    	if copy (ChaineDirectrice,l-1,2)='=0' // quation cartsienne
    		then begin
         	Chx:=ChaineDirectrice;
      		Delete(Chx,l-1,2);  // suppression =0
      		NomVar:='X';
         	NomPar:='Y';
         	Chx:=Traduction(Chx , err);
            uFonctions.p:=0;  // y=0
            z1:=uFonctions.F(Chx,1);
            z2:=uFonctions.F(Chx,0);
            ad:=z1-z2;        // en posant f(x,y)=ax+by+c: a = f(1,0)-f(0,0)
            uFonctions.p:=1;  // y=1
            z1:=uFonctions.F(Chx,0);
            bd:=z1-z2;        // b = f(0,1)-f(0,0)
            cd:=z2;           // c = f(0,0)
            end;
      if (ChaineDirectrice[1]='(') and (ChaineDirectrice[l]=')')//si dfinie par deux points existants, comme(AB)
      	then begin
         Point1:=ChaineDirectrice[2];
         Point2:=ChaineDirectrice[3];
         ExistePoint(Point1,x1,y1);
         ExistePoint(Point2,x2,y2);
         ad:=y2-y1;
         bd:=x1-x2;
         cd:=y1*x2-x1*y2;
         end;
      if (pos ('=',ChaineDirectrice)=0) and (ChaineDirectrice[1]<>'(')
         then begin                // si nom d'une droite existante comme d, d1
         Directrice:=ChaineDirectrice;
         ExisteDroite(ChaineDirectrice,x1,y1,x2,y2);
         ad:=y1;
         bd:=-x1;
         cd:=x1*y2-y1*x2;
         end;
      //coefficients de l'quation de la conique:
      e2:=excentricite*excentricite;
      A:=(1-e2)*ad*ad+bd*bd;
      B:=-2*ad*bd*e2;
      C:=ad*ad+(1-e2)*bd*bd;
      D:=-2*(xf*(ad*ad+bd*bd)+ad*cd*e2);
      E:=-2*(yf*(ad*ad+bd*bd)+bd*cd*e2);
      F:=(xf*xf+yf*yf)*(ad*ad+bd*bd)-e2*cd*cd;
      end;
   end;
DecomposeChaineConique:=Conique;
end;


function TfmSchema.ConstruitChaineBezier : string;
var ch : string;
    chSommets : string;
    k,n       : integer;
    ErreurA   : boolean;
    NomsSommets : array[1..40]of string[3];
    x1,y1       : real;
begin
   with fmBezier do
   begin
      ch:='Courbe de Bzier de type '+IntToStr(rgType.ItemIndex)+',';
      chSommets:=edSommets.Text;
      ErreurA:=false;
      k:=0;
      while chSommets<>'' do
      begin
         n:=Pos(',',chSommets);
         if n=0 then
         begin
            inc(k);
            NomsSommets[k]:=chSommets; //c'est le nom du dernier sommet : il n'y a pas de virgule aprs
            ErreurA:=ErreurA or not ExistePoint(NomsSommets[k],x1,y1);
            chSommets:='';
         end
         else
         begin
            inc(k);
            NomsSommets[k]:=Copy(chSommets,1,n-1);
            Delete(chSommets,1,n);
            ErreurA:=ErreurA or not ExistePoint(NomsSommets[k],x1,y1);
         end;
      end;
      ch:=ch+inttostr(k)+','+edSommets.Text+',';
      if ErreurA then ch:='Erreur : l''un des sommets, au moins, n''existe pas ...';
      ch:=ch+inttostr(udEpaisseur.Position)+','+inttostr(cgCouleur.ForeGroundIndex);
   end;
   ConstruitChaineBezier:=ch;
end;

function TfmSchema.DecomposeChaineBezier(ch:string):TObjBezier;
var Bezier : TObjBezier;
    chx      : string;
    n        : integer;
begin
   delete(ch,1,pos(',',ch)-3);
   chx:=copy(ch,1,pos(',',ch)-1);Bezier.nature:=StrToInt(chx);delete(ch,1,pos(',',ch));
   chx:=copy(ch,1,pos(',',ch)-1);Bezier.nbSommets:=StrToInt(chx);delete(ch,1,pos(',',ch));
   chx:='';
   for n:=1 to Bezier.nbSommets do
   begin
      chx:=chx+Copy(ch,1,pos(',',ch)-1);
      delete(ch,1,pos(',',ch));
      chx:=chx+',';
   end;
   delete(chx,length(chx),1);
   Bezier.Sommets:=chx;
   chx:=Copy(ch,1,1);Bezier.epaisseur:=StrToInt(chx);delete(ch,1,2);
   Bezier.Couleur:=StrToInt(ch);
   fmBezier.cgCouleur.ForegroundIndex:=Bezier.Couleur;
   Bezier.Couleur:=fmBezier.cgCouleur.ForegroundColor;
   DecomposeChaineBezier:=Bezier;
end;

Function TfmSchema.ConstruitChaineAngle : string;
var ch : string;
begin
   with fmAngle do
   begin
      if rb3Points.Checked then
      begin
         ch:='Angle 3 points,';
         ch:=ch+edNoms3Points.Text+',';
      end
      else
      begin
         ch:='Angle sommet et angles,';
         ch:=ch+edSommet.Text+','+edAngleDebut.Text+','+edAngleFin.Text+',';
      end;
      if sbAngle1.Down then ch:=ch+'0,';
      if sbAngle1Barre1.Down then ch:=ch+'1,';
      if sbAngle1Barre2.Down then ch:=ch+'2,';
      if sbAngle2.Down then ch:=ch+'3,';
      if sbAngle2Barre1.Down then ch:=ch+'4,';
      if sbAngle2Barre2.Down then ch:=ch+'5,';
      if sbAngleDroit.Down then ch:=ch+'6,';
      ch:=ch+inttostr(rgEpaisseur.itemindex)+','+inttostr(ColorGrid1.ForegroundColor)+',';
      if rbAngleSimple.Checked then ch:=ch+'0,';
      if rbAngleOrientePositif.Checked then ch:=ch+'1,';
      if rbAngleOrienteNegatif.Checked then ch:=ch+'2,';
      ch:=ch+inttostr(udTaille.position);
   end;
   ConstruitChaineAngle:=ch;
end;

function TfmSchema.DecomposeChaineAngle(ch:string):TObjAngle;
var Angle : TObjAngle;
    chx : string;
begin
   with Angle do
   begin
      if Copy(ch,1,15)='Angle 3 points,' then nature:=0 else nature:=1;
      delete(ch,1,Pos(',',ch));
      case nature of
         0 : begin
                A:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));
                B:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));
                C:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));
                Sommet:='';
                AngleDebut:=0;
                AngleFin:=0;
             end;
         1 : begin
                A:='';B:='';C:='';
                Sommet:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));
                chx:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));AngleDebut:=StrToInt(chx);
                chx:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));AngleFin:=StrToInt(chx);
             end;
      end;
      chx:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));Style:=StrToInt(chx);
      chx:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));Epaisseur:=StrToInt(chx);
      chx:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));Couleur:=StrToInt(chx);
      chx:=Copy(ch,1,Pos(',',ch)-1);delete(ch,1,Pos(',',ch));Oriente:=StrToInt(chx);
      Taille:=StrToInt(ch);
   end;
   DecomposeChaineAngle:=Angle;
end;

procedure TfmSchema.btSupprimerClick(Sender: TObject);
begin
   ListeObjets.Items.Delete(ListeObjets.ItemIndex);
   if ListeObjets.Items.Count=0 then
   begin
      btSupprimer.Enabled:=false;
      btModifier.Enabled:=false;
   end;
end;

procedure TfmSchema.btModifierClick(Sender: TObject);
var Point   : TObjPoint;
    Segment : TObjSegment;
    Vecteur : TObjVecteur;
    Droite  : TObjDroite;
    DemiDroite : TObjDemiDroite;
    Cercle  : TObjCercle;
    Ellipse : TObjEllipse;
    Conique : TObjConique;
    Carre   : TObjCarre;
    Angle   : TObjAngle;
    ch,chDef,Chx : string;
    i,j,n   : integer;
    mr      : TModalResult;
begin
   n:=ListeObjets.Items.Count;
   j:=ListeObjets.ItemIndex;
   For i:=0 to n-1 do
   BEGIN
   ch:=ListeObjets.Items[i];
   if Pos('Point',ch)>0 then with fmPoint do//modification d'un point
   begin
      Caption:='Modification d''un point';
      Tag:=1;
      if not DecomposeChainePoint(ch,point)then exit;
      edNom.Text:=Point.Nom;
      gbPositionNom.Tag:=Point.Position;
      case gbPositionNom.Tag of
         0 : rbDroite.Checked:=true;
         1 : rbHautDroite.Checked:=true;
         2 : rbHaut.Checked:=true;
         3 : rbHautGauche.Checked:=true;
         4 : rbGauche.Checked:=true;
         5 : rbBasGauche.Checked:=true;
         6 : rbBas.Checked:=true;
         7 : rbBasDroite.Checked:=true;
         8 : rbAucunePosition.Checked:=true;
      end;
      if point.Nature<8 then rgNature.ItemIndex:=Point.Nature else rgNature.ItemIndex:=0;
      case Point.Nature of
         0 : begin
                edAbscisse.Text:=FloatToStrF(Point.x,ffGeneral,nbChiffresSignificatifsX,4);
                edOrdonnee.Text:=FloatToStrF(Point.y,ffGeneral,nbChiffresSignificatifsY,4);
                cbCartesiennes.Checked:=true;
                edr.Text:=FloatToStrF(sqrt(sqr(Point.x)+sqr(Point.y)),ffGeneral,nbChiffresSignificatifsX,4);
                if point.x=0 then
                begin
                   if point.y>0 then edTheta.Text:='90'
                                else edTheta.text:='-90';
                end
                else if point.x>0
                   then edTheta.text:=FloatToStrF(arctan(point.y/point.x)*180/pi,ffGeneral,nbChiffresSignificatifsY,4)
                   else edTheta.text:=FloatToStrF((arctan(point.y/point.x)+pi)*180/pi,ffGeneral,nbChiffresSignificatifsY,4);
             end;
         1 : edXAB.Text:=point.chDefinition;
         2 : edNomsDroites.Text:=point.chDefinition;
         3 : edPointsPonderes.Text:=point.chDefinition;
         4 : edIsobarycentre.Text:=point.chDefinition;
         5 : ed4Point.Text:=point.chDefinition;
         6 : begin
                chDef:=Point.chDefinition;
                edPOint.Text:=Copy(chDef,1,Pos(',',chDef)-1);delete(chDef,1,pos(',',chDef));
                edDroite.Text:=chDef;
             end;
         7 : begin
                chDef:=Point.chDefinition;
                edPOintRotation.Text:=Copy(chDef,1,Pos(',',chDef)-1);delete(chDef,1,pos(',',chDef));
                edCentre.Text:=Copy(chDef,1,Pos(',',chDef)-1);delete(chDef,1,pos(',',chDef));
                edAngle.Text:=chDef;
             end;
         8 : begin
                edAbscisse.Text:=FloatToStrF(Point.x,ffGeneral,nbChiffresSignificatifsX,4);
                edOrdonnee.Text:=FloatToStrF(Point.y,ffGeneral,nbChiffresSignificatifsY,4);
                edr.Text:=FloatToStrF(sqrt(sqr(Point.x)+sqr(Point.y)),ffGeneral,nbChiffresSignificatifsX,4);
                if point.x=0 then
                begin
                   if point.y>0 then edTheta.Text:='90'
                                else edTheta.text:='-90';
                end
                else if point.x>0
                   then edTheta.text:=FloatToStrF(arctan(point.y/point.x)*180/pi,ffGeneral,nbChiffresSignificatifsY,4)
                   else edTheta.text:=FloatToStrF((arctan(point.y/point.x)+pi)*180/pi,ffGeneral,nbChiffresSignificatifsY,4);
                cbPolaires.Checked:=true;
             end;
      end;
      if Point.style=0 then rbAucuneMarque.Checked:=true;
      if Point.style=1 then rbPoint.Checked:=true;
      if Point.style=2 then rbPlus.Checked:=true;
      if Point.style=3 then rbCroix.Checked:=true;
      if Point.style=4 then rbEtoile.Checked:=true;
      if Point.style=5 then rbCarre.Checked:=true;
      if Point.style=6 then rbLosange.Checked:=true;
      if Point.style=7 then rbRond.Checked:=true;
      if Point.style=8 then rbCarre2.Checked:=true;
      if Point.style=9 then rbLosange2.Checked:=true;
      rgTaille.ItemIndex:=Point.Epaisseur;
      cbLigneCote.Checked:=(Point.LigneCote=1);
      ColorGrid1.ColorToIndex(Point.Couleur);
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChainePoint;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if Pos('Segment',ch)>0 then with fmSegment do//modification d'un segment
   begin
      Caption:='Modification d''un segment';
      Tag:=1;
      if not DecomposeChaineSegment(ch,segment)then exit;
      rgDefinition.ItemIndex:=Segment.nature;
      edOrigine.Text:=Segment.Origine;
      edExtremite.Text:=Segment.Extremite;
      edX1.Text:=FloatToStrF(segment.x1,ffGeneral,4,4);
      edY1.Text:=FloatToStrF(segment.y1,ffGeneral,4,4);
      edX2.Text:=FloatToStrF(segment.x2,ffGeneral,4,4);
      edY2.Text:=FloatToStrF(segment.y2,ffGeneral,4,4);
      edNomTriangle.Text:=Segment.A+','+Segment.B+','+Segment.C;
      edSommet.Text:=Segment.Sommet;
      rgStyle.ItemIndex:=Segment.style;
      rgEpaisseur.ItemIndex:=Segment.epaisseur;
      ColorGrid1.ColorToIndex(Segment.Couleur);
      rgFormatSegment.ItemIndex:=Segment.format;
      rgNature.ItemIndex:=segment.fermeture;
      spinedittaille.Value:=segment.taille;
      rgCodage.ItemIndex:=segment.codage;
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineSegment;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if Pos('Vecteur',ch)>0 then with fmVecteur do //modification d'un vecteur
   begin
      caption:='Modification d''un vecteur';
      Tag:=1;
      if not DecomposeChaineVecteur(ch,vecteur)then exit;
      edNom.Text:=Vecteur.Nom;
      cbPositionNom.ItemIndex:=Vecteur.Position;
      rgNature.ItemIndex:=Vecteur.Nature;
      edX.Text:=FloatToStr(Vecteur.abscisse);
      edY.Text:=FloatToStr(Vecteur.ordonnee);
      edOrigine.Text:=Vecteur.Origine;
      edExtremite.Text:=Vecteur.Extremite;
      cbDessinFleche.Checked:=Vecteur.blDessinFleche;
      rgEpaisseur.ItemIndex:=Vecteur.epaisseur;
      case Vecteur.style of
         1 : rbStyle1.Checked:=true;
         2 : rbStyle2.Checked:=true;
         3 : rbStyle3.Checked:=true;
      end;
      SpinEdit1.value:=Vecteur.TailleFleche;
      ColorGrid1.ColorToIndex(Vecteur.couleur);
      edXOrigine.Text:=FloatToStr(vecteur.x);
      edYOrigine.Text:=FloatToStr(vecteur.y);
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineVecteur;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if Pos('Droite',ch)>0 then with fmObjDroite do //Modification d'une droite
   begin
      caption:='Modification d''une droite';
      Droite:=DecomposeChaineDroite(ch);
      edNom.Text:=Droite.Nom;
      rgDefinition.ItemIndex:=Droite.Nature;
      edPoint1.Text:=Droite.Point1;
      edPoint2.Text:=Droite.Point2;
      edVecteurDirecteur.Text:=Droite.VecteurDirecteur;
      edVecteurNormal.Text:=Droite.VecteurNormal;
      edDroiteParallele.Text:=Droite.DroiteParallele;
      edDroitePerpendiculaire.Text:=Droite.DroitePerpendiculaire;
      edSegment.Text:=Droite.Segment;
      edAngle3Points.Text:=Droite.Angle3Points;
      edAngle2Vecteurs.Text:=Droite.Angle2Vecteurs;
      rgEpaisseur.ItemIndex:=Droite.epaisseur;
      rgStyle.ItemIndex:=Droite.Style;
      ColorGrid1.ColorToIndex(Droite.couleur);
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineDroite;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if Pos('Demi-droite',ch)>0 then with fmDemiDroite do//modification d'une demi-droite
   begin
      Caption:='Modification d''une demi-droite';
      Tag:=1;
      DemiDroite:=DecomposeChaineDemiDroite(ch);
      edOrigine.Text:=DemiDroite.Origine;
      edPoint.Text:=DemiDroite.Point;
      edVecteurDirecteur.Text:=DemiDroite.VecteurDirecteur;
      edAnglePolaire.Text:=DemiDroite.AnglePolaire;
      rgDefinition.ItemIndex:=DemiDroite.Nature;
      rgEpaisseur.ItemIndex:=DemiDroite.epaisseur;
      rgStyle.ItemIndex:=DemiDroite.Style;
      ColorGrid1.ColorToIndex(DemiDroite.couleur);
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineDemiDroite;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if Pos('Cercle',ch)>0 then with fmCercle do //modification d'un cercle
   begin
      caption:='Modification d''un cercle';
      Tag:=1;
      Cercle:=DecomposeChaineCercle(ch);
      case cercle.nature of
         0 : begin
                edCentre1.Text:=cercle.Centre;
                edRayon.Text:=cercle.rayon;
             end;
         1 : begin
                edCentre2.Text:=cercle.Centre;
                edPoint.Text:=cercle.point1;
             end;
         2 : begin
                edPoint1.Text:=cercle.point1;
                edPoint2.Text:=cercle.point2;
             end;
         3 : edTriangle1.Text:=cercle.Triangle;
         4 : edTriangle2.Text:=cercle.Triangle;
         5 : begin
                edCentre3.Text:=cercle.Centre;
                edDroite.Text:=cercle.Droite;
             end;
      end;//case cercle.nature of
      rgDefinition.ItemIndex:=Cercle.nature;
      udEpaisseur.Position:=cercle.epaisseur;
      rgStyle.ItemIndex:=cercle.style;
      ColorGrid1.ColorToIndex(cercle.clBord);
      ColorGrid2.ColorToIndex(cercle.clInterieur);
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineCercle;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if pos('Ellipse',ch)>0 then with fmEllipse do//Modification d'une ellipse
   begin
      Ellipse:=DecomposeChaineEllipse(ch);
      rgDefinition.ItemIndex:=Ellipse.Nature;
      edCentre.Text:=Ellipse.Centre;
      edAxeHorizontal.Text:=Ellipse.AxeHorizontal;
      edAxeVertical.Text:=Ellipse.AxeVertical;
      edSommet1.Text:=Ellipse.Sommet1;
      edSommet2.Text:=Ellipse.Sommet2;
      udEpaisseur.position:=Ellipse.epaisseur;
      rgStyle.ItemIndex:=Ellipse.style;
      ColorGrid1.ColorToIndex(Ellipse.clBord);
      ColorGrid2.ColorToIndex(Ellipse.clInterieur);
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineEllipse;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if pos('Conique',ch)>0 then with fmConique do  //Modification d'une conique
   begin
      Conique:=DecomposeChaineConique(ch);
      rgDefinition.ItemIndex:=Conique.Nature;
      with Conique
      	do begin
         edFoyer.Text:=ExtraitItem(ch,2);
         edDirectrice.Text:=ExtraitItem(ch,3);
         edExcentricite.Text:=ExtraitItem(ch,4);
         edA.Text:=ExtraitItem(ch,5);
         edB.Text:=ExtraitItem(ch,6);
         edC.Text:=ExtraitItem(ch,7);
         edD.Text:=ExtraitItem(ch,8);
         edE.Text:=ExtraitItem(ch,9);
         edF.Text:=ExtraitItem(ch,10);
      	if Foy Then cbFoyer.Checked:=True else cbFoyer.Checked:=False;
      	if Dir Then cbDirectrice.Checked:=True else cbDirectrice.Checked:=False;
      	if Axe Then cbAxe.Checked:=True else cbAxe.Checked:=False;
      	if Som Then cbSommet.Checked:=True else cbSommet.Checked:=False;
      	if Cen Then cbCentre.Checked:=True else cbCentre.Checked:=False;
      	if Asy Then cbAsymptote.Checked:=True else cbAsymptote.Checked:=False;
      	if Exc Then cbExcentricite.Checked:=True else cbExcentricite.Checked:=False;
      	if Met Then cbMetriques.Checked:=True else cbMetriques.Checked:=False;
      	if Coo Then cbCoordonnees.Checked:=True else cbCoordonnees.Checked:=False;
      	if Equ Then cbEquations.Checked:=True else cbEquations.Checked:=False;
      	if Exa Then rbValeursExactes.Checked:=True else rbValeursApprochees.Checked:=True;
      	udEpaisseur.position:=Conique.epaisseur;
      	cgCouleur.ColorToIndex(Conique.couleur);
         Case styleDroites of
         	1: rbStyleDroites1.Checked:=True;
            2: rbStyleDroites2.Checked:=True;
            3: rbStyleDroites3.Checked:=True;
         	end;
      	cgCouleurDroites.ColorToIndex(Conique.couleurDroites);
         case StylePoints of
         	1: rbPoint.Checked:=True;
         	2: rbPlus.Checked:=True;
         	3: rbCroix.Checked:=True;
         	4: rbEtoile.Checked:=True;
         	5: rbCarre.Checked:=True;
         	6: rbLosange.Checked:=True;
         	7: rbRond.Checked:=True;
         	8: rbCarre2.Checked:=True;
         	9: rbLosange2.Checked:=True;
         	end;
         end;
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineConique;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if pos('Carr',ch)>0 then with fmCarre do //Modification d'un carr
   begin
      carre:=DecomposeChaineCarre(ch);
      case carre.Nature of
         0 : begin
                edCentre1.Text:=carre.Centre;
                edCote.Text:=carre.Cote;
             end;
         1 : begin
                edCentre2.Text:=carre.Centre;
                edRayon.Text:=carre.Rayon;
             end;
         2 : begin
                edSommet1.Text:=carre.Sommet1;
                edSommet2.Text:=carre.Sommet2;
             end;
         3 : begin
                edSommet3.Text:=carre.Sommet1;
                edSommet4.Text:=carre.Sommet2;
             end;
      end;//case nature of
      rgEpaisseur.ItemIndex:=Carre.epaisseur;
      rgStyle.ItemIndex:=Carre.style;
      ColorGrid1.ColorToIndex(Carre.clBord);
      ColorGrid2.ColorToIndex(Carre.clInterieur);
      if i=j then mr:=ShowModal else mr:=mrCancel;
      if (mr=mrOK)or(i<>j) then
      begin
         ch:=ConstruitChaineCarre;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
   if pos('Angle',ch)>0 then with fmAngle do   //modification d'un angle ou d'un arc
   begin
      Angle:=DecomposeChaineAngle(ch);
      case angle.nature of
         0 : begin
               rb3Points.Checked:=true;
               edNoms3Points.Text:=angle.A+','+angle.B+','+angle.C;
             end;
         1 : begin
               rbSommet.Checked:=true;
               edSommet.Text:=angle.Sommet;
               edAngleDebut.Text:=IntToStr(Angle.angleDebut);
               edAngleFin.Text:=IntToStr(angle.AngleFin);
             end;
          end;
       rgEpaisseur.ItemIndex:=Angle.epaisseur;
       case Angle.style of
          0 : sbAngle1.Down:=true;
          1 : sbAngle1Barre1.Down:=true;
          2 : sbAngle1Barre2.Down:=true;
          3 : sbAngle2.Down:=true;
          4 : sbAngle2Barre1.Down:=true;
          5 : sbAngle2Barre2.Down:=true;
          6 : sbAngleDroit.Down:=true;
       end;
       ColorGrid1.ColorToIndex(angle.couleur);
       case Angle.Oriente of
          0 : begin sbAngleSimple.Down:=true;rbAngleSimple.Checked:=true;end;
          1 : begin sbAngleOrientePositif.Down:=true;rbAngleOrientePositif.Checked:=true;end;
          2 : begin sbAngleOrienteNegatif.Down:=true;rbAngleOrienteNegatif.Checked:=true;end;
       end;
       udTaille.Position:=angle.taille;
       edTaille.Text:=IntToStr(angle.taille);
       if i=j then mr:=ShowModal else mr:=mrCancel;
       if (mr=mrOK)or(i<>j) then
       begin
         ch:=ConstruitChaineAngle;
         ListeObjets.Items[i]:=ch;
         ListeObjets.ItemIndex:=i;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
       end;
   end;
   END;
end;

procedure TfmSchema.FormActivate(Sender: TObject);
begin
   if ListeObjets.Items.Count>0 then ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
end;

procedure TfmSchema.ListeObjetsClick(Sender: TObject);
var ch : string;
begin
   if ListeObjets.ItemIndex<0 then exit;
   ch:=ListeObjets.Items[listeObjets.ItemIndex];
   btModifier.Enabled:=not ((pos('Polygone',ch)>0)or(pos('Colorier',ch)>0));
   btSupprimer.Enabled:=true;
end;

procedure TfmSchema.btPointClick(Sender: TObject);
//crer un nouveau point
var k : integer;
    ch : string;
begin
   with fmPoint do
   begin
      caption:='Dfinir un nouveau point';
      tag:=0;
      for k:=0 to ComponentCount-1 do
         if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
      if rgTaille.ItemIndex<0 then rgTaille.ItemIndex:=0;
      if showModal=mrOK then
      begin
         ch:=ConstruitChainePoint;
         if ch<>'' then ListeObjets.Items.Add(ch);
         if ListeObjets.Items.count>0 then
         begin
            ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
            btModifier.Enabled:=true;btSupprimer.Enabled:=true;
         end;
      end;
   end;
end;

procedure TfmSchema.btSegmentClick(Sender: TObject);
//crer un nouveau segment
var k:integer;
begin
   with fmSegment do
   begin
      caption:='Dfinir un nouveau segment';
      Tag:=0;
      for k:=0 to ComponentCount-1 do
         if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
      if showModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineSegment);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btVecteurClick(Sender: TObject);
var k : integer;
begin
   with fmVecteur do
   begin
      caption:='Dfinir un nouveau vecteur';
      Tag:=0;
      for k:=0 to ComponentCount-1 do
         if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
      if ShowModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineVecteur);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btDroiteClick(Sender: TObject);
var k : integer;
begin
   with fmObjDroite do
   begin
      caption:='Dfinir une nouvelle droite';
      for k:=0 to ComponentCount-1 do
         if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
      tag:=0;
      if ShowModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineDroite);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btDemiDroiteClick(Sender: TObject);
var k : integer;
begin
   with fmDemiDroite do
   begin
      for k:=0 to ComponentCount-1 do
         if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
      caption:='Dfinir une nouvelle demi-droite';
      tag:=0;
      if ShowModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineDemiDroite);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btCercleClick(Sender: TObject);
var k : integer;
begin
   with fmCercle do
   begin
      for k:=0 to ComponentCount-1 do
         if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
      caption:='Dfinir un nouveau cercle';
      tag:=0;
      if ShowModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineCercle);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btEllipseClick(Sender: TObject);
begin
   with fmEllipse do
   begin
      caption:='Dfinir une nouvelle ellipse';
      tag:=0;
      if ShowModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineEllipse);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btCarreClick(Sender: TObject);
begin
   with fmCarre do
   begin
      caption:='Dfinir un nouveau carr';
      tag:=0;
      if ShowModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineCarre);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btPolygonesPredefinisClick(Sender: TObject);
var ch : string;
begin
   with fmPolygonePredefini do
   begin
      caption:='Choisir un nouveau polygone prdfini';
      tag:=0;
      if ShowModal=mrOK then
      begin
         ch:=ConstruitChainePolygonePredefini;
         if copy(ch,1,3)<>'Err' then ListeObjets.Items.Add(ch)
                                else showmessage(ch);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=false;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btAutresPolygonesClick(Sender: TObject);
var ch : string;
begin
   with fmPolygone do
   begin
      Caption:='Dfinir un nouveau polygone';
      Tag:=0;
      if ShowModal=mrOK then
      begin
         ch:=ConstruitChainePolygone;
         if Copy(ch,1,3)<>'Err' then ListeObjets.Items.Add(ch)
                                else showmessage(ch);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=false;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btConiqueClick(Sender: TObject);
begin
   with fmConique do
   begin
      caption:='Dfinir une nouvelle conique';
      Tag:=0;
      if ShowModal=mrOK then
      begin
         ListeObjets.Items.Add(ConstruitChaineConique);
         ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
         btModifier.Enabled:=true;btSupprimer.Enabled:=true;
      end;
   end;
end;

procedure TfmSchema.btPoliceClick(Sender: TObject);
begin
   FontDialog1.Font:=PoliceSchema;
   if FontDialog1.Execute then PoliceSchema:=FontDialog1.Font;
end;

procedure TfmSchema.btBezierClick(Sender: TObject);
var ch : string;
begin
   if fmBezier.showmodal=mrOK then
   begin
      ch:=ConstruitChaineBezier;
      if copy(ch,1,3)<>'Err' then ListeObjets.Items.Add(ch)
                             else showmessage(ch);
      ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
      btModifier.Enabled:=false;btSupprimer.Enabled:=true;
   end;
end;

procedure TfmSchema.btAngleClick(Sender: TObject);
var ch : string;
begin
   if fmAngle.ShowModal=mrOK then
   begin
      ch:=ConstruitChaineAngle;
      if copy(ch,1,3)<>'Err' then ListeObjets.Items.Add(ch)
                             else showmessage(ch);
      ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
      btModifier.Enabled:=false;btSupprimer.Enabled:=true;
   end;
end;

procedure TfmSchema.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmSchema.btColorierClick(Sender: TObject);
var ch : string;
begin
   if fmColorier.ShowModal=mrOK then
   begin
      ch:='Colorier;' + fmColorier.edX.Text + ';' + fmColorier.edY.Text + ';' + inttostr(fmColorier.ColorGrid1.ForegroundColor);
      ListeObjets.Items.Add(ch);
      ListeObjets.ItemIndex:=ListeObjets.Items.Count-1;
      btModifier.Enabled:=false;btSupprimer.Enabled:=true;
   end;
end;

procedure TfmSchema.btnAideClick(Sender: TObject);
begin
   Aide(28);
end;

end.
