unit uSegment;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ColorGrd, ExtCtrls, StdCtrls, Spin, shellAPI;

type
  TfmSegment = class(TForm)
    rgDefinition: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edOrigine: TEdit;
    Label2: TLabel;
    edExtremite: TEdit;
    rgEpaisseur: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    ColorGrid1: TColorGrid;
    btAnnuler: TButton;
    btOK: TButton;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    edX1: TEdit;
    edY1: TEdit;
    edX2: TEdit;
    edY2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    edNomTriangle: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    edSommet: TEdit;
    rgFormatSegment: TRadioGroup;
    GroupBox5: TGroupBox;
    Image1: TImage;
    rgNature: TRadioGroup;
    Memo1: TMemo;
    SpinEditTaille: TSpinEdit;
    Label12: TLabel;
    rgCodage: TRadioGroup;
    Panel4: TPanel;
    Image2: TImage;
    btnAide: TButton;
    procedure rgDefinitionClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edOrigineExit(Sender: TObject);
    procedure edExtremiteExit(Sender: TObject);
    procedure edNomTriangleExit(Sender: TObject);
    procedure edSommetExit(Sender: TObject);
    procedure rgFormatSegmentClick(Sender: TObject);
    procedure rgEpaisseurClick(Sender: TObject);
    procedure rgStyleClick(Sender: TObject);
    procedure ColorGrid1Click(Sender: TObject);
    procedure rgNatureClick(Sender: TObject);
    procedure SpinEditTailleChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure ApercuSegment;
  public
    { Dclarations publiques }
  end;

var
  fmSegment: TfmSegment;

implementation
uses uDessin;
{$R *.DFM}

procedure TfmSegment.rgDefinitionClick(Sender: TObject);
begin
   Label1.Enabled:=rgDefinition.ItemIndex=0;
   Label2.Enabled:=rgDefinition.ItemIndex=0;
   edOrigine.Enabled:=rgDefinition.ItemIndex=0;
   edExtremite.Enabled:=rgDefinition.ItemIndex=0;
   Label3.Enabled:=rgDefinition.ItemIndex=1;
   Label4.Enabled:=rgDefinition.ItemIndex=1;
   Label5.Enabled:=rgDefinition.ItemIndex=1;
   Label6.Enabled:=rgDefinition.ItemIndex=1;
   Label7.Enabled:=rgDefinition.ItemIndex=1;
   Label8.Enabled:=rgDefinition.ItemIndex=1;
   Label9.Enabled:=rgDefinition.ItemIndex>1;
   edX1.Enabled:=rgDefinition.ItemIndex=1;
   edX2.Enabled:=rgDefinition.ItemIndex=1;
   edY1.Enabled:=rgDefinition.ItemIndex=1;
   edY2.Enabled:=rgDefinition.ItemIndex=1;
   Label10.Enabled:=rgDefinition.ItemIndex>1;
   Label11.Enabled:=rgDefinition.ItemIndex>1;
   edNomTriangle.Enabled:=rgDefinition.ItemIndex>1;
   edSommet.Enabled:=rgDefinition.ItemIndex>1;
   case rgDefinition.ItemIndex of
   0 : begin
          edOrigine.Color:=clWhite;
          edExtremite.Color:=clWhite;
          edX1.color:=clBtnFace;
          edY1.color:=clBtnFace;
          edX2.color:=clBtnFace;
          edY2.color:=clBtnFace;
          edNomTriangle.color:=clBtnFace;
          edSommet.color:=clBtnFace;
          if self.Visible then edOrigine.setFocus;
       end;
   1 : begin
          edOrigine.Color:=clBtnFace;
          edExtremite.Color:=clBtnFace;
          edX1.color:=clWhite;
          edY1.color:=clWhite;
          edX2.color:=clWhite;
          edY2.color:=clWhite;
          edNomTriangle.color:=clBtnFace;
          edSommet.color:=clBtnFace;
          if self.Visible then edX1.setFocus;
       end;
   2,3:begin
          edOrigine.Color:=clBtnFace;
          edExtremite.Color:=clBtnFace;
          edX1.color:=clBtnFace;
          edY1.color:=clBtnFace;
          edX2.color:=clBtnFace;
          edY2.color:=clBtnFace;
          edNomTriangle.color:=clWhite;
          edSommet.color:=clWhite;
          if self.Visible then edNomTriangle.setFocus;
       end;
   end;
end;

procedure TfmSegment.FormActivate(Sender: TObject);
begin
   rgDefinitionClick(sender);
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmSegment.edOrigineExit(Sender: TObject);
begin
   edOrigine.Text:=SansEspace(edOrigine.Text);
end;

procedure TfmSegment.edExtremiteExit(Sender: TObject);
begin
   edExtremite.Text:=SansEspace(edExtremite.Text);
end;

procedure TfmSegment.edNomTriangleExit(Sender: TObject);
begin
   edNomTriangle.Text:=SansEspace(edNomTriangle.Text);
end;

procedure TfmSegment.edSommetExit(Sender: TObject);
begin
   edSommet.Text:=SansEspace(edSommet.Text);
end;

Procedure TfmSegment.ApercuSegment;
var k,t : integer;
begin
   with Image1.canvas do
   begin
      pen.color:=clWhite;
      brush.style:=bsSolid;brush.color:=clFond;Rectangle(0,0,100,60);
      pen.color:=ColorGrid1.ForegroundColor;
      pen.width:=rgEpaisseur.ItemIndex+1;
      t:=SpinEditTaille.Value;
      MoveTo(10,30);
      case rgStyle.ItemIndex of        //on trace d'abord le "trait" horizontal selon le style
         0 : LineTo(90,30);            //style continu
         1 : for k:=0 to 7 do          //style tirets
                if odd(k) then LineTo(10+10*k,30)
                          else MoveTo(10+10*k,30);
         2 : begin                     //style pointills
                k:=0;
                pen.width:=1;
                if rgEpaisseur.ItemIndex=0 then while 10+2*k<90 do
                                                begin
                                                   Pixels[10+2*k,30]:=pen.color;
                                                   inc(k);
                                                end;
                if rgEpaisseur.ItemIndex=1 then while 10+4*k<90 do
                                                begin
                                                   MoveTo(9+4*k,30);Lineto(11+4*k,30);
                                                   MoveTo(10+4*k,29);LineTo(10+4*k,31);
                                                   inc(k);
                                                end;
                if rgEpaisseur.ItemIndex=2 then while 10+5*k<90 do
                                                begin
                                                   MoveTo(9+5*k,29);Lineto(11+5*k,29);
                                                   MoveTo(9+5*k,30);LineTo(11+5*k,30);
                                                   MoveTo(9+5*k,29);LineTo(11+5*k,31);
                                                   inc(k);
                                                end;
             end;
         3 : begin                     //style ronds
                pen.width:=1;
                brush.Style:=bsClear;
                for k:=0 to 7 do Ellipse(10+10*k-(rgEpaisseur.ItemIndex+2),30-(rgEpaisseur.ItemIndex+2),10+10*k+(rgEpaisseur.ItemIndex+2),30+(rgEpaisseur.ItemIndex+2));
             end;
         4 : begin                    //style points
                pen.width:=1;
                brush.Style:=bsSolid;Brush.Color:=ColorGrid1.ForegroundColor;
                for k:=0 to 7 do Ellipse(10+10*k-(rgEpaisseur.ItemIndex+2),30-(rgEpaisseur.ItemIndex+2),10+10*k+(rgEpaisseur.ItemIndex+2),30+(rgEpaisseur.ItemIndex+2));
                brush.style:=bsClear;
             end;
      end;
      case rgFormatSegment.ItemIndex of
      0 : begin end;    //extrmits simples  : rien  tracer
      1 : case rgNature.ItemIndex of           //extrmits flches simples
          0 : begin                            //ferm
                 MoveTo(90-t,30-t div 2);LineTo(90,30);LineTo(90-t,30+t div 2);
                 MoveTo(10+t,30-t div 2);LineTo(10,30);LineTo(10+t,30+t div 2);
              end;
          1 : begin                            //ouvert
                 MoveTo(90+t,30-t div 2);LineTo(90,30);LineTo(90+t,30+t div 2);
                 MoveTo(10-t,30-t div 2);LineTo(10,30);LineTo(10-t,30+t div 2);
              end;
          2 : begin                            //semi-ouvert
                 MoveTo(90+t,30-t div 2);LineTo(90,30);LineTo(90+t,30+t div 2);
                 MoveTo(10+t,30-t div 2);LineTo(10,30);LineTo(10+t,30+t div 2);
              end;
          end;
      2 : case rgNature.ItemIndex of           //extrmits flches pleines
          0 : begin                            //ferm
                 brush.Style:=bsSolid;brush.color:=ColorGrid1.ForegroundColor;
                 polygon([point(90-t,30-t div 2),point(90,30),point(90-t,30+t div 2)]);
                 polygon([point(10+t,30-t div 2),point(10,30),point(10+t,30+t div 2)]);
                 brush.Style:=bsClear;
              end;
          1 : begin                            //ouvert
                 brush.Style:=bsSolid;brush.color:=ColorGrid1.ForegroundColor;
                 polygon([point(90+t,30-t div 2),point(90,30),point(90+t,30+t div 2)]);
                 polygon([point(10-t,30-t div 2),point(10,30),point(10-t,30+t div 2)]);
                 brush.Style:=bsClear;
              end;
          2 : begin                            //semi-ouvert
                 brush.Style:=bsSolid;brush.color:=ColorGrid1.ForegroundColor;
                 polygon([point(90+t,30-t div 2),point(90,30),point(90+t,30+t div 2)]);
                 polygon([point(10+t,30-t div 2),point(10,30),point(10+t,30+t div 2)]);
                 brush.Style:=bsClear;
              end;
          end;
      3 : case rgNature.ItemIndex of           //extrmits flches lancoles
          0 : begin                            //ferm
                 brush.Style:=bsSolid;brush.color:=ColorGrid1.ForegroundColor;
                 polygon([point(90-t div 2,30),point(90-t,30-t div 2),point(90,30),point(90-t,30+t div 2)]);
                 polygon([point(10+t div 2,30),point(10+t,30-t div 2),point(10,30),point(10+t,30+t div 2)]);
                 brush.Style:=bsClear;
              end;
          1 : begin                            //ouvert
                 brush.Style:=bsSolid;brush.color:=ColorGrid1.ForegroundColor;
                 polygon([point(90+t div 2,30),point(90+t,30-t div 2),point(90,30),point(90+t,30+t div 2)]);
                 polygon([point(10-t div 2,30),point(10-t,30-t div 2),point(10,30),point(10-t,30+t div 2)]);
                 brush.Style:=bsClear;
              end;
          2 : begin                            //semi-ouvert
                 brush.Style:=bsSolid;brush.color:=ColorGrid1.ForegroundColor;
                 polygon([point(90-t div 2,30),point(90+t,30-t div 2),point(90,30),point(90+t,30+t div 2)]);
                 polygon([point(10+t div 2,30),point(10+t,30-t div 2),point(10,30),point(10+t,30+t div 2)]);
                 brush.Style:=bsClear;
              end;
          end;
      4 : case rgNature.ItemIndex of           //extrmits crochets
          0 : begin                            //ferm
                 polyline([point(90-t div 3,30-t div 2),point(90,30-t div 2),point(90,30+t div 2),point(90-t div 3,30+t div 2)]);
                 polyline([point(10+t div 3,30-t div 2),point(10,30-t div 2),point(10,30+t div 2),point(10+t div 3,30+t div 2)]);
              end;
          1 : begin                            //ouvert
                 polyline([point(90+t div 3,30-t div 2),point(90,30-t div 2),point(90,30+t div 2),point(90+t div 3,30+t div 2)]);
                 polyline([point(10-t div 3,30-t div 2),point(10,30-t div 2),point(10,30+t div 2),point(10-t div 3,30+t div 2)]);
              end;
          2 : begin                            //semi-ouvert
                 polyline([point(90+t div 3,30-t div 2),point(90,30-t div 2),point(90,30+t div 2),point(90+t div 3,30+t div 2)]);
                 polyline([point(10+t div 3,30-t div 2),point(10,30-t div 2),point(10,30+t div 2),point(10+t div 3,30+t div 2)]);
              end;
          end;
      5 : case rgNature.ItemIndex of           //extrmits arcs
          0 : begin                            //ferm
                 arc(90-2*t,30-t,90,30+t,90-t,30+t,90-t,30-t);
                 arc(10,30-t,10+2*t,30+t,10+t,30-t,10+t,30+t);
              end;
          1 : begin                            //ouvert
                 arc(90,30-t,90+2*t,30+t,90+t,30-t,90+t,30+t);
                 arc(10-2*t,30-t,10,30+t,10-t,30+t,10-t,30-t);
              end;
          2 : begin                            //semi-ouvert
                 arc(90,30-t,90+2*t,30+t,90+t,30-t,90+t,30+t);
                 arc(10,30-t,10+2*t,30+t,10+t,30-t,10+t,30+t);
              end;
          end;
      end;
   end;
end;

procedure TfmSegment.rgFormatSegmentClick(Sender: TObject);
begin
   ApercuSegment;
end;

procedure TfmSegment.rgEpaisseurClick(Sender: TObject);
begin
   ApercuSegment;
end;

procedure TfmSegment.rgStyleClick(Sender: TObject);
begin
   ApercuSegment;
end;

procedure TfmSegment.ColorGrid1Click(Sender: TObject);
begin
   ApercuSegment;
end;

procedure TfmSegment.rgNatureClick(Sender: TObject);
begin
   ApercuSegment;
end;

procedure TfmSegment.SpinEditTailleChange(Sender: TObject);
begin
   ApercuSegment;
end;

procedure TfmSegment.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmSegment.btnAideClick(Sender: TObject);
begin
   Aide(30);
end;

end.
