unit uSimulations;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls, Gauges, ColorGrd, Spin, shellAPI;

type
  TfmSimulations = class(TForm)
    rgLoi: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    edTailleEchantillon: TEdit;
    edNombreEchantillons: TEdit;
    rgGraphiques: TRadioGroup;
    btCopierDonnees: TButton;
    btCopierCalculs: TButton;
    btAnnuler: TButton;
    btOK: TButton;
    lblMin: TLabel;
    edMin: TEdit;
    edMax: TEdit;
    lblMax: TLabel;
    Gauge1: TGauge;
    cbSeriesOrdonnees: TCheckBox;
    Memo1: TMemo;
    btSimulations: TButton;
    lblP: TLabel;
    edP: TEdit;
    lblNbIterations: TLabel;
    edNbIterations: TEdit;
    lblPoisson: TLabel;
    edPoisson: TEdit;
    lblLoiNormale1: TLabel;
    edMoyenneLoiNormale: TEdit;
    lblLoiNormale2: TLabel;
    edEcartTypeLoiNormale: TEdit;
    Label3: TLabel;
    ColorGrid1: TColorGrid;
    Label4: TLabel;
    Label5: TLabel;
    SpinDistance: TSpinEdit;
    lblDistance: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    edTitre: TEdit;
    Label6: TLabel;
    cbAjouterCourbe: TCheckBox;
    Label7: TLabel;
    spNbClasses: TSpinEdit;
    cbEchelleAutomatique: TCheckBox;
    cbIntervalleConfiance: TCheckBox;
    asgEchantillons: TStringGrid;
    asgUneColonne: TStringGrid;
    asgCalculs: TStringGrid;
    asgGeneral: TStringGrid;
    btnAide: TButton;
    procedure rgLoiClick(Sender: TObject);
    procedure asgEchantillonsTopLeftChanged(Sender: TObject);
    procedure btSimulationsClick(Sender: TObject);
    procedure btCopierDonneesClick(Sender: TObject);
    procedure btCopierCalculsClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rgGraphiquesClick(Sender: TObject);
    procedure edMoyenneLoiNormaleKeyPress(Sender: TObject; var Key: Char);
    procedure edPKeyPress(Sender: TObject; var Key: Char);
    procedure edPoissonKeyPress(Sender: TObject; var Key: Char);
    procedure edEcartTypeLoiNormaleKeyPress(Sender: TObject;
      var Key: Char);
    procedure edMinKeyPress(Sender: TObject; var Key: Char);
    procedure edMaxKeyPress(Sender: TObject; var Key: Char);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Procedure Calculs;
    Procedure LoiUniformeDiscrete;
    Procedure LoiUniformeContinue;
    Procedure LoiBernoulli;
    Procedure LoiBinomiale;
    Procedure LoiGeometrique;
    Procedure LoiPoisson;
    Procedure LoiNormale;
  end;

var
  fmSimulations: TfmSimulations;
  Tab : array[0..10000000] of real;

implementation
uses uDessin;
{$R *.DFM}
const     Textes : array[0..6] of string=('On dit qu''une srie statistique suit une loi uniforme discrte sur un intervalle donn [a, b]'+
                                          ' lorsque toutes les valeurs entires de l''intervalle ont la mme frquence thorique d''apparition.',

                                          'On dit qu''une srie statistique suit une loi uniforme continue sur un intervalle donn [a, b]'+
                                          ' lorsque la densit thorique des valeurs est la mme sur tout l''intervalle.',

                                          'Une srie statistique suit une loi de Bernoulli de paramtre p lorsque 2 valeurs sont possibles :'+chr(13)+chr(10)+
                                          '- succs (1) avec une probabilit p'+chr(13)+chr(10)+
                                          '- chec (0) avec une probabilit 1-p',

                                          'Quand une srie statistique suit une loi binomiale de paramtres n et p, les valeurs possibles sont {0,1,...n}.'+chr(13)+chr(10)+
                                          'On rpte n fois la mme preuve dans laquelle il y a 2 issues possibles :'+chr(13)+chr(10)+
                                          '- succs avec une probabilit p'+chr(13)+chr(10)+
                                          '- chec avec une probabilit 1-p.'+chr(13)+chr(10)+
                                          'Les valeurs 0,1...,n correspondent au nombre de succs obtenus  la fin des n rptitions.',

                                          'Une srie statistique qui suit une loi gomtrique permet de modliser l''exprience suivante :'+chr(13)+chr(10)+
                                          'On a 2 issues possibles (succs de probabilit p, ou chec) et on rpte cette exprience jusqu'' obtenir un succs.'+chr(13)+chr(10)+
                                          'Le rsultat est le nombre de rptitions ncessaires pour obtenir un succs.'+chr(13)+chr(10)+
                                          'Une loi gomtrique est caractrise par le nombre p.',

                                          'La loi de Poisson est utilise pour dcrire le nombre d''vnements se produisant dans un laps de temps fix, si ces vnements se produisent avec une frquence moyenne connue et indpendamment du temps coul depuis l''vnement prcdent. '+chr(13)+chr(10)+
                                          'Par exemple, si un vnement se produit en moyenne 2 fois toutes les minutes, alors le nombre de fois o il se produit sur une dure'+
                                          'de 10 minutes est donn par la loi de Poisson de paramtre 2x10=20.',

                                          'La loi normale (ou loi de Laplace-Gauss) est caractrise par une fonction de densit "en cloche". Quelques critres permettent '+
                                          'de juger rapidement de la normalit d''une distribution de donnes de moyenne m et d''cart type s :'+chr(13)+chr(10)+
                                          '-> 68% des donnes sont dans [m-s; m+s]'+chr(13)+chr(10)+
                                          '-> 95% des donnes sont dans [m-2s; m+2s]'+chr(13)+chr(10)+
                                          '-> 99% des donnes sont dans [m-3s; m+3s]');
var Taille,nbEchantillons : LongInt;
    T : LongInt;

Procedure Trier;
var i,j,nbLignes,ecart : integer;
    permut             : boolean;
    r                  : real;
begin
   nbLignes:=Taille*nbEchantillons;
   ecart:=nbLignes div 2;
   while ecart<>0 do
   begin
      for i:=0 to NbLignes-ecart-1 do
      begin
         j:=i;
         permut:=true;
         while (j>=0) and permut do
         begin
            permut:=false;
            if Tab[j]>Tab[j+ecart] then
            begin
               r:=Tab[j];Tab[j]:=Tab[j+ecart];Tab[j+ecart]:=r;
               permut:=true;
               j:=j-ecart;
            end
         end
      end;
      ecart:=ecart div 2;
   end;
end;

Procedure TrierEchantillon(e:integer);
var i,j,ecart : integer;
    permut    : boolean;
    r         : real;
    Tab       : array[0..100000] of real;
begin
   for i:=0 to Taille-1 do Tab[i]:=Floats(fmSimulations.asgEchantillons.cells[e,i+1]);
   ecart:=Taille div 2;
   while ecart<>0 do
   begin
      for i:=0 to Taille-ecart-1 do
      begin
         j:=i;
         permut:=true;
         while (j>=0) and permut do
         begin
            permut:=false;
            if Tab[j]>Tab[j+ecart] then
            begin
               r:=Tab[j];Tab[j]:=Tab[j+ecart];Tab[j+ecart]:=r;
               permut:=true;
               j:=j-ecart;
            end
         end
      end;
      ecart:=ecart div 2;
   end;
   For i:=1 to Taille do fmSimulations.asgUneColonne.cells[0,i]:=floattostr(Tab[i-1]);
end;

Procedure TfmSimulations.Calculs;
var Moyenne,Ecarttype,SommeX,SommeXX,Min,Max,x : real;
    c,i : longint;
begin
   screen.Cursor:=crHourGlass;
   Label3.caption:='Progression des calculs :';
   refresh;
   //for i:=1 to Taille do asgCalculs.Cells[0,i]:=intToStr(i);
   asgCalculs.Cells[0,0]:='Moyenne';
   asgCalculs.Cells[0,1]:='cart type';
   asgCalculs.Cells[0,2]:='Minimum';
   asgCalculs.Cells[0,3]:='Dcile 1';
   asgCalculs.Cells[0,4]:='Quartile 1';
   asgCalculs.Cells[0,5]:='Mdiane';
   asgCalculs.Cells[0,6]:='Quartile 3';
   asgCalculs.Cells[0,7]:='Dcile 9';
   asgCalculs.Cells[0,8]:='Maximum';
   for i:=1 to nbEchantillons do asgCalculs.Cells[i,0]:=inttostr(i);
   For c:=1 to nbEchantillons do
   begin
      SommeXX:=0;SommeX:=0;Min:=Floats(asgEchantillons.cells[c,1]);max:=Floats(asgEchantillons.cells[c,1]);
      for i:=1 to taille do
      begin
         x:=Floats(asgEchantillons.cells[c,i]);
         SommeXX:=SommeXX+sqr(x);
         SommeX:=SommeX+x;
         if x<Min then Min:=x;
         if x>Max then Max:=x;
      end;
      Moyenne:=SommeX/taille;
      asgCalculs.cells[c,0]:=FloatToStr(Moyenne);
      EcartType:=sqrt(SommeXX/Taille-sqr(Moyenne));
      asgCalculs.cells[c,1]:=FloatToStr(EcartType);
      asgCalculs.cells[c,2]:=FloatToStr(min);                  //minimum
      asgCalculs.cells[c,8]:=FloatToStr(max);                  //maximum
      TrierEchantillon(c);
      asgCalculs.cells[c,4]:=asgUneColonne.cells[0,(taille+3)div 4];                             //1er quartile
      if not odd(taille) then asgCalculs.cells[c,5]:=floattostr((floats(asgUneColonne.cells[0,Taille div 2])+floats(asgUneColonne.cells[0,(taille div 2)+1]))/2)
                         else asgCalculs.cells[c,5]:=asgUneColonne.cells[0,(Taille+1)div 2];     //mdiane
      asgCalculs.cells[c,6]:=asgUneColonne.cells[0,3*(taille div 4)+(taille mod 4)];             //3e quartile
      asgCalculs.cells[c,3]:=asgUneColonne.cells[0,(Taille+9)div 10];                            //1er dcile
      asgCalculs.cells[c,7]:=asgUneColonne.cells[0,Taille-(Taille div 10)];                      //9e dcile
      if cbSeriesOrdonnees.Checked then asgEchantillons.Cols[c]:=asgUneColonne.cols[0];
      asgCalculs.Refresh;
      asgEchantillons.refresh;
      Gauge1.Progress:=round(c/nbEchantillons*100);
   end;
   T:=Taille*nbEchantillons;
   Label3.Caption:='Tri de l''ensemble des '+inttostr(T)+' tirages ...';
   refresh;
   Trier;
   SommeXX:=0;SommeX:=0;
   for i:=0 to T-1 do begin
                         SommeXX:=SommeXX+sqr(Tab[i]);
                         SommeX:=SommeX+Tab[i];
                      end;
   Moyenne:=SommeX/T;
   asgGeneral.Cells[0,0]:='Gnral';
   asgGeneral.cells[0,1]:=FloatToStr(Moyenne);
   EcartType:=sqrt(SommeXX/T-sqr(Moyenne));
   asgGeneral.cells[0,2]:=FloatToStr(EcartType);
   asgGeneral.cells[0,3]:=FloatToStr(Tab[0]);                                                 //minimum
   asgGeneral.cells[0,9]:=FloatToStr(Tab[T-1]);                                               //maximum
   asgGeneral.cells[0,5]:=FloatToStr(Tab[(T+3)div 4-1]);                                      //1er quartile
   if not odd(T) then asgGeneral.cells[0,6]:=floattostr((Tab[T div 2-1]+Tab[T div 2])/2)      //mdiane si pair
                 else asgGeneral.cells[0,6]:=FloatToStr(Tab[(T-1)div 2]);                     //mdiane si impair
   asgGeneral.cells[0,7]:=FloatToStr(Tab[(3*T)div 4+T mod 4-1]);                              //3e quartile
   asgGeneral.cells[0,4]:=FloatToStr(Tab[(T+9) div 10-1]);                                    //1er dcile
   asgGeneral.cells[0,8]:=FloatToStr(Tab[T-T div 10-1]);                                      //9e dcile
   Label3.Visible:=false;Gauge1.Visible:=false;
   screen.Cursor:=crDefault;
end;

Procedure TfmSimulations.LoiUniformeDiscrete;
var  i,j,x,Min,Max : integer;
begin
   Randomize;
   try
      Min:=StrToInt(edMin.text);Max:=StrToInt(edMax.text);
   except
      Showmessage('Saisir les bornes (min et max) de l''intervalle (nombres entiers).');
      exit;
   end;
   try
      Taille:=StrToInt(edTailleEchantillon.text);
   except
      ShowMessage('Saisir la taille (nombre entier) des chantillons.');
      exit;
   end;
   try
      nbEchantillons:=StrToInt(edNombreEchantillons.text);
   except
      ShowMessage('Saisir le nombre d''chantillons  produire.');
      exit;
   end;
      if nbEchantillons*taille>10000000 then
   begin
      ShowMessage('Le nombre de tirages est limit  10 millions.'+chr(13)+'Vous avez demand '+inttostr(nbEchantillons)+' chantillons de '
                  +inttostr(taille)+' tirages chacun, soit '+inttostr(nbEchantillons*Taille)+' tirages ...');
      exit;
   end;
   screen.Cursor:=crHourGlass;
   Label3.visible:=true;
   Label3.caption:='Tirages des chantillons :';refresh;
   asgEchantillons.RowCount:=Taille+1;   asgUneColonne.RowCount:=Taille+1;
   asgEchantillons.ColCount:=nbEchantillons+1;
   asgCalculs.ColCount:=nbEchantillons+1;
   for j:=1 to Taille do asgEchantillons.cells[0,j]:=inttostr(j);
   for i:=1 to nbEchantillons do
   begin
      asgEchantillons.cells[i,0]:=inttostr(i);
      for j:=1 to Taille do
      begin
         x:=random(max-min+1)+min;
         asgEchantillons.cells[i,j]:=intToStr(x);
         Tab[(i-1)*Taille+j-1]:=x;
      end;
      Gauge1.Progress:=round(i/nbEchantillons*100);
      asgEchantillons.Refresh;
   end;
   Trier;
   screen.Cursor:=crDefault;
   Calculs;
end;

Procedure TfmSimulations.LoiUniformeContinue;
var  i,j : integer;
     x,Min,Max : real;
begin
   Randomize;
   try
      Min:=StrToFloat(edMin.text);Max:=StrToFloat(edMax.text);
   except
      ShowMessage('Saisir les bornes (min et max) de l''intervalle.');
      exit;
   end;
   try
      Taille:=StrToInt(edTailleEchantillon.text);
   except
      ShowMessage('Saisir la taille (nombre entier) des chantillons.');
      exit;
   end;
   try
      nbEchantillons:=StrToInt(edNombreEchantillons.text);
   except
      ShowMessage('Saisir le nombre d''chantillons  produire.');
      exit;
   end;
   if nbEchantillons*taille>10000000 then
   begin
      ShowMessage('Le nombre de tirages est limit  10 millions.'+chr(13)+'Vous avez demand '+inttostr(nbEchantillons)+' chantillons de '
                  +inttostr(taille)+' tirages chacun, soit '+inttostr(nbEchantillons*Taille)+' tirages ...');
      exit;
   end;
   screen.Cursor:=crHourGlass;
   Label3.caption:='Tirages des chantillons :';refresh;
   asgEchantillons.RowCount:=Taille+1;   asgUneColonne.RowCount:=Taille+1;
   asgEchantillons.ColCount:=nbEchantillons+1;
   asgCalculs.ColCount:=nbEchantillons+1;
   for j:=1 to Taille do asgEchantillons.cells[0,j]:=inttostr(j);
   for i:=1 to nbEchantillons do
   begin
      asgEchantillons.cells[i,0]:=inttostr(i);
      for j:=1 to Taille do
      begin
         x:=min+(max-min)*random;
         asgEchantillons.cells[i,j]:=FloatToStr(x);
         Tab[(i-1)*Taille+j-1]:=x;
      end;
      Gauge1.Progress:=round(i/nbEchantillons*100);
   end;
   screen.Cursor:=crDefault;
   Calculs;
end;

Procedure TfmSimulations.LoiBernoulli;
var i,j : integer;
    x,p : real;
begin
   Randomize;
   try
      p:=StrToFloat(edP.Text);
   except
      ShowMessage('La probabilit d''un succs doit tre un nombre rel dans l''intervalle [0;1]');
      exit;
   end;
   try
      Taille:=StrToInt(edTailleEchantillon.text);
   except
      ShowMessage('Saisir la taille (nombre entier) des chantillons.');
      exit;
   end;
   try
      nbEchantillons:=StrToInt(edNombreEchantillons.text);
   except
      ShowMessage('Saisir le nombre d''chantillons  produire.');
      exit;
   end;
   if nbEchantillons*taille>10000000 then
   begin
      ShowMessage('Le nombre de tirages est limit  10 millions.'+chr(13)+'Vous avez demand '+inttostr(nbEchantillons)+' chantillons de '
                  +inttostr(taille)+' tirages chacun, soit '+inttostr(nbEchantillons*Taille)+' tirages ...');
      exit;
   end;
   screen.Cursor:=crHourGlass;
   Label3.caption:='Tirages des chantillons :';refresh;
   asgEchantillons.RowCount:=Taille+1;   asgUneColonne.RowCount:=Taille+1;
   asgEchantillons.ColCount:=nbEchantillons+1;
   asgCalculs.ColCount:=nbEchantillons+1;
   for j:=1 to Taille do asgEchantillons.cells[0,j]:=inttostr(j);
   for i:=1 to nbEchantillons do
   begin
      asgEchantillons.cells[i,0]:=inttostr(i);
      for j:=1 to Taille do
      begin
         x:=random;
         if x>p then asgEchantillons.cells[i,j]:='0' else asgEchantillons.cells[i,j]:='1';
         if x>p then Tab[(i-1)*Taille+j-1]:=0 else Tab[(i-1)*Taille+j-1]:=1;
      end;
      Gauge1.Progress:=round(i/nbEchantillons*100);
   end;
   screen.Cursor:=crDefault;
   Calculs;
end;

Procedure TfmSimulations.LoiBinomiale;
var i,j,k,n,b : integer;
    x,p : real;
begin
   Randomize;
   screen.Cursor:=crHourGlass;
   try
      p:=StrToFloat(edP.Text);
   except
      ShowMessage('La probabilit d''un succs doit tre un nombre rel dans l''intervalle [0;1]');
      exit;
   end;
   try
      Taille:=StrToInt(edTailleEchantillon.text);
   except
      ShowMessage('Saisir la taille (nombre entier) des chantillons.');
      exit;
   end;
   try
      nbEchantillons:=StrToInt(edNombreEchantillons.text);
   except
      ShowMessage('Saisir le nombre d''chantillons  produire.');
      exit;
   end;
   try
      n:=StrToInt(edNbIterations.text);
   except
      ShowMessage('Saisir le nombre de rptitions (entier positif non nul).');
      exit;
   end;
   if nbEchantillons*taille>10000000 then
   begin
      ShowMessage('Le nombre de tirages est limit  10 millions.'+chr(13)+'Vous avez demand '+inttostr(nbEchantillons)+' chantillons de '
                  +inttostr(taille)+' tirages chacun, soit '+inttostr(nbEchantillons*Taille)+' tirages ...');
      exit;
   end;
   screen.Cursor:=crHourGlass;
   Label3.caption:='Tirages des chantillons :';refresh;
   asgEchantillons.RowCount:=Taille+1;   asgUneColonne.RowCount:=Taille+1;
   asgEchantillons.ColCount:=nbEchantillons+1;
   asgCalculs.ColCount:=nbEchantillons+1;
   for j:=1 to Taille do asgEchantillons.cells[0,j]:=inttostr(j);
   for i:=1 to nbEchantillons do
   begin
      asgEchantillons.cells[i,0]:=inttostr(i);
      for j:=1 to Taille do
      begin
         b:=0;     //nombre de succs
         for k:=1 to n do
         begin
            x:=random;
            if x<=p then inc(b);
         end;
         asgEchantillons.cells[i,j]:=IntToStr(b);
         Tab[(i-1)*Taille+j-1]:=b;
      end;
      Gauge1.Progress:=round(i/nbEchantillons*100);
   end;
   screen.Cursor:=crDefault;
   Calculs;
end;

Procedure TfmSimulations.LoiGeometrique;
var i,j,k,n : integer;
    x,p : real;
begin
   Randomize;
   try
      p:=StrToFloat(edP.Text);
   except
      ShowMessage('La probabilit d''un succs doit tre un nombre rel dans l''intervalle [0;1]');
      exit;
   end;
   try
      Taille:=StrToInt(edTailleEchantillon.text);
   except
      ShowMessage('Saisir la taille (nombre entier) des chantillons.');
      exit;
   end;
   try
      nbEchantillons:=StrToInt(edNombreEchantillons.text);
   except
      ShowMessage('Saisir le nombre d''chantillons  produire.');
      exit;
   end;
   if nbEchantillons*taille>10000000 then
   begin
      ShowMessage('Le nombre de tirages est limit  10 millions.'+chr(13)+'Vous avez demand '+inttostr(nbEchantillons)+' chantillons de '
                  +inttostr(taille)+' tirages chacun, soit '+inttostr(nbEchantillons*Taille)+' tirages ...');
      exit;
   end;
   screen.Cursor:=crHourGlass;
   Label3.caption:='Tirages des chantillons :';refresh;
   asgEchantillons.RowCount:=Taille+1;   asgUneColonne.RowCount:=Taille+1;
   asgEchantillons.ColCount:=nbEchantillons+1;
   asgCalculs.ColCount:=nbEchantillons+1;
   for j:=1 to Taille do asgEchantillons.cells[0,j]:=inttostr(j);
   for i:=1 to nbEchantillons do
   begin
      asgEchantillons.cells[i,0]:=inttostr(i);
      for j:=1 to Taille do
      begin
         k:=0;
         repeat
            inc(k);
            x:=random;
         until x<=p;
         asgEchantillons.cells[i,j]:=intToStr(k);
         Tab[(i-1)*Taille+j-1]:=k;
      end;
      Gauge1.Progress:=round(i/nbEchantillons*100);
   end;
   screen.Cursor:=crDefault;
   Calculs;
end;

Procedure TfmSimulations.LoiPoisson;
var r,i,j : integer;
    Lambda,s : real;
begin
   Randomize;
   try
      Lambda:=StrToFloat(edPoisson.Text);
   except
      ShowMessage('Saisir le paramtre lambda de la loi de Poisson (rel strictement positif).');
      exit;
   end;
   try
      Taille:=StrToInt(edTailleEchantillon.text);
   except
      ShowMessage('Saisir la taille (nombre entier) des chantillons.');
      exit;
   end;
   try
      nbEchantillons:=StrToInt(edNombreEchantillons.text);
   except
      ShowMessage('Saisir le nombre d''chantillons  produire.');
      exit;
   end;
   if nbEchantillons*taille>10000000 then
   begin
      ShowMessage('Le nombre de tirages est limit  10 millions.'+chr(13)+'Vous avez demand '+inttostr(nbEchantillons)+' chantillons de '
                  +inttostr(taille)+' tirages chacun, soit '+inttostr(nbEchantillons*Taille)+' tirages ...');
      exit;
   end;
   screen.Cursor:=crHourGlass;
   Label3.caption:='Tirages des chantillons :';refresh;
   asgEchantillons.RowCount:=Taille+1;   asgUneColonne.RowCount:=Taille+1;
   asgEchantillons.ColCount:=nbEchantillons+1;
   asgCalculs.ColCount:=nbEchantillons+1;
   for j:=1 to Taille do asgEchantillons.cells[0,j]:=inttostr(j);
   for i:=1 to nbEchantillons do
   begin
      asgEchantillons.cells[i,0]:=inttostr(i);
      for j:=1 to Taille do
      begin
         s:=Lambda;
         r:=-1;
         while s>=0 do
         begin
            r:=r+1;
            s:=s+ln(1-random);
         end;
         asgEchantillons.cells[i,j]:=IntToStr(r);
         Tab[(i-1)*Taille+j-1]:=r;
      end;
      Gauge1.Progress:=round(i/nbEchantillons*100);
   end;
   screen.Cursor:=crDefault;
   Calculs;
end;

Procedure TfmSimulations.LoiNormale;
Var Moyenne,EcartType,x,y,z,s : real;
    i,j : integer;
begin
   Randomize;
   try
      Moyenne:=StrToFloat(edMoyenneLoiNormale.Text);
   except
      ShowMessage('Saisir la moyenne de la loi normale.');
      exit;
   end;
   try
      EcartType:=StrToFloat(edEcartTypeLoiNormale.Text);
   except
      ShowMessage('Saisir l''cart type de la loi normale (rel strictement positif).');
      exit;
   end;
   try
      Taille:=StrToInt(edTailleEchantillon.text);
   except
      ShowMessage('Saisir la taille (nombre entier) des chantillons.');
      exit;
   end;
   try
      nbEchantillons:=StrToInt(edNombreEchantillons.text);
   except
      ShowMessage('Saisir le nombre d''chantillons  produire.');
      exit;
   end;
   if nbEchantillons*taille>10000000 then
   begin
      ShowMessage('Le nombre de tirages est limit  10 millions.'+chr(13)+'Vous avez demand '+inttostr(nbEchantillons)+' chantillons de '
                  +inttostr(taille)+' tirages chacun, soit '+inttostr(nbEchantillons*Taille)+' tirages ...');
      exit;
   end;
   screen.Cursor:=crHourGlass;
   Label3.caption:='Tirages des chantillons :';refresh;
   asgEchantillons.RowCount:=Taille+1;   asgUneColonne.RowCount:=Taille+1;
   asgEchantillons.ColCount:=nbEchantillons+1;
   asgCalculs.ColCount:=nbEchantillons+1;
   for j:=1 to Taille do asgEchantillons.cells[0,j]:=inttostr(j);
   for i:=1 to nbEchantillons do
   begin
      asgEchantillons.cells[i,0]:=inttostr(i);
      for j:=1 to Taille do
      begin                     //mthode de Box-Muller
         repeat
            x:=2*random-1;
            y:=2*random-1;
         until x*x+y*y<1;
         s:=x*x+y*y;
         z:=x*sqrt((-2*ln(s))/s);
         z:=Moyenne+EcartType*z;
         asgEchantillons.cells[i,j]:=FloatToStr(z);
         Tab[(i-1)*Taille+j-1]:=z;
      end;
      Gauge1.Progress:=round(i/nbEchantillons*100);
   end;
   screen.Cursor:=crDefault;
   Calculs;
end;


procedure TfmSimulations.rgLoiClick(Sender: TObject);
begin
   Memo1.Text:=Textes[rgLoi.ItemIndex];
   edMin.Visible:=rgLoi.ItemIndex<2;lblMin.Visible:=rgLoi.ItemIndex<2;
   edMax.Visible:=rgLoi.ItemIndex<2;lblMax.Visible:=rgLoi.ItemIndex<2;
   lblDistance.Visible:=rgGraphiques.ItemIndex=2;
   SpinDistance.Visible:=rgGraphiques.ItemIndex=2;
   Label7.Visible:=(((rgGraphiques.ItemIndex=1)or(rgGraphiques.ItemIndex=3))and((rgLoi.ItemIndex=1)or(rgLoi.ItemIndex=6)))or(rgGraphiques.ItemIndex=5);
   spNbClasses.Visible:=(((rgGraphiques.ItemIndex=1)or(rgGraphiques.ItemIndex=3))and((rgLoi.ItemIndex=1)or(rgLoi.ItemIndex=6)))or(rgGraphiques.ItemIndex=5);
   edP.Visible:=(rgLoi.ItemIndex=2)or(rgLoi.ItemIndex=3)or(rgLoi.ItemIndex=4);  lblP.Visible:=(rgLoi.ItemIndex=2)or(rgLoi.ItemIndex=3)or(rgLoi.ItemIndex=4);
   edNbIterations.Visible:=rgLoi.ItemIndex=3;              lblNbIterations.Visible:=rgLoi.ItemIndex=3;
   edPoisson.Visible:=rgLoi.ItemIndex=5;                   lblPoisson.Visible:=rgLoi.ItemIndex=5;
   edMoyenneLoiNormale.Visible:=rgLoi.ItemIndex=6;         edEcartTypeLoiNormale.Visible:=rgLoi.ItemIndex=6;
   lblLoiNormale1.Visible:=rgLoi.ItemIndex=6;              lblLoiNormale2.Visible:=rgLoi.ItemIndex=6;
   cbIntervalleConfiance.Enabled:=(rgLoi.ItemIndex=2)and(rgGraphiques.ItemIndex>4);
end;

procedure TfmSimulations.asgEchantillonsTopLeftChanged(Sender: TObject);
begin
   asgCalculs.LeftCol:=asgEchantillons.LeftCol;
end;

procedure TfmSimulations.btSimulationsClick(Sender: TObject);
begin
   Gauge1.Visible:=true;
   Label3.Visible:=true;
   case rgLoi.ItemIndex of
      0 : LoiUniformeDiscrete;
      1 : LoiUniformeContinue;
      2 : LoiBernoulli;
      3 : LoiBinomiale;
      4 : LoiGeometrique;
      5 : LoiPoisson;
      6 : LoiNormale;
   end;
end;

procedure TfmSimulations.btCopierDonneesClick(Sender: TObject);
begin
   StringGridCopyToClipBoard(asgEchantillons,0,Taille,0,nbEchantillons);
end;

procedure TfmSimulations.btCopierCalculsClick(Sender: TObject);
begin
   StringGridCopyToClipBoard(asgCalculs,0,9,0,nbEchantillons);
end;

procedure TfmSimulations.FormShow(Sender: TObject);
begin
    rgLoiClick(sender);
end;

procedure TfmSimulations.rgGraphiquesClick(Sender: TObject);
begin
   lblDistance.Visible:=rgGraphiques.ItemIndex=2;
   SpinDistance.Visible:=rgGraphiques.ItemIndex=2;
   spNbClasses.Visible:=(((rgGraphiques.ItemIndex=1)or(rgGraphiques.ItemIndex=3))and((rgLoi.ItemIndex=1)or(rgLoi.ItemIndex=6)))or(rgGraphiques.ItemIndex=5);
   Label7.Visible:=(((rgGraphiques.ItemIndex=1)or(rgGraphiques.ItemIndex=3))and((rgLoi.ItemIndex=1)or(rgLoi.ItemIndex=6)))or(rgGraphiques.ItemIndex=5);
   cbIntervalleConfiance.Enabled:=(rgLoi.ItemIndex=2)and(rgGraphiques.ItemIndex>4);
end;

procedure TfmSimulations.edMoyenneLoiNormaleKeyPress(Sender: TObject;
  var Key: Char);
begin
   if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmSimulations.edPKeyPress(Sender: TObject; var Key: Char);
begin
   if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmSimulations.edPoissonKeyPress(Sender: TObject; var Key: Char);
begin
   if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmSimulations.edEcartTypeLoiNormaleKeyPress(Sender: TObject;
  var Key: Char);
begin
   if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmSimulations.edMinKeyPress(Sender: TObject; var Key: Char);
begin
   if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmSimulations.edMaxKeyPress(Sender: TObject; var Key: Char);
begin
   if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmSimulations.btnAideClick(Sender: TObject);
begin
   Aide(64);
end;

end.
