unit uTableValeurs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, ComCtrls, ColorGrd, shellAPI;

type
  TfmTableValeurs = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    rgTypeVariable: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    edDepart: TEdit;
    edPas: TEdit;
    Label3: TLabel;
    edPrecision: TEdit;
    udPrecision: TUpDown;
    btOK: TButton;
    btAnnuler: TButton;
    UpDown1: TUpDown;
    btCopier: TButton;
    cbImprimerTable: TCheckBox;
    UpDown2: TUpDown;
    rgTypeVariableT: TRadioGroup;
    Label4: TLabel;
    Label5: TLabel;
    edDepartT: TEdit;
    edPasT: TEdit;
    edPrecisionT: TEdit;
    udPrecisionT: TUpDown;
    Label6: TLabel;
    GroupBox1: TGroupBox;
    rbAucuneMarque: TRadioButton;
    rbPoint: TRadioButton;
    rbPlus: TRadioButton;
    rbCroix: TRadioButton;
    rbEtoile: TRadioButton;
    rbCarre: TRadioButton;
    rbLosange: TRadioButton;
    cgCouleur: TColorGrid;
    edTaille: TEdit;
    Label13: TLabel;
    udTaille: TUpDown;
    GroupBox2: TGroupBox;
    Label20: TLabel;
    rbAucuneMarqueT: TRadioButton;
    rbPointT: TRadioButton;
    rbPlusT: TRadioButton;
    rbCroixT: TRadioButton;
    rbEtoileT: TRadioButton;
    rbCarreT: TRadioButton;
    rbLosangeT: TRadioButton;
    cgCouleurT: TColorGrid;
    edTailleT: TEdit;
    udTailleT: TUpDown;
    cbFractions: TCheckBox;
    asgTable1: TStringGrid;
    asgTable2: TStringGrid;
    btnAide: TButton;
    Image1: TImage;
    Image2: TImage;
    rbRondT: TRadioButton;
    rbCarre2T: TRadioButton;
    rbLosange2T: TRadioButton;
    Image3: TImage;
    Image4: TImage;
    rbRond: TRadioButton;
    rbCarre2: TRadioButton;
    rbLosange2: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure rgTypeVariableClick(Sender: TObject);
    procedure edDepartChange(Sender: TObject);
    procedure edPasChange(Sender: TObject);
    procedure edPrecisionChange(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure asgTable1CellValidate(Sender: TObject; Col, Row: Integer;
      var Value: String; var Valid: Boolean);
    procedure btCopierClick(Sender: TObject);
    procedure edDepartKeyPress(Sender: TObject; var Key: Char);
    procedure edPasKeyPress(Sender: TObject; var Key: Char);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure edDepartTKeyPress(Sender: TObject; var Key: Char);
    procedure edPasTKeyPress(Sender: TObject; var Key: Char);
    procedure edPrecisionTChange(Sender: TObject);
    procedure rgTypeVariableTClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure asgTable2CellValidate(Sender: TObject; Col, Row: Integer;
      var Value: String; var Valid: Boolean);
    procedure edDepartTChange(Sender: TObject);
    procedure edPasTChange(Sender: TObject);
    procedure asgTable1Click(Sender: TObject);
    procedure asgTable2Click(Sender: TObject);
    procedure cbFractionsClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure asgTable1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure asgTable1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure asgTable1KeyPress(Sender: TObject; var Key: Char);
    procedure asgTable2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure asgTable2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure asgTable2KeyPress(Sender: TObject; var Key: Char);
    procedure edPasTKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
     procedure Calculs;
     Procedure CalculsT;
  public
    { Dclarations publiques }
  end;

var
  fmTableValeurs: TfmTableValeurs;
  ValeurDepart,ValeurPas : real;
  ValeurDepartT,ValeurPasT : real;

implementation

{$R *.DFM}

uses uDessin,uFonctions;

Procedure TfmTableValeurs.Calculs;//calculs automatiques
var i,k,num,den : integer;
    err : byte;
    x,y : real;
    chFonction : string;
begin
   if rgTypeVariable.ItemIndex=1 then exit;    //inutile normalement
   i:=0;
   try
      ValeurDepart:=StrToFloat(edDepart.Text);
      ValeurPas:=StrToFloat(edPas.text);
   except
      i:=1;
   end;
   if (i=1)then exit;
   for i:=1 to 11 do
   begin
      x:=ValeurDepart+(i-1)*ValeurPas;
      asgTable1.cells[0,i]:=floattostrf(x,ffFixed,10,udPrecision.position);
      for k:=1 to 10 do if Courbes[k].expression<>'' then
      begin
         chFonction:=Courbes[k].Expression;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            y:=f(chFonction,x);
            if ok then asgTable1.cells[k,i]:=floattostrf(y,ffFixed,10,udPrecision.position)
                  else asgTable1.cells[k,i]:='';
            if (asgTable1.cells[k,i]<>'') and cbFractions.Checked then
            begin
               if DecomposeFraction(y,num,den) then if y>0 then asgTable1.cells[k,i]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable1.cells[k,i]:='-'+inttostr(num)+'/'+inttostr(den);
            end;
         end;
      end;
   end;
end;

procedure TfmTableValeurs.CalculsT;
var i,k,num,den : integer;
    err : byte;
    t,x,y : real;
    chFonction : string;
begin
   if rgTypeVariableT.ItemIndex=1 then exit;  //on ne fait ici que les calculs automatiques
   i:=0;
   try
      ValeurDepartT:=StrToFloat(edDepartT.Text);
      ValeurPasT:=StrToFloat(edPasT.text);
   except
      i:=1;
   end;
   if i=1 then exit;
   for i:=1 to 11 do
   begin
      t:=ValeurDepartT+(i-1)*ValeurPasT;
      asgTable2.cells[0,i]:=floattostrf(t,ffFixed,10,udPrecisionT.position);
      for k:=1 to 10 do if (CourbesParametrees[k].expressionX<>'')and(CourbesParametrees[k].expressionY<>'') then
      begin
         chFonction:=CourbesParametrees[k].ExpressionX;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            x:=f(chFonction,t);
            if ok then asgTable2.cells[2*k-1,i]:=floattostrf(x,ffFixed,10,udPrecisionT.position)
                  else asgTable2.cells[2*k-1,i]:='';
            if (asgTable2.Cells[2*k-1,i]<>'')and cbFractions.Checked then
            begin
               if DecomposeFraction(x,num,den) then if x>0 then asgTable2.cells[2*k-1,i]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable2.cells[2*k-1,i]:='-'+inttostr(num)+'/'+inttostr(den)
            end;
         end;
         chFonction:=CourbesParametrees[k].ExpressionY;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            y:=f(chFonction,t);
            if ok then asgTable2.cells[2*k,i]:=floattostrf(y,ffFixed,10,udPrecisionT.position)
                  else asgTable2.cells[2*k,i]:='';
            if (asgTable2.Cells[2*k,i]<>'')and cbFractions.Checked then
            begin
               if DecomposeFraction(y,num,den) then if y>0 then asgTable2.cells[2*k,i]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable2.cells[2*k,i]:='-'+inttostr(num)+'/'+inttostr(den)
            end;
         end;
      end;
   end;
end;

procedure TfmTableValeurs.FormShow(Sender: TObject);
var i,j : integer;
begin
   if PageControl1.ActivePage=TabSheet1 then
   begin
      NomVar:='X';
      Calculs;
   end
   else
   begin
      nomVar:='T';
      CalculsT;
   end;
end;

procedure TfmTableValeurs.rgTypeVariableClick(Sender: TObject);
var i,j : integer;
begin
   if rgTypeVariable.ItemIndex=0 then
   begin
       label1.Enabled:=true;
       label2.Enabled:=true;
       edDepart.Enabled:=true;
       edPas.Enabled:=true;
       edDepart.Color:=clWindow;
       edPas.Color:=clWindow;
       asgTable1.FixedCols:=1;
       asgTable1.Options:=asgTable1.Options-[goEditing];
       UpDown1.Visible:=true;
       Calculs;
   end
   else
   begin
       label1.Enabled:=false;
       label2.Enabled:=false;
       edDepart.Enabled:=false;
       edPas.Enabled:=false;
       edDepart.Color:=clBtnFace;
       edPas.Color:=clBtnFace;
       asgTable1.FixedCols:=0;
       asgTable1.Options:=asgTable1.Options+[goEditing];
       UpDown1.Visible:=false;
       asgTable1.col:=0;
       asgTable1.row:=1;
       for i:=1 to 11 do
       begin
          asgTable1.RowS[i].Clear;
       end;
   end;
end;

procedure TfmTableValeurs.edDepartChange(Sender: TObject);
begin
   Calculs;
end;

procedure TfmTableValeurs.edPasChange(Sender: TObject);
begin
   Calculs;
end;

procedure TfmTableValeurs.edPrecisionChange(Sender: TObject);
var i,j,num,den:integer;
    x,y        :real;
    chFonction : string;
    err        : byte;
begin
   if rgTypeVariable.ItemIndex=0 then Calculs
   else for i:=1 to 11 do if asgTable1.cells[0,i]<>'' then
   try
      chFonction:=Traduction(asgTable1.cells[0,i],err);
      x:=f(chFonction,1);
      asgTable1.cells[0,i]:=FloatToStrf(x,ffFixed,10,udPrecision.position);
      for j:=1 to 10 do if Courbes[j].expression<>'' then
      begin
         chFonction:=Courbes[j].Expression;
         chFonction:=Traduction(chFonction,err);
         ok:=true;
         y:=f(chFonction,x);
         if ok then asgTable1.cells[j,i]:=floattostrf(y,ffFixed,10,udPrecision.position)
               else asgTable1.cells[j,i]:='';
         if (asgTable1.cells[j,i]<>'')and cbFractions.Checked then
            if DecomposeFraction(y,num,den) then if y>0 then asgTable1.cells[j,i]:=inttostr(num)+'/'+inttostr(den)
                                                        else asgTable1.cells[j,i]:='-'+inttostr(num)+'/'+inttostr(den);
      end;
   except
   end;
end;

procedure TfmTableValeurs.UpDown1Click(Sender: TObject;
  Button: TUDBtnType);
begin
   if rgTypeVariable.ItemIndex=0 then
   begin
      if button=btNext then ValeurDepart:=ValeurDepart-ValeurPas
                       else ValeurDepart:=ValeurDepart+ValeurPas;
      edDepart.Text:=FloatToStrf(ValeurDepart,ffFixed,10,udPrecision.position);
      Calculs;
   end;
end;

procedure TfmTableValeurs.asgTable1CellValidate(Sender: TObject; Col,
  Row: Integer; var Value: String; var Valid: Boolean);
var k,i,num,den : integer;
    x,y : real;
    chFonction : string;
    err : byte;
begin
   i:=0;
   try
      //x:=StrToFloat(value);
      chFonction:=Traduction(value,err);
      x:=f(chFonction,1);
   except;
      i:=1;
   end;
   if i>0 then exit;
   for k:=1 to 10 do if Courbes[k].expression<>'' then
      begin
         chFonction:=Courbes[k].Expression;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            y:=f(chFonction,x);
            if ok then asgTable1.cells[k,row]:=floattostrf(y,ffFixed,10,udPrecision.position)
                  else asgTable1.cells[k,row]:='';
            if (asgTable1.cells[k,row]<>'')and cbFractions.Checked then
               if DecomposeFraction(y,num,den) then if y>0 then asgTable1.cells[k,row]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable1.cells[k,row]:='-'+inttostr(num)+'/'+inttostr(den)
         end;
      end;
end;

procedure TfmTableValeurs.btCopierClick(Sender: TObject);
begin
//   if PageControl1.ActivePage=TabSheet1 then asgTable1.CopyToClipBoard
//                                        else asgTable2.CopyToClipBoard;
if PageControl1.ActivePage=TabSheet1
	then StringGridCopyToClipBoard(asgTable1,0,11,0,10)
	else StringGridCopyToClipBoard(asgTable2,0,11,0,20);
end;

procedure TfmTableValeurs.edDepartKeyPress(Sender: TObject; var Key: Char);
begin
   if key='.' then key:=',';
end;

procedure TfmTableValeurs.edPasKeyPress(Sender: TObject; var Key: Char);
begin
   if key='.' then key:=',';
end;

procedure TfmTableValeurs.UpDown2Click(Sender: TObject;
  Button: TUDBtnType);
begin
   if rgTypeVariableT.ItemIndex=0 then
   begin
      if button=btNext then ValeurDepartT:=ValeurDepartT-ValeurPasT
                       else ValeurDepartT:=ValeurDepartT+ValeurPasT;
      edDepartT.Text:=FloatToStrf(ValeurDepartT,ffFixed,10,udPrecisionT.position);
      CalculsT;
   end;
end;

procedure TfmTableValeurs.edDepartTKeyPress(Sender: TObject;
  var Key: Char);
begin
   if key='.' then key:=',';
end;

procedure TfmTableValeurs.edPasTKeyPress(Sender: TObject; var Key: Char);
begin
   if key='.' then key:=',';
end;

procedure TfmTableValeurs.edPrecisionTChange(Sender: TObject);
var i,j        :integer;
    t,x,y      :real;
    chFonction : string;
    err        : byte;
begin
   if rgTypeVariableT.ItemIndex=0 then CalculsT
   else for i:=1 to 11 do if asgTable2.cells[0,i]<>'' then
   try
      chFonction:=Traduction(asgTable2.cells[0,i],err);
      t:=f(chFonction,1);
//      t:=Floats(asgTable2.cells[0,i]);
      asgTable2.cells[0,i]:=FloatToStrf(t,ffFixed,10,udPrecisionT.position);
      for j:=1 to 10 do if (CourbesParametrees[j].expressionX<>'')and(CourbesParametrees[j].expressionY<>'') then
      begin
         chFonction:=CourbesParametrees[j].ExpressionX;
         chFonction:=Traduction(chFonction,err);
         ok:=true;
         x:=f(chFonction,t);
         if ok then asgTable2.cells[2*j-1,i]:=floattostrf(x,ffFixed,10,udPrecisionT.position)
               else asgTable2.cells[2*j-1,i]:='';
         chFonction:=CourbesParametrees[j].ExpressionY;
         chFonction:=Traduction(chFonction,err);
         ok:=true;
         y:=f(chFonction,t);
         if ok then asgTable2.cells[2*j,i]:=floattostrf(y,ffFixed,10,udPrecisionT.position)
               else asgTable2.cells[2*j,i]:='';
      end;
   except
   end;
end;

procedure TfmTableValeurs.rgTypeVariableTClick(Sender: TObject);
var i,j : integer;
begin
   if rgTypeVariableT.ItemIndex=0 then
   begin
       label4.Enabled:=true;
       label5.Enabled:=true;
       edDepartT.Enabled:=true;
       edPasT.Enabled:=true;
       edDepartT.Color:=clWindow;
       edPasT.Color:=clWindow;
       asgTable2.FixedCols:=1;
       asgTable2.Options:=asgTable2.Options-[goEditing];
       UpDown2.Visible:=true;
       CalculsT;
   end
   else
   begin
       label4.Enabled:=false;
       label5.Enabled:=false;
       edDepartT.Enabled:=false;
       edPasT.Enabled:=false;
       edDepartT.Color:=clBtnFace;
       edPasT.Color:=clBtnFace;
       asgTable2.FixedCols:=0;
       asgTable2.Options:=asgTable2.Options+[goEditing];
       UpDown2.Visible:=false;
       asgTable2.col:=0;
       asgTable2.row:=1;
       for i:=1 to 11 do asgTable2.RowS[i].clear;
   end;
end;

procedure TfmTableValeurs.PageControl1Change(Sender: TObject);
var i,j : integer;
begin
    if PageControl1.ActivePage=TabSheet1 then NomVar:='X' else nomVar:='T';
    if (NomVar='X') and (rgTypeVariable.ItemIndex=0) then Calculs;
    if (NomVar='T') and (rgTypeVariable.ItemIndex=0) then CalculsT;
end;

procedure TfmTableValeurs.asgTable2CellValidate(Sender: TObject; Col,
  Row: Integer; var Value: String; var Valid: Boolean);
var k,i : integer;
    t,x,y : real;
    chFonction : string;
    err : byte;
begin
   i:=0;
   try
      t:=StrToFloat(value);
   except;
      i:=1;
   end;
   if i>0 then exit;
   for k:=1 to 10 do if (CourbesParametrees[k].expressionX<>'')and(CourbesParametrees[k].expressionY<>'') then
      begin
         chFonction:=CourbesParametrees[k].ExpressionX;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            x:=f(chFonction,t);
            if ok then asgTable2.cells[2*k-1,row]:=floattostrf(x,ffFixed,10,udPrecisionT.position)
                  else asgTable2.cells[2*k-1,row]:='';
         end;
         chFonction:=CourbesParametrees[k].ExpressionY;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            y:=f(chFonction,t);
            if ok then asgTable2.cells[2*k,row]:=floattostrf(y,ffFixed,10,udPrecisionT.position)
                  else asgTable2.cells[2*k,row]:='';
         end;
      end;
end;

procedure TfmTableValeurs.edDepartTChange(Sender: TObject);
begin
   CalculsT;
end;

procedure TfmTableValeurs.edPasTChange(Sender: TObject);
begin
   CalculsT;
end;

procedure TfmTableValeurs.asgTable1Click(Sender: TObject);
begin
   if (asgTable1.col=0)and(asgTable1.row>0)and(rgTypeVariable.ItemIndex=1)
      then asgTable1.Options:=asgTable1.Options+[goEditing]
      else asgTable1.Options:=asgTable1.Options-[goEditing];
end;

procedure TfmTableValeurs.asgTable2Click(Sender: TObject);
begin
   if (asgTable2.col=0)and(asgTable2.row>0)and(rgTypeVariableT.ItemIndex=1)
      then asgTable2.Options:=asgTable2.Options+[goEditing]
      else asgTable2.Options:=asgTable2.Options-[goEditing];
end;

procedure TfmTableValeurs.cbFractionsClick(Sender: TObject);
var t,x,y : extended;
    Texte,chFonction : string;
    num,den,i,j,k : integer;
    err : byte;
begin
   if PageControl1.ActivePageIndex=0 then  //Table de valeurs des fonctions
   begin
      Calculs;                             //calculs automatiques
      if rgTypeVariable.ItemIndex=1 then   //calculs manuels
      for j:=1 to asgTable1.RowCount-1 do
      begin
         i:=0;
         texte:=asgTable1.Cells[0,j];
         try
            chFonction:=Traduction(texte,err);
            x:=f(chFonction,1);
         except;
            i:=1;
         end;
         if i=0 then
         begin
            for k:=1 to 10 do if Courbes[k].expression<>'' then
            begin
               chFonction:=Courbes[k].Expression;
               chFonction:=Traduction(chFonction,err);
               if err=0 then
               begin
                  ok:=true;
                  y:=f(chFonction,x);
                  if ok then asgTable1.cells[k,j]:=floattostrf(y,ffFixed,10,udPrecision.position)
                        else asgTable1.cells[k,j]:='';
                  if (asgTable1.cells[k,j]<>'')and cbFractions.Checked then
                  if DecomposeFraction(y,num,den) then if y>0 then asgTable1.cells[k,j]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable1.cells[k,j]:='-'+inttostr(num)+'/'+inttostr(den)
               end;
            end;
         end;
      end;
   end
   else    //PageControl1.activePageIndex=1  (table de valeurs courbes paramtres)
   begin
      CalculsT;
      if rgTypeVariable.ItemIndex=1 then   //calculs manuels
      for j:=1 to asgTable2.RowCount-1 do
      begin
         i:=0;
         texte:=asgTable2.Cells[0,j];
         try
            chFonction:=Traduction(texte,err);
            t:=f(chFonction,1);
         except;
            i:=1;
         end;
         if i=0 then
         begin
            for k:=1 to 10 do if (CourbesParametrees[k].expressionX<>'' )and(CourbesParametrees[k].expressionY<>'')then
            begin
               chFonction:=CourbesParametrees[k].ExpressionX;
               chFonction:=Traduction(chFonction,err);
               if err=0 then
               begin
                  ok:=true;
                  x:=f(chFonction,t);
                  if ok then asgTable2.cells[2*k-1,j]:=floattostrf(x,ffFixed,10,udPrecisionT.position)
                        else asgTable2.cells[2*k-1,j]:='';
                  if (asgTable2.cells[2*k-1,j]<>'')and cbFractions.Checked then
                  if DecomposeFraction(x,num,den) then if x>0 then asgTable2.cells[2*k-1,j]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable2.cells[2*k-1,j]:='-'+inttostr(num)+'/'+inttostr(den)
               end;
               chFonction:=CourbesParametrees[k].ExpressionY;
               chFonction:=Traduction(chFonction,err);
               if err=0 then
               begin
                  ok:=true;
                  y:=f(chFonction,t);
                  if ok then asgTable2.cells[2*k,j]:=floattostrf(x,ffFixed,10,udPrecisionT.position)
                        else asgTable2.cells[2*k,j]:='';
                  if (asgTable2.cells[2*k,j]<>'')and cbFractions.Checked then
                  if DecomposeFraction(y,num,den) then if y>0 then asgTable2.cells[2*k,j]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable2.cells[2*k,j]:='-'+inttostr(num)+'/'+inttostr(den)
               end;
            end;
         end;
      end;
   end;
end;

procedure TfmTableValeurs.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmTableValeurs.FormCreate(Sender: TObject);
var i : integer;
begin
   with asgTable1 do
   begin
      cells[0,0]:='x';
      for i:=1 to 10 do cells[i,0]:='f'+inttostr(i)+'(x)';
   end;
   with asgTable2 do
   begin
      cells[0,0]:='t';
      for i:=1 to 10 do
      begin
         cells[2*i-1,0]:='x'+inttostr(i)+'(t)';
         cells[2*i  ,0]:='y'+inttostr(i)+'(t)';
      end;
   end;
end;

procedure TfmTableValeurs.asgTable1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
  var Texte : string;
begin
   Texte:=asgTable1.cells[ACol,ARow];
   if (ARow=0)or((ACol=0)and(rgTypeVariable.ItemIndex=0))
   then GrilleCouleur(asgTable1,Rect,Texte,taCenter,clBtnFace,clNavy,[])
   else if odd(ARow) then GrilleCouleur(asgTable1,Rect,Texte,taCenter,$00aaffaa,clBlack,[])
                     else GrilleCouleur(asgTable1,Rect,Texte,taCenter,clWindow,clBlack,[]);
   if (ACol=0)and(rgTypeVariable.ItemIndex=1) then
      if odd(ARow) then GrilleCouleur(asgTable1,Rect,Texte,taCenter,$00ffffaa,clBlack,[])
                   else GrilleCouleur(asgTable1,Rect,Texte,taCenter,clWindow,clBlack,[])
end;

procedure TfmTableValeurs.asgTable1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var ACol,ARow,i,k,num,den : integer;
    x,y : extended;
    texte,chFonction : string;
    err : byte;
begin
   ACol:=asgTable1.Col;
   ARow:=asgTable1.Row;
   texte:=asgTable1.Cells[ACol,ARow];
   if key=vk_return then
   begin
      i:=0;
      try
         chFonction:=Traduction(texte,err);
         x:=f(chFonction,1);
      except;
         i:=1;
      end;
      if i>0 then exit;
      for k:=1 to 10 do if Courbes[k].expression<>'' then
      begin
         chFonction:=Courbes[k].Expression;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            y:=f(chFonction,x);
            if ok then asgTable1.cells[k,Arow]:=floattostrf(y,ffFixed,10,udPrecision.position)
                  else asgTable1.cells[k,Arow]:='';
            if (asgTable1.cells[k,Arow]<>'')and cbFractions.Checked then
               if DecomposeFraction(y,num,den) then if y>0 then asgTable1.cells[k,Arow]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable1.cells[k,Arow]:='-'+inttostr(num)+'/'+inttostr(den)
         end;
      end;
      if ARow<asgTable1.RowCount-1 then asgTable1.Row:=ARow+1;
   end;
end;

procedure TfmTableValeurs.asgTable1KeyPress(Sender: TObject;
  var Key: Char);
begin
   if key='.' then key:=DecimalSeparator;
end;

procedure TfmTableValeurs.asgTable2DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var Texte : string;
begin
   Texte:=asgTable2.cells[ACol,ARow];
   if (ARow=0)or((ACol=0)and(rgTypeVariableT.ItemIndex=0))
   then GrilleCouleur(asgTable2,Rect,Texte,taCenter,clBtnFace,clNavy,[])
   else if odd(ARow) then GrilleCouleur(asgTable2,Rect,Texte,taCenter,$00aaffaa,clBlack,[])
                     else GrilleCouleur(asgTable2,Rect,Texte,taCenter,clWindow,clBlack,[]);
   if (ACol=0)and(rgTypeVariableT.ItemIndex=1) then
      if odd(ARow) then GrilleCouleur(asgTable2,Rect,Texte,taCenter,clWindow,clBlack,[])
                   else if ARow>0 then GrilleCouleur(asgTable2,Rect,Texte,taCenter,$00ffffaa,clBlack,[]);

   if odd(ARow)and (((ACol-1)div 2)mod 2=0)and (ARow*ACol<>0) then GrilleCouleur(asgTable2,Rect,Texte,taCenter,$00ccffcc,clBlack,[]);
   if odd(ARow)and (((ACol-1)div 2)mod 2=1)and (ARow*ACol<>0) then GrilleCouleur(asgTable2,Rect,Texte,taCenter,clWindow,clBlack,[]);
   if not odd(ARow)and (((ACol-1)div 2)mod 2=0)and (ARow*ACol<>0) then GrilleCouleur(asgTable2,Rect,Texte,taCenter,$00aaffaa,clBlack,[]);
   if not odd(ARow)and (((ACol-1)div 2)mod 2=1)and (ARow*ACol<>0) then GrilleCouleur(asgTable2,Rect,Texte,taCenter,$00eeeeee,clBlack,[]);
end;

procedure TfmTableValeurs.asgTable2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var ACol,ARow,i,k,num,den : integer;
    t,x,y : extended;
    texte,chFonction : string;
    err : byte;
begin
   ACol:=asgTable2.Col;
   ARow:=asgTable2.Row;
   texte:=asgTable2.Cells[ACol,ARow];
   if key=vk_return then
   begin
      i:=0;
      try
         chFonction:=Traduction(texte,err);
         t:=f(chFonction,1);
      except;
         i:=1;
      end;
      if i>0 then exit;
      for k:=1 to 10 do if (CourbesParametrees[k].expressionX<>'')and(CourbesParametrees[k].expressionY<>'') then
      begin
         chFonction:=CourbesParametrees[k].ExpressionX;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            x:=f(chFonction,t);
            if ok then asgTable2.cells[2*k-1,Arow]:=floattostrf(x,ffFixed,10,udPrecisionT.position)
                  else asgTable2.cells[2*k-1,Arow]:='';
            if (asgTable2.cells[2*k-1,Arow]<>'')and cbFractions.Checked then
               if DecomposeFraction(x,num,den) then if x>0 then asgTable2.cells[2*k-1,Arow]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable2.cells[2*k-1,Arow]:='-'+inttostr(num)+'/'+inttostr(den)
         end;
         chFonction:=CourbesParametrees[k].ExpressionY;
         chFonction:=Traduction(chFonction,err);
         if err=0 then
         begin
            ok:=true;
            y:=f(chFonction,t);
            if ok then asgTable2.cells[2*k,Arow]:=floattostrf(y,ffFixed,10,udPrecisionT.position)
                  else asgTable2.cells[2*k,Arow]:='';
            if (asgTable2.cells[2*k,Arow]<>'')and cbFractions.Checked then
               if DecomposeFraction(y,num,den) then if y>0 then asgTable2.cells[2*k,Arow]:=inttostr(num)+'/'+inttostr(den)
                                                           else asgTable2.cells[2*k,Arow]:='-'+inttostr(num)+'/'+inttostr(den)
         end;
      end;
      if ARow<asgTable2.RowCount-1 then asgTable2.Row:=ARow+1;
   end;
end;

procedure TfmTableValeurs.asgTable2KeyPress(Sender: TObject;
  var Key: Char);
begin
   if key='.' then key:=DecimalSeparator;
end;

procedure TfmTableValeurs.edPasTKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var ch : string;
    t  : extended;
    err : byte;
begin
   if key=vk_return then
   begin
      ch:=edPasT.Text;
      ch:=Traduction(ch,err);
      if err=0 then begin t:=f(ch,1);edPasT.Text:=FloatToStr(t);end;
   end;
   CalculsT;
end;

procedure TfmTableValeurs.btnAideClick(Sender: TObject);
begin
   Aide(95);
end;

end.
